function predefineColors() {
  let colors = [
    '#003666', '#00AEFF', '#8E42E7', '#B84692', '#FF4F81', '#FF6C5F', '#FEC168', '#2CDE98', '#1CC7D0'
  ]
  return colors[Math.floor(Math.random() * 9)]
}
function getRules(v) {
  let strList = []
  let signs = ["", "≤", "<", "=", ">", "≥"]
  if (Number(v.lctflag) === 1) {
    strList.push('最后消费时间' + signs[v.lctSigns] + v.lctVal + "天")
  }
  if (Number(v.cfflag) === 1) {
    strList.push((v.cfMonth ? v.cfMonth + '个月内' : '') + '消费金额' + signs[v.cfSigns] + v.cfVal)
  }
  if (Number(v.ctFlag) === 1) {
    strList.push((v.ctMonth ? v.ctMonth + '个月内' : '') + '消费次数' + signs[v.ctSigns] + v.ctVal + "次")
  }
  if (Number(v.caFlag) === 1) {
    strList.push((v.caMonth ? v.caMonth + '个月内' : '') + '客单价' + signs[v.casigns] + v.caval)
  }
  return strList
}