(function(){
    var self = amGloble.page.addTag = new $.am.Page({
        id: 'page-addTag',
        init: function(){
            this.$header.find('.left').vclick(function() {
                $.am.page.back('slidedown');
            });

            this.$header.find('.right').vclick(function(){
                var tags = [];
                var list = self.$.find('.selected,.new');
                for(var i=0;i<list.length;i++){
                    var data = $(list[i]).data('data');
                    if($(list[i]).hasClass('selected')){
                        data.memId = self.customer.id;
                    }else {
                        data.memId = '';
                    }
                    data.tagId = data.id;
                    tags.push(data);
                }
                self.addTag(tags);
            });

            // this.$myList = this.$.find('.mine ul');
            // this.$adminList = this.$.find('.admin ul');
			// this.$otherList = this.$.find('.other ul');
			// this.$addBtn = this.$myList.find('.tag_add_btn').remove();
            this.$tagGroupItem = this.$.find('.tagGroupItem');
            this.$tagGroupList = this.$.find('.tagGroupList')
            this.$item = this.$tagGroupItem.find('li').remove();
            this.$tag = this.$.find('.tag').focus(function(){
                // self.$mask.show();
                $('body').addClass('inputfocus');
                var _this = $(this);
                if(self.inputTimer){
                    clearInterval(self.inputTimer);
                }
                self.inputTimer = setInterval(function(){
                    var val = _this.val();
                    if(val){
                        _this.next().addClass('able');
                    }else {
                        _this.next().removeClass('able');
                    }
                },100);
            }).blur(function(){
                $('body').removeClass('inputfocus');
                clearInterval(self.inputTimer);
            }).change(function(){
                var val = $(this).val();
                if(val){
                    $(this).next().addClass('able');
                }else {
                    $(this).next().removeClass('able');
                }
            });
            this.$toggle = this.$.find('.toggle').remove();

            this.$toDel = this.$.find('.toDel').vclick(function(){
                if($(this).hasClass('active')){
                    $(this).removeClass('active');
                    self.$.find('ul .del').hide();
                }else {
                    $(this).addClass('active');
                    self.$.find('ul .del').show();
                }
            });

            this.$.on('vclick','.tagname',function(){
                var num = self.$.find('.amBodyInner .selected').length;
                if($(this).parent().hasClass('selected')){
                    $(this).parent().removeClass('selected');
                }else{
                    if(num>=20){
                        amGloble.msg('最多只能添加20个标签');
                    }else {
                        $(this).parent().addClass('selected');
                    }
                }
            }).on('vclick','.del',function(){
                var data = $(this).parent().data('data');
                if(!data.id){
                    $(this).parent().remove();
                    self.mainScroll.refresh();
                }else{
                    var _this = $(this);
                    self.delTag(data.id,function(){
                        var parent = _this.parents('.wrapper'),
                            toggle = parent.find('.toggle');
                        _this.parent().remove();
                        if(toggle.length){
                            toggle.trigger('vclick');
                            self.checkToggle(parent.find('ul'));
                            toggle.trigger('vclick');
                            self.mainScroll.refresh();
                        }
                    });
                }
            }).on('vclick','.toggle',function(){
                var data = $(this).parent().next().data('data'),
                    min = data.min,
                    max = data.max;
                if($(this).hasClass('up')){
                    $(this).removeClass('up');
                    $(this).parent().next().css('height',min+'px');
                }else {
                    $(this).addClass('up');
                    $(this).parent().next().css('height',max+'px');
                }
                self.mainScroll.refresh();
            }).on('vclick','.add-icon',function(){
                if(self.inputTimer){
                    clearInterval(self.inputTimer);
                }
                var val = self.$tag.val();
                if(!val) {
                    return;
                }
                var lis = self.$.find('li');
                for(var i=0;i<lis.length;i++){
                    if(val==$(lis[i]).find('.tagname').html()){
                        amGloble.msg('此标签已存在');
                        return;
                    }
                }
                var mylis = self.$myList.find('li').not('.tag_add_btn').length;
                if(mylis>=10){
                    amGloble.msg('每人最多添加10个标签');
                    return;
                }
                var $li = self.$item.clone();
                $li.find('p').html(val);
                var num = self.$.find('.amBodyInner .selected').length;
                if(num<5){
                    $li.addClass('selected');
                }
                $li.data('data',{
                    tagId: '',
                    tagName: val,
                    empId: amGloble.metadata.userInfo.userId,
                    type: amGloble.metadata.userInfo.userType,
                    empShopId: amGloble.metadata.userInfo.shopId,
                    parentShopId: amGloble.metadata.userInfo.parentShopId
                });
                self.$myList.prepend($li);
                self.$tag.val('').next().removeClass('able');
                self.mainScroll.refresh();
            });

            // this.$mask = this.$.find('.mask').on('touchstart',function(){
            //     self.$.find("input, textarea").blur().prop("disabled", true);
            //     setTimeout(function(){
            //         self.$mask.hide();
            //         self.$.find("input, textarea").prop("disabled", false);;
            //     },500);
			// });

			// this.$myList.on('vclick', '.tag_add_btn', function(){
			// 	var mylis = self.$myList.find('li').not('.tag_add_btn').length;
            //     if(mylis>=10){
            //         amGloble.msg('每人最多添加10个标签');
            //         return;
			// 	}
			// 	$.am.changePage(amGloble.page.iosInput, "slideup", {
			// 		callbackFn: self.addTagName,
			// 		fromPage: 'addTag',
			// 		placeholder: '在此输入可增加新标签',
			// 		title: '添加标签'
			// 	});
			// })
            this.$.find(".btnList").on('vclick','.toManageTag',function(){
                $.am.changePage(amGloble.page.tagManage, 'slideup');
            }).on('vclick','.toManageDelTag',function(){
                $.am.changePage(amGloble.page.delTagManage, 'slideup');
            })
            this.$.find(".empty").on('vclick','.btn',function(){
                $.am.changePage(amGloble.page.tagManage, 'slideup', {toAdd: 1});
            })

            if($.am.checkScroll(true)<11){
                // this.$mask.remove();
            }
            self.mainScroll = new $.am.ScrollView({
                $wrap: self.$.find(".tagScroll"),
                $inner: self.$.find(".tagGroupList"),
                direction: [0, 1]
            });
            self.mainScroll.bubble = true;
            this.$pic = this.$.find(".am-header .pic")
            this.$name = this.$.find(".am-header .name")
        },
        beforeShow: function(params){
			if (params === 'back') return;
            this.$.find(".empty>div").show()
            var userinfo = amGloble.metadata.userInfo
            if(userinfo.userType == 1){
                var metadataConfig = amGloble.metadata.configs;
                var notAllowedAddAndDelTag = metadataConfig.staffHandle?JSON.parse(metadataConfig.staffHandle).notAllowedAddAndDelTag:0;
                if(notAllowedAddAndDelTag==1){
                    this.$.find(".btnList").hide()
                    this.$.find(".empty>div").hide()
                    this.$.find(".tagScroll").addClass('not_footer');
                    this.mainScroll.refresh();
                } else {
                    this.$.find(".tagScroll").removeClass('not_footer')
                    this.$.find(".btnList").show()
                    this.mainScroll.refresh();
                }
            }else{
                if(userinfo.operatestr && userinfo.operatestr.indexOf('a83') == -1){
                    this.$.find(".btnList").hide()
                    this.$.find(".empty>div").hide()
                    this.$.find(".tagScroll").addClass('not_footer');
                    this.mainScroll.refresh();
                } else {
                    this.$.find(".tagScroll").removeClass('not_footer')
                    this.$.find(".btnList").show()
                    this.mainScroll.refresh();
                }
            }

            this.$.find('.wrapper').hide();
            this.$.find('.toggle').remove();
            this.$toDel.removeClass('active');
            this.$tagGroupList.find(".wrapper").remove()

            // this.$adminList.empty().css('height','auto');
            // this.$otherList.empty().css('height','auto');
            this.$tag.val('');
            if(params && params.customer){
                this.customer = params.customer;

                this.$name.text(this.customer.name);
                this.$pic.empty().html(amGloble.photoManager.createImage("customer", {
                    parentShopId: amGloble.metadata.userInfo.parentShopId,
                    updateTs: this.customer.lastconsumetime
                }, this.customer.id + ".jpg", "s"));
                if(this.customer.gender == 'F'){
                    this.$pic.removeClass("male")
                }else{
                    this.$pic.addClass("male")
                }
            }
        },
        afterShow: function(params){
			// if (params === 'back') return;
            this.$tag.prop("disabled", false);
            this.getTagList();
            if (amGloble.metadata.userInfo.shopType !== 0) {
                amGloble.page.delTagManage.getTagList(function(tagList){
                    var list = tagList
                    if(amGloble.metadata.userInfo.userType){
                        list = tagList.filter(function(tag){
                            return tag.empId == amGloble.metadata.userInfo.userId
                        })
                    }
                    if(list.length == 0){
                        self.$.find(".toManageDelTag").hide().siblings(".toManageTag").css("width","100%")
                    }else{
                        self.$.find(".toManageDelTag").show().siblings(".toManageTag").css("width","49%")
                    }
                })
            } else {
                self.$.find(".toManageDelTag").show().siblings(".toManageTag").css("width","49%")
            }
        },
        beforeHide: function(){
            this.$tag.prop("disabled", true);
        },
        afterHide: function(){

		},
		addTagName: function(tagName) {
			var tags = self.tagList;
			for(var i = 0;i < tags.length; i++){
				if(tagName == tags[i].tagName){
					amGloble.msg('此标签已存在');
					return;
				}
			}
			var $li = self.$item.clone();
			$li.find('p').html(tagName);
			var num = self.$.find('.amBodyInner .selected').length;
			if(num<5){
				$li.addClass('selected');
			}
			$li.data('data',{
				tagId: '',
				tagName: tagName,
				empId: amGloble.metadata.userInfo.userId,
				type: amGloble.metadata.userInfo.userType,
				empShopId: amGloble.metadata.userInfo.shopId,
				parentShopId: amGloble.metadata.userInfo.parentShopId
			});
			self.$myList.prepend($li);
			self.$tag.val('').next().removeClass('able');
			self.mainScroll.refresh();
			$.am.page.back("");
		},
        addTag: function(tags){
            amGloble.loading.show();
            amGloble.api.tagAdd.exec({
                shopId: self.customer.storeId,
                memberId: self.customer.id,
                tags: tags
            },function(ret){
                amGloble.loading.hide();
                var customerTags = [];
                if(tags.length){
                    for(var i=0;i<tags.length;i++){
                        if(tags[i].memId){
                            customerTags.push(tags[i]);
                        }
                    }
				}
				if (ret && ret.code == 0) {
					$.am.changePage(amGloble.page.customerDetail,'slidedown',{customerTags:customerTags});
				} else {
					amGloble.msg(ret.message || "数据保存失败，请稍后重试！");
				}
            });
        },
        delTag: function(id,callback){
            amGloble.loading.show();
            amGloble.api.tagDel.exec({
                id:id
            },function(ret){
                amGloble.loading.hide();
                amGloble.msg('删除成功');
                callback && callback();
            })
        },
        getTagList: function(){
            self.setStatus('pageLoading');
            var userInfo = amGloble.metadata.userInfo;
            var shopId = userInfo.shopType === 0 ? amGloble.storeSelect.getCurrentShops().shopId : userInfo.shopId; // 总部身份取当前选择门店，否则是自身门店
            amGloble.api.queryTags.exec({
                parentShopId: userInfo.parentShopId,
                shopIds: [userInfo.parentShopId, shopId],
                status: 0,
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    self.setStatus('normal');
                    self.render(ret.content.filter(function(item){
                        return item.shopId == userInfo.parentShopId || item.shopId == shopId
                    }),[userInfo.parentShopId, shopId]);
                    self.mainScroll.refresh();
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.getTagList();
                    }, function() {
                        $.am.changePage(amGloble.page.customerDetail,'slidedown');
                    });
                }
            })
        },
        // getTagList: function(){
        //     // amGloble.loading.show();
        //     self.setStatus('pageLoading');
        //     var userInfo = amGloble.metadata.userInfo;
        //     amGloble.api.tagList.exec({
        //         shopId: userInfo.newRole > 3 ? userInfo.shopId : self.customer.storeId,
        //         memId: self.customer.id,
        //     },function(ret){
        //         // amGloble.loading.hide();
        //         console.log(ret);
        //         if(ret && ret.code==0){
        //             self.setStatus('normal');
        //             self.render(ret.content);
        //         }else {
        //             atMobile.nativeUIWidget.confirm({
        //                 caption: '网络异常',
        //                 description: '数据读取失败，是否立即重试？',
        //                 okCaption: '重试',
        //                 cancelCaption: '取消'
        //             }, function() {
        //                 self.getTagList();
        //             }, function() {
        //                 $.am.changePage(amGloble.page.customerDetail,'slidedown');
        //             });
        //         }
        //     })
        // },
        render:function(data, shopList){
            var newData = JSON.parse(JSON.stringify(data))
            if(this.customer && this.customer.tags && this.customer.tags.length){
                var tagsObj = {}
                data.forEach(function(item){
                    tagsObj[item.id] = item
                })
                for (var index = 0; index < this.customer.tags.length; index++) {
                    var item = this.customer.tags[index];
                    if(!tagsObj[item.id]){
                        newData.push(item)
                    }
                }
            }
            this.$tagGroupList.find('.tagGroupItem').remove()
            var parentShopId = amGloble.metadata.userInfo.parentShopId
            var listdata = this.tagList = processData(newData, shopList, true);
            for (var index = 0; index < listdata.length; index++) {
                var group = listdata[index];
                var $group = this.$tagGroupItem.clone()
                $group.find('.type').text(group.groupName)
                for (var i = 0; i < group.children.length; i++) {
                    var tag = group.children[i];
                    var $li = this.$item.clone();
                    $li.find('.tagname .tagText').text(tag.tagName);
                    if(tag.status == 1){
                        $li.addClass("del")
                    }
                    $li.data('data',tag);
                    $group.find("ul").append($li);
                }
                this.$tagGroupList.append($group)
            }
            if(this.$tagGroupList.find(".wrapper").length == 0){
                this.$tagGroupList.hide().siblings(".empty").show()
                if(amGloble.metadata.userInfo.userType == 1){
                    this.$.find(".empty>div").hide()
                }
            }else{
                this.$tagGroupList.show().siblings(".empty").hide()
            }
            // var myList = [],adminList = [],otherList = [];
            // for(var i=0;i<data.length;i++){
            //     if(data[i].empId==amGloble.metadata.userInfo.userId){
            //         myList.push(data[i]);
            //     }
            //     if(data[i].type==0 && data[i].empId!=amGloble.metadata.userInfo.userId){
            //         adminList.push(data[i]);
            //     }
            //     if(data[i].type==1 && data[i].empId!=amGloble.metadata.userInfo.userId){
            //         otherList.push(data[i])
            //     }
            // }
			// this.renderItem(myList,this.$myList,1);
			// this.$myList.append(this.$addBtn.clone());
            // this.renderItem(adminList,this.$adminList,amGloble.metadata.userInfo.userType==0);
            // this.renderItem(otherList,this.$otherList,amGloble.metadata.userInfo.userType==0);

            // if(adminList.length){
            //     this.checkToggle(this.$adminList);
            // }
            // if(otherList.length){
            //     this.checkToggle(this.$otherList);
            // }
            this.renderTags();
            this.$.find('.wrapper').show();
            this.mainScroll.refresh();
            this.mainScroll.scrollTo('top');
        },
        renderItem:function(list,parent,ableDel){
            if(list.length){
                for(var i=0;i<list.length;i++){
                    var $li = this.$item.clone();
                    $li.find('p').html(list[i].tagName);
                    // if(!ableDel){
                    //     $li.find('.del').remove();
                    // }
                    list[i].empShopId = list[i].shopId;
                    $li.data('data',list[i]);
                    parent.append($li);
                }
            }
        },
        renderTags:function(){
            if(this.customer && this.customer.tags && this.customer.tags.length){
                var tags = this.customer.tags;
                for(var i=0;i<tags.length;i++){
                    var lis = this.$.find('li');
                    for(var j=0;j<lis.length;j++){
                        if(tags[i].id==$(lis[j]).data("data").id){
                            $(lis[j]).addClass('selected');
                        }
                    }
                }
            }
        },
        checkToggle:function($dom){
            $dom.css('height','auto');
            var rowHeight = $dom.find('li').outerHeight(true);
                totalHeight = $dom.outerHeight(true);
            $dom.css('height',rowHeight+'px');
            $dom.data('data',{
                min:rowHeight,
                max:totalHeight
            });
            if(totalHeight>rowHeight){
                if(!$dom.prev().find('.toggle').length){
                    var $toggle = this.$toggle.clone();
                    $dom.prev().append($toggle);
                }
            }else {
                $dom.prev().find('.toggle').hide();
            }
        },
    });
})();
