(function() {

    var typePicker = window.typePicker = {
        init: function() {
            var self = this;
            this.$1 = amGloble.page.archiveList.$.find(".mainTypeContainer");
            this.$2 = amGloble.page.archiveList.$.find(".secTypeContainer");

            this.$ul1 = this.$1.find("ul");
            this.$ul2 = this.$2.find(".archiveList_tab");

            this.$li1 = this.$ul1.children(":first").remove();
            this.$li2 = this.$ul2.children(":first").remove();

            this.mainType = new $.am.ScrollView({
                $wrap: this.$1.find(".mainTypeTab"),
                $inner: this.$1.find(".mainTypeTab_inner"),
                direction: [1, 0]
            });

            this.$1.on("vclick", "ul > li", function() {
                // $(this).addClass("selected").siblings().removeClass("selected");
                var $this = $(this);
                self.openSecMenu($this);
            });

            this.$2.on("vclick", ".archiveList_tab > span", function() {
                // $(this).addClass("selected").siblings().removeClass("selected");
                var $this = $(this);
                self.changeType($this);
            });

            this.$subMenuText = this.$1.find(".subMenuText");
        },
        render: function(data) {
            var self = this;
            var $ul = this.$ul1.empty();
            var total = 0;

            if(amGloble.metadata.configs.category_1){
                var newworks=[];
                for(var worksname=1;worksname<7;worksname++){
                    if(amGloble.metadata.configs['category_'+worksname]=="true"){
                        if(worksname==2){
                            for(var iims=1;iims<4;iims++){
                                if(amGloble.metadata.configs['category_'+worksname+'_text'+iims]){
                                    newworks.push({
                                        category:worksname,
                                        subCategory:worksname+'0'+iims,
                                        subCategoryName:amGloble.metadata.configs['category_'+worksname+'_text'+iims]
                                    })
                                }
                            }
                        }else{
                            for(var iims=1;iims<10;iims++){
                                if(amGloble.metadata.configs['category_'+worksname+'_text'+iims]){
                                    newworks.push({
                                        category:worksname,
                                        subCategory:worksname+'0'+iims,
                                        subCategoryName:amGloble.metadata.configs['category_'+worksname+'_text'+iims]
                                    })
                                }
                            }
                        }
    
                    }
                }
                metaConfig.invention.subCategories=newworks;
            }
            var categories = metaConfig.invention.getInventionJSON();
            var activeCategories = [];
            //大类数据筛选
            for (var j = 0; j < categories.length; j++) {
                for (var i = 0; i < data.length; i++) {
                    if (categories[j].category == data[i].type && data[i].count > 0) {
                        var c = $.extend(true, {}, categories[j]);
                        //找到有内容的大类
                        //activeCategories["c"+categories[j].category] = c;
                        activeCategories.push(c);
                        break;
                    }
                }
            }
            // for(var i=0;i<data.length;i++){
            // 	if(data[i].count>0 && !activeCategories["c"+data[i].type]){
            // 		for (var j = 0; j < categories.length; j++) {
            // 			if(categories[j].category == data[i].type){
            // 				var c = $.extend(true,{},categories[j]);
            // 				//找到有内容的大类
            // 				activeCategories["c"+categories[j].category] = c;
            // 				activeCategories.push(c);
            // 				break;
            // 			}
            // 		}
            // 	}
            // }
            //小类数据筛选
            for (var i = 0; i < activeCategories.length; i++) {
                var subcate = activeCategories[i].subCategories;
                var newSub = [];
                for (var j = 0; j < subcate.length; j++) {
                    for (var k = 0; k < data.length; k++) {
                        if (subcate[j].subCategory == data[k].subType && data[k].count > 0) {
                            subcate[j].number = data[k].count;
                            newSub.push(subcate[j]);
                            break;
                        }
                    }
                }
                activeCategories[i].subCategories = newSub;
            }
            console.log("有数据的作品大类", activeCategories);
            //删除不勾选的大类,

            //找到隐藏的大类
            var noneArray=[];
            var oldArray=activeCategories;
            for(var none=1;none<7;none++){
                if(amGloble.metadata.configs['category_'+none]=="false"){
                       noneArray.push(none);
                }
            };
            if(noneArray.length>0){
                noneArray.map(function(item,index){
                    activeCategories.map(function(item1,index1){
                        if(item1.category==item){
                            oldArray.splice(index1,1)
                        }
                    })
                })
            }
            console.log("有数据并且有隐藏的作品大类", oldArray);
            amGloble.metadata.inventionCategories = oldArray;   
        
            $.each(amGloble.metadata.inventionCategories, function(i, item) {
                var $li = self.$li1.clone(true, true);
                if (self.currentItemData && self.currentItemData.category && self.currentItemData.category == item.category) {
                    $li.addClass("selected");
                }
                $li.find(".text").html(item.categoryName);
                $li.find(".icon").addClass("icon" + (i + 1));
                $li.data("item", item);
                $ul.append($li);
            });
            this.mainType.refresh();
            amGloble.page.archiveList.getOnePage(true);
        },
        openSecMenu: function($this) {
            var self = this;
            var $ul = this.$ul2.empty();
            var data = $this.data("item");

            if ($this.hasClass("selected2")) {
                $this.removeClass("selected2");
                this.hideSecMenu();
                this.currentItem1 = null;
                return;
            }

            this.currentItem1 = $this;

            $this.addClass("selected2").siblings().removeClass("selected2");

            var total = 0;
            $.each(data.subCategories, function(i, item) {
                var $li = self.$li2.clone(true, true);
                $li.html(item.subCategoryName + "<span class='small'>(" + (item.number || 0) + ")</span>");
                $li.data("item", item);
                if (self.currentItemData && self.currentItemData.subCategory && self.currentItemData.subCategory == item.subCategory) {
                    $li.addClass("selected");
                }
                $ul.append($li);
                total += item.number;
            });

            var allData = {
                category: data.category,
                subCategoryName: "全部"
            };

            var $all = self.$li2.clone(true, true).html("全部" + "<span class='small'>(" + total + ")</span>");
            if (this.currentItem1.hasClass("selected") && self.currentItemData.subCategory == null) {
                $all.addClass("selected");
            }
            $all.data("item", allData);
            $ul.prepend($all);
            this.showSecMenu();

        },
        showSecMenu: function() {
            this.$2.slideDown(200);
        },
        hideSecMenu: function() {
            this.$1.find(".selected2").removeClass("selected2");
            this.$2.slideUp(200);
        },

        getVal: function() {
            if (!this.currentItemData) {
                this.currentItemData = this.$ul1.find("li:first").addClass("selected").data("item");
                this.$subMenuText.html("全部");
            }
            return this.currentItemData;
        },
        resetVal:function(){
            this.currentItemData = null;
        },
        changeType: function($this) {

            var data = $this.data("item");

            this.currentItemData = data;
            this.currentItem1.addClass("selected").siblings().removeClass("selected");

            this.$subMenuText.html(data.subCategoryName);

            this.hideSecMenu();
            this.onchange && this.onchange(this.currentItemData);
        },
        onchange: function(data) {
            console.log(data);
        }
    };

    var self = amGloble.page.archiveList = new $.am.Page({
        id: "page_archiveList",
        backButtonOnclick: function() {
            if ($("#pswp_dom").is(":visible")) {
                amGloble.gallery.close();
            } else if($(".secTypeContainer").is(":visible")){
                typePicker.hideSecMenu();
                $.am.page.back();
            } else {
                $.am.page.back();
            }
        },
        init: function() {

            typePicker.init();
            typePicker.onchange = function() {
                self.scrollview.touchTop(3);
            };

            //
            this.$.find("span.createArchive").vclick(function() {
                amGloble.page.addArchive.changeToMe("slideup");
            });

            this.scrollview.$inner.bind("vtouchstart", function() {
                typePicker.hideSecMenu();
            });

            //列表页相关逻辑
            this.activityEle = new $.am.ScrollView({
                $wrap: $(".select_dynamic_box").find(".content_box_list"),
                $inner: $(".select_dynamic_box").find(".content_boxs"),
                direction: [0, 1]
            });
            this.$ul = this.$.find(".archiveList > ul");
            this.$li = this.$ul.find(":first").remove();
            this.$commentLi = this.$li.find(".commentsList > p:first").remove();

            this.$ul.empty();

            this.$ul.on("vclick", ".userHeader", function() {
                // //点击头像
            }).on("vclick", ".left > .like", function(e) {
                // //赞
            }).on("vclick", ".left > .share", function(e) {
                //分享
                e.stopPropagation();
                var $this = $(this);
                var $li = $this.parents("li");
                var data = $this.parents("li").data("item");
                console.log(data);

                var shareObj = {
                    title: "哎哟，不错哦~" + amGloble.metadata.userInfo.shopName + amGloble.getStoresById(data.shopId).shopFullName + data.empName + "近期作品「" + data.title + "」，你心动了吗？约起！",
                    link: amGloble.getShareRoot() + $.param({
                        tenantId: amGloble.metadata.userInfo.parentShopId,
                        view: 8,
                        modelId: data.id
                    }),
                    imgUrl: $li.find("ul.photos img").eq(0).attr("src"),
                    success: function() {
                    }
                };

                amGloble.share(shareObj);

            }).on("vclick", ".right > .comment", function(e) {
				//审核和取消审核
                e.stopPropagation();
                var $thisli = $(this).parents("li");
                var data = $thisli.data("item");
                if (data.visible) {
                    atMobile.nativeUIWidget.confirm({
                        caption: "取消审核",
                        description: "取消审核后此作品将不再显示在美一客，确认要取消吗?",
                        okCaption: "确定",
                        cancelCaption: "取消"
                    }, function() {
                        amGloble.loading.show();
                        amGloble.api.inventionVisible.exec({
                            id: data.id,
                            visible: 0
                        }, function(ret) {
                            amGloble.loading.hide();
                            if (ret.code == 0) {
                                data.visible = 0;
                                $thisli.find(".comment").text("审核");
                                $thisli.find(".mykVisible").text("待审核");
                                amGloble.msg("取消成功!");
                            } else {
                                amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                            }
                        });
                    }, function() {

                    });
                } else {
                    atMobile.nativeUIWidget.confirm({
                        caption: "审核",
                        description: "审核通过后作品将显示在美一客，确认审核吗?",
                        okCaption: "确定",
                        cancelCaption: "取消"
                    }, function() {
                        amGloble.loading.show();
                        amGloble.api.inventionVisible.exec({
                            id: data.id,
                            visible: 1
                        }, function(ret) {
                            amGloble.loading.hide();
                            if (ret.code == 0) {
                                data.visible = 1;
                                $thisli.find(".mykVisible").text("美一客可见");
                                $thisli.find(".comment").text("取消审核");
                                amGloble.msg("审核成功!");
                            } else {
                                amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                            }
                        });
                    }, function() {

                    });
                }
            }).on("vclick", ".right > .complain", function(e) {
				//删除
                e.stopPropagation();
                var $thisli = $(this).parents("li");
                var data = $thisli.data("item");
                atMobile.nativeUIWidget.confirm({
                    caption: "删除作品",
                    description: "确认要删除此作品吗?",
                    okCaption: "确定",
                    cancelCaption: "取消"
                }, function() {
                    amGloble.loading.show();
                    amGloble.api.delInvention.exec({
                        id: data.id,
                        empId:data.empId
                    }, function(ret) {
                        amGloble.loading.hide();
                        if (ret.code == 0) {
                            data.visible = 1;
                            $thisli.remove();
                            amGloble.msg("删除成功!");
                            self.refresh();
                        } else {
                            amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                        }
                    });
                }, function() {});
            }).on("vclick", ".center > .un_involved", function(e) {
				//参与投票活动
                e.stopPropagation();
                $(".un_involved").attr("data-that","");
                $(this).attr("data-that","selected");
                var submitData = $(this).parents("li.am-touchable").data("item");
                if (submitData.visible != 1) {
                    amGloble.msg('作品未审核，无法参赛')
                    return
                }
                self.$.find(".select_dynamic_box").data("data",submitData);
                amGloble.loading.show();
                amGloble.api.getVoteActive.exec({
                    "activityType":2,
                    "parentShopId": amGloble.metadata.userInfo.parentShopId,
                    "shopId": amGloble.metadata.userInfo.shopId,
                    "userId":amGloble.metadata.userInfo.userId
                }, function (res) {
                    amGloble.loading.hide();
                    console.log("获取参赛活动回调",res);
                    if(res.code == 0) {
                        if(res.content && res.content.length > 0) {
                            self.renderActive(res.content);
                            self.$.find(".select_dynamic_box").fadeIn();
                        } else {
                            amGloble.msg("暂时没有可参赛的活动！！");
                        }
                    } else {
                        amGloble.msg(res.message || "网络请求失败,请稍后再试！");
                    }
                });
            }).on("vclick", ".center > .has_involved .canvassing", function(e) {
                //拉票
                e.stopPropagation();
                var that = this;
                self.gotoMinipro(that,function(dataUrl){
                    amGloble.shareImage({
						title: '',
						imageBase64: dataUrl,
						success: function() {
							$.am.debug.log('shareImage success');
						},
						fail: function() {
							$.am.debug.log('shareImage fail');
						}
					})
                });
                // self.$.find(".shareVotePhoto").show();
                // amGloble.api.getSmallAppInfo.exec({
                //     id: window.config.parentShopId
                // }, function (ret) {
                //     console.log("ret====", ret)
                //     amGloble.loading.show("正在生成图片");
                //     if (ret.code == 0 && ret.content && ret.content.isSmallPro) { //用的小程序
                //         self.gotoMinipro(that);
                //     }
                // });
            }).on("vclick", ".center > .has_involved .downPic", function(e) {
                //下载海报
                e.stopPropagation();
                var that = this;
                self.gotoMinipro(that,function(dataUrl){
                    shareImageUtils.saveImageByBase64(dataUrl).catch(() => {
                        window.RouterUtils.push({
                            name: 'promotionbenefitShare',
                            params: {
                                base64Url: `data:image/png;base64,${dataUrl}`,
                                pageTitle: "作品海报",
                                bodyStyle: 'padding: 0;'
                            }
                        })
                    })
                });
            }).on("vclick", ".center > .has_involved .waiver", function(e) {
				//弃权
                e.stopPropagation();
                var submitData = $(this).parents("li.am-touchable").data("item");
                console.log("弃权数据==============================",submitData)
                var that = $(this);
                atMobile.nativeUIWidget.confirm({
                    caption: "弃权",
                    description: "确定弃权吗？",
                    okCaption: "是",
                    cancelCaption: "否"
                }, function() {
                    amGloble.loading.show();
                    amGloble.api.waiverFunc.exec({
                        "parentShopId": amGloble.metadata.userInfo.parentShopId,
                        "shopId": amGloble.metadata.userInfo.shopId,
                        "memId":amGloble.metadata.userInfo.userId,
                        // "activityId": submitData.votActivityId, //活动id
                        "activityType":2,
                        "inventionId": submitData.id //作品id
                    }, function (res) {
                        amGloble.loading.hide();
                        console.log("弃权回调",res);
                        if(res.code == 0) {
                            // self.getOnePage(true);
                            that.parents(".has_involved").siblings(".un_involved").show();
                            that.parents(".has_involved").hide();
                            that.parents(".actions").find('.right .complain').show();
                        } else {
                            amGloble.msg(res.message || "网络请求失败,请稍后再试！");
                        }
                    });
                })
            }).on("vclick", "ul.photos > li", function(e) {
				//看大图
                e.stopPropagation();
                var itemData = $(this).parents('li').data('item');
                if (itemData.videos) {
                    var options = {
                        catigoryId: itemData.type,
                        parentShopId: itemData.parentShopId,
                        authorId: itemData.empId,
                    }
                    $.am.videoPlayer.show({
                        poster: amGloble.photoManager.getPhotoUrl("show", options, itemData.photo ? itemData.photo.split(',')[0] : ''),
                        videoUrl: amGloble.photoManager.getPhotoUrl("show", options, itemData.videos)
                    })
                    return;
                }
                var items = [];
                var index = $(this).parent().children().index($(this));
                $(this).parent().find("img").each(function() {
                    var imageWidth = $(this).attr("w"),
						imageHeight = $(this).attr("h");
                    items.push({
                        src: $(this).attr("src").replace("_s", "_l"),
                        w: 2048,
                        h: (2048 * imageHeight)/imageWidth,
                    });
                    // items.push({
                    //     src: $(this).attr("src").replace("_s", "_l"),
                    //     w: $(this).attr("w")==256?1024:2048,
                    //     h: $(this).attr("w")==256?1024:2048,
                    // });
                });
                self.pswpTimer && clearTimeout(self.pswpTimer);
                amGloble.loading.show();
                self.pswpTimer = setTimeout(function() {
                    amGloble.loading.hide();
                    amGloble.pswp(items, index);
                }, 500);
            }).on("vclick", ".commentsList .del", function(e) {
				//删除评论
                e.stopPropagation();
                //删除评论
                var $this = $(this);
                var data = $this.parents("p").data("item");
                console.log(data);

                atMobile.nativeUIWidget.confirm({
                    caption: "删除评论",
                    description: "确定要删除这个评论吗？",
                    okCaption: "是",
                    cancelCaption: "否"
                }, function() {
                    amGloble.loading.show();
                    amGloble.api.inventionDeleteEvaluation.exec({
                        id: data.id,
                        //token : amGloble.token
                    }, function(ret) {
                        amGloble.loading.hide();
                        if (ret.code == 0) {
                            var $list = $this.parents(".commentsList");
                            $this.parent().remove();
                            if ($list.is(":empty")) {
                                $list.hide();
                            }

                            amGloble.msg("删除成功.");
                        } else {
                            amGloble.msg(ret.message || "数据提交失败,请检查网络!");
                        }
                    });
                }, function() {});

            });

            this.$select_dynamic_box = this.$.find(".select_dynamic_box");
            this.$select_dynamic_box.on("click", ".mask",function() {
                $(this).parents(".select_dynamic_box").fadeOut();
            }).on("click", ".cancel",function() {
                $(this).parents(".select_dynamic_box").fadeOut();
            }).on("click", ".dynamic_detail",function() {
                var activeData = $(this).parents(".content_box").data("data"),
                    activeData2 = $(this).parents(".select_dynamic_box").data("data");
                activeData.dynamicData = activeData2;
                $(this).parents(".select_dynamic_box").fadeOut();
                $.am.changePage(amGloble.page.participate, "slideleft", {
                    activeData:activeData
                });
                // self.goParticipate(activeData);
            })
            this.$canvassing_box = this.$.find(".canvassing_box");
            this.$canvassing_box.on("click", ".mask",function() {
                $(this).parents(".canvassing_box").hide();
            })
            this.$error = this.$.find("div.am-page-error");
            this.$error.find(".button-common").vclick(function() {
                if (self.$error.hasClass("listError")) {
                    self.scrollview.touchTop(3);
                } else {
                    self.getTypes();
                }
            });

            this.$empty = this.$.find("div.am-page-empty");

            this.$filter = this.$.find(".archiveFilterUl").find("li");
            this.$filter.vclick(function() {
                var i = self.$filter.index($(this));
                $(this).addClass("selected").siblings().removeClass("selected");
                typePicker.currentItemData = null;
                typePicker.hideSecMenu();
                self.getTypes();
            });

            this.$listEmpty = this.$.find("div.archiveList-empty");
        },
        // 渲染活动
        renderActive: function(data) {
            console.log("活动渲染数据",data);
            var $html = "";
            this.$.find(".select_dynamic_box .content_boxs").empty();
            for(var i = 0; i < data.length; i++) {
                $html = $(
                    '<div class="content_box">' +
                        '<div class="list_title">' + data[i].activityName + '</div>' +
                        '<div class="submit_time">' +
                            '<span>作品提交时间：</span>' +
                            '<span class="time_txt">' + (new Date(data[i].competitionTimeStart).format("yyyy.mm.dd") + '-' + new Date(data[i].competitionTimeEnd).format("yyyy.mm.dd")) + '</span>' +
                        '</div>' +
                        '<div class="submit_time vote_time">' +
                            '<span>投票时间：</span>' +
                            '<span class="time_txt">' + (new Date(data[i].voteTimeStart).format("yyyy.mm.dd") + '-' + new Date(data[i].voteTimeEnd).format("yyyy.mm.dd")) + '</span>' +
                        '</div>' +
                        (data[i].partake == 1?
                        '<div class="dynamic_detail">' +
                            '<span class="trophy iconfont icon-trophy"></span>' +
                            '<span>详情</span>' +
                        '</div>':
                        '<div class="dynamic_detail1">' +
                            '<span>已参赛</span>' +
                        '</div>') +
                    '</div>'
                )
                $html.data("data",data[i]);
                this.$.find(".select_dynamic_box .content_boxs").append($html);
            }
            this.activityEle.refresh();
        },
        // 点击拉票如果是小程序用户则绘制成一张图片分享给好友
gotoMinipro: function (that,callback) {
            amGloble.loading.show("正在生成图片");
            var $li = $(that).parents('li');
            var _item = $li.data('item');
            console.log("分享数据",_item);
            var user = amGloble.metadata.userInfo;
            // 作品图片
            if(_item.photo) {
                var imgUrl = _item.photo.split(",");
                var $img = amGloble.photoManager.getPhotoUrl("show", {
                    catigoryId: _item.type,
                    parentShopId: _item.parentShopId,
                    authorId: _item.empId
                }, imgUrl[0], "s");
            }
            if($(that).parents("li").find(".userHeader img").attr("data-load")) {
                // 作品作者头像
                var $head;
                if (_item.empType != 1) {
                    $head = amGloble.photoManager.getPhotoUrl("manager", {
                        parentShopId: amGloble.metadata.userInfo.parentShopId
                    }, _item.empId + ".jpg", "s");
                } else {
                    $head = amGloble.photoManager.getPhotoUrl("artisan", {
                        parentShopId: amGloble.metadata.userInfo.parentShopId
                    }, _item.empId + ".jpg", "s");
                }

                $('.shareVotePhoto .avatar_box .avatar_img').attr("src", $head);
            } else {
                $('.shareVotePhoto .avatar_box .avatar_img').attr("src", "css/img/MYK/head_male.png");
            }
            $('.shareVotePhoto .productImg img').attr("src", $img);
            // $('.shareVotePhoto .avatar_box .avatar_img').attr("src", $head);
            var shopName = user.osName.trim() || user.shopName
            $('.shareVotePhoto .user_box .user_name').text(shopName + "-" + _item.empName);
            $('.shareVotePhoto .shareVoteTitle').text(amGloble.cutString(_item.title,80));
            if(_item.votActivityId && _item.votActivityId != "null") {
                var qrImgSrc = config.miniProUrl + "/xcx/qrCode/?tenantId=" + window.config.parentShopId + "&page=pages/mine/index&scene=61@" + _item.votActivityId + "_" + _item.empId + "_2";
            } else {
                amGloble.loading.hide();
                amGloble.msg("网络请求失败，请刷新重新！！");
                return
            }
            console.log("二维码路径",qrImgSrc);
            $.am.debug.log("二维码路径"+qrImgSrc);
            $('.shareVotePhoto .qrImg').attr("src", qrImgSrc);
            $('.shareVotePhoto').show();
            var shareDom = document.getElementById('shareVotePhoto');
            var canvas=document.createElement('canvas');
            var ctx = canvas.getContext('2d');
            if (window.device.platform == "iOS") {
                canvas.width = shareDom.clientWidth * 2;
                canvas.height = shareDom.clientHeight * 2;
                ctx.scale(2, 2);
            } else {
              var scaleSize = 2.75;
              canvas.width = shareDom.clientWidth * scaleSize;
              canvas.height = shareDom.clientHeight * scaleSize;
              ctx.scale(scaleSize, scaleSize);
            }
            
            html2canvas(shareDom, {
                canvas:canvas,
                useCORS:true,
                onrendered: function (canvas) {
                    // document.body.appendChild(canvas)
                    var context = canvas.getContext('2d');
                    // 【重要】关闭抗锯齿
                    context.mozImageSmoothingEnabled = false;
                    context.webkitImageSmoothingEnabled = false;
                    context.msImageSmoothingEnabled = false;
                    context.imageSmoothingEnabled = false;
                    var clientHeight=canvas.height;
                    var clientWith=canvas.width;
                    if( window.device.platform == "iOS"){
                        clientHeight=clientHeight*2;
                        clientWith=clientWith*2;
					}
					var img = Canvas2Image.convertToImage(canvas, clientWith,clientHeight);
					dataUrl = img.src.substring(22);
					$('.shareVotePhoto').hide();
					amGloble.loading.hide();
					$.am.debug.log('shareImage before');
					callback(dataUrl)
                }
            });
        },
        beforeShow: function(paras) {
            this.$.find('.actions').removeClass('audit');
            this.$.find(".archiveFilterUl").parent().show();
            if (amGloble.metadata.userInfo.userType == 1) {
                //员工，全部/我的
            }else{
                //管理员
                this.$filter.eq(1).text("管理");
                //全部/管理
                if(amGloble.metadata.userInfo.newRole==3){
                    //总部老板，不显示tab
                    this.$.find(".archiveFilterUl").parent().hide();
                }
            }
            if(paras && paras.EMPID){
                this.EMP = paras;
                this.$.find(".archiveFilterUl").parent().hide();
                this.$header.find('.right').hide();
            }else {
                this.EMP = null;
                this.$header.find('.right').show();
            }
            if(paras == "backSign") {
                var participateList = this.$.find(".un_involved");
                for(var i = 0; i < participateList.length; i++) {
                    if($(participateList[i]).attr("data-that") == "selected") {
                        $(participateList[i]).siblings(".has_involved").show();
                        $(participateList[i]).hide();
                    }
                }
            } else {
                this.$.find(".un_involved").attr("data-that","");
            }
            console.log("所有数据888888888888888888",amGloble)
            this.getOnePage(true);
            typePicker.resetVal();
        },
        afterShow: function(paras) {
            if (paras == "forceRefresh" || new Date().getTime() - this.refreshTime > 7200000 || (paras && paras.EMPID)) {
                // if(this.pageNumber){
                // 	this.scrollview.touchTop(3);
                // }else{
                this.getTypes();
                this.setStatus("loading");
                //this.getOnePage(true);
                //}
            }
        },
        beforeHide: function(paras) {
            $("#pswp_dom").removeClass("pswp--open");
        },
        //列表加载逻辑
        refreshTime: 0,

        refreshPage: function() {
            self.setStatus("normal");
            this.getOnePage(true);
        },
        getPeriod:function(arr){
            var start = arr[0],end = arr[1];
            var period = new Date(start).format('yyyy-mm-dd')+'_'+new Date(end).format('yyyy-mm-dd');
            return period;
        },
        getOnePage: function(clear) {
            var self = this;
            var type = typePicker.getVal();
            if (clear) {
                this.pageNumber = 0;
            }
            opt = {
                pageNumber: this.pageNumber,
                pageSize: this.pageSize,
                // barberId : barber ? barber.userid : null,
                type: type ? type.category : null,
                subType: type ? type.subCategory : null
            };
            if(this.EMP){
                opt.empId = this.EMP.EMPID;
                opt.shopIds = [this.EMP.shopId];
                opt.period = this.getPeriod(this.EMP.time);
            }else {
                var tab = this.$filter.index(this.$filter.filter(".selected"));
                if (tab) {
                    if (amGloble.metadata.userInfo.userType == 1) {
                        opt.empId = amGloble.metadata.userInfo.userId;
                    } else if (amGloble.metadata.userInfo.userType == 0) {
                        var shops = amGloble.metadata.shops;
                        if (shops) {
                            opt.shopIds = [];
                            for (var s = 0; s < shops.length; s++) {
                                opt.shopIds.push(shops[s].shopId);
                            }
                        }
                    }
                }
            }

            this.getData(opt, function(data) {

                if (data.code == 0) {
                    var list = data.content;
                    //刷新时的处理
                    if (clear) {
                        self.refreshTime = new Date().getTime();
                        self.$ul.empty();
                        self.scrollview.scrollTo("top");
                    }
                    if (list.length) {
                        self.pageNumber++;
                    }
                    if (self.pageSize > list.length) {
                        self.scrollview.pauseTouchBottom = true;
                    } else {
                        self.scrollview.pauseTouchBottom = false;
                    }
                    self.appendList(list);
                } else {
                    if (clear) {
                        self.setStatus("error");
                        self.$error.addClass("listError");
                    }
                }

                self.closeTopLoading();
                self.closeBottomLoading();
                if (clear) {
                    self.scrollview.scrollTo("top");
                }
            });
        },
        amDragTopTips: ["下拉刷新列表", "松开开始加载", "加载中..."],
        amDragBottomTips: ["上拉加载更多", "松开开始加载", "加载中..."],
        touchTop: function() {
            this.refreshPage();
        },
        touchBottom: function() {
            this.getOnePage();
        },

        //私有逻辑
        pageSize: 10,
        createItem: function(item) {
            var editable = 0;
            if (amGloble.metadata.userInfo.userType == 1 && item.empId == amGloble.metadata.userInfo.userId) {
                editable = 1;
            } else if (amGloble.metadata.userInfo.userType == 0) {
                var shops = amGloble.metadata.shops;
                if (shops) {
                    for (var s = 0; s < shops.length; s++) {
                        if (item.shopId == shops[s].shopId) {
                            editable = 1;
                            break;
                        }
                    }
                }
            }
            var $li = self.$li.clone(true, true);

            var type = "";
            if (item.empLevelName) {
                type = "<span class='type'>" + item.empLevelName + "</span>";
            }
            // 显示参与投票活动(或拉票弃权)按钮  ----非小程序用户不显示,非本人账号不显示,作品创建时间是30天以前的不显示
            if(item.smallPro && amGloble.metadata.userInfo.userId == item.empId && (new Date().getTime() - item.createTime < 30 * 24 * 60 * 60 * 1000)) {
                if(item.votActivityId) {
                    $li.find(".has_involved").show();
                    $li.find(".right .complain").hide();
                    $li.find(".un_involved").hide();
                } else {
                    $li.find(".has_involved").hide();
                    $li.find(".un_involved").show();
                    $li.find(".right .complain").show();
                }
            } else {
                $li.find(".has_involved").hide();
                $li.find(".un_involved").hide();
                $li.find(".right .complain").show();
            }
            //美发师名字级别
            $li.find(".userName").html(item.empName + type);

            //头像
            var $head;
            if (item.empType != 1) {
                // if (amGloble.metadata.configs && amGloble.metadata.configs.v4_tenantLogo) {
                //     $head = amGloble.photoManager.createImage("tenantLogo", {
                //         parentShopId: amGloble.metadata.userInfo.parentShopId
                //     }, amGloble.metadata.configs.v4_tenantLogo);
                // }
                $head = amGloble.photoManager.createImage("manager", {
                    parentShopId: amGloble.metadata.userInfo.parentShopId
                }, item.empId + ".jpg", "s");
            } else {
                $head = amGloble.photoManager.createImage("artisan", {
                    parentShopId: amGloble.metadata.userInfo.parentShopId
                }, item.empId + ".jpg", "s");
            }

            if ($head) {
                $li.find(".userHeader").empty().append($head);
            } else {
                $li.find(".userHeader").empty();
            }

            //门店和发布时间
            $li.find(".store").html(amGloble.getStoresById(item.shopId).shopFullName);
            $li.find(".postTime").html(amGloble.time2str(Math.round(item.createTime / 1000)));

            //描述
            $li.find(".text").html(item.title);
            if (item.price) {
                $li.find(".price").css("display", "inline-block").html("门店价：￥" + item.price);
            } else {
                $li.find(".price").hide();
            }

            if (!item.visible) {
                $li.find(".mykVisible").text("待审核");
            }
            //图片列表
            var $photos = $li.find(".photos").empty();
            var photos = item.photo.split(",");
            var videoPoster = item.videos ? '<span><i class="iconfont icon-bofang"></i></span>' : '';
            $.each(photos, function(j, itemj) {
                var w = Math.floor(($(".am-widthLimite").width() - 80) / 3);
                if (itemj) {
                    var $img = amGloble.photoManager.createImage("show", {
                        catigoryId: item.type,
                        parentShopId: item.parentShopId,
                        authorId: item.empId,
                        updateTs: 1,
                    }, itemj, "s");
                    $photos.append($("<li class='am-clickable'>"+ videoPoster +"</li>").css({
                        width: w,
                        height: w
                    }).append($img));
                    var img = new Image();
                    img.src = $img.attr('src');
                    img.onload = function(){
                        $img.attr('w',this.width);
                        $img.attr('h',this.height);
                    }
                }
            });

            if (photos.length == 1) {
                $photos.addClass("onlyOne");
            }

            //赞和分享次数

            if (localStorage.getItem("like" + item.id)) {
                $li.find(".like").addClass("am-disabled").html(item.likes || 0);
            } else {
                $li.find(".like").html(item.likes || 0);
            }

            $li.find(".share").html(item.shares || 0);
            //预约按钮
            //if (!item.empAvailable) {
            $li.find(".reseration").hide();
            //}
            if (editable) {
                if (item.visible) {
                    $li.find(".comment").text("取消审核");
                } else {
                    $li.find(".comment").text("审核");
                }
                if (amGloble.metadata.userInfo.userType == 1) {
                    $li.find(".comment").hide();
                }
            } else {
                $li.find(".complain").hide();
                $li.find(".comment").hide();
            }


            //评论列表

            var $comments = $li.find(".commentsList").empty();
            if (item.inventionEvaluations && item.inventionEvaluations.length) {
                $.each(item.inventionEvaluations, function(j, itemj) {
                    var $cli = self.$commentLi.clone(true, true);
                    var delBtn = "";
                    if (editable) {
                        delBtn = '<span class="am-clickable del">删除</span>';
                    }

                    $cli.html('<span class="name">' + itemj.memName + '：</span>' + itemj.content + delBtn);
                    $cli.data("item", itemj);
                    $comments.append($cli);
                });
            } else {
                $comments.hide();
            }
            //新手指引

            if(this.EMP){
                $li.find('.actions').addClass('audit');
            }else{
                $li.find('.actions').removeClass('audit');
            }

            $li.data("item", item);
            return $li;
        },
        appendList: function(list) {
            //zjy
            console.log(list,'87999999999999999')
            var self = this;
            var $ul = this.$ul;
            if (list && list.length) {
                $.each(list, function(i, item) {
                    $ul.append(self.createItem(item));
                });
            }

            if ($ul.is(":empty")) {
                self.setStatus("empty");
                self.$empty.addClass("listEmpty");
            } else {
                self.setStatus("normal");
            }

            self.refresh();
        },
        getData: function(opt, scb) {
            amGloble.api.inventionList.exec($.extend({
                tenantId: amGloble.metadata.tenantId
            }, opt), function(ret) {
                if (ret.code == 0) {
                    console.log(ret);
                    scb && scb(ret);
                } else {
                    if (self.$ul.children(":not(.empty)").length) {
                        amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                    } else {

                    }
                    scb && scb({
                        code: -1,
                        msg: ""
                    });
                }
            });
        },
        getTypes: function() {
            var self = this;
            this.setStatus("loading");
            var opt = {};
            if(this.EMP){
                opt.empId = this.EMP.EMPID;
                opt.shopIds = [this.EMP.shopId];
                opt.period = this.getPeriod(this.EMP.time);
            }else {
                var tab = this.$filter.index(this.$filter.filter(".selected"));
                if (tab) {
                    if (amGloble.metadata.userInfo.userType == 1) {
                        opt.empId = amGloble.metadata.userInfo.userId;
                    } else if (amGloble.metadata.userInfo.userType == 0) {
                        var shops = amGloble.metadata.shops;
                        if (shops) {
                            opt.shopIds = [];
                            for (var s = 0; s < shops.length; s++) {
                                opt.shopIds.push(shops[s].shopId);
                            }
                        }
                    }
                }
            }
            amGloble.api.inventionSubTypes.exec(opt, function(ret) {
                if (ret.code == 0) {
                    if (ret.content.length) {
                        typePicker.render(ret.content);
                    } else {
                        self.setStatus("empty");
                        self.$empty.removeClass("listEmpty");
                    }
                } else {
                    self.setStatus("error");
                    self.$error.removeClass("listError");
                }
            });
        }
    });
})();
