
amGloble.page.customerCreatFile = new $.am.Page({
    id: "page-customerCreatFile",
    init: function() {
        var _this = this;
        /*this.$.find(".submit").vclick(function () {
            $.am.page.back("slidedown");
        });*/
        this.$header.find(".left").vclick(function() {
            $.am.page.back("slidedown");
        });

        this.$text = this.$.find("textarea");
        this.$save = this.$.find("div.submit,span.right").vclick(function() {
            var comment = _this.$text.val();
            if (comment.length < 1 && comment.length > 200) {
                amGloble.msg("请输入1-200个字符客户档案内容！");
                return;
            }
            var categoryChecked = $('.creatCustInfo_form .archives div.active').data() || {};
            var categoryId = categoryChecked.id || undefined;
            // if(!categoryId && _this.data.archiveList && _this.data.archiveList.length) {
            //     amGloble.msg('请先选择档案类型'); 
            //     return;
            // }
            if (_this.$photos.find('.multiple_upload_loading').length) {
                amGloble.msg("您还有图片在上传，请等待上传完毕后再上传！");
                return;
            }
            amGloble.loading.show();
            var imgs = _this.$photos.find('.photo:visible');
            var imgArr = [];
            var videoFileNameList = [];
            for(var i=0;i<imgs.length;i++){
                var id = $(imgs[i]).data('id');
                var type = $(imgs[i]).data("type")
                if(id){
                    if (type === 'video') {
                        videoFileNameList.push(id);
                    } else {
                        imgArr.push(id);
                    }
                }
            }
            var user = amGloble.metadata.userInfo;
            amGloble.api.customerAddArchives.exec({
                "memId": _this.data.id,
                "shopId": _this.data.storeId,
                "userType": user.userType,
                "userId": user.userId,
                "userName": user.userName,
                "categoryId": categoryId,
                "archives": comment,
                "imgs": imgArr.join(','),
                "videos": videoFileNameList.join(',')
            }, function(ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    amGloble.msg("添加成功");
                    $.am.page.back("slidedown");

                    //将客户档案页码消0
                    setTimeout(function(){
                        amGloble.page.customerDetail.data.meta.archivesCount++;
                        amGloble.page.customerDetail.custProfile.pageIndex = 0;
                        amGloble.page.customerDetail.custProfile.$list.empty();
                        amGloble.page.customerDetail.tab.$inner.find("li:eq(0)").trigger("vclick");
                    },300);
                } else {
                    amGloble.msg(ret.message || "提交失败");

                }
            });
        });

        this.$photos = this.$.find('.photos').on('vclick','.add_image',function(){
            var $this = $(this);
            var opt = {
                parentShopId: amGloble.metadata.userInfo.parentShopId,
            };
            if (amGloble.canUseGetPictures()) {
                var count = _this.videoThumb ? 1 : 9 - _this.$photos.find('img').length;
                amGloble.photoManager.multipleUploadPhoto("customerFile", opt, {maximumImagesCount: count}, function(imgUrl) {
                    var $li = $('<div class="photo"><div class="photos_close am-clickable"><i class="iconfont icon icon-close-b"></i></div></div>');
                    $li.append('<img width="100%" src="data:image/png;base64,'+ imgUrl +'"/>');
                    _this.$photos.find('.add_image').before($li);
                    var imageLength = _this.$photos.find("img").length;
                    if (imageLength > 0) {
                        _this.$photos.find('.add_video').hide();
                    }
                    if (imageLength >= 9 || _this.videoThumb) {
                        _this.$photos.find('.add_image').hide();
                    }
                    return $li;
                }, function(uuid, $dom) {
                    $.am.debug.log('uuid: ' + uuid);
                    $dom.data('id', uuid);
                })
            } else {
                amGloble.photoManager.takePhoto('customerFile', opt, function(uuid) {
                    $this.html(amGloble.photoManager.createImage('customerFile', opt, uuid, "s"));
                    $this.removeClass('iconfont icon-xiangji');
                    $this.data("id",uuid);
                    if(_this.$photos.find('.photo').length < 9) {
                        _this.$photos.append('<div class="photo add am-clickable iconfont icon-xiangji"></div>');
                    }
                }, function() {
                    console.log("fail");
                });
            }
        }); 
        this.$.find('.photos').on('vclick','.photos_close',function(e){
            e.stopPropagation();
            $(this).parent().remove();
            var imageLength = _this.$photos.find("img").length;
            if (imageLength < 9) {
                if (imageLength === 0) {    
                    _this.$photos.find('.add_video').show();
                }
                _this.$photos.find('.add_image').show();
            }
        })

        this.$.find(".photos").delegate(".add_video", "vclick", function() {
            var $this = $(this);
            var user = amGloble.metadata.userInfo;
            var opt = {
                parentShopId: user.parentShopId,
            };
            var filePath = imageConfig.getImageUrl('customerFile', opt, '');
            var remoteUrl = config.baseUrl + 'shengyibao/shop/uploag?fileName=' + filePath;
            atMobile.getVideo({}, function(result) {
                var videoData = JSON.parse(result[0]);
                _this.videoThumb = videoData.thumb;
                var $li = $('<div class="photo"><i class="iconfont icon-bofang uploaded_video"></i><div class="video_close am-clickable"><i class="iconfont icon icon-close-b"></i></div></div>');
                $li.append('<img width="100%" src="data:image/png;base64,'+ _this.videoThumb +'"/>');
                $li.data('type', 'video');
                var addImageDOM = _this.$photos.find('.add_image');
                addImageDOM.before($li);
                _this.$photos.find('.add_video').hide();
                amGloble.loading.show('视频压缩中...');
                var toastParams = ['原尺寸：' + (videoData.size / 1024 / 1024).toFixed(2)]
                var startTime = new Date().getTime();
                atMobile.compressVideo({ uri: videoData.uri, quality: 3 }, function(data) {
                    console.log('视频压缩 callback', data);
                    if (data.status == 2) {
                        toastParams.push('压缩时间：' + ((new Date().getTime() - startTime) / 1000).toFixed(2));
                        amGloble.loading.hide();
                        amGloble.loading.show('视频上传中...');
                        var fileName = Math.uuid() + '.mp4';
                        var updateOpt = {
                            localUri: data.path,
                            fileName: fileName,
                            remoteUrl: remoteUrl + fileName,
                        }
                        toastParams.push('尺寸：' + (data.size / 1024 / 1024).toFixed(2))
                        var uploadTime = new Date().getTime();
                        atMobile.uploadVideo(updateOpt, function() {
                            toastParams.push('上传时间：' + ((new Date().getTime() - uploadTime)/ 1000).toFixed(2));
                            $.am.debug.log(toastParams.join('；'));
                            $li.data("id", updateOpt.fileName);
                            var thumbUrl = 'data:image/png;base64,'+ _this.videoThumb;
                            if (addImageDOM.find('img').length) {
                                addImageDOM.find('img').attr('src', thumbUrl);
                            } else {
                                addImageDOM.addClass("thumb");
                                addImageDOM.append('<img width="100%" src="'+ thumbUrl +'"/>').find('.add_action span').text('替换封面');
                                addImageDOM.find('.add_action').addClass("video_post_cover");
                            }
                            var typeOption = imageConfig.getOptionObj("customerFile", opt);
                            delete typeOption.variationList;
                            delete typeOption.size;
                            typeOption.imageBase64 = _this.videoThumb;
                            amGloble.photoManager.uploadPhotoBase64(_this.videoThumb, typeOption,  function(uuid) {
                                addImageDOM.data('id', uuid);
                                amGloble.loading.hide();
                            }, function() {
                                amGloble.loading.hide();
                                amGloble.msg('上传封面图失败!')
                            })
                        }, function() {
                            amGloble.msg('上传失败!')
                            var addVideoDom = _this.$photos.find('.add_video');
                            addVideoDom.show().siblings().remove();
                            addVideoDom.before($(_this.addImageLi));
                            _this.videoThumb = null;
                            amGloble.loading.hide();
                        })
                    } else if (data.status == 3) {
                        amGloble.loading.hide();
                        amGloble.msg(data ? JSON.stringify(data) : '压缩视频失败了...');
                    }
                }, function(res) {
                    amGloble.loading.hide();
                    amGloble.msg(res ? JSON.stringify(res) : '压缩视频失败...');
                })
            }, function(result) {
                amGloble.msg('失败了')
                amGloble.msg(JSON.stringify(result))
            })

        }).delegate('.video_close', 'vclick', function() {
            _this.videoThumb = null;
            var addVideoDom = _this.$photos.find('.add_video');
            addVideoDom.show().siblings().remove();
            addVideoDom.before($(_this.addImageLi));
        })
        this.$archives =  $('.creatCustInfo_form .archives').on('vclick', 'div.item', function(e){
            var $this = $(this);
            if($this.hasClass('active')) {
                $this.removeClass('active');
            } else {
                $this.addClass('active').siblings().removeClass('active');
            }
        })
    },
    beforeShow: function(paras) {
        this.videoThumb = '';
        this.addImageLi = '<div class="add photo add_image am-clickable"><div class="add_action"><i class="iconfont icon-paizhao"></i><span>上传图片</span></div></div>';
        var $li = $(this.addImageLi);
        this.$photos.html($li);
        if (amGloble.canUseGetVideo()) {
            this.$photos.append($('<div class="add photo add_video am-clickable"><div class="add_action"><i class="iconfont icon-shipin"></i><span>上传视频</span></div></div>'));
        }

        this.data = paras;
        this.render();
    },

    afterShow: function() {
        var _this = this;
        setTimeout(function() {
            _this.$text.attr("disabled", false);
        }, 200);
    },
    beforeHide: function() {
        this.$text.attr("disabled", true);
    },
    gender: {
        "M": "先生",
        "F": "女士"
    },
    render: function() {
        this.$header.find("p").text(this.data.name + (this.gender[this.data.gender] || ""));
        this.$text.val("");
        if(this.data.archiveList && this.data.archiveList.length) {
            var list = this.data.archiveList;
            this.$archives.html('');
            for(var i = 0; i < list.length; i++) {
                var $dom = $('<div class="item am-clickable">'+ list[i].name +'</div>');
                $dom.data(list[i]);
                this.$archives.append($dom);
            }
            $('.creatCustInfo_form .archives_box').show();
        } else {
            $('.creatCustInfo_form .archives_box').hide();
        }
    }
});
