(function(){
    var self = amGloble.page.iosInput = new $.am.Page({
		id: 'page-iosInput',
		disabled: false,
        init: function(){
			this.$wrap = this.$.find('.add_tag_input_wrap');
			this.$detaultInput = this.$.find('input');
			this.$title = this.$.find('.am-header > p');
            this.$header.find('.left').vclick(function() {
                $.am.page.back('slidedown');
			});
			this.$header.find('.right').vclick(function(){
				if (self.disabled) return;
				self.disabledSubmit();
				var val = self.$input.val();
				if(!val)  return;
				self.callbackFn(val, self.enableSubmit);
            });
		},
		enableSubmit: function() {
			self.disabled = false;
		},
		disabledSubmit: function(){
			this.disabled = true;
		},
        beforeShow: function(params){
			this.enableSubmit();
			if (params.type == 'textarea') {
				this.$input = $('<textarea class="input_content"></textarea>');
			} else {
				this.$input = this.$detaultInput;
			}
			this.$wrap.html('').append(this.$input);
			this.fromPage = params.fromPage;
			this.callbackFn = params.callbackFn;
			this.$input.attr('placeholder', params.placeholder);
			this.$title.html(params.title);
			var attrs = params.attrs;
			if (attrs) {
				self.attrs = attrs;
				for (var attrKey in attrs) {
					this.$input.attr(attrKey, attrs[attrKey]);
				}
			}
			this.$input.val('');
		},
    });
})();