amGloble.page.participate = new $.am.Page({
    id: "page_participate",
    init: function () {
        var self = this;
        self.participateContent = new $.am.ScrollView({
            $wrap: self.$.find(".am-body"),
            $inner: self.$.find(".participate_content"),
            direction: [0, 1]
        });

        self.$.on("click", ".submit_participate_btn", function () {
            console.log("所有数据1",amGloble)
            var submitDat = self.parasData.activeData;
            console.log("提交参赛活动数据",submitDat)
            amGloble.loading.show();
            amGloble.api.submitParticipate.exec({
                'parentShopId':amGloble.metadata.userInfo.parentShopId,
                'shopId':amGloble.metadata.userInfo.shopId,
                'activityType':submitDat.activityType, //活动类型
                'activityId':submitDat.id, //活动id
                'inventionId':submitDat.dynamicData.id //作品id
            }, function (res) {
                amGloble.loading.hide();
                console.log("提交参赛活动回调",res);
                if(res.code == 0) {
                    amGloble.msg("活动参与成功！");
                    $.am.page.back("slidedown","backSign");
                    // $.am.changePage(amGloble.page.archiveList, "slideright");
                } else {
                    amGloble.msg(res.message || "网络请求失败,请稍后再试！");
                }
            });
        });
    },
    // 渲染活动规则
    renderActRule: function(data) {
        var $html = "";
        this.$.find(".participate_rule .content_lists").empty();
        for(var i = 0; i < data.length; i++) {
            $html = $(
                '<div class="content_list">' + data[i] + '</div>'
            )
            this.$.find(".participate_rule .content_lists").append($html);
        }
        this.participateContent.refresh();
    },
    beforeShow: function (paras) {
        console.log("传过来的数据",paras);
        if(paras) {
            this.parasData = paras;
            var data = paras.activeData,
                submitTime = new Date(data.competitionTimeStart).format("yyyy.mm.dd") + '-' + new Date(data.competitionTimeEnd).format("yyyy.mm.dd"),
                voteTime = new Date(data.competitionTimeStart).format("yyyy.mm.dd") + '-' + new Date(data.competitionTimeEnd).format("yyyy.mm.dd");
            this.$.find(".list_title").text(data.activityName);
            this.$.find(".submit_time1 .time_txt").text(submitTime);
            this.$.find(".vote_time .time_txt").text(voteTime);
            var ruleContent = data.remark.replace(/\r\n/g, '\n').split("\n");
            this.renderActRule(ruleContent);
        }
    },
    afterShow: function () {

    },
});
