(function () {
    var self = amGloble.page.promotionbenefit = new $.am.Page({
		id: "page-promotionbenefit",
		noticeMarquee: null,
        init: function () {
            var self = this;
            this.$amHeader = this.$.find('.am-header');
            this.$text = this.$.find('.title .text');
            this.$amBodyInner = this.$.find('.am-body-inner');
            this.$extensionWrap = this.$.find('.extensionWrap');
            this.$menuListWrapInnerUl = this.$.find('.menuListWrapInner ul');
            this.$contentListWrapInnerUl = this.$.find('.contentListWrapInner ul');
            this.$footTab = this.$.find('.footTab');
			this.$extensionEmpty = this.$.find('.extension-empty');
			this.$benefitReportBtn = this.$.find('.benefit_report_btn');
            //推广左侧菜单
            this.menuListWrap = new $.am.ScrollView({
                $wrap: this.$.find(".menuListWrap"),
                $inner: this.$.find(".menuListWrapInner"),
                direction: [0, 1]
            });
            this.menuListWrap.refresh();
            //推广右侧列表
            this.contentListWrap = new $.am.ScrollView({
                $wrap: this.$.find(".contentListWrap"),
                $inner: this.$.find(".contentListWrapInner"),
                direction: [0, 1]
            });
            this.contentListWrap.refresh();
            //推广左侧菜单点击事件
            this.$menuListWrapInnerUl.on('vclick', 'li', function () {
                $(this).addClass('on').siblings('li').removeClass('on');
                var _subCategoryId = $(this).data('subcategoryid');
                var _category = $(this).data('category');

                amGloble.loading.show("查询中,请稍候...");
                var opt={
                    category: _category,
					subCategory: _subCategoryId,
					includeZeroCampaignMoney: false,
					newFlag: 1
                }
                // if(self.isSmallPro){
                //     opt.newFlag='1';
                // }
                amGloble.api.queryMallItem.exec(opt, function (ret) {
                    amGloble.loading.hide();
                    if (ret.code == 0) {
                        self.renderQueryMallItem(ret.content);
                    } else {
                        amGloble.msg(ret.message || "数据获取失败,请重试!");
                    }
                });

            });
            //点击小类明细
            this.$contentListWrapInnerUl.on('vclick', 'li', function () {
                var user = amGloble.metadata.userInfo;
                var _item = $(this).data('item');
                var url = amGloble.getShareRoot() + $.param({
                    tenantId: user.parentShopId,
                    view: 4,
                    modelId: _item.id,
                    promoteUser: user.userType + "_" + user.userId
                });
                window.open(url, '_blank', 'location=no');
            });
            this.$extensionWrap.on('vclick', '.tip-extension a', function (e) {
				e.stopPropagation();
				amGloble.loading.show("正在生成图片");
                var that = this;
                amGloble.api.getSmallAppInfo.exec({
                    id: window.config.parentShopId
                }, function (ret) {
                    // 分享链接已作了区分集群，此处不做处理
                    if (ret.code == 0 && ret.content && ret.content.isSmallPro) { //用的小程序
                        self.gotoMallMinipro(that);
                    } else { //跳转web
                        self.gotoMallWeb(that);
                    }
                });
            })
            //我要推广
            this.$contentListWrapInnerUl.on('vclick', '.promotionbenefit .generalize_btn', function (e) {
				e.stopPropagation();
				amGloble.loading.show("正在生成图片");
                var that = this;
                amGloble.api.getSmallAppInfo.exec({
                    id: window.config.parentShopId
                }, function (ret) {
                    if (ret.code == 0 && ret.content && ret.content.isSmallPro) { //用的小程序
                        self.gotoMinipro(that);
                    } else { //跳转web
                        self.gotoWeb(that);
                    }
                });


                // var shareObj = {
                //     title: user.shopName + "精品推荐 - " + _item.name,
                //     link: amGloble.getShareRoot() + $.param({
                //         tenantId: user.parentShopId,
                //         view: 4,
                //         modelId: _item.id,
                //         promoteUser: user.userType + "_" + user.userId
                //     }),
                //     imgUrl: _imgUrl,
                //     success:function(){}
                // };

            });
            //推广,收益tab切换
            this.$footTab.on('vclick', 'span', function () {
                $(this).addClass('selected').siblings('span').removeClass('selected');
                var _index = $(this).index();
                if (_index == 0) { //推广
                    self.showExtension();
					self.queryMallItemCategory();
					self.hideBenefitReportBtn();
					self.noticeMarquee && self.noticeMarquee.marquee('destroy');
				} else if (_index == 1) { //收益
					self.showBenefitReportBtn();
                    self.showProfit();
                    self.queryPromoteData();
                    self.refresh();
					self.scrollview.scrollTo("top");
					self.noticeMarquee && self.noticeMarquee.marquee('destroy');
					self.$.find('.benefit_tip').show();
					self.noticeMarquee = self.$.find('.benefit_tip-content').marquee({
						duplicated: true,
						duration: 1e4,
						startVisible: true,
						delayBeforeStart: 1500,
						gap: 20
					});
                }
            });
            //为收益页面的报表按钮绑定点击事件
			this.$.find('.benefit_report_btn').on("vclick", function () {
                // $.am.changePage(amGloble.page.benefitSummary, "slideleft", {'userid' : self.userid, 'balance' : self.balance});
                $.am.changePage(amGloble.page.promotionReport, "slideleft", {
                    report: {
                        name: "收益",
                        apiName: "queryCampaignReport",
                    },
                    shops: amGloble.storeSelect.getCurrentShops()
                });
			});
			this.$amBodyInner.on('vclick', '.benefit_tip-close', function() {

				self.noticeMarquee && self.noticeMarquee.marquee('destroy');
				self.$.find('.benefit_tip').hide();
			})
			// 提现记录跳转
			this.$amBodyInner.on('vclick', '.look_icon', function() {
				$.am.changePage(amGloble.page.benefitsWithdrawalrecord, 'sideleft')
			})
			// 提现按钮
			this.$amBodyInner.on('vclick', '.btn_withdraw', function() {
				$.am.changePage(amGloble.page.withdrawbenefit, "slideleft", {balance: self.enableTotalWithdraw});
            })
            // 待入账记录
            this.$amBodyInner.on('vclick', '.delay_benefit_content', function() {
				$.am.changePage(amGloble.page.delayBenefit, "slideleft");
            }).on('vclick', '.tip_icon', function(e) {
                e.stopPropagation();
                var delayTime = amGloble.metadata && amGloble.metadata.configs && amGloble.metadata.configs.toAcountDay ? amGloble.metadata.configs.toAcountDay : 0,
                    tipContentTxt = '亲，考虑到退货、退款等因素，待入账收益将自关联订单生成之日起，' + delayTime + '天后自动返还至您的账户';
                $("#tipContentBox").text(tipContentTxt);
                $("#tipContentBox").show();
                self.tipContent = setTimeout(function() {
                    $("#tipContentBox").hide();
                    clearTimeout(self.tipContent);
                }, 3000);
            }).on("vclick", ".benefit_list", function() {
                $("#tipContentBox").hide();
                clearTimeout(self.tipContent);
            })
            $("#page-promotionbenefit").click(function() {
                $("#tipContentBox").hide();
                clearTimeout(self.tipContent);
            })
            //获得收益页面的scrollView
            // self.benefitScroll = new $.am.ScrollView({
            //     $wrap: this.$.find(".am-body-wrap"),
            //     $inner: this.$.find(".am-body-inner"),
            //     direction: [false, true],
            //     hasInput: false
            // });
			// self.benefitScroll.refresh();
			// self.refresh();
        },
        setMiniproValue:function(value){
            this.isSmallPro=value;
        },
        getCanvasBase64: function (img, done) {
            var image = new Image();
            //至关重要
            image.crossOrigin = '';
            image.src = img;
            //至关重要
            // var deferred = $.Deferred();
            if (img) {
                image.onload = function () {
                    return done(getBase64Image(image))
                    // deferred.resolve(); //将base64传给done上传处理
                }
                // return deferred.promise(); //问题要让onload完成后再return sessionStorage['imgTest']
            }

            function getBase64Image(img, width, height) {
                var canvas = document.createElement("canvas");
                canvas.width = width ? width : img.width;
                canvas.height = height ? height : img.height;

                var ctx = canvas.getContext("2d");
                ctx.drawImage(img, 0, 0, canvas.width, canvas.height);
                var dataURL = canvas.toDataURL();
                return dataURL;
            }
        },
        gotoMallMinipro: function (that) {
            var user = amGloble.metadata.userInfo;
            var qrImgSrc = config.miniProUrl + "/xcx/qrCode/?tenantId=" + window.config.parentShopId + "&page=pages/mall/index&scene=3@" + user.userId + "@" + user.userType;
            $('.mallSharePhoto .content .bigW').text(user.shopName);
            $('.mallSharePhoto .content .qrImg').attr("src", qrImgSrc);
            $('.mallSharePhoto').show();
            var shareDom = document.getElementById('mallSharePhoto');
            var canvas=document.createElement('canvas');
            var ctx = canvas.getContext('2d');
            canvas.width=shareDom.clientWidth*2;
            canvas.height=shareDom.clientHeight*2;
            ctx.scale(2,2);
            html2canvas(shareDom, {
                canvas:canvas,
                useCORS:true,
                onrendered: function (canvas) {
                    var context = canvas.getContext('2d');
                    // 【重要】关闭抗锯齿
                    context.mozImageSmoothingEnabled = false;
                    context.webkitImageSmoothingEnabled = false;
                    context.msImageSmoothingEnabled = false;
                    context.imageSmoothingEnabled = false;
                    var clientHeight=canvas.height;
                    var clientWith=canvas.width;
                    clientHeight=clientHeight*2;
                    clientWith=clientWith*2;
					var img = Canvas2Image.convertToImage(canvas,clientWith, clientHeight);
					dataUrl = img.src.substring(22);
					$('.mallSharePhoto').hide();
					amGloble.loading.hide();
					$.am.debug.log('shareImage before');
					amGloble.shareImage({
						title: '',
						imageBase64: dataUrl,
						success: function() {
							$.am.debug.log('shareImage success');
						},
						fail: function() {
							$.am.debug.log('shareImage fail');
						}
					})
                    // var img = Canvas2Image.convertToImage(canvas,clientWith, clientHeight);
                    // dataUrl = img.src;
                    // $('.mallSharePhoto').hide();
                    // // amGloble.loading.hide();
                    // var itemData = {
                    //     parentShopId: user.parentShopId
                    // };
                    // var opt = imageConfig.getOptionObj("mall", itemData);
                    // opt.name = "qrMallcode" + window.config.parentShopId + user.userId + ".jpg";
                    // opt.imageBase64 = dataUrl.substring(22);
                    // delete opt.size;
                    // amGloble.api.base64Upload.exec(opt, function (ret) {
					// 	amGloble.loading.hide();
                    //     if (ret.code == 0) {
                    //         console.log(opt)
                    //         var qrcodeImgUrl = amGloble.photoManager.getPhotoUrl("mall", itemData, ret.content);
                    //         var shareObj = {
                    //             imgUrl: qrcodeImgUrl,
                    //             success: function () {}
                    //         };
                    //         amGloble.share(shareObj);
                    //     } else {
                    //         amGloble.msg( "上传图片超时!");
                    //         // amGloble.loading.hide();
                    //     }

                    // }, true, 200000)
                }
            });
        },
        createShareBase: function(type, shareReportData){
            var _this = this;
            if(type==0){
                $('.sharePhoto .productImg .img').html('');
            }
            var shareDom = document.getElementById('sharePhoto');
            var canvas=document.createElement('canvas');
            var ctx = canvas.getContext('2d');
            canvas.width=shareDom.clientWidth*2;
            canvas.height=shareDom.clientHeight*2;
            ctx.scale(2,2);
            html2canvas(shareDom, {
                canvas:canvas,
                useCORS:true,
                onrendered: function (canvas) {
                    // document.body.appendChild(canvas)
                    var context = canvas.getContext('2d');
                    // 【重要】关闭抗锯齿
                    context.mozImageSmoothingEnabled = false;
                    context.webkitImageSmoothingEnabled = false;
                    context.msImageSmoothingEnabled = false;
                    context.imageSmoothingEnabled = false;
                    var clientHeight=canvas.height;
                    var clientWith=canvas.width;
                    clientHeight=clientHeight*2;
                    clientWith=clientWith*2;
					var img = Canvas2Image.convertToImage(canvas, clientWith,clientHeight);
					dataUrl = img.src.substring(22);
					$('.sharePhoto').hide();
					amGloble.loading.hide();
					$.am.debug.log('shareImage before');
					amGloble.shareImage({
						title: '',
						imageBase64: dataUrl,
						success: function() {
							$.am.debug.log('shareImage success');
                            _this.reportMonitor(shareReportData);
						},
						fail: function() {
							$.am.debug.log('shareImage fail');
						}
					})
                    // var img = Canvas2Image.convertToImage(canvas, clientWith,clientHeight);
                    // dataUrl = img.src;
                    // $('.sharePhoto').hide();
                    // amGloble.loading.hide();
                    // var itemData = {
                    //     parentShopId: user.parentShopId
                    // };
                    // var opt = imageConfig.getOptionObj("mall", itemData);
                    // opt.name = "qrcode" + _item.id + user.userId+ ".jpg";
                    // opt.imageBase64 = dataUrl.substring(22);
                    // delete opt.size;
                    // amGloble.api.base64Upload.exec(opt, function (ret) {
                    //     if (ret.code == 0) {
                    //         console.log(opt)
                    //         var qrcodeImgUrl = amGloble.photoManager.getPhotoUrl("mall", itemData, ret.content);
                    //         var shareObj = {
                    //             imgUrl: qrcodeImgUrl,
                    //             success: function () {}
                    //         };
                    //         amGloble.share(shareObj);
                    //     } else {
                    //         amGloble.msg( "上传图片超时!");
                    //         amGloble.loading.hide();
                    //     }

                    // }, true, 200000)
                }
            });
        },
        createBgImg: function(url, cb){
            var img=document.createElement("img");
            img.src=url;
            $.am.debug.log('进入创建图片');
            var falg = true;
            img.onload= function(res) {
                $.am.debug.log('本地图片加载成功');
                //图片加载成功
                cb(1);
            }
            img.onerror = function(res){
                if(falg){
                    falg = false;
                    img.src = null;
                    img.style.display = 'none';
                    //图片加载失败
                    cb(0);
                }
            }
            return img;
        },
        gotoMinipro: function (that) {
            $.am.debug.log('点击推广收益');
            var _this = this;
            var $li = $(that).parents('li');
            var _item = $li.data('item');
            var user = amGloble.metadata.userInfo;
            var imgLoadStatus = [-1, -1];

            if ($li.find(".imgwrap img").is(":visible")) { //如果是显示
                if((_item.goodsType=='2' || _item.goodsType=='4') && (_item.images==null || _item.images.indexOf("minipro")!=-1 ) ){
                   var _imgUrl= $li.find(".imgwrap img").attr("src")
                }else{
                    var $img = amGloble.photoManager.createImage("mall", { //"goods"改为"mall"
                    parentShopId: amGloble.metadata.userInfo.parentShopId}, _item.images.split(",")[0]);
                    var _imgUrl = $img.attr("src");
                }
            } else { //是隐藏
                var _imgUrl = amGloble.metadata.userInfo.logo; //用租户logo
            }

            var shareReportData = {
                itemId: _item.id,
                empId: user.userId,
                parentShopId: window.config.parentShopId,
                shopId: user.shopId
            }


            $('.sharePhoto .productImg .img').html(this.createBgImg(_imgUrl, function(type){
                imgLoadStatus[0] = type;
                if(imgLoadStatus[1]==1){
                    _this.createShareBase(type, shareReportData);
                }
            }));


            // $('.sharePhoto .productImg img').attr("src", _imgUrl);
            $('.sharePhoto .productText').text(_item.name);
            $('.sharePhoto .priceText .red').text("￥" + _item.price.toFixed(1));
            $('.sharePhoto .priceText .gray').text("原价" + _item.originalprice.toFixed(1));
            if(_item.allowGroupBuying=='1' || _item.saleprop=='1'){
                if(_item.allowGroupBuying=='1'){
                    $('.sharePhoto .priceNum .redTag ').text('团购商品');
                }else{
                    $('.sharePhoto .priceNum .redTag ').text('抢购商品');
                }
            }else{
                $('.sharePhoto .priceNum .redTag').hide();
                $('.sharePhoto .priceNum .tagText').hide();
            }
            if(_item.amount -_item.useamount>0){
                $('.sharePhoto .priceNum .num ').text('仅剩'+(_item.amount-_item.useamount)+'件');
            }else{
                $('.sharePhoto .priceNum .num ').hide();
            }

            var qrImgSrc = config.miniProUrl + "/xcx/qrCode/?tenantId=" + window.config.parentShopId + "&page=pages/mall/index&scene=2@" + _item.id + "@" + user.userType + "@" + user.userId;
            $.am.debug.log('小程序生成地址----------------------------'+qrImgSrc);
            $('.sharePhoto .qrcode .img').html(this.createBgImg(qrImgSrc, function(type){
                imgLoadStatus[1] = type;
                if(type==0){
                    $('.sharePhoto').hide();
					amGloble.loading.hide();
                    amGloble.confirm("提示", "分享失败，点击重试？", "确定", "返回", function() {
                        _this.gotoMinipro(that);
                    }, function() {});
                }else if(type == 1){
                    if(imgLoadStatus[0] != -1){
                        _this.createShareBase(imgLoadStatus[0], shareReportData);
                    }
                }
            }));
            $('.sharePhoto').show();
        },
        gotoMallWeb: function (that) {
            amGloble.loading.hide();
            var user = amGloble.metadata.userInfo;
            var _imgUrl = amGloble.metadata.userInfo.logo; //用租户logo
            var shareObj = {
                title: user.shopName + "线上商城，扫码享受优惠，天天有特价 ",
                link: amGloble.getShareRoot() + $.param({
                    tenantId: user.parentShopId,
                    view: 3,
                    promoteUser: user.userType + "_" + user.userId+ "_admin"
                }),
                imgUrl: _imgUrl,
                success: function () {}
            };
            amGloble.share(shareObj);
        },
        gotoWeb: function (that) {
            var _this = this;
            amGloble.loading.hide();
            var $li = $(that).parents('li');
            var _item = $li.data('item');
            var user = amGloble.metadata.userInfo;

            if ($li.find(".imgwrap img").is(":visible")) { //如果是显示
                var _imgUrl = $li.find(".imgwrap img").attr("src");
            } else { //是隐藏
                var _imgUrl = amGloble.metadata.userInfo.logo; //用租户logo
            }
            var shareObj = {
                title: user.shopName + "精品推荐 - " + _item.name,
                link: amGloble.getShareRoot() + $.param({
                    tenantId: user.parentShopId,
                    view: 4,
                    modelId: _item.id,
                    promoteUser: user.userType + "_" + user.userId
                }),
                imgUrl: _imgUrl,
                success: function () {
                    var shareReportData = {
                        itemId: _item.id,
                        empId: user.userId,
                        parentShopId: window.config.parentShopId,
                        shopId: user.shopId
                    }
                    _this.reportMonitor(shareReportData);
                }
            };
            amGloble.share(shareObj);
        },
        beforeShow: function (ret) {
            var self=this;
            var tabIndex = 0;
            if (ret == "back") {
				if (this.$footTab.find('span').eq(1).hasClass('selected')) {
					self.queryPromoteData();
				}
                return;
            } else {
				tabIndex = ret && ret.tabIndex ? 1 : 0
			}
            // if (typeof domtoimage == 'undefined') {
            //     var newscript = document.createElement('script');
            //     newscript.setAttribute('type', 'text/javascript');
            //     newscript.setAttribute('src', 'libs/dom-to-image.js');
            //     var head = document.getElementsByTagName('head')[0];
            //     head.appendChild(newscript);
            // }
            amGloble.loading.show("查询中,请稍候...");
            amGloble.api.getSmallAppInfo.exec({
                id: window.config.parentShopId
            }, function (ret) {
                if( ret.code == 0 && ret.content && ret.content.isSmallPro){
                    self.setMiniproValue(1);
                }else{
                    self.setMiniproValue(0);
				}
				self.$footTab.find('span').eq(tabIndex).trigger('vclick');
				self.queryPromoteData();
                // self.$footTab.find('span:first').trigger('vclick');
                // self.queryCampaignList(1);

            })

        },
        afterShow: function (paras) {
            this.menuListWrap.refresh();
            this.contentListWrap.refresh();
        },
        uploadImg: function () {

        },
        beforeHide: function () {},
        amDragTopTips: ["下拉刷新列表", "松开开始加载", "加载中..."],
        amDragBottomTips: ["上拉加载更多", "松开开始加载", "加载中..."],
        touchTop: function () {
			self.queryPromoteData();
        },
        touchBottom: function () {
            this.queryCampaignList(this.pageNumber);
        },
        pageNumber: 1,
        pageSize: 10,
        queryMallItemCategory: function () { //查询商品分类
            var _this = this;
            amGloble.loading.show("查询中,请稍候...");
            amGloble.api.queryMallItemCategory.exec({
                //'category': 2 //1 服务类，2 卖品类
            }, function (ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    _this.renderQueryMallItemCategory(ret.content);
                } else {
                    amGloble.msg(ret.message || "数据获取失败,请重试!");
                }
            });
        },
        renderQueryMallItemCategory: function (data) {
            if (data.length == 0) {
                return;
            }
            var _html = '';
            var _num = 0;
            for (var i = 0; i < data.length; i++) {
                if (data[i].count == 0) continue;
                _num++;
                _html += '<li class="am-clickable" data-category="' + data[i].category + '" data-subcategoryid="' + data[i].subCategoryId + '">' + data[i].subCategoryName + '</li>';
            }
            if (_num > 0) {
                this.$extensionEmpty.hide();
            } else {
                this.$extensionEmpty.show();
            }
            this.$menuListWrapInnerUl.html(_html);
            this.menuListWrap.refresh();

            this.$menuListWrapInnerUl.find('li:first').trigger('vclick');
        },
        renderQueryMallItem: function (data) {
            // 修改过滤收益为0的
            // data = datasort && datasort.filter(function (item) {
            //     return item.campaignmoney != 0
			// })
			// 按推广收益金额倒序排序
			data.sort(function (a, b) {
				return b.campaignmoney - a.campaignmoney;
			});
            this.$contentListWrapInnerUl.html('');
            if (data.length == 0) {

            } else {
                for (var i = 0; i < data.length; i++) {
                    if (data[i].campaignmoney == undefined || data[i].campaignmoney == 0) {
                        continue;
                    }
                    var sharediscount = data[i].sharediscount == 0 ? '' : '<span>  /  分享立减' + data[i].sharediscount + '</span>元'

                    var $li = $('<li class="am-clickable">' +
                        '<div class="imgwrap">' +
                        //'<img src="'+ data[i].images +'">' +
                        '</div>' +
                        '<h2 class="tith2">' + data[i].name + '</h2>' +
                        '<p class="pricep">原价: ￥' + data[i].price + sharediscount + '</p>' +
                        '<div class="promotionbenefit">' +
                        '推广收益:<span>￥' + data[i].campaignmoney + '</span><div class="generalize_btn am-clickable"><a href="javascript:;">我要推广</a></div>' +
                        '</div>' +
                        '</li>');
                    if((data[i].goodsType=='2' || data[i].goodsType=='4') && (data[i].images==null || data[i].images.indexOf("minipro")!='-1' ) ){
                        var $img = $('<img src="' + config.filesMgr+data[i].images + '">').show();
                        $img.load(function() {
                            $img.show();
                        });

                    }else{
                        var $img = amGloble.photoManager.createImage("mall", { //"goods"改为"mall"
                            parentShopId: amGloble.metadata.userInfo.parentShopId
                        }, data[i].images.split(",")[0], "s"); /*增加 split(",")[0] 代码片段——取数组，前第一个图片*/
                    }

                    $li.find('.imgwrap').append($img);
                    $li.data('item', data[i]);
                    this.$contentListWrapInnerUl.append($li);
                }
            }
            this.contentListWrap.refresh();
            this.contentListWrap.scrollTo("top");
		},
		renderPromote: function(data) {
			var currentDate = new Date();
			var currentDateString = currentDate.getFullYear() + '-' + (currentDate.getMonth() + 1) + '-' + currentDate.getDate();
			this.$.find('.benefit_tip-time').text(data.startDate || currentDateString);
            // 本月收益与总余额调换
            this.$.find('.once_month').text(data.monthIncome);
			this.$.find('.history_total_benefit').text(data.totalIncome);
			this.$.find('.withdraw_total').text(data.totalWithdraw);
            this.$.find('.monry_total-number').text(data.enableTotalWithdraw);
            if(amGloble.metadata && amGloble.metadata.configs && amGloble.metadata.configs.toAcountMode && amGloble.metadata.configs.toAcountMode == "0" && data.freezeWithdraw > 0) {
                this.$.find('.delay_money .delay_money_num').text(data.freezeWithdraw);
                this.$.find('.inner_header').css("height","210px");
                this.$.find('.delay_benefit ').show();
            } else {
                this.$.find('.inner_header').css("height","180px");
                this.$.find('.delay_benefit ').hide();
            }
			this.enableTotalWithdraw = data.enableTotalWithdraw;
		},
		queryPromoteData: function() {
			var metadata = amGloble.metadata.userInfo;
			amGloble.loading.show("查询中,请稍候...");
			amGloble.api.queryPromoteData.exec({
				parentShopId: metadata.parentShopId,
				shopId: metadata.shopId,
				userId: metadata.userId,
				userType: metadata.userType
			}, function(ret) {
                console.log("收益回调===================",ret);
				if (ret.code == 0) {
					var promoteData = ret.content;
					self.renderPromote(promoteData);
					self.queryCampaignList(1);
				} else {
					amGloble.msg(ret.message || "数据获取失败,请重试!");
				}
			})
		},
        queryCampaignList: function (pageNumber) { //查询收益列表
            var metadata = amGloble.metadata.userInfo;
            if (pageNumber == 1) {
                self.pageNumber = 1;
                self.$.find('ul.benefit_list').html('');
            }
            amGloble.api.queryCampaignList.exec({
                "parentShopId": metadata.parentShopId,
                "shopId": metadata.shopId,
                "pageNumber": self.pageNumber,
                "pageSize": self.pageSize,
                "userId": metadata.userId,
                "userType": metadata.userType
            }, function (ret) {
				amGloble.loading.hide();
                if (ret.code == 0) {
                    //benefit_list
                    var _len = ret.content.data.length;
                    if (_len == 10) { //当上次返回数据的条数为10个时，pageNumber就++
                        self.pageNumber++;
                    }
                    if (self.pageSize > _len) {
                        self.scrollview.pauseTouchBottom = true;
                    } else {
                        self.scrollview.pauseTouchBottom = false;
					}
					if (_len != 0) {
						if (self.pageNumber == 1) {
                            self.$.find('ul.benefit_list').html('');
						}
						self.renderQueryCampaignList(ret.content);
					} else if (_len == 0 && self.pageNumber == 1) {
						self.showEmpty();
					}
                    // if (_len == 0 && self.pageNumber == 1) {
					// 	self.showEmpty();
					// 	self.hideBenefitReportBtn();
                    // } else {
                    //     if (self.pageNumber == 1) {
                    //         self.$.find('ul.benefit_list').html('');
                    //     }
                    //     /*if(_len == 0 && self.pageNumber != 1){
                    //         self.showNomore();
                    //     }*/
                    //     self.renderQueryCampaignList(ret.content);
                    //     /*if(_len<self.pageSize){
                    //          self.showNomore();
                    //     }*/
                    // }
                } else {
                    amGloble.msg(ret.message || "数据获取失败,请重试!");
                }
                self.closeTopLoading();
                self.closeBottomLoading();
            });
        },
        renderNormalBenefitPage: function () {
            //收益从无到有的时候先清空容器
            this.$.find('.am-body-inner').empty();
            var _html = $(
                '<div class="inner_header">' +
					'<div class="benefit am-clickable">' +
						'<div class="this_benefit ">总余额</div>' +
						'<div class="monry_total-number"></div>' +
						'<p class="monry_total">本月收益 <span class="once_month"></span></p>' +
                        '<button class="btn_withdraw">我要提现</button>' +
                        '<div class="delay_benefit" style="display:none;">' +
                            '<span class="tip_icon iconfont icon-tishi1"></span>' +
                            '<span class="delay_money">待入账收益 ¥ 0</span>' +
                            '<span class="right_arrow iconfont icon-you"></span>'+
                        '</div>' +
					'</div>' +
					'<div class="benefit_tip">' +
						'<i class="benefit_tip-icon"></i>' +
						'<p class="benefit_tip-content">自2019-01-01上线日起，商城推广收益可即时提现啦！上线前发放的收益，仍需随工资发放~~</p>' +
						'<div class="benefit_tip-close"></div>' +
					'</div>' +
				'</div>' +
				'<div class="moneywrap">' +
					'<ul>' +
						'<li class="brgrey">' +
							'<p class="titp">历史总收益</p>' +
							'<p class="moneyp history_total_benefit"></p>' +
						'</li>' +
						'<li>' +
							'<p class="titp">提现记录</p>' +
							'<p class="moneyp withdraw_total"></p>' +
							'<span class="look_icon"></span>' +
						'</li>' +
				'	</ul>' +
				'</div>' +
                '<ul class="benefit_list am-clickable">' +
                '</ul>');
            this.$.find('.am-body-inner').append(_html);
            this.refresh();
        },
        renderQueryCampaignList: function (data) { //渲染收益列表
            //只有从收益为无到有，才干的事情
            // this.$.find('.emptydiv').length > 0 && self.renderNormalBenefitPage();
            //monthTotal
            // var monthTotal = data.monthTotal;
            // $(".am-body-inner .money_content").html(monthTotal);
            //收益本来有，走的逻辑
            // self.benefitScroll.refresh();
            // self.benefitScroll.scrollTo("top");
            var listdata = data.data;
            for (var i = 0; i < listdata.length; i++) {
                var _html = $('<li>' +
                    '<div class="left">' +
                    '<p class="serviceName">' + listdata[i].serviceName + '</p>' +
                    '<p class="benefitSrc">收益来自顾客:<span class="benefitUserName">' + listdata[i].customName + '</span></p>' +
                    '</div>' +
                    '<div class="right">' +
                    '<p class="money">￥' + listdata[i].campaignMoney + '</p>' +
                    '<p class="time">' + listdata[i].datetime + '</p>' +
                    '</div>' +
                    '</li>');
                this.$.find('ul.benefit_list').append(_html);
            }
            this.refresh();
            // self.benefitScroll.refresh();
        },
		showExtension: function () { //显示推广
            this.$extensionWrap.show();
            this.$amHeader.removeClass('header-profit');
            this.$amBodyInner.hide();
            // this.$text.text('推广');
        },
        showProfit: function () { //显示收益
            this.$extensionWrap.hide();
            this.$amHeader.addClass('header-profit');
            this.$amBodyInner.show();
            this.$text.text('收益');
        },
        showEmpty: function () { //没有收益时的渲染
            // var _div = '<div class="emptydiv"><div class="pic"></div><p>还没有收益，要加油哦~</p></div>';
			// this.$.find('.am-body-inner').html(_div);
			var _li = '<li class="emptyli">还没有收益，要加油哦~</li>';
			this.$.find('ul.benefit_list').html( _li );
			this.refresh();
		},
		showBenefitReportBtn: function() {
			this.$benefitReportBtn.show();
		},
		hideBenefitReportBtn: function() {
			this.$benefitReportBtn.hide();
		},
        reportMonitor: function(shareReportData) {
            if (!shareReportData) return;
            $.am.debug.log('promotionbenefit report monitor start');
            $.am.debug.log(JSON.stringify(shareReportData));
            shareReportData.type = 1;
            shareReportData.time = new Date().getTime();
            shareReportData.appVersion = $('.app_version').text();
            var postData = {
                dbName: 'mgj-monitor',
                collName: 'promotionbenefitShare',
                data: shareReportData
            }
            $.ajax({
                type: "post",
                data: JSON.stringify(postData),
                url: this.getUrl(),
                timeout: 30 * 1000,
                dataType: "json",
                contentType: "application/json",
                success: function (ret) {
                    $.am.debug.log('promotionbenefit report monitor success');
                    $.am.debug.log(JSON.stringify(ret));
                }
            })
        },
        getUrl: function() {
            if(!this.url){
                var url = 'https://ops.meiguanjia.net/monitor/commdata/save';
                if(location.protocol === 'http:'){
                    url = url.replace('https','http');
                }
                this.url = url;
            }
            return this.url;
        }
    });
})();
