(function () {

    // permission 1盛传版 2风尚版 3尊享版

    var reportList = [{
        text: "决策",
        reports: [{
            aid: "", //权限ID
            name: "生意总览",
            level: 1,
            apiName: "rpt_busitotal",
            permission: '1,2,3,6',
            icon: "r11",
            target: "tradePandect"
        }, {
            aid: "K01",
            name: "各门店业绩汇总",
            level: 1,
            apiName: "rpt_shopperflist",
            icon: "r33",
            permission: '3,6' //权限、1只允许尊享版使用,
        }, {
            aid: "K1",
            name: "各门店员工业绩排行",
            level: 1,
            apiName: "rpt_empPerformanceRank",
            icon: "r32",
            permission: '3,6', //权限、1只允许尊享版使用,
            filter: "level" //dept部门  level级别 none隐藏filter
        }]
    }, {
        text: "财务",
        reports: [
            // {
            //     aid: "J02",
            //     name: "营业额流水",
            //     level: 2,
            //     apiName: "rpt_turnover",
            //     icon: "r22",
            //     permission: '3' //权限、1只允许尊享版使用,
            // }, 
            {
                aid: "J3",
                name: "现金流水表",
                level: 2,
                apiName: "rpt_cashflow",
                icon: "r23",
                permission: '3,6' //权限、1只允许尊享版使用,
            }, {
                aid: '',
                apiName: "rpt_wageReport",
                name: '工资提成表',
                level: 2,
                icon: "r21",
                permission: '1, 2, 3, 6',
                isShow: function (params) {
                    var shopData = params.shopData;
                    return shopData.enabledNewBonusModel == '1';
                },
                toPageFn: function (params) {
                    var shopData = params.shopData;
                    window.RouterUtils.push({ name: 'employeeGainStatisticsMain', params: { shopId: shopData.shopId }, animation: 'slideleft' });
                }
            },
            // , {
            //     aid: "J2",
            //     name: "损益表（暂无）",
            //     level: 2,
            //     apiName: "",
            //     icon: "r21"
            // }
        ]
    }, {
        text: "业绩",
        reports: [
        {
                aid: "",
                name: "业绩提成汇总",
                apiName: "employeeIncomeTotal",
                level: 2,   // 级别
                permission: '3',    // 权限、1只允许尊享版使用
                icon: "r31",    // 图标
                levelList:[3],   // 级别数据
                // 点击回调方法
                toPageFn: function (params) {
                    window.RouterUtils.push({name: 'employeeIncomeTotal', params});  // 跳转到趋势页面
                 },
                 // 是否显示
                isShow: function() {
                    return amGloble.metadata.configs.mgjMergeGainByMobile == 1 && amGloble.metadata.userInfo.userType == 1;
                }
        }, {
            aid: "K00",
            name: "店内业绩统计表",
            level: 2,
            apiName: "rpt_shopperf",
            permission: '1,2,3,6',
            icon: "r12",
            target: "reportStorePerf"
        }, {
            aid: "K20",
            name: "项目分类统计明细",
            level: 2,
            apiName: "rpt_typeStatDetail",
            icon: "r32",
            permission: '3,6', //权限、1只允许尊享版使用,
            dataProcessor: function (data) {
                var others = data.others = [];
                data.head[7] = "操作"
                $.each(data.data, function (i, item) {
                    others.push(item[7]);
                    item[7] = '<span class="am-clickable" data-index="' + i + '">查看明细</span>';
                });

                return data;
            }
        }, {
            aid: "",
            name: "套餐统计表",
            level: 1,
            apiName: "packageStatistics",
            levelList:[1, 2],
            icon: "r32",
            permission: '3', //权限、1只允许尊享版使用,
            toPageFn: function (params) {
                if (params.shopData) {
                    window.RouterUtils.push({ name: 'packageShopStatistics', params: params, animation: 'slideleft' });
                } else {
                    window.RouterUtils.push({ name: 'packageHeadquartersStatistics', animation: 'slideleft' });
                }
            },
            isShow: function () {
                return amGloble.metadata.userInfo.userType == 0;
            }
        }, {
            aid: "K3",
            name: "卡储值消费统计",
            level: 2,
            apiName: "rpt_cardConsume",
            icon: "r43",
            permission: '3,6' //权限、1只允许尊享版使用,
        }, {
            aid: "K3",
            name: "卡金结余统计",
            level: 2,
            apiName: "rpt_cardBalance",
            icon: "r41",
            permission: '3,6', //权限、1只允许尊享版使用,
            filter: "none" //dept部门  level级别 none隐藏filter
        }, {
            aid: "K10",
            name: "员工业绩汇总",
            level: 2,
            apiName: "rpt_empPerformanceTotal",
            icon: "r31",
            permission: '3,6', //权限、1只允许尊享版使用,,
            filter: "level" //dept部门  level级别
        }, {
            aid: "",
            name: "业绩总览",
            level: 3,
            apiName: "rpt_employeeEmpperf",
            permission: '1,2,3,6',
            icon: "r12",
            target: "employeePandect"
        }, {
            aid: "",
            name: "工资提成",
            reportName: "reportList",
            level: 3,
            apiName: "rpt_employeeEmpgain",
            permission: '1,2,3,6',
            icon: "r21",
            target: "employeeWageSystem",

        }, {
            aid: "",
            name: "项目服务记录",
            reportName: 'reportStandard',
            level: 3,
            apiName: "rpt_employeeItemlist",
            permission: '1,2,3,6',
            icon: "r53",
            params: {
                pageType: 0
            }
        }, {
            aid: "",
            name: "卖品销售记录",
            reportName: 'reportStandard',
            level: 3,
            apiName: "rpt_employeeBuylist",
            permission: '1,2,3,6',
            icon: "r54",
            params: {
                pageType: 1
            }
        }, {
            aid: "",
            name: "开卡记录",
            reportName: 'reportStandard',
            level: 3,
            apiName: "rpt_employeeReclist",
            permission: '1,2,3,6',
            icon: "r55",
            params: {
                pageType: 2
            }
        }, {
            aid: "",
            name: "充卡记录",
            reportName: 'reportStandard',
            level: 3,
            apiName: "rpt_employeeReclist",
            permission: '1,2,3,6',
            icon: "r55",
            params: {
                pageType: 3
            }
        }, {
            aid: "",
            name: "套餐销售记录",
            reportName: 'reportStandard',
            level: 3,
            apiName: "rpt_employeeTreatlist",
            permission: '1,2,3,6',
            icon: "r56",
            params: {
                pageType: 4
            }
        },
            // {
            //     aid: "",
            //     name: "年卡销售记录",
            //     level: 3,
            //     apiName: "rpt_employeeYearlist",
            //     permission: '1,2,3',
            //     icon: "r57",
            // },
            {
                aid: "",
                name: "特权卡开通记录",
                apiName: "privilegeOpenRecord",
                level: 3,
                permission: '2,3',
                icon: "r61",
                levelList:[2, 3],
                toPageFn: function (params) {
                    var shopData = params.shopData;
                    // console.log(shopData)
                    window.RouterUtils.push({ name: 'openRecord', params: { shopId: shopData.shopId,name:shopData.name||shopData.shopFullName }, animation: 'slideleft' });
                },
                isShow: function() {
                    return amGloble.metadata.configs.mgjMallPrivilege=='1';
                }
            },
            {
                aid: "",
                name: "业绩月趋势",
                apiName: "employeeFeeOfMonth",
                level: 2,   // 级别
                permission: '3',    // 权限、1只允许尊享版使用
                icon: "r31",    // 图标
                levelList:[3],   // 级别数据
                // 点击回调方法
                toPageFn: function (params) {
                    window.RouterUtils.push({name: 'performanceTrend', params});  // 跳转到趋势页面
                 },
                 // 是否显示
                isShow: function() {
                    return true;
                }
            },
            {
                aid: "",
                name: "各分类业绩占比",
                permission: '3',    // 权限、1只允许尊享版使用
                icon: "r31",    // 图标
                levelList:[3],   // 级别数据
                // 点击回调方法
                toPageFn: function (params) {
                    if (!self.dashboardData) {
                        amGloble.msg('未查询到各分类业绩占比，请退出重试');
                        return;
                    }
                    window.RouterUtils.push({
                        name: "sourceIndex",
                        params: {
                          list: [self.dashboardData],
                          currentIndex: 0,
                          shop: amGloble.metadata.shopMap[amGloble.metadata.userInfo.shopId]
                        }
                      });
                 },
            },
        ]
    }, {
        text: "服务",
        reports: [{
            aid: "",
            name: "洗发时长统计",
            level: 2,
            permission: '3', //权限、1只允许尊享版使用,
            apiName: "hairTime",
            icon: "r60"
        }, {
            aid: "",
            name: "洗发合格率",
            level: 2,
            permission: '3', //权限、1只允许尊享版使用,
            filter: "selectTime",
            apiName: "clearHairRate",
            icon: "r59"
        }]
    }, {
        text: "商城",
        reports: [{
            name: "门店PK",
            icon: "r57",
            apiName: "mallreportStopPK",
            level: 1,
            permission: '2,3,6',
            dataProcessor: function (data) {
                return data;
            }
        }, {
            name: "分类汇总",
            apiName: "reportCategory",
            level: 1,
            permission: '2,3,6',
            icon: "r57",
            filter: "showCategory",
            dataProcessor: function (data) {
                return data;
            }
        }, 
        {
            name: "明细汇总",
            filter: "showCategory",
            level: 1,
            permission: '2,3,6',
            icon: "r58",
            apiName: "reportItem"
        },
        {
            name: "商城订单",
            level: 1,
            permission: '1,2,3,6',
            icon: "r62",
            levelList:[1,2,3],
            apiName: "mallOrder",
            toPageFn: function (params) {
                var shopId = 0
                if(params&&params.shopData&&params.shopData.shopId){
                    var shopId = params.shopData.shopId;
                }
                window.RouterUtils.push({ name: 'mallOrder', params: { shopId: shopId }, animation: 'slideleft' });
            },
        },
        {
            name: "红包明细",
            level: 1,
            permission: '1,2,3,6',
            icon: "r63",
            levelList:[1,2,3],
            apiName: "redPackDetails",
            toPageFn: function (params) {
                var shopId = 0
                if(params&&params.shopData&&params.shopData.shopId){
                    var shopId = params.shopData.shopId;
                }
                window.RouterUtils.push({ name: 'redPack', params: { shopId: shopId }, animation: 'slideleft' });
            },
        },
    ]
    }, {
        text: "点评",
        reports: [{
            name: "汇总",
            apiName: "commentStatistics",
            permission: '2,3,6',
            level: 1,
            icon: "r57",
            paramsFilter: function (defultParam) {
                defultParam.shopIds = defultParam.shopids.join(",");
                defultParam.type = 0;
                return defultParam;
            }
        }, {
            name: "门店PK",
            icon: "r57",
            apiName: "commentStatistics",
            permission: '2,3,6',
            level: 1,
            paramsFilter: function (defultParam) {
                defultParam.shopIds = defultParam.shopids.join(",");
                defultParam.type = 1;
                return defultParam;
            }
        }, {
            name: "员工PK",
            level: 2,
            icon: "r58",
            apiName: "commentStatistics",
            permission: '2,3,6',
            paramsFilter: function (defultParam) {
                defultParam.shopIds = defultParam.shopid + "";
                defultParam.type = 1;
                return defultParam;
            }
        }]
    }];
    var self = amGloble.page.reportList = new $.am.Page({
        id: "page-reportList",
        init: function () {
            this.$.find(".mainList").on("vclick", "li", function () {
                var $this = $(this);
                var report = $this.data("item");
                //风尚版弹框
                if ($this.hasClass("disabled")) {
                    amGloble.checkVersion(true);
                    return;
                }
                if (report.reportName) {
                    if (report.reportName == "reportList") {
                        var _configs = amGloble.metadata.configs;
                        if (_configs['enabledNewBonusModel'] && _configs['enabledNewBonusModel'] == 1) {
                            window.RouterUtils.push({ name: report.reportName, params: report.params, animation: 'slideleft' })
                        } else {
                            $.am.changePage(amGloble.page[report.target], "slideleft", {
                                report: report,
                                shops: amGloble.storeSelect.getCurrentShops()
                            });
                        }
                    } else {
                        window.RouterUtils.push({ name: report.reportName, params: report.params, animation: 'slideleft' })
                    }
                } else if (report.target) {
                    $.am.changePage(amGloble.page[report.target], "slideleft", {
                        report: report,
                        shops: amGloble.storeSelect.getCurrentShops()
                    });
                } else if (report.toPageFn) {
                    var cshop = amGloble.storeSelect.getCurrentShops();
                    // if(!cshop){
                    //     var allShops = window.amGloble.metadata.allShops
                    //     var userShopId = window.amGloble.metadata.userInfo.shopId
                    //     for (let index = 0; index < allShops.length; index++) {
                    //         if(userShopId == allShops[index].shopId){
                    //             cshop = allShops[index]
                    //         }
                    //     }
                    // }
                    report.toPageFn({ shopData: cshop });
                } else if (report.apiName) {
                    $.am.changePage(amGloble.page.reportStandard, "slideleft", {
                        report: report,
                        shops: amGloble.storeSelect.getCurrentShops()
                    });
                } else {
                    alert("开发中...");
                }
            });
            this.$reportList = this.$.find(".mainList");
            this.$header.children(".right").vclick(function () {
                self.openEditionTip();
            });
        },
        backButtonOnclick: function() {
            window.RouterUtils.backByName('dashboard');
        },
        arr2Obj: function (arr, key) {
            var obj = {};
            for (var i = 0, len = arr.length; i < len; i++) {
                if (arr[i][key]) {
                    obj[arr[i][key]] = arr[i];
                    obj[arr[i][key]].index = i;
                    // obj[key].index=i;
                }
            }
            return obj;
        },
        beforeShow: function (ret) {
            amGloble.storeSelect.onShopChange = function (shops) {
                self.render();
            };
            // 获取员工各分类业绩占比报表数据
            if (amGloble.metadata.userInfo.userType === 1) {
                amGloble.api.getDashboards.exec({}, function(ret) {
                    if (ret.code === 0) {
                        self.dashboardData = ret.content.find(function(item) {
                            return Number(item.no) === 13
                        })
                    }
                })
            }
            this.render();
        },
        afterShow: function (paras) {
            var editionTip = JSON.parse(localStorage.getItem("editionTip"));
            if (amGloble.enableNewReport == undefined && !editionTip) {
                self.openEditionTip();
            }
        },
        beforeHide: function () {
            amGloble.storeSelect.onShopChange = null;
        },
        findPermissions: function (key) {
            var found = false;
            var permissions = amGloble.metadata.userInfo.powerstr ? amGloble.metadata.userInfo.powerstr.split(",") : [];
            for (var i = 0; i < permissions.length; i++) {
                var item = permissions[i];
                // console.log(item, key);
                if (item == key) {
                    found = true;
                    break;
                }
            }
            return found;
        },
        updateSetting: function(data, cb) {
            var userinfo = amGloble.metadata.userInfo;
            amGloble.api.addUserData.exec({
                mobile: userinfo.mobile,
                tableName: "SYB_enableNewReport",
                data: data
            }, function(res) {
                if (res && res.code == 0) {
                    amGloble.enableNewReport = data;
                    cb && cb();
                } else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function () {
                        self.updateSetting(data, cb);
                    }, function () {

                    });
                }
            })
        },
        openEditionTip: function () {
            var editionTip = JSON.parse(localStorage.getItem("editionTip"));
            if (!editionTip) {
                localStorage.setItem("editionTip", JSON.stringify(true));
            }

            amGloble.confirm("提示", "您需要体验新版的数据页面？", "不需要", "确认", function() {
            }, function() {
                self.updateSetting(true, function() {
                    window.RouterUtils.push({name: 'dataBoard', params:'', animation:'slideleft'});
                })
            });
        },
        render: function () {
            var reportApiNameList = ['employeeFeeOfMonth'];
            var userType = amGloble.metadata.userInfo.userType;
            var cshop = amGloble.storeSelect.getCurrentShops();
            var $reportList = this.$reportList.empty();

            var _configs = amGloble.metadata.configs;
            var userinfo = amGloble.metadata.userInfo;
            var sybPowerStr = userinfo.sybPowerStr;
            var jurisdiction = {};
            if (userinfo.newRole == 1 || userinfo.newRole == 2 || userinfo.newRole == 3) {  //操作员1 管理员2
                if (_configs.operatorFacility) {
                    jurisdiction = JSON.parse(_configs.operatorFacility);
                }
            } else if (userinfo.newRole >= 4) {    //员工
                if (_configs.staffFacility) {
                    jurisdiction = JSON.parse(_configs.staffFacility);
                }
            }
            var replaceShampoo = amGloble.metadata.configs.replaceShampoo || "洗发"
            for (var i = 0; i < reportList.length; i++) {
                var cati = reportList[i];
                var $title = $('<div class="listTitle">' + cati.text + '</div>');
                var $ul = $('<ul class="subList"></ul>');
                for (var j = 0; j < cati.reports.length; j++) {
                    var report = cati.reports[j];
                    if (report.name == "洗发时长统计") {
                        report.name = replaceShampoo + "时长统计"
                    } else if (report.name == "洗发合格率") {
                        report.name = replaceShampoo + "合格率"
                    }
                    var hasPermission = (sybPowerStr && (sybPowerStr.indexOf(','+report.apiName+',') != -1 || (report.permission && !report.permission.includes(userinfo.mgjVersion)))) || !sybPowerStr || sybPowerStr == ',,';
                    var jurisdictionType = Number(jurisdiction[report.apiName]);
                    if (jurisdictionType === 0 || (reportApiNameList.indexOf(report.apiName) !== -1 && jurisdictionType !== 1) || !hasPermission) {
                        continue;
                    }

                    console.log('.report', report);

                    //  1/总部 2/门店 3/员工
                    if (userType == 1) {
                        //员工只显示level=3
                        // console.log("员工只显示level=3");
                        if (report.level != 3&&(!report.levelList||report.levelList.indexOf(3)===-1)) {
                            continue;
                        }
                    } else if (cshop) {
                        //单门店只能看到门店级
                        // console.log("单门店只能看到门店级");
                        if (report.level != 2&&(!report.levelList||report.levelList.indexOf(2)===-1)) {
                            continue;
                        }
                    } else {
                        //全部门店时只能看到总部级
                        // console.log("全部门店时只能看到总部级");
                        if (report.level != 1) {
                            // console.log(report.level);
                            continue;
                        }
                    }


                    if (report.aid && !this.findPermissions(report.aid)) {
                        continue;
                    }

                    if (report.isShow && !report.isShow({ shopData: cshop })) {
                        continue;
                    }

                    var mgjVersion = cshop ? cshop.mgjversion : amGloble.metadata.userInfo.mgjVersion;

                    if (report.permission && report.permission.indexOf(mgjVersion) == -1) {
                        if (mgjVersion == 6) {
                            continue;
                        }
                        var $li = $('<li class="' + report.icon + ' am-clickable disabled">' + report.name + '（尊享版专属）</li>');
                    } else {
                        var $li = $('<li class="' + report.icon + ' am-clickable">' + report.name + '</li>');
                    }
                    
                    $li.data("item", report);
                    $ul.append($li);
                }
                if (!$ul.is(":empty")) {
                    $reportList.append($title).append($ul);
                }
            }



            var reportPermission = JSON.parse(amGloble.metadata.configs.reportPermission);
            if (reportPermission && reportPermission.enable > 0) {
                var userNames = reportPermission.userNames.split(',');
                var itemData = {
                    aid: "", //权限ID
                    name: "多品牌营收总览",
                    // level: 1,
                    // apiName: "rpt_busitotal",
                    // permission: '1,2,3',
                    // icon: "r11",
                    target: "brandRevenueOverview"
                }
                if (userNames.indexOf(userinfo.loginName) >= 0) {
                    var $title = $('<div class="listTitle">定制报表</div>');
                    var $ul = $('<ul class="subList"></ul>');
                    var $li = $('<li class="r11 am-clickable">多品牌营收总览</li>');
                    $li.data('item', itemData)
                    $ul.append($li);
                    $reportList.append($title).append($ul);
                }
            }

            this.refresh();
        }
    });

})();
