(function() {
  var reservationTimeDialog = {
    init: function(){
        var _this = this;
        this.$ = $("#popup_reservationTimeDialog").on("vclick", function(){
          _this.hide();
        }).on("vclick", ".main", function(e){
          e.stopPropagation()
        });
        this.$cancal = this.$.find(".cancal").vclick(function() {
            _this.hide();
        });
        this.$.find(".toReservation").vclick(function() {
            _this.hide();
            _this.cb &&_this.cb();
        });
      },
      arr2Obj: function(arr){
          var res={},obj={};
          if(arr){
              $.each(arr,function(i,v){
                  obj[v.employeeId+'']={};
                  obj[v.employeeId+''].employeeId=v.employeeId;
                  obj[v.employeeId+''].employeeName=v.employeeName;
                  var shift=v;
                  var shiftInfo='未排班';
                  if(shift && shift.shiftName){
                      shiftInfo=shift.shiftName+'（'+shift.goWorkTime+'~'+shift.outWorkTime+'）';
                      if(shiftInfo && (shiftInfo.indexOf('休')>-1)){
                          shiftInfo='休假';
                      }
                  }
                  obj[v.employeeId+''].shiftInfo=shiftInfo;
              });
              res=obj;
          }
          return res;
      },
      render: function(data){
        this.shiftObj = this.arr2Obj(data.shifts)
        this.$.find(".empHeader").html(amGloble.photoManager.createImage("artisan", {
            parentShopId: amGloble.metadata.userInfo.parentShopId,
            updateTs: data.emp.lastphotoupdatetime || new Date().getTime()
        }, data.emp.barberId + ".jpg", "s"));
        var today = new Date();
        var d = this._formatDate(data.reservationTime)
        if(d == this._formatDate(today)){
          this.$.find(".text .day").text("今天")
        }else if(d == this._formatDate(new Date(today.setDate(today.getDate() + 1)))){
          this.$.find(".text .day").text("明天")
        }else if(d == this._formatDate(new Date(today.setDate(today.getDate() + 1)))){
          this.$.find(".text .day").text("后天")
        }else {
          this.$.find(".text .day").text(d)
        }
        if(data.emp.gender == "M"){
          this.$.find(".empHeader").addClass("male")
        }else{
          this.$.find(".empHeader").removeClass("male")
        }
        this.$.find(".empName").text(data.emp.barberName)
        var shiftInfo = this.shiftObj[data.emp.barberId] ? this.shiftObj[data.emp.barberId].shiftInfo : ''
        this.$.find(".text .shift").text(shiftInfo)
        this.$.find(".text .time").text(data.reservationTime.format("HH:MM"))
      },
      _formatDate: function(date) {
          var y = date.getFullYear();
          var m = date.getMonth() + 1;
          var d = date.getDate();
          if(m < 10){
            m = '0' + m
          }
          if(d < 10){
            d = '0' + d
          }
          return y + "-" + m + "-" + d;
      },
      show: function(data, cb){
        var _this = this
        this.render(data);
        this.cb = cb
        setTimeout(function() {
          _this.$.show();
        },100)
      },
      hide: function(){
        this.$.hide();
      }
    }
    var page = amGloble.page.reservation = new $.am.Page({
        id: "page-reservation",
        init: function() {
            var self = this;
            //chali 初始化
            page.$showItemConfirm = page.$.find(".showItemConfirm");
            page.$itemClone = page.$showItemConfirm.find(".content .reservationItems .item").clone();
            page.$showItemConfirm.vclick(function(){
                page.$showItemConfirm.hide();
            });

            page.$reservationInfo = page.$.find(".reservationInfo");
            page.$reservationItemClone = page.$reservationInfo.find(".content .reservationItems .item").clone();
            page.$reservationInfo.vclick(function(){
                page.$reservationInfo.hide();
            });
            page.$reservationInfo.find('.content .reservationInfo-header .close').vclick(function(){
                page.$reservationInfo.hide();
            });
            page.$reservationInfo.find('.content').vclick(function() {
                return false;
            })
            page.$reservationInfo.find(".content").removeClass("am-clickable");

            reservationTimeDialog.init()
        },
        initReservation: function() {
            timeBar.init();
            table.init();
            table.createFrame();
            this.inited = true;
        },
        beforeShow: function(paras) {
            var self = this;
            this.paras = paras;
            console.log(paras,"看看顾客列表返回了啥")
            if(paras && paras!='back' && paras.emp){
                page.emp=paras.emp;
                page.shopId=paras.shopId;
            }
            if(paras&&paras.code==0){
                timeBar.refresh();
                // timeBar.refresh(true,true);
        
                // this.inited=false;
                //调用接口拿数据 重新渲染
                // amGloble.api.reservationList.exec({
                //     // parentShopId:amGloble.metadata.userInfo.realParentShopId,
                //     "shopId":paras&&paras.shopId?paras.shopId:amGloble.metadata.userInfo.shopId,
                //     "reservationTime": 1546084486205, //new Date(paras.currentDate).getTime(),
                //     "barberId": page.emp.barberId
                // }, function(ret) {
                //     self.loading = false;
                //     // if (!disableTip) {
                //     //     page.setStatus("normal");
                //     // }
                //     if (ret.code == 0) {
                //         console.log(ret.content);
                //         // self.data = ret.content;
                //         mainTable.renderData(ret.content);
                //         // if (!disableScroll) {
                //         //     // self.scroll("current");
                //         // }
                //         console.log(ret);
                //     } else {
                //         amGloble.msg("数据加载失败,点击重试!");
                //     }
                // });
            }
            if (!this.inited) {
                this.initReservation();
            }
            this.setStatus("loading");
            this.getReservationDataByShopId(paras ? paras.shopId : undefined, function(data) {
                var newReservationFrom = data.reservationFrom;
                var newReservationTo = data.reservationTo;
                if (newReservationTo != self.reservationTo || newReservationFrom != self.newReservationFrom) {
                    self.reservationFrom = newReservationFrom;
                    self.reservationTo = newReservationTo;
                    table.initDate();
                    table.createFrame();
                }
                if(paras && paras != 'back'&&paras.code!==0){
                    timeBar.refresh();
                }
                self.initTimeBarSelect(paras);
                self.setStatus("normal");
            })
        },
        getReservationDataByShopId: function(shopId, callback) {
            var self = this;
            var configs = amGloble.metadata.configs;
            var reservationFrom = shopId ? (self.reservationFrom || configs.reservationFrom) : configs.reservationFrom,
                reservationTo = shopId ? (self.reservationTo || configs.reservationTo) : configs.reservationTo;
            if (shopId === undefined || shopId == this.lastShopId || amGloble.metadata.userInfo.shopType != 0) {
                callback({
                    reservationTo: reservationTo,
                    reservationFrom: reservationFrom,
                });
                return;
            }
            amGloble.api.listNormalConfig.exec({
                shopId: shopId,
                keys: ['reservationTo', 'reservationFrom', 'customAppointmentSet']
            }, function(res) {
                if (res.code === 0) {
                    var customAppointmentSet = res.content.customAppointmentSet;
                    if (customAppointmentSet === 'true') {
                        reservationFrom = res.content.reservationFrom || configs.reservationFrom;
                        reservationTo = res.content.reservationTo || configs.reservationTo;
                    }
                    self.lastShopId = shopId;
                    callback({
                        reservationTo: reservationTo,
                        reservationFrom: reservationFrom,
                    })
                }
            })
        },
        initTimeBarSelect: function(paras) {
            timeBar.currentDate = paras && paras.currentDate?paras.currentDate:amGloble.now();
            timeBar.gotoDate(timeBar.currentDate);
            var tm = timeBar.currentDate.getDate() - amGloble.now().getDate();
            var lis = page.$.find(".reservation_tab ul li");
            if(tm == 0 ){
                $(lis[0]).addClass("selected").siblings().removeClass("selected");
            }else if(tm == 1 ){
                $(lis[1]).addClass("selected").siblings().removeClass("selected");
            }else if(tm == 2 ) {
                $(lis[2]).addClass("selected").siblings().removeClass("selected");
            }else{
                $(lis[3]).addClass("selected").siblings().removeClass("selected");
            }
        },
        afterShow: function(paras) {
            if (paras == "back") {
                return;
            }
            setTimeout(function() {
                table.scroll();
            }, 300);
        },
        afterHide: function(){
            page.shopId = undefined;
		},
    });

    var timeBar = amGloble.page.reservation.timeBar = {
        init: function() {
            var self = this;
            //类型bar

            var $tabc = page.$.find(".reservation_tab");
            this.$tab = $tabc.find("ul").on("vclick", "li", function() {
                var $this = $(this);
                var idx = $this.index();

                if (table.loading) {
                    return;
                }
                $(this).addClass("selected").siblings().removeClass("selected");

                if (idx == 0) {
                    self.today();
                } else if (idx == 1) {
                    self.tomorrow();
                } else if (idx == 2) {
                    self.aftertomorrow();
                } else if (idx == 3) {
                    setTimeout(function() {
                        self.$currentDate.mobiscroll('setVal', new Date(self.$currentDate.text()));
                        self.$currentDate.mobiscroll('show');
                    }, 50);
                }
            });
            //chali
            this.$currentDate = this.$tab.find("#timePicker_custom .text");
            //chali 最大可选择日期
            var maxDate = new Date(amGloble.now().setDate(amGloble.now().getDate() + (amGloble.metadata.configs.mgjReservationDays?amGloble.metadata.configs.mgjReservationDays*1:30)));
            this.$currentDate.mobiscroll().date({
                dateFormat: "yyyy-mm-dd",
                display: 'bottom',
                animate: 'slideup',
                lang: "zh",
                mode: "scroller",
                max: maxDate,
                onSet: function(valueText, inst) {
                    self.gotoDate(valueText.valueText, undefined, undefined, 'datepicker');
                }
            });
			timeBar.today();
			
			document.addEventListener("backbutton", function() {
				self.$currentDate && self.$currentDate.mobiscroll('hide');
			}, false);

        },
        gotoDate: function(date, disableTip, disableScroll, flag) {
            var dt = parseDate(date);
            if(table.isCrossDay(table.startTs.format('HH:MM'), dt.format('HH:MM')) &&
            table.isCrossDay(table.startTs.format("HH:MM"), table.endTs.format("HH:MM")) &&
            !page.paras.absoluteDay &&
            flag != 'datepicker'
            ) {
                date = new Date(dt.getTime()-24*60*60*1000);
            }
            this.currentDate = parseDate(date);
            this.renderDate(disableTip, disableScroll);
        },
        prevDay: function() {
            var cd = this.currentDate;
            cd.setDate(cd.getDate() - 1);
            this.renderDate();
        },
        nextDay: function() {
            var cd = this.currentDate;
            cd.setDate(cd.getDate() + 1);
            this.renderDate();
        },
        today: function() {
            this.currentDate = amGloble.now();
            this.renderDate();
        },
        tomorrow: function() {
            var cd = this.currentDate = amGloble.now();
            cd.setDate(cd.getDate() + 1);
            this.renderDate();
        },
        aftertomorrow: function() {
            var cd = this.currentDate = amGloble.now();
            cd.setDate(cd.getDate() + 2);
            this.renderDate();
        },
        renderDate: function(disableTip, disableScroll) {
            this.$currentDate.html(this.currentDate.format("yyyy-mm-dd")||'');
            this.refresh(disableTip, disableScroll);
        },
        refresh: function(disableTip, disableScroll) {
            table.getData(this.currentDate.getTime(), disableTip, disableScroll);
        },
        isToday: function() {
            return this.currentDate.format("yyyy-mm-dd") == amGloble.now().format("yyyy-mm-dd");
        },
        thatday: function() {
            var thatday = parseDate(this.currentDate.format("yyyy-mm-dd")).getTime();
            var today = parseDate(amGloble.now().format("yyyy-mm-dd")).getTime();

            if (thatday < today) {
                return -1;
            } else if (thatday == today) {
                return 0;
            } else if (thatday > today) {
                return 1;
            }

        },
    };

    var table = window.mainTable = {
        initDate: function() {
            var self = this;
            var configs = amGloble.metadata.configs;
            var reservationFrom = page.reservationFrom || configs.reservationFrom;
            var reservationTo = page.reservationTo || configs.reservationTo;
            
            var sts = (reservationFrom || "9:00").split(":");
            var ets = (reservationTo || "22:00").split(":");
            var currentDate = amGloble.now();
            if(this.isCrossDay(reservationFrom, reservationTo)) {
                if(this.isCrossDay(page.reservationFrom, currentDate.format('HH:MM'))) {
                    currentDate =new Date(currentDate.getTime()-24*60*60*1000);
                }
            }
            this.startTs = new Date(currentDate.format("yyyy/mm/dd ") + (reservationFrom || "9:00") + ":00");
            this.endTs = new Date(currentDate.format("yyyy/mm/dd ") + (reservationTo || "22:00") + ":00");
            if(this.isCrossDay(reservationFrom || "9:00", reservationTo || "22:00")) {
                this.endTs = new Date(this.endTs.getTime()+24*60*60*1000);
            }

            //TODO
            this.startHour = sts[0] * 1;
            if (ets[1] * 1 > 0) {
                this.endHour = ets[0] * 1;
            } else {
                this.endHour = ets[0] * 1 - 1;
            }
        },
        init: function() {
            var self = this;
            this.initDate();
            page.$showItemConfirmScroll = new $.am.ScrollView({
                $wrap: page.$.find(".showItemConfirm > .content .contentItems"),
                $inner: page.$.find(".showItemConfirm > .content > .contentItems .reservationItems"),
                direction: [false, true],
                hasInput: false
            });

            page.$reservationInfoScroll = new $.am.ScrollView({
                $wrap: page.$.find(".reservationInfo > .content .contentItems"),
                $inner: page.$.find(".reservationInfo > .content > .contentItems .reservationItems"),
                direction: [false, true],
                hasInput: false
            });


            //  chali点击查看预约的项目
            this.$tbody = page.$.find("#panel_table").children("tbody").on("vclick", ".reservation .showItem", function() {
                var item = $(this).parent().parent().data("item");
                item.itemProp = JSON.parse(item.itemProp);
                if(!item.itemProp || !item.itemProp.items){
                    return false;
                }
                var itemList = item.itemProp.items;
                var packages = item.itemProp.packages;
                if(item.itemProp.packages){
                    for (var key in packages) {
                        if (packages.hasOwnProperty(key)) {
                            // if(key != "name" || packages[key]){
                            //     item[key] = packages[key];
                            // }
                            packages[key].name = packages[key].serviceItemName;
                            itemList[key] = packages[key];
                        }
                    }
                }
                page.$showItemConfirm.find(".content .reservationItems").empty();
                $.each(item.itemProp.packages?$.extend(item.itemProp.items, item.itemProp.packages):item.itemProp.items, function(i, it) {
                    var itClone = page.$itemClone.clone();
                    var items = page.$showItemConfirm.find(".content .reservationItems");
                    itClone.find(".text").text(it.name);
                    items.append(itClone);
                });
                page.$showItemConfirm.show();
                // console.log(page.$showItemConfirmScroll,"dayinsha")
                page.$showItemConfirmScroll.refresh();
                page.$showItemConfirmScroll.scrollTo("top");
                return false;
            }).on("vclick", ".reservation .headerImg", function(event) {//点击查看预约会员信息
                console.log('点击头像', event);
                var item = $(this).parent().data("item");
                item = Array.isArray(item) ? item[0] : item;
                // var item = $(this).parent().parent().data("item");
                console.log("点击到了头像",page.barberId)
                var shop = amGloble.storeSelect.getCurrentShops();
                $.am.changePage(amGloble.page.customerDetail, "slideleft", {
                    custId: item.custId,
                    currentDate:timeBar.currentDate,
                    eid:page.barberId,
                    shopId: shop.shopId,
                    isHighQuality:item.mgjIsHighQualityCust //优质客
                });
                return false;
            }).on("vclick", ".reservation", function() {
                console.log('点击表格', $(this).data("item"))
                //if (page.barberId != '-1') {
                //    return false;
                //}
                var item = $(this).data("item");
                item = Array.isArray(item) ? item : [item];
                page.$reservationInfo.find(".content .reservationInfo-header .title .num").text(item.length);
                page.$reservationInfo.find(".content .reservationItems").empty();

                var items = page.$reservationInfo.find(".content .reservationItems");
                $.each(item, function(i, its) {
                    var itClone = page.$reservationItemClone.clone();
                    its.itemProp = JSON.parse(its.itemProp);

                    itClone.find('.user-info-box .user-image').html(amGloble.photoManager.createImage("customer", {
                        parentShopId: amGloble.metadata.userInfo.parentShopId
                    }, its.custId + ".jpg", "s"));
                    itClone.find('.user-info-box .user-info .user-name').text(its.custName);
                    if (amGloble.metadata.permissions.allowphone) {
                        itClone.find('.user-info-box .user-info .user-phone-number').text(its.memmobile);
                    } else {
                        itClone.find('.user-info-box .user-info .user-phone-number').hide();
                    }

                    if (its.itemProp) {
                        its.itemProp.items && $.each(its.itemProp.items, function(i, it) {
                            itClone.find('.project .right-main').append(`<div class="tab">${it.name}</div>`);
                        });
                        its.itemProp.packages && $.each(its.itemProp.packages, function(i, it) {
                            itClone.find('.project .right-main').append(`<div class="tab">${it.serviceItemName}</div>`);
                        });
                        if (itClone.find('.project .right-main').children().length == 0) {
                            itClone.find('.project .right-main').html('-');
                        }
                    } else {
                        if (its.categoryName) {
                            itClone.find('.project .right-main').append(`<div class="tab">${its.categoryName}</div>`);
                        } else {
                            itClone.find('.project .right-main').html('-');
                        }
                    }
	if(its.mallItemName){
                                itClone.find('.mall .right-main').html(its.mallItemName)
                                itClone.find('.mall').css({"display":"flex"})
                            }

                    itClone.find('.time .right-main').text(parseDate(its.reservationTime).format("mm月dd日 HH:MM"));
                    itClone.find('.remarks .right-main').text(its.comment || '-');
                    itClone.data("item", its);
                    var metadataConfig = amGloble.metadata.configs;
                    var notAllowedCancelEmployeeReservation = "";
                    if (metadataConfig.staffHandle && amGloble.metadata.userInfo.userType == 1) {
                        notAllowedCancelEmployeeReservation = JSON.parse(metadataConfig.staffHandle).notAllowedCancelEmployeeReservation; 
                    }
                    if (notAllowedCancelEmployeeReservation == 1) {
                        itClone.find('.cancel').hide();
                    }

                    items.append(itClone);
                });

                page.$reservationInfo.find('.content .reservationItems .user-info-box').on("vclick", ".cancel", function(e) {
                    e.stopPropagation();
                    var $this = $(this);
                    var item = $this.parent().parent().data("item");
    
                    if (item.type == 0) {
                        atMobile.nativeUIWidget.confirm({
                            caption: "取消预约",
                            description: "确定取消这一单预约么？",
                            okCaption: "是",
                            cancelCaption: "否"
                        }, function() {
                            page.$reservationInfo.hide();
                            self.cancel(item);
                        }, function() {});
                    } else {
                        page.$reservationInfo.hide();
                        self.cancel(item);
                    }
    
                    return false;
    
                })

                page.$reservationInfo.find('.content .reservationItems .user-info-box').on("vclick", ".user-image", function(event) {//点击查看预约会员信息
                    var item = $(this).parent().parent().data("item");
                    // var item = $(this).parent().parent().data("item");
                    console.log("点击到了头像",page.barberId)
                    var shop = amGloble.storeSelect.getCurrentShops();
                    $.am.changePage(amGloble.page.customerDetail, "slideleft", {
                        custId: item.custId,
                        currentDate:timeBar.currentDate,
                        eid:page.barberId,
                        shopId: shop.shopId,
                        isHighQuality:item.mgjIsHighQualityCust //优质客
                    });
                    return false;
                })
	page.$reservationInfo.find('.content .reservationItems .mall').on("vclick", ".right-main", function(event) {//点击查看预约会员信息
                    var item = $(this).parent().parent().data("item");
                    var shop = amGloble.storeSelect.getCurrentShops();
                    $.am.changePage(amGloble.page.customerDetail, "slideleft", {
                        custId: item.custId,
                        currentDate:timeBar.currentDate,
                        eid:page.barberId,
                        shopId: shop.shopId,
                        isHighQuality:item.mgjIsHighQualityCust, //优质客
                        idx: 7
                    });
                    return false;
                })

                page.$reservationInfo.show();
                page.$reservationInfoScroll.refresh();
                page.$reservationInfoScroll.scrollTo("top");
                return false;
            });

            this.$tr = this.$tbody.children("tr:first").remove();

            this.$nocontent = this.$tr.find(".nocontent").remove();
            this.$leave = this.$tr.find(".leave").remove();
            this.$placehold = this.$tr.find(".placehold").remove();
            //chali 预约占用
            this.$reservationPlaceHold = this.$tr.find(".reservationPlaceHold").remove();
            this.$reservation = this.$tr.find(".reservation").remove();

            this.$timeline = page.$.find(".timeline");
            //已占用
            this.$tbody.on("vclick", ".placehold", function() {
                var $this = $(this);
                var item = $this.data("item");
                var shop = amGloble.storeSelect.getCurrentShops();
                $.am.changePage(amGloble.page.reservationRemark,"slideup", {
                    item:item,
                    data:{
                        currentDate:timeBar.currentDate,
                        eid:page.barberId,
                        shopId: shop.shopId
                    }
                });
            });
            //鼠标点击占位 休假和过去时间提示无法预约
            this.$tbody.on("vclick", ".createPlaceHolderBtn", function() {
                self.createHolder($(this).parent().parent().parent());
                return false;
            });

            //鼠标点击创建 休假和过去时间提示无法预约
            this.$tbody.on("vclick", ".createReservationBtn", function() {
                if (amGloble.metadata.userInfo.mgjVersion != 6) {
                    if (amGloble.checkVersion()) {
                        return;
                    }
                }
                var $tr = $(this).parent().parent().parent();
                var timeData = $tr.data("data");
                var time = timeData.time;
                var from = page.reservationFrom || "09:00";
                if(self.isCrossDay(from, time.format('HH:MM'))) {
                    time = new Date(new Date(timeBar.currentDate.format("yyyy/mm/dd") + time.format(" HH:MM:ss")).getTime()+24*60*60*1000)
                } else {
                    time = parseDate(timeBar.currentDate.format("yyyy-mm-dd") + time.format(" HH:MM:ss"));
                }
                var day = new Date(time).getDate();
                var trTimes;
                if(timeBar.isToday()){
                    trTimes = JSON.parse(JSON.stringify(self.$trTimes));
                }else {
                    trTimes = JSON.parse(JSON.stringify(self.$allTrTimes));
                }
                for(var i=0;i<trTimes.length;i++){
                    trTimes[i].time = new Date(new Date(trTimes[i].time).setDate(day));
                    trTimes[i].name = trTimes[i].time.format('yyyy-mm-dd HH:MM');
                }
                var params = {
                  reservationTime: time,
                  timeNum:timeData.timeNum,
                  trTimes:trTimes,
                  emp:page.emp,
                  shopId:page.shopId,
                  user:page.paras && page.paras.user ?page.paras.user:'',
                  fromPage:page.paras && page.paras.fromPage ? page.paras.fromPage : undefined,
                  shifts:self.shifts
                }
                if($tr.hasClass("scheduleShiftBg")){
                  reservationTimeDialog.show(params, function(){
                    $.am.changePage(amGloble.page.reservationCreate,"slideup", params);
                  })
                }else{
                  $.am.changePage(amGloble.page.reservationCreate,"slideup", params);
                }
            });
            //取消占位/预约
            this.$tbody.on("vclick", ".block .cancel", function(e) {
                e.stopPropagation();
                var $this = $(this);
                var item = $this.parent().data("item");

                if (item.type == 0) {
                    atMobile.nativeUIWidget.confirm({
                        caption: "取消预约",
                        description: "确定取消这一单预约么？",
                        okCaption: "是",
                        cancelCaption: "否"
                    }, function() {
                        self.cancel(item);
                    }, function() {});
                } else {
                    self.cancel(item);
                }

                return false;

			});
			this.$tbody.on('vclick', '.block .pledge_flag', function(e) {
				e.stopPropagation();
				var $this = $(this);
                var item = $this.parent().parent().data("item");
                if(parseInt(item.pledgeStatus) === 2 ){
                    amGloble.msg('保证金已按原支付方式退回');
                }else if(parseInt(item.pledgeStatus) === 1){
                    if(item.status==1){
                        amGloble.msg('您已到店，保证金将按原支付方式退回');
                    }else{
                        amGloble.msg('该顾客已经缴纳了预约保证金￥' + item.pledgeMoney);
                    }
                }
				
			});
			this.$tbody.on('vclick', '.block .reservation_reject_flag', function(e) {
				e.stopPropagation();
				amGloble.msg('该顾客由于爽约次数太多，已被取消自助预约权限');
			});
			this.$tabDays = page.$.find(".reservation_tab .day")
            this.$tabnum = page.$.find(".reservation_tab .num");
            this.$shiftInfo=page.$.find('.shift-info');
            this.$shiftName=this.$shiftInfo.find('.shift-name');
            this.$shiftTime=this.$shiftInfo.find('.shift-time');
        },
        isCrossDay: function(from, to){
            if(typeof from === 'number' && typeof to === 'number') {
                return to < from;
            }
            var f = new Date(new Date().format('yyyy/mm/dd ') + (from||'09:00'))
            var t = new Date(new Date().format('yyyy/mm/dd ') + (to||'22:00'))
            return t.getTime() < f.getTime();
        },
        createHolder: function($td) {
            var self = this;
            var time = $td.data("data").time;
            var from = page.reservationFrom || "09:00";
            if(this.isCrossDay(from, time.format('HH:MM'))) {
                time = new Date(new Date(timeBar.currentDate.format("yyyy/mm/dd") + time.format(" HH:MM:ss")).getTime()+24*60*60*1000)
            } else {
                time = parseDate(timeBar.currentDate.format("yyyy-mm-dd") + time.format(" HH:MM:ss"));
            }
            // var shop = amGloble.storeSelect.getCurrentShops();
            amGloble.loading.show("正在提交，请稍候...");
            var opt={
                "shopId": amGloble.metadata.userInfo.shopId,
                "type": 1,
                "reservationTime": time.getTime(),
                "barberId": amGloble.metadata.userInfo.userId,
                "barberName": amGloble.metadata.userInfo.userName,
                "barberNickname": amGloble.metadata.userInfo.nickname,
                "channel": 3, //0收银 1美一客web 2美一客app 3生意宝
                "custId": -1,
                "categoryId": -1,
                "number": 1,
                "reservationType": 1 //反预约
            };
            if(self.isManager()){
                opt.barberId=page.emp.barberId;
                opt.barberName=page.emp.barberName;
                opt.barberNickname=page.emp.barberNickname;
			}
			var apiCallback = function(ret) {
				amGloble.loading.hide();
                if (ret.code == 0) {
                    amGloble.page.dashboard.reservationCacheUtil.clear();
                    amGloble.page.dashboard.dashboardCacheUtil.clear();
                    amGloble.msg("预约已经登记！");
                    timeBar.gotoDate(parseDate(time), true, true);
                } else {
                    amGloble.msg(ret.message || "提交失败，请重试！", true);
                }
			}
            amGloble.api.reservationAdd.exec(opt, function(ret) {
				if (ret.code == 203005) {
					amGloble.api.reservationAdd.exec(opt, function(result) {
						apiCallback(result)
					})
				} else {
					apiCallback(ret);
				}
                
            });
            // amGloble.confirm("占用备注", "是否填写备注?", "不填写", "填写", function() {
            //     amGloble.loading.show("正在提交，请稍候...");
            //     amGloble.api.reservationAdd.exec({
            //         "shopId": amGloble.metadata.userInfo.shopId,
            //         "type": 1,
            //         "reservationTime": time.getTime(),
            //         "barberId": amGloble.metadata.userInfo.userId,
            //         "barberName": amGloble.metadata.userInfo.userName,
            //         "barberNickname": amGloble.metadata.userInfo.nickname,
            //         "channel": 3, //0收银 1美一客web 2美一客app 3生意宝
            //         "custId": -1,
            //         "categoryId": -1,
            //         "number": 1,
            //         "reservationType": 1 //反预约
            //     }, function(ret) {
            //         amGloble.loading.hide();
            //         if (ret.code == 0) {
            //             amGloble.msg("预约已经登记！");
            //             timeBar.gotoDate(parseDate(time), true, true);
            //         } else {
            //             amGloble.msg(ret.message || "提交失败，请重试！", true);
            //         }
            //     });
            // }, function() {
            //     $.am.changePage(amGloble.page.reservationRemark,"slideup", {
            //         timeBar:timeBar,
            //         time:time,
            //         data:{
            //             currentDate:timeBar.currentDate,
            //             eid:page.barberId,
            //             shopId: shop.shopId
            //         }
            //     });
            // });
        },

        //创建空的框架

        createFrame: function() {
            //TODO
            var self = this;
            var startHour = this.startHour;
            var endHour = this.endHour;
            var startTs = this.startTs.getTime();
            var endTs = this.endTs.getTime();

            var strategy = amGloble.metadata.configs.strategy;

            var $tbody = this.$tbody.empty();

            var blocks = (endTs - startTs) / 900000;
            for (var i = 0; i < blocks; i++) {

                var $tr = this.$tr.clone(true, true);

                var time = parseDate(startTs + i * 900000);
                var min = time.format("MM");
                if ((strategy == "0" && ["15","45"].indexOf(min) != -1) || (strategy == "1" && ["15","30","45"].indexOf(min) != -1)) {
                    continue;

                }
                if (min == "00") {
                    $tr.find(".time").html("<span>" + time.format("HH") + "</span>:" + min + "");
                } else {
                    $tr.addClass("small").find(".time").html("<span>" + time.format("HH") + "</span>:" + min + "");
                }

                // $tr.data("ts", time); chali
                $tr.data("data", {time:time,timeNum:null});
                $tbody.append($tr);
            }

        },

        //清空框架

        clearFrame: function() {
            var self = this;
            this.$tbody.find("td.content").each(function() {
                $(this).empty().append(self.$nocontent.clone(true, true));
            });

        },

        //render数据
        renderData: function(data) {
            this.clearFrame();
            var self = this;
            var $trs = this.$tbody.children("tr");
            
            //chali判断是否开启高级预约模式
            // var mgjReservationConfig = amGloble.metadata.configs.mgjReservationItem;
            var vacation = false;
            //判断是否休假
            if (data.vacations && data.vacations.length) {
                $.each(data.vacations, function(i, item) {
                    if (item.empId == amGloble.metadata.userInfo.userId || item.empId ==  page.barberId) {
                        vacation = true;
                        return false;
                    }
                });
            }

			var total = 0;
			var nowDay = amGloble.now().getDay()
            this.$tabDays.each(function(i) {
                var dayCount = data.countOfDays[i];
                total += dayCount;
				$(this).text(self.getWeekDay(nowDay + i));
				$(this).siblings().find('.count').text(dayCount || 0);
			});
           
            // console.log("loop data", i);
            self.$trTimes = [];
            self.$allTrTimes = [];
            $trs.each(function(j, tr) {
                var trShow = false;
                var $this = $(tr);
                var timeData = $this.data("data");
                var ts = timeData.time;//chali
                var bool = true;
                var endTs = self.endTs.getTime();
                var strategy = amGloble.metadata.configs.strategy;
                timeData.timeNum = parseInt((endTs-ts)/1800000/2);
                if(strategy == 0){
                    timeData.timeNum = parseInt((endTs-ts)/1800000);
                }
                if(strategy == 2){
                    timeData.timeNum = parseInt((endTs-ts)/900000);
                }
                self.$allTrTimes.push(timeData)
                var $content = $this.find(".content");

                if (vacation) {
                    //休假
                    var $leave = self.$leave.clone(true, true);
                    $content.empty().append($leave);
                    // console.log("休假中，哈哈哈哈",)
                    trShow = true;
                } else {

                    // console.log("loop tr", ts);
                    var reservationArr = [];

                    var currentDate=timeBar.currentDate.format("yyyy/mm/dd");
                    var r_from = page.reservationFrom || "09:00";
                    var r_to = page.reservationTo || "22:00";
                    var startTime = new Date(currentDate + ' ' + r_from).getTime();
                    var endTime = new Date(currentDate + ' ' + r_to).getTime();
                    if(self.isCrossDay(r_from, r_to)) {
                        endTime = endTime + 24*60*60*1000;
                    }
                    data.reservations.sort(function(a, b) {
                        return a.createtime - b.createtime;
                    })

                    $.each(data.reservations, function(i, item) {
                        //遍历所有预约

                        var reservationTime = parseDate(item.reservationTime);
                        var reservationTs = reservationTime.getTime();

                        //查找对应行，美发师匹配&&并且是同一天
                        if (reservationTs < startTime || reservationTs > endTime) {
                            return true;
                        } else {
                            //TODO
                            var hour = ts.getHours();
                            var thour = reservationTime.getHours();
                            var minute = ts.getMinutes();
                            var tminute = reservationTime.getMinutes();
                            // console.log("loop td", k, hour, thour);

                            var dMin = tminute - minute;
                            //计算本日后面有预约或者占用的情况下，本时间段的最长可用时间段
                            if(ts <= reservationTime && bool){
                                if (strategy == "1"){
                                    timeData.timeNum = parseInt((reservationTime - ts)/1800000/2);
                                }else if (strategy == "0"){
                                    timeData.timeNum = parseInt((reservationTime - ts)/1800000);
                                }else {
                                    timeData.timeNum = parseInt((reservationTime - ts)/900000);
                                }
                                $this.data("data",timeData);
                                bool = false;
                            }
                            if (hour == thour && ((strategy==1 && dMin <= 30) || (strategy == 0 && dMin >= 0 && dMin < 30) || (strategy == 2 && dMin == 0)) && item.status != 2) {
                                // console.log(hour, tminute, minute);
                                var metadataConfig = amGloble.metadata.configs;
                                var notAllowedCancelEmployeeReservation = "";
                                if (metadataConfig.staffHandle && amGloble.metadata.userInfo.userType == 1) {
                                    notAllowedCancelEmployeeReservation = JSON.parse(metadataConfig.staffHandle).notAllowedCancelEmployeeReservation; 
                                }
                                //添加一个预约模块
                                if (item.type) {
                                    if($content.find('.reservation').length){
                                        return false;
                                    }
                                    var $holder = self.$placehold.clone(true, true);
                                    //前面预约引起的占用,不可取消
                                    if(item.reservId){
                                        $holder = self.$reservationPlaceHold.clone(true, true);
                                    }
                                    //占用
                                    $holder.data("item", item);
                                    if(amGloble.metadata.userInfo.newRole < 4){
                                        if(!self.isManager()){
                                            $holder.find(".cancel").remove();
                                        }
                                    }
                                    if (notAllowedCancelEmployeeReservation == 1 && (amGloble.metadata.userInfo.userType != 1 || item.reservId)) {
                                        $holder.find(".cancel").hide();
                                    }
                                    if(item && item.comment &&item.comment.length>0){ // 占用如果有备注则显示
                                        $holder.find('.holder-comment').show().text(item.comment)
                                    }else{
                                        $holder.find('.holder-comment').hide().text('');
                                    }
                                    $content.empty().append($holder);
                                } else{
                                    reservationArr.push(item);
                                    // console.log("添加一个正常预约模块", item);
                                    //正常预约
                                    
                                    var $rvitem = self.$reservation.clone(true, true);
                                    $rvitem.find(".reservation-num").hide();
                                    $rvitem.removeClass('reservation-layer');
                                    if (item.barberId == -1) {
                                        $rvitem.find(".cancel").hide();
                                    }

                                    var projectData = JSON.parse(item.itemProp);

                                    var objEmpty = function(obj) {
                                        return obj && Object.keys(obj).length
                                    }

                                    if (!projectData || (!objEmpty(projectData.items) && !objEmpty(projectData.packages))) {
                                        $rvitem.find(".showItem").hide();
                                    }

                                    if (reservationArr.length > 1) {
                                        $rvitem.find(".showItem").hide();
                                        $rvitem.find(".reservation-num").html(reservationArr.length);
                                        $rvitem.find(".reservation-num").show();
                                        $rvitem.addClass('reservation-layer');
                                    }
                                    $rvitem.find(".header").html(amGloble.photoManager.createImage("customer", {
                                        parentShopId: amGloble.metadata.userInfo.parentShopId
                                    }, item.custId + ".jpg", "s"));

                                    if (item.gender == "M") {
                                        $rvitem.find(".header").addClass("male");
                                    }
                                    if (item.mgjIsHighQualityCust == 1) {
                                        $rvitem.find(".header").addClass("good");
                                    } else {
                                        $rvitem.find(".header").removeClass("good");
                                    }
                                    if ($.trim(item.comment)) {
                                        $rvitem.find(".comment").html(item.comment);
                                    } else {
                                        $rvitem.find(".comment").hide();
                                    }
                                    $rvitem.find(".cati").html(item.categoryName);
                                    // console.log(amGloble.metadata.configs.mgjReservationItem,"amGloble.metadata.configs.mgjReservationItem",item.itemProp?1:0)
                                    //查理是否显示项目详情 chali
                                    if(item.itemProp){
                                        $rvitem.find(".cati").hide();
                                    }else{
                                        $rvitem.find(".showItem").hide();
                                    }

                                    if (!item.categoryName) {
                                        $rvitem.find(".cati").hide();
                                    }
                                    
                                    if(item.number == 4){
                                        $rvitem.find(".num").html("多人");
                                    } else if (item.number > 1 ) {
                                        $rvitem.find(".num").html(item.number + "位");
                                    }else{
                                        $rvitem.find(".num").hide();
                                    }

                                    $rvitem.find(".name").html(item.custName);

                                    if (item.status == 1 || item.status == 3) {
                                        //已到店
                                        $rvitem.addClass("green");
                                        $rvitem.find(".cancel").hide();
                                    } else {
                                        if (amGloble.now().getTime() > item.reservationTime) {
                                            //已逾期
                                            $rvitem.addClass("red");
                                        } else {
                                            //预约中
                                        }
                                    }
                                    if(amGloble.metadata.userInfo.newRole < 4){
                                        if(!self.isManager()){
                                            $rvitem.find(".cancel").remove()
                                        }
									}
                                    if (notAllowedCancelEmployeeReservation == 1) {
                                        $rvitem.find(".cancel").hide();
                                    }
									if ((parseInt(item.pledgeStatus) === 1||parseInt(item.pledgeStatus) === 2) && item.pledgeMoney > 0) {
										$rvitem.find('.line1').append('<span class="am-clickable pledge_flag">保证金</span>');
                                    }
									if (parseInt(item.mgjReservationReject) === 1) {
										$rvitem.find('.line1').append('<span class="am-clickable reservation_reject_flag">爽约限制</span>');
									}
                                    $rvitem.data("item", reservationArr.length > 1 ? reservationArr : item);
                                    $content.empty().append($rvitem);
                                }
                                trShow = true;
                            }
                        }

                    });
                    if(ts > amGloble.now() && timeData.timeNum){
                        timeData.name = timeData.time.format("yyyy-mm-dd HH:MM");
                        self.$trTimes.push(timeData);
                    }
                }
                //chali tr没有预约跟占用, 登陆角色不是4 手艺人,或者员工不允许预约 清空tr
                var userInfo=amGloble.metadata.userInfo;
                if(!trShow && userInfo.newRole < 4 ||(userInfo.newRole >= 4 && userInfo.mgjshowmyk == '0')){
                    if(!self.isManager()){
                        $content.empty()
                    }else{
                        // var reservationHtml='<div class="block nocontent"><span class="am-clickable createReservationBtn">反预约</span></div>'
                        // $content.empty().html(reservationHtml);
                        if(userInfo.shopType==0 && (userInfo.newRole==1 || userInfo.newRole==2 || userInfo.newRole==3)){//总部操作员 管理员 老板不能反预约
                            // 总部老板管理员操作员不能反预约
                            $content.empty();
                        }else{
                            var reservationHtml='<div class="block nocontent"><span class="am-clickable createReservationBtn">反预约</span></div>'
                            $content.empty().html(reservationHtml);
                        }
                    }
                }
            });

            //时间线
            this.renderTimeline();

		},
		getWeekDay: function(day) {
			if (day > 6) {
				day = day - 7
			}
			return '星期' + '日一二三四五六'.charAt(day)
		},
        isManager:function(){
            var userInfo=amGloble.metadata.userInfo;
            if(userInfo.newRole!=1&&userInfo.newRole!=2&&userInfo.newRole!=3){
               return false;
            }else{
                return true;
            }
        },

        renderTimeline: function() {
            var self = this;
            var strategy = amGloble.metadata.configs.strategy;
            var now = amGloble.now();

            var nowTs = now.getTime();
            var startTime = page.reservationFrom || "09:00";
            var endTime = page.reservationTo || "22:00";
            var currentDate = timeBar.currentDate.format("yyyy/mm/dd");
            var startTs = new Date(currentDate + ' ' + startTime).getTime();
            var endTs = new Date(currentDate + ' ' + endTime).getTime();
            if(this.isCrossDay(startTime, endTime)) {
                endTs = endTs + 24*60*60*1000;
            }
            if (nowTs >= startTs && nowTs <= endTs) {
                if (strategy == "1") {
                    if (this.endTs.format("MM") == "30") {
                        endTs += 1800000;
                    }
                } else {}
                var percent = (nowTs - startTs) / (endTs - startTs);
                // console.log(startTs, nowTs, endTs, (endTs - startTs), (nowTs - startTs), percent);
                this.$timeline.show().css("top", percent * 100 + "%");

                clearTimeout(this.timer);
                this.timer = setTimeout(function() {
                    self.renderTimeline();
                }, 3000);

            } else {
                this.$timeline.hide();
            }

            //

            var $trs = this.$tbody.find("tr").removeClass("passed");

            var thatday = timeBar.thatday();

            if (thatday < 0 && !this.isCrossDay(startTime, endTime)) {
                $trs.addClass("passed");

            } else if (thatday == 0 || (this.isCrossDay(startTime, endTime) && thatday == -1)) {

                $trs.each(function() {
                    //TODO
                    var $this = $(this);
                    var ts = $this.data("data").time;
                    // console.log(thour, hour);
                    ts = new Date(currentDate + ts.format(" HH:MM"));
                    if(self.isCrossDay(startTime, endTime) && self.isCrossDay(startTime, ts.format("HH:MM"))){ 
                        ts = new Date(ts.getTime()+24*60*60*1000);
                    }
                    if (nowTs > ts) {
                        $this.addClass("passed");
                        // var tmData = $this.data("data")
                        // tmData.timeNum = 0;
                        // $this.data("data",tmData)
                    }

                });

            } else if (thatday > 0) {}

        },
        renderShiftInfo: function (data) {
            var self = this;
            self.$shiftInfo.show();
            var item = data && data[0] && data[0].scheduleShift && data[0].scheduleShift[0];
            // self.$shiftInfo.show();
            if (item && item.id && item.shiftName) {
                self.shifts = [item]
                var shiftName = item.shiftName;
                var shiftTime = '(' + item.goWorkTime + '~' + item.outWorkTime + ')';
                self.$shiftName.text(shiftName);
                if (shiftName.indexOf('休') != -1) {
                    self.$shiftTime.text('(可正常占用和反预约)');
                } else {
                    self.$shiftTime.text(shiftTime);
                }
            } else {
                self.$shiftName.text('未排班');
                self.$shiftTime.text('');
                // self.$shiftInfo.hide();
            }
            var userInfo = amGloble.metadata.userInfo
            if(userInfo.userType == 0 && userInfo.shopType != 0){
              var $trs = this.$tbody.children("tr");
              $trs.each(function(j, tr) {
                var $this = $(tr);
                var timeData = $this.data("data");
                var ts = timeData.time;//chali
                if(item){
                  var goWorkTime = item.goWorkTime
                  var outWorkTime = item.outWorkTime
                  if(table.isCrossDay(goWorkTime, ts.format("HH:MM")) || !table.isCrossDay(outWorkTime, ts.format("HH:MM"))){ 
                    $this.addClass("scheduleShiftBg")
                  }else{
                    $this.removeClass("scheduleShiftBg")
                  }
                }else{
                  $this.removeClass("scheduleShiftBg")
                }
              })
            }
        },
        // 调排班接口 渲染排班信息
        getShiftInfo:function(params){
            var self = this;
            var date =new Date(params.reservationTime).format('yyyy-mm-dd');
            var opt={
                period:date,
                shopId:page.shopId|| amGloble.metadata.userInfo.shopId,
                parentShopId:amGloble.metadata.userInfo.parentShopId,
                employeeIds:[params.barberId]

            };
            console.log(opt);
            amGloble.api.shiftsList.exec(opt, function (ret) {
                    amGloble.loading.hide();
                    if (ret.code == 0 && ret.content) {
                        self.renderShiftInfo(ret.content)
                    } else {
                        page.setStatus("error");
                        // _this.setStatus("error");
                    }
            });

        },
        getData: function(ts, disableTip, disableScroll) {
            var self = this;

            if (!disableTip) {
                page.setStatus("pageLoading", '', {top: 112});
            }
            this.loading = true;
            // TODO 参数
            page.barberId = page.paras && page.paras.eid ? page.paras.eid : amGloble.metadata.userInfo.userId;
            var params={
                // parentShopId:amGloble.metadata.userInfo.realParentShopId,
                "shopId":page.paras&&page.paras.shopId?page.paras.shopId:amGloble.metadata.userInfo.shopId,
                "reservationTime": ts,
                "barberId": page.barberId
            };
            if(self.isManager()){
                params.barberId=page.emp&&page.emp.barberId;
                params.shopId=page.shopId
            }
            var emp = page.paras && page.paras.emp;
            if (emp && emp.page && emp.page == "page_todoList") {
                // 来自amGloble.page.todoList
                page.barberId = emp.empid;
                params.barberId = emp.empid;
                params.shopId = emp.shopId;
            }
            amGloble.api.reservationList.exec(params, function(ret) {
                self.loading = false;
                if (!disableTip) {
                    page.setStatus("normal");
                }
                if (ret.code == 0) {
                    console.log('reservationList', ret.content);
                    self.data = ret.content;
                    self.renderData(self.data);
                    if (!disableScroll) {
                        // self.scroll("current");
                    }
                    console.log(ret);
                    params.barberId != '-1' && self.getShiftInfo(params) // 未指定的跳转不查询排班
                } else {
                    page.setStatus("error");
                    amGloble.msg("数据加载失败,点击重试!");
                }
            });
        },
        cancel: function(item) {
            var self = this;
            amGloble.loading.show("正在提交，请稍候...");
            amGloble.api.reservationCancel.exec({
                "storeId": amGloble.metadata.userInfo.shopId,
                "id": item.id,
                cancelChannel: 4,
                cancelOperator: amGloble.metadata.userInfo.userId,
                cancelUserType: amGloble.metadata.userInfo.userType,
            }, function(ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    item.status = 2;
                    table.getData(timeBar.currentDate.getTime());
                    amGloble.msg("已成功取消！");
                } else {
                    amGloble.msg(ret.message || "提交失败，请重试！", true);
                }
            });
        },
        scroll: function(direction) {
            var scrollview = page.scrollview;
            var $timeline = this.$timeline;

            if ($timeline.is(":visible")) {
                var top = $timeline.position().top;
                scrollview.scrollTo([0, -top + 30]);
            }

        }
    };

})();
