(function(){
    var self = amGloble.page.tagGroupManage = new $.am.Page({
        id: 'page-tagGroupManage',
        init: function(){
            this.$header.find('.left').vclick(function() {
                var isEdit = false
                isEdit = self.$groupName.val() != (self.groupDetail.groupName||"")
                if(!isEdit){
                    var $addTagNameList = self.$.find(".addTagName")
                    $.each($addTagNameList, function(i, item){
                        if($(item).val()){
                            isEdit = true
                        }
                    })
                }
                if(isEdit){
                    atMobile.nativeUIWidget.confirm({
                        caption: '确认删除',
                        description: '您有未保存的内容，确认返回吗？',
                        okCaption: '返回',
                        cancelCaption: '保存'
                    }, function() {
                        $.am.page.back('slideright');
                    }, function() {
                        self.$header.find('.right').trigger("vclick")
                    });
                }else{
                    $.am.page.back('slideright');
                }
            });

            this.$header.find('.right').vclick(function(){
                self.setStatus('pageLoading');
                var haveEmptyName = false
                $.each(self.$.find(".tagList li"), function(i, item){
                    var data = $(item).data("data")
                    if(data.isAdd){
                        var tagName = $(item).find(".addTagName").val()
                        if(!tagName){
                            haveEmptyName = true
                        }
                    }
                })
                if(haveEmptyName){
                    amGloble.msg("请输入标签名")
                    return
                }
                if(!self.groupDetail.groupName){
                    self.addGroup()
                    return
                }
                if(self.groupDetail.groupId !== -1 && self.$groupName.val() != self.groupDetail.groupName){
                    self.saveGroupName()
                }else{
                    var addLength = self.$.find(".tagList li").filter(function(i,item){
                        var data = $(item).data("data")
                        return data.isAdd
                    })
                    if(addLength.length){
                        self.toAddTags()
                    }else{
                        $.am.page.back('slideright');
                    }
                }
                // self.toAddTags()
            });
            this.delType = 0
            this.$tagList = this.$.find(".tagList")
            this.$groupName = this.$.find(".groupName")
            this.$tagList = this.$.find(".tagList").on("vclick","li .icon-tishi2",function(){
                var data = $(this).parent("li").data("data")
                var time = data.createTime ? new Date(data.createTime*1).format('yyyy-mm-dd HH:MM') : ""
                var emp = null
                if(data.type == 1){
                    emp = amGloble.metadata.adminList.find(function(accountData) {
                        return accountData.id == data.empId;
                    })
                }else{
                    emp = amGloble.metadata.employees.find(function(accountData) {
                        return accountData.empid == data.empId;
                    })
                }
                if(emp||data.empId == '-1'){
                    var empName = data.empId == '-1' ? "" : emp.name||emp.empname
                    amGloble.msg(empName+" "+ time + " 添加")
                }else{
                    amGloble.msg("创建者已删除")
                }

            })
            this.$li = this.$tagList.find("li").remove()
            this.$delBox = this.$.find(".delBox").on("vclick",".item",function(){
                $(this).addClass("selected").find(".iconfont").addClass("icon-danxuankuangxuanzhong").removeClass("icon-danxuankuang")
                $(this).siblings(".item").removeClass("selected").find(".iconfont").addClass("icon-danxuankuang").removeClass("icon-danxuankuangxuanzhong")
                self.delType = $(this).data("type")
            }).on("vclick",".cancel",function(){
                self.$delBox.hide()
                self.$mask.hide()
            }).on("vclick",".confirm",function(){
                self.toDelTags()
            })
            this.$upBox = this.$.find(".upBox").on("vclick",".cancel",function(){
                self.$upBox.hide()
                self.$mask.hide()
            }).on("vclick",".confirm",function(){
                self.upGroup()
            })
            this.$errorUp = this.$.find(".errorUp").on("vclick",".cancel",function(){
                self.$errorUp.hide()
                self.$mask.hide()
            }).on("vclick",".confirm",function(){
                var id = $(this).data("id")
                var item = $(this).data("item")
                if(item){
                    self.upTag(item)
                }else{
                    self.upGroup(id)
                }
            })
            this.$mask = this.$.find(".mask").vclick(function(){
                self.$upBox.hide()
                self.$errorUp.hide()
                self.$delBox.hide()
                self.$mask.hide()
            })

            this.$delGroup = this.$.find(".delGroup").vclick(function(){
                atMobile.nativeUIWidget.confirm({
                    caption: '确认删除',
                    description: '是否删除标签组？',
                    okCaption: '确定',
                    cancelCaption: '取消'
                }, function() {
                    self.delGroup()
                }, function() {
                });
            })
            this.$upGroup = this.$.find(".upGroup").vclick(function(){
                self.$upBox.find(".text span").text(self.groupDetail.groupName)
                self.$upBox.show()
                self.$mask.show()
            })
            this.$addTag = this.$.find(".addTag")
            this.$addTagLi = $('<li><i class="iconfont icon-display_b am-clickable"></i><input class="addTagName" type="text" maxlength="15" placeholder="请输入15字以内的标签" maxlength="20"></li>')
            this.$.on("vclick", ".addTag", function(){
                var $addDom = self.$addTagLi.data("data",{isAdd: true}).clone(true, true)
                self.$.find(".tagList").append($addDom)
                self.refreshPage();
                // if(!self.$addTag.val()) return
                // var shop = amGloble.getTagShop();
                // self.groupDetail.children.push({
                //     tagName: self.$addTag.val(),
                //     isAdd: true,
                //     shopId: shop.shopId,
                //     empId: amGloble.metadata.userInfo.userId,
                //     time: new Date().getTime()
                // })
                // self.render(self.groupDetail)
                // self.$addTag.val("")
            }).on("vclick", ".icon-display_b", function(){
                var data = $(this).parents("li").data("data")
                if(data.isAdd){
                    $(this).parents("li").remove()
                    self.refreshPage();
                    // var index = self.groupDetail.children.findIndex(function(item){
                    //     return data.time == item.time
                    // })
                    // self.groupDetail.children.splice(index, 1)
                    // self.render(self.groupDetail)
                }else{
                    self.delTagDetail = data
                    self.showDelBox(data)
                }
            })
        },
        refreshPage: function() {
            // var buttonDOM = this.$.find('.addTag');
            // var buttonOffset = buttonDOM.offset();
            // var buttonHeight = buttonDOM.height();
            // var windowHeight = self.$.height();
            // if (buttonOffset.top + buttonHeight > windowHeight) {
            //     buttonDOM.addClass('addTag__fixed');
            //     this.$.find('.am-body-wrap').addClass('')
            // } else {
            //     buttonDOM.removeClass('addTag__fixed');
            // }
            self.refresh();
        },
        beforeShow: function(params){
			if (params === 'back') return;
            this.$groupName.attr("disabled", false)
            this.$addTag.show()
            this.$delGroup.show()
            this.$groupName.val("")
            this.$mask.hide()
            this.$delBox.hide()
            this.groupDetail = params
            var userInfo = amGloble.metadata.userInfo
            this.$upGroup.hide()
            if(userInfo.parentShopId !== params.shopId && params.groupName && userInfo.parentShopId == userInfo.shopId && params.groupId != -1){
                this.$upGroup.show()
            }
            if(userInfo.userType == 1){
                this.$upGroup.hide()
                this.$delGroup.hide()
                this.$groupName.attr("disabled", true)
            }
            var shop = amGloble.getTagShop();
            if(shop.shopId != userInfo.shopId){
                this.$addTag.hide()
            }
            this.render(params)
            if(params.shopId && userInfo.shopId != params.shopId){
                this.$delGroup.hide()
                this.$groupName.attr("disabled", true)
            }
            if(params.groupId == -1){
                this.$addTag.hide()
                this.$delGroup.hide()
                this.$groupName.attr("disabled", true)
            }

        },
        afterShow: function(params){
          if (params === 'back') return;
          if(!self.groupDetail.groupName){
            this.$groupName.focus()
          }
        },
        beforeHide: function(){
            self.$errorUp.hide()
            self.$mask.hide()
        },
        afterHide: function(){

		    },
        addGroup: function(){
            if(!self.$groupName.val().trim()){
                amGloble.msg("请输入标签组名")
                return
            }
            var userInfo = amGloble.metadata.userInfo;
            var shop = amGloble.getTagShop();
            amGloble.api.addTagGroup.exec({
                parentShopId: userInfo.parentShopId,
                shopId: shop.shopId,
                groupName: self.$groupName.val()
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    self.groupDetail.groupId = ret.content.id
                    var addLength = self.$.find(".tagList li").filter(function(i,item){
                        var data = $(item).data("data")
                        return data.isAdd
                    })
                    if(addLength.length){
                        self.toAddTags()
                    }else{
                        amGloble.msg("添加标签组成功")
                        $.am.page.back('slideright');
                    }
                }else if(ret.code==2022051901){
                    var id = ret.content[0].id
                    if(ret.content[0].shopId != userInfo.parentShopId && shop.shopId == userInfo.parentShopId){
                        var shopName = amGloble.metadata.shopMap[ret.content[0].shopId].osName || amGloble.metadata.shopMap[ret.content[0].shopId].shopFullName
                        var text = ""
                        if(ret.content.length > 1){
                            text = shopName + "门店等"+ret.content.length+"个门店已存在标签组【"+self.$groupName.val()+"】，需要升级为全企业级标签组吗？"
                        }else{
                            text = shopName + "门店已存在标签组【"+self.$groupName.val()+"】，需要升级为全企业级标签组吗？"
                        }
                        self.$errorUp.show().find(".text").text(text).end().find(".confirm").data("id",id).data("item","")
                        self.$mask.show()
                    }else{
                        amGloble.msg("标签组名重复")
                    }
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.addGroup();
                    }, function() {
                    });
                }
            })
        },
        saveGroupName: function(){
            if(!self.$groupName.val().trim()){
                amGloble.msg("请输入标签组名")
                return
            }
            var userInfo = amGloble.metadata.userInfo;
            var shop = amGloble.getTagShop();
            amGloble.api.updTagGroup.exec({
                parentShopId: userInfo.parentShopId,
                shopId: shop.shopId,
                id: self.groupDetail.groupId,
                groupName: self.$groupName.val()
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    // self.setStatus('normal')
                    var addLength = self.groupDetail.children.filter(function(item){
                        return item.isAdd
                    })
                    if(addLength.length){
                        self.toAddTags()
                    }else{
                        amGloble.msg("修改标签组名成功")
                        $.am.page.back('slideright');
                    }
                }else if(ret.code == 2022051901){
                    self.isEditToUp = true
                    var id = ret.content[0].id
                    if(ret.content[0].shopId != userInfo.parentShopId && shop.shopId == userInfo.parentShopId){
                        var shopName = amGloble.metadata.shopMap[ret.content[0].shopId].osName || amGloble.metadata.shopMap[ret.content[0].shopId].shopFullName
                        var text = ""
                        if(ret.content.length > 1){
                            text = shopName + "门店等"+ret.content.length+"个门店已存在标签组【"+self.$groupName.val()+"】，需要升级为全企业级标签组吗？"
                        }else{
                            text = shopName + "门店已存在标签组【"+self.$groupName.val()+"】，需要升级为全企业级标签组吗？"
                        }
                        self.$errorUp.show().find(".text").text(text).end().find(".confirm").data("id",id).data("item","")
                        self.$mask.show()
                    }else{
                        amGloble.msg("标签组名重复")
                    }
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.saveGroupName();
                    }, function() {
                    });
                }
            })
        },
        showDelBox: function(){
            var userInfo = amGloble.metadata.userInfo;
            amGloble.api.queryCustomerTagNums.exec({
                parentShopId: this.delTagDetail.parentShopId,
                shopId: this.delTagDetail.shopId,
                ids: [this.delTagDetail.id]
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    self.refreshPage();
                    var tag = ret.content&&ret.content[0] ? ret.content[0] : {}
                    if(tag.count){
                        self.$mask.show()
                        self.$delBox.find(".num").text(tag.count||0).end().find(".tag").text(self.delTagDetail.tagName).end().show()
                        self.$delBox.find(".item[data-type='1']").trigger("vclick")
                    }else{
                        atMobile.nativeUIWidget.confirm({
                            caption: '删除标签',
                            description: '是否彻底删除标签？',
                            okCaption: '取消',
                            cancelCaption: '确定'
                        }, function() {
                        }, function() {
                            self.delType = 2
                            self.toDelTags()
                        });
                    }

                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.showDelBox();
                    }, function() {
                    });
                }
            })

        },
        toDelTags:function(){
            var userInfo = amGloble.metadata.userInfo;
            var tag = this.delTagDetail
            amGloble.api.delTag.exec({
                parentShopId: userInfo.parentShopId,
                ids: [tag.id],
                tagMode: this.delType || 1
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    // self.setStatus('normal')
                    var index = self.groupDetail.children.findIndex(function(item){
                        return tag.id == item.id
                    })
                    self.groupDetail.children.splice(index, 1)

                    if(self.delType == 2){
                        var customer = amGloble.page.addTag.customer.tags || []
                        for (var i = 0; i < customer.length; i++) {
                            if(customer[i].id == tag.id){
                                customer.splice(i, 1)
                                break
                            }
                        }
                    }

                    amGloble.msg("删除成功")
                    self.render(self.groupDetail)
                    self.$delBox.hide()
                    self.$mask.hide()
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.toDelTags();
                    }, function() {
                    });
                }
            })
        },
        toAddTags:function(cb){
            var userInfo = amGloble.metadata.userInfo;
            var shop = amGloble.getTagShop();
            var tagReqs = []
            var addLi = this.$.find(".tagList li").filter(function(i,item){
                var data = $(item).data("data")
                return data.isAdd
            })
            if(addLi.length === 0){
                cb && cb()
                return
            }
            $.each(addLi, function(i, item){
                tagReqs.push({
                    parentShopId: userInfo.parentShopId,
                    shopId: shop.shopId,
                    tagName: $(item).find(".addTagName").val(),
                    type: 1,
                    empId: userInfo.userId,
                    groupId: self.groupDetail.groupId
                })
            })
            if(!tagReqs.length) {
                cb && cb()
                return
            }
            amGloble.api.batchAddTag.exec({
                parentShopId: userInfo.parentShopId,
                shopId: shop.shopId,
                tagReqs: tagReqs
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    self.setStatus('normal')
                    amGloble.msg("保存成功")
                    if(cb){
                        cb()
                    }else{
                        $.am.page.back('slideright');
                    }
                } else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.toAddTags();
                    }, function() {
                    });
                }
            })
        },
        upTag: function(item){
            self.setStatus('pageLoading');
            var userInfo = amGloble.metadata.userInfo;
            var apiKey = amGloble.api.updGradeTag
            apiKey.exec({
                parentShopId: item.parentShopId,
                shopId: item.shopId,
                tagName: item.tagName,
                type: item.type,
                empId: item.empId,
                groupId: item.groupId,
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    self.setStatus('normal');
                    amGloble.msg("升级成功")
                    self.$errorUp.hide()
                    self.$upBox.hide()
                    self.$mask.hide()
                    $.am.changePage(amGloble.page.tagManage,'slideright');
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.upTag();
                    }, function() {
                    });
                }
            })
        },
        upGroup: function(id){
            self.setStatus('pageLoading');
            var userInfo = amGloble.metadata.userInfo;
            var apiKey = amGloble.api.updGradeTagGroup
            if(this.isEditToUp){
                this.isEditToUp = false
                apiKey = amGloble.api.updGradeTagGroupNewName
            }
            apiKey.exec({
                parentShopId: userInfo.parentShopId,
                id: id || self.groupDetail.groupId,
                oldGroupId: self.groupDetail.groupId
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    self.setStatus('normal');
                    amGloble.msg("升级成功")
                    self.$errorUp.hide()
                    self.$upBox.hide()
                    self.$mask.hide()
                    self.groupDetail.groupId = id || self.groupDetail.groupId
                    self.toAddTags(function(){
                        $.am.changePage(amGloble.page.tagManage,'slideright');
                    })
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.upGroup();
                    }, function() {
                    });
                }
            })
        },
        delGroup: function(){
            self.setStatus('pageLoading');
            var userInfo = amGloble.metadata.userInfo;
            amGloble.api.delTagGroup.exec({
                parentShopId: userInfo.parentShopId,
                id: self.groupDetail.groupId,
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    self.setStatus('normal');
                    amGloble.msg("删除成功")
                    $.am.changePage(amGloble.page.tagManage,'slideright');
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.delGroup();
                    }, function() {
                    });
                }
            })
        },
        render: function(params){
            if(!this.$groupName.val()){
                this.$groupName.val(params.groupName)
            }
            this.$tagList.empty()
            if(params.children.length){
                this.$.find(".delGroup").hide()
                var shop = amGloble.getTagShop();
                var userInfo = amGloble.metadata.userInfo
                for (var index = 0; index < params.children.length; index++) {
                    var tag = params.children[index];
                    if(tag.shopId == shop.shopId){
                        if((userInfo.userType == 1 && tag.empId != userInfo.userId)||tag.status == 1){
                            continue
                        }
                        var $tag = this.$li.clone()
                        $tag.data("data", tag)
                        $tag.find("span").text(tag.tagName)
                        if((params.shopId && userInfo.shopId != tag.shopId && !tag.isAdd)&&userInfo.shopId != userInfo.parentShopId){
                            $tag.find(".icon-display_b").hide()
                        }
                        if(userInfo.shopType == 0){
                            $tag.find(".icon-tishi2").hide()
                        }
                        this.$tagList.append($tag)
                    }
                }
            }else if(params.groupId){
                this.$.find(".delGroup").show()
            }else{
                this.$.find(".delGroup").hide()
            }
            self.refreshPage();
        }
    });
})();
