(function(){
    var self = amGloble.page.tagManage = new $.am.Page({
        id: 'page-tagManage',
        init: function(){
            this.$header.find('.left').vclick(function() {
                $.am.page.back('slidedown', {noRefresh: true});
            });

            this.$header.find('.right').vclick(function(){
                if($(this).hasClass("saveSort")){
                    $(this).text("排序").removeClass("saveSort")
                    self.$.find('.tagGroupItem').find(".iconfont").removeClass("icon-sort_bar").addClass("icon-gengduo2")
                }else{
                    $(this).text("保存").addClass("saveSort")
                    self.$.find('.tagGroupItem').find(".iconfont").removeClass("icon-gengduo2").addClass("icon-sort_bar")
                }
                // setTimeout(function(){
                //     self.$.find('.tagGroupList').sortable()
                // },100)
            });

            this.$tagGroupItem = this.$.find('.tagGroupItem');
            this.$tagGroupList = this.$.find('.tagGroupList')
            this.$item = this.$tagGroupItem.find('li').remove();


            this.$.on("vclick", ".tagGroupItem", function(){
                var data = $(this).data("data")
                $.am.changePage(amGloble.page.tagGroupManage,'slideleft', data);
            }).on("vclick", ".toManageTag, .empty .btn", function(){
                var shop = amGloble.getTagShop();
                $.am.changePage(amGloble.page.tagGroupManage,'slideleft',{
                    parentShopId: shop.parentShopId,
                    shopId: shop.shopId,
                    children: [],
                });
            }).on("vclick", ".tagManageShopButton", function(e){
                var shopids = amGloble.metadata.userInfo.shopids;
                var manageShopIds = String(amGloble.metadata.userInfo.shopId) + ',' + shopids;
                amGloble.allShops.show({
                    showManaged: shopids ? true : false,
                    manageShopIds: manageShopIds,
                    callback: function(shopData) {
                        amGloble.setTagShop(shopData);
                        self.onShopChange(shopData);
                        self.getTagList();
                    }
                })
            }).on("vclick", ".icon-tishi2", function(e){
                e.stopPropagation()
                amGloble.msg("未分组标签可由管理员在【基础系统管理层-基础设置-基础分类设置-标签管理】进行合并、分组操作")
            })

            self.mainScroll = new $.am.ScrollView({
                $wrap: self.$.find(".tagScroll"),
                $inner: self.$.find(".tagGroupList"),
                direction: [0, 1]
            });
            self.mainScroll.bubble = true;
            if($.am.checkScroll(true)<11){
                // this.$mask.remove();
            }

        },
        onShopChange: function(shopData) {
            self.$.find('.tagManageShopButton .text').text(shopData.shopFullName);
            if(shopData.shopId != amGloble.metadata.userInfo.shopId){
                self.$.find(".toManageTag").hide().siblings(".toManageDelTag").css("width","100%")
                self.$.find(".empty>div").hide()
                if (self.hideSelectShop) {
                    this.hideShopSelect();
                }
            }else{
                self.$.find(".empty>div").show()
                self.$.find(".toManageTag").show().siblings(".toManageDelTag").css("width","49%")
            }
        },
        beforeShow: function(params){
			// if (params === 'back') return;
            this.$.find(".topTips").show()
            this.$.find(".topTips-no").hide()
            this.$.find(".tagScroll").removeClass('not_footer');
            this.$.find(".btnList").show().find(".toManageTag").show().css("width","49%").end().find(".toManageDelTag").show().css("width","49%")
            this.$.find(".empty>div").show()
            this.$header.find('.right').text("排序").removeClass("saveSort")
            self.$.find('.tagGroupItem').find(".iconfont").removeClass("icon-sort_bar").addClass("icon-gengduo2")
            var userinfo = amGloble.metadata.userInfo
            if (params === 'back') {
                var shop = amGloble.getTagShop();
                this.onShopChange(shop);
            } else {
                var shop = amGloble.metadata.shopMap[userinfo.shopId];
                amGloble.setTagShop(shop);
            }
            this.$.find('.tagManageShopButton .text').text(shop.shopFullName);
            if(amGloble.metadata.userInfo.userType == 1){
                this.$header.find('.right').hide()
            }else{
                this.$header.find('.right').show()
            }
            this.hideSelectShop = false;
            if (userinfo.shopType != 0) {
                this.$.find(".toManageDelTag").hide().siblings(".toManageTag").css("width","100%")
                this.hideSelectShop = true;
            }
            if(userinfo.shopType == 1){
                self.$.find(".topTips").hide()
            }
            if(userinfo.userType == 1){
                var metadataConfig = amGloble.metadata.configs;
                var notAllowedAddAndDelTag = metadataConfig.staffHandle?JSON.parse(metadataConfig.staffHandle).notAllowedAddAndDelTag:0;
                if(notAllowedAddAndDelTag){
                    this.$.find(".tagGroupItem").removeClass("am-clickable").find(".icon-gengduo2").remove()
                }
                this.$.find(".toManageTag").hide().siblings(".toManageDelTag").css("width","100%")
                this.$.find(".empty>div").hide()
                if (this.hideSelectShop) {
                    this.hideShopSelect();
                }
            }
            if(shop.shopId != userinfo.shopId){
                this.$.find(".toManageTag").hide().siblings(".toManageDelTag").css("width","100%")
                this.$.find(".empty>div").hide()
                if (this.hideSelectShop) {
                    this.hideShopSelect();
                }
            }else{
                this.$.find(".toManageTag").show().siblings(".toManageDelTag").css("width","49%")
            }
            this.$.find('.wrapper').hide();
            this.$.find('.toggle').remove();
            this.getTagList();
        },
        afterShow: function(params){
			// if (params === 'back') return;
            if(params && params.toAdd){
                this.$.find(".empty .btn").trigger("vclick")
            }
        },
        hideShopSelect: function(){
            this.$.find(".btnList").hide()
            this.$.find(".tagScroll").addClass('not_footer')
            this.mainScroll.refresh();
        },
        beforeHide: function(){
        },
        afterHide: function(){
		},
        getTagList: function(){
            self.setStatus('pageLoading');
            var userInfo = amGloble.metadata.userInfo;
            var shop = amGloble.getTagShop();
            amGloble.api.queryTags.exec({
                parentShopId: userInfo.parentShopId,
                shopIds: [userInfo.parentShopId, shop.shopId],
            },function(ret){
                console.log(ret);
                if(ret && ret.code==0){
                    self.setStatus('normal');
                    self.render(ret.content, shop.shopId, [userInfo.parentShopId, shop.shopId]);
                }else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: ret.message || '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function() {
                        self.getTagList();
                    }, function() {
                    });
                }
            })
        },
        render:function(data, shopId, shopList){
            this.$tagGroupList.find(".wrapper").remove()
            var userInfo = amGloble.metadata.userInfo
            var parentShopId = userInfo.parentShopId
            var userShopId = userInfo.shopId
            var shop = amGloble.getTagShop();
			var listdata = self.tagList = processData(data, shopList);
            for (var index = 0; index < listdata.length; index++) {
                var group = listdata[index];
                var shopChildren = group.children.filter(function(item){
                    return item.shopId == shop.shopId
                })

                if(!(shop.shopId != userShopId && !shopChildren.length)){
                    var $group = this.$tagGroupItem.clone()
                    $group.data("data", group)
                    $group.find('.type').text(group.groupName)
                    // if(group.groupId == '-1'){
                    //     $group.removeClass('am-clickable').find('.icon-gengduo2').remove()
                    // }
                    if(group.shopId !== parentShopId && group.groupId != -1){
                        $group.find('.title').addClass("shop")
                    }
                    if(group.groupId == -1){
                        $group.find('.title').css("color","#000")
                        $group.find('.title').append("<i class='iconfont icon-tishi2 am-clickable'></i>")
                    }
                    for (var i = 0; i < group.children.length; i++) {
                        var tag = group.children[i];
                        if(tag.shopId == shopId && tag.status != 1){
                            if(userInfo.userType == 1 && tag.empId != userInfo.userId){
                                continue
                            }
                            var $li = this.$item.clone();
                            $li.find('p').html(tag.tagName);
                            $li.data('data',tag);
                            if(tag.shopId !== parentShopId){
                                $li.find('p').addClass("shop")
                            }
                            $group.find("ul").append($li);
                        }
                    }
                    if (userInfo.userType == 1 && group.groupId == -1 && $group.find("ul").children('li').length === 0) {
                        continue;
                    }
                    if ($group.find("ul").children('li').length === 0 && group.groupName == '其他') {
                        continue;
                    }
                    if($group.find("li.item").length == 0){
                        $group.append("<span class='emptyText'>还未添加标签</span>")
                    }
                    this.$tagGroupList.append($group)
                }
            }
            if(this.$tagGroupList.find(".wrapper").length == 0){
                this.$tagGroupList.hide().siblings(".empty").show()
                if(shop.shopId != userInfo.shopId){
                    this.$.find(".empty>div").hide()
                }
                if(userInfo.userType == 1 && userInfo.shopType != 1){
                    this.$.find(".topTips").hide()
                    this.$.find(".topTips-no").show()
                }
            }else{
                this.$tagGroupList.show().siblings(".empty").hide()
            }
            this.$.find('.wrapper').show();
            this.mainScroll.refresh();
            this.mainScroll.scrollTo('top');
        },
        checkToggle:function($dom){
            $dom.css('height','auto');
            var rowHeight = $dom.find('li').outerHeight(true);
                totalHeight = $dom.outerHeight(true);
            $dom.css('height',rowHeight+'px');
            $dom.data('data',{
                min:rowHeight,
                max:totalHeight
            });
            if(totalHeight>rowHeight){
                if(!$dom.prev().find('.toggle').length){
                    var $toggle = this.$toggle.clone();
                    $dom.prev().append($toggle);
                }
            }else {
                $dom.prev().find('.toggle').hide();
            }
        },
    });
})();
