(function() {


    var self = amGloble.page.userinfo = new $.am.Page({
        id: "page-userinfo",
        backButtonOnclick: function () {
            $.am.page.back('', this.backParams)
        },
        init: function() {
            this.$logout = this.$.find('.logout').vclick(function(){
                atMobile.nativeUIWidget.confirm({
                    caption: "退出登录",
                    description: "您将退出当前登录用户，是否继续？",
                    okCaption: "是",
                    cancelCaption: "否"
                }, function() {
                    $.am.changePage(amGloble.page.login, "slideright", "logout");
                }, function() {});
            });

            this.$c = this.$.find(".am-body-inner").on("vclick", "li:not(.stop)", function() {
                var $this = $(this);
                $.am.changePage(amGloble.page.userinfoEditor, "slideleft", {
                    key: $this.attr("data-key"),
                    cValue: $this.attr("data-cvalue")
                });
            });

            var rules = {
                name: function(val) {
                    return val ? '' : '请输入姓名';
                },
                sex: function(val) {
                    return val ? '' : '请选择性别';
                },
                shopid: function(val) {
                    return val ? '' : '请选择入职门店';
                },
                dutyid: function(val) {
                    return val ? '' : '请选择角色/级别';
                },
                mobile: function(val) {
                    return val ? '' : '请选择入职门店';
                },
                idNo: function(val) {
                    return val ? '' : '请输入身份证号';
                },
                userName: function(val) {
                    return val ? '' : '请输入您的登录用户名';
                },
                passWord: function(val) {
                    return val ? '' : '请输入密码';
                },
            }

            this.$checkin = this.$.find(".am-body-inner-checkin").on("vclick", "li.shopid",function(){
                if(self.codeDetail && self.codeDetail.softgenre != 0) {
                    return
                }
                var shopList = self.allShopList.map(function(item){
                    return {
                        name: item.osName,
                        id: item.shopId,
                        parentShopId: item.parentShopId,
                        baseId: item.baseId,
                    }
                })
                amGloble.popupMenu(
                    "请选择门店",
                    shopList,
                    function (ret) {
                        console.log(ret);
                        var parentshopid = self.$checkin.find("li").filter("[data-key=shopid]").find(".value").data("parentshopid");
                        var id = self.$checkin.find("li").filter("[data-key=shopid]").find(".value").data("id");
                        if (parentshopid != ret.parentShopId || id != ret.id) {
                            var shop = self.allShopList.find(function(item){
                                return item.shopId == ret.id
                            })
                            self.$checkin.find("li").filter("[data-key=shopid]").find(".value").text(ret.name).data("id",ret.id).data("parentshopid",ret.baseId || ret.parentShopId).data("shop",shop)
                            self.getShopDuty(ret.baseId || ret.parentShopId, ret.id);
                            self.$checkin.find("li").filter("[data-key=dutyid]").find(".value").text("").data("dutyid","").data("role","");
                            if (shop.softgenre == 0) {
                                // 如果是总部的门店需要默认选中角色
                                self.$checkin.find("li").filter("[data-key=dutyid]").find(".value").text('管理员').data("role", 2).data("dutyid","");
                                self.$checkin.find("[data-key=sex]").hide()
                                self.$checkin.find("li").filter("[data-key=dutyid]").css("background-size", "0px");
                                self.$checkin.find("[data-key=userName]").show()
                                self.$checkin.find("[data-key=idNo]").hide()
                            } else {
                                self.$checkin.find("[data-key=sex]").show()
                                self.$checkin.find("li").filter("[data-key=dutyid]").css("background-size", "6px 10px");
                            }
                        }
                    })
            }).on("vclick", "li.dutyId",function(){
                if(!self.dutyList){
                    amGloble.msg("请先选择门店")
                    return
                }
                var shopData = self.$checkin.find("li").filter("[data-key=shopid]").find(".value").data("shop")
                if (shopData.softgenre == 0) {
                    return;
                }
                var dutyList = [
                    {
                        name: "操作员",
                        role: "1"
                    },
                    {
                        name: "管理员",
                        role: "2"
                    }
                ]
                self.dutyList.forEach(function(item){
                    dutyList.push({
                        name: item.name,
                        dutyId: item.dutyId
                    })
                })
                amGloble.popupMenu(
                    "请选择级别",
                    dutyList,
                    function (ret) {
                        console.log(ret);
                        if(ret.role){
                            self.$checkin.find("[data-key=userName]").show()
                            self.$checkin.find("[data-key=idNo]").hide()
                            self.$checkin.find("[data-key=sex]").hide()
                            self.$checkin.find("li").filter("[data-key=dutyid]").find(".value").text(ret.name).data("role",ret.role).data("dutyid","")
                        }else{
                            self.$checkin.find("[data-key=userName]").hide()
                            self.$checkin.find("[data-key=idNo]").show()
                            self.$checkin.find("[data-key=sex]").show()
                            self.$checkin.find("li").filter("[data-key=dutyid]").find(".value").text(ret.name).data("dutyid",ret.dutyId).data("role","")
                        }
                    })
            }).on("vclick", "li.sex .iconfont",function(){
                $(this).addClass("icon-danxuankuangxuanzhong selected").removeClass("icon-danxuankuang")
                .siblings(".iconfont").addClass("icon-danxuankuang").removeClass("icon-danxuankuangxuanzhong selected")
            }).on("change", "li .checkin-input", function() {
                var $this = $(this);
                var $parent = $this.parent();
                var key = $parent.data("key");
                var value = $this.val();

                var message = rules[key](value.trim());
                if (message) {
                    $parent.find(".waring-text").text(message).show();
                } else {
                    $parent.find(".waring-text").hide();
                }
            });
            this.$checkinDetail = this.$.find(".am-body-inner-checkinDetail").on('vclick','.result .mask',function(){
                if (self.$.find(".am-body-inner-checkinDetail .result .btn").hasClass("pass")) {
                    // 提交成功禁止关闭弹框
                    return;
                }
                self.$checkinDetail.find(".result").hide()
            }).on('vclick','.result .btn',function(){
                if($(this).hasClass("pass")){
                    var data = self.checkinParams
                    // amGloble.page.login.login(data.mobile, data.password, data.code, data)
                    $.extend(true, window.config, {parentShopId: data.parentShopId,isCheckin: false,});
                    delete window.config.userInfo;
                    localStorage.setItem("BusinessAppV2_config", JSON.stringify(window.config));
                    amGloble.page.login.getMetadata(function() {
                        if(amGloble.hideEducation || amGloble.metadata.configs.hideEducation === "true"){
                            if (amGloble.metadata.userInfo.mgjVersion === 5) {
                                window.RouterUtils.push({ name: 'marketingDashboard' })
                                $.am.changePage(amGloble.page.vueApp, "slideleft");
                            } else {
                                $.am.changePage(amGloble.page.dashboard, "slideleft");
                                location.reload();
                            }
                        } else {
                            // 不会再进
                            $.am.changePage(amGloble.page.education);
                        }
                    });
                }else if($(this).hasClass("refuse")){
                    // localStorage.setItem("BusinessAppV2_config", {token: ""});
                    var data = $(this).data()
                    var obj = {
                        type: 'checkin',
                        shopId: data.shopid,
                        parentShopId: data.parentshopid,
                        softgenre: data.shopid==data.parentshopid?0:2,
                        userInfo: self.checkinParams
                    }
                    if(data.oldtype != undefined){
                        self.checkinParams.oldType = data.oldtype
                    }
                    self.beforeShow(obj)
                }else{
                    self.$checkinDetail.find(".result").hide()
                }
            }).on('vclick','.result .outLogin',function(){
                $.extend(true, window.config, {token: "", parentShopId:"",isCheckin: false});
                localStorage.setItem("BusinessAppV2_config", JSON.stringify(window.config));
                $.am.changePage(amGloble.page.login, "slideleft");
            }).on('vclick', "[data-key=header]", function(){
                var user = self.checkinParams
                var $this = $(this);
                var type = user.userType == 1 ? "artisan" : "manager";
                amGloble.photoManager.takePhoto(type, {
                    parentShopId: user.parentShopId,
                    employeeId: user.userId
                }, function() {
                    // console.log("succ");
                    $this.find(".photo").html(amGloble.photoManager.createImage(type, {
                        parentShopId: user.parentShopId,
                        updateTs: amGloble.now().getTime()
                    }, user.userId + ".jpg", "s"));
                    user.lastphotoupdatetime = amGloble.now().getTime();
                }, function() {
                    // console.log("fail");
                });
            })
            this.$lis = this.$c.find("li").hide();
            this.$lis.filter("[data-key=header]").vclick(function() {
                var user = amGloble.metadata.userInfo;
                var $this = $(this);
                var type = user.userType == 1 ? "artisan" : "manager";
                amGloble.photoManager.takePhoto(type, {
                    parentShopId: user.parentShopId,
                    employeeId: user.userId
                }, function() {
                    // console.log("succ");
                    $this.find(".photo").html(amGloble.photoManager.createImage(type, {
                        parentShopId: user.parentShopId,
                        updateTs: amGloble.now().getTime()
                    }, user.userId + ".jpg", "s"));
                    user.lastphotoupdatetime = amGloble.now().getTime();
                }, function() {
                    // console.log("fail");
                });
            });

            this.$lis.filter("[data-key=password]").vclick(function() {
                var user = amGloble.metadata.userInfo;
                // $.am.changePage(amGloble.page.userinfoResetPwd, "slideleft", {
                //     phone: user.mobile,
                //     shopId: user.shopId,
                //     userId: user.userId,
                //     userType: user.userType
                // });
                var params = {
                    phone: user.mobile,
                    shopId: user.shopId,
                    userId: user.userId,
                    userType: user.userType
                }
                window.RouterUtils.push({name:'validatePhoneNum',params:params,animation:'slideleft'})
            });

            this.$lis.filter("[data-key=privacy]").vclick(function() {
                $.am.changePage(amGloble.page.privacy, "slideleft");
            })
            this.$lis.filter("[data-key=agreement]").vclick(function() {
                $.am.changePage(amGloble.page.privacy, "slideleft", {
                    type: "agreement"
                });
            })

            this.$shareTop = this.$header.children(".share").vclick(function() {
                self.share();
            });
            this.$shareCode = this.$header.children(".sharePage").vclick(function() {
                amGloble.loading.show();
                self.getShareData();
            });
            this.$shareBottom = this.$.find(".page-shareButton").vclick(function() {
                //已改造成打开个人主页的功能
                // self.share();
                var user = amGloble.metadata.userInfo;
                window.open(amGloble.getShareRoot() + $.param({
                    tenantId: user.parentShopId,
                    view: 6,
                    modelId: user.userId
                }), '_blank', 'location=no');
            });

            //log开关

            var timeArr = [];

            var compareTime = function(time1, time2) {
                return time2 / 1000 - time1 / 1000;
            };

            this.$name = this.$header.find('.title').vclick(function() {

                var nowTime = new Date().getTime();
                timeArr.push(nowTime);
                var difference = compareTime(timeArr[0], nowTime);
                if (difference < 4) { //时差在3秒内
                    if (timeArr.length > 9) { //点击了10次
                        timeArr.length = 0;
                        atMobile.nativeUIWidget.confirm({
                            caption: "工程模式",
                            description: "是否进入工程模式，可能会让你的APP挂掉，你怕不怕？怕不怕？？",
                            okCaption: "老子要进",
                            cancelCaption: "我怕怕"
                        }, function() {

                            $.am.changePage(amGloble.page.engineering, "slideleft");

                        }, function() {

                        });

                    }
                } else { //时差大于3秒
                    timeArr.length = 0;
                }

            });

            this.$swtich = this.$.find('.push_switch').on('vclick', function() {
                var $checkbox = $(this).find('.am_switch__checkbox');
                var result = !$checkbox.prop('checked');
                var postData = self.getDevicePostData();
                postData.active = result ? 1 : 0;
                amGloble.loading.show();
                amGloble.api.updDeviceActive.exec(postData, function(ret) {
                    $.am.debug.log(JSON.stringify(ret));
                    amGloble.loading.hide();
                    if (ret.code === 0) {
                        $checkbox.prop('checked', result);
                        if (result) {
                            window.localStorage.removeItem('closePushToken');
                        } else {
                            window.localStorage.setItem('closePushToken', 1);
                        }
                    } else {
                        amGloble.msg(ret.message);
                    }
                })
            });
        },
        getCheckinParams: function(){
            var $cli = self.$checkin.find("li")
            var params = {}
            var name = $cli.filter("[data-key=name]").find(".checkin-input").val(),
                sex = $cli.filter("[data-key=sex]").find(".value .selected").data("sex"),
                shopid = $cli.filter("[data-key=shopid]").find(".value").data("id"),
                parentShopId = $cli.filter("[data-key=shopid]").find(".value").data("parentshopid"),
                dutyId = $cli.filter("[data-key=dutyid]").find(".value").data("dutyid"),
                role = $cli.filter("[data-key=dutyid]").find(".value").data("role"),
                mobile = $cli.filter("[data-key=mobile]").find(".checkin-input").val(),
                idNo = $cli.filter("[data-key=idNo]").find(".checkin-input").val(),
                userName = $cli.filter("[data-key=userName]").find(".checkin-input").val(),
                passWord = $cli.filter("[data-key=passWord]").find(".checkin-input").val();
            params.sex = sex
            params.deviceType = device.platform != "Android" ? 1 : 2
            params.deviceId = device.uuid
            params.sysInfo = ""
            params.pushToken = config.pushToken
            var data = self.$.find(".result .btn.refuse").data()
            var dutyTypeNameMap = {};
            var roleMap = { 1: '操作员', 2: '管理员' }
            this.dutyList.forEach(function(dutyItem) {
                dutyTypeNameMap[dutyItem.dutyId] = dutyItem.name;
            })
            if(data && data.userid){
                params.id = data.userid
            }
            if(name){
                params.name = name
            }else{
                amGloble.msg("请输入姓名")
                return
            }
            var result = /^[\u4e00-\u9fa5_a-zA-Z0-9]+$/
            var resultName = /^[\u4e00-\u9fa5_a-zA-Z0-9_\(\)\（\）]+$/
            if (role==1||role==2) {
                if(!result.test(name)){
                    amGloble.msg("姓名只能输入中英文加数字")
                    return
                }
            } else {
                if(!resultName.test(name)){
                    amGloble.msg("姓名只能输入中英文加数字或括号")
                    return
                }
            }
            if(shopid){
                params.shopId = shopid
                params.parentShopId = parentShopId
            }else{
                amGloble.msg("请选择入职门店")
                return
            }
            if(dutyId||role){
                dutyId ? params.dutyId = dutyId : params.role = role
                params.type = dutyId ? 1 : 0
                params.dutyTypeName = dutyId ? dutyTypeNameMap[dutyId] : roleMap[role];
            }else{
                amGloble.msg("请输入角色/级别")
                return
            }
            if(mobile && mobile.length == 11){
                params.mobile = mobile
            }else{
                amGloble.msg("请输入正确的手机号")
                return
            }
            var mobileResult = /^[0-9]*$/
            if(!mobileResult.test(mobile)){
                amGloble.msg("手机号只能是数字")
                return
            }
            if(role==1||role==2){
                if(userName){
                    params.userName = userName
                }else{
                    amGloble.msg("请输入登录用户名")
                    return
                }
                if(!result.test(userName)){
                    amGloble.msg("用户名只能输入中英文加数字")
                    return
                }
            }else{
                if(idNo && (idNo.length == 15||idNo.length == 18)){
                    params.idNo = idNo
                } else if (idNo) {
                    amGloble.msg("请输入正确的身份证号")
                    return
                }
            }
            if(passWord){
                params.passWord = passWord
            }else{
                amGloble.msg("请输入密码")
                return
            }
            if(this.checkinParams&&this.checkinParams.oldType != undefined){
                params.oldType = this.checkinParams.oldType
            }
            return params
        },
        initCheckin: function(){
            var self = this
            self.$mobile = this.$.find(".am-body-wrap .am-body-inner-checkin .mobile .checkin-input");
            this.$.find(".am-body-wrap .am-body-inner-checkin .next").vclick(function(){
                var checkinParams = self.getCheckinParams()
                if(checkinParams){
                    self.validMobile(checkinParams, function(){
                        // $.am.changePage(amGloble.page.userinfoResetPwd, "slideleft", {
                        //     phone: self.$mobile.val(),
                        //     type: "checkin",
                        //     checkin: checkinParams
                        // });
                        var params = {
                            phone: self.$mobile.val(),
                            type: "checkin",
                            checkin: checkinParams
                        }
                        window.RouterUtils.push({name:'validatePhoneNum',params:params,animation:'slideleft'})
                    })
                }
            })
            self.getShopList()
        },
        validMobile: function(checkinParams, cb){
            if (this.checkinParams) {
                cb()
                return
            }
            this.setStatus("loading");
            amGloble.api.checkPhone.exec({
                "parentShopId": checkinParams.parentShopId,
                "shopId": checkinParams.shopId,
                "type": checkinParams.type,
                "mobile":checkinParams.mobile,
                "userName":checkinParams.userName
            }, function(ret) {
                self.setStatus("normal");
                if (ret.code == 0) {
                    cb()
                }else if(ret.code == 2022052601 || ret.code == 2022062401 || ret.code == 200001){
                    amGloble.msg(ret.message)
                } else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function () {
                        self.validMobile(checkinParams, cb);
                    }, function () {

                    });
                }
            })
        },
        getShopList: function(){
            this.setStatus("loading");
            amGloble.api.getShopInfo.exec({
                shopid: self.codeDetail.parentShopId
            }, function(ret) {
                self.setStatus("normal");
                if (ret.code == 0) {
                    var content = ret.content || [];
                    content.forEach(function(item) {
                        item.osName = item.osName ? (item.osName.trim() || item.shopName) : item.shopName;
                    })
                    self.allShopList = content;
                    if(self.codeDetail){
                        var shop = self.allShopList.find(function(item){
                            return item.shopId == self.codeDetail.shopId
                        })
                        self.$checkin.find(".shopid .value").text(shop.osName).data("id", shop.shopId).data("parentshopid",shop.parentShopId).data("shop",shop);
                        if (shop.softgenre == 0) {
                            // 如果是总部的门店需要默认选中角色
                            self.$checkin.find("[data-key=userName]").show();
                            self.$checkin.find("[data-key=idNo]").hide();
                            self.$checkin.find("li").filter("[data-key=dutyid]").find(".value").text('管理员').data("role", 2).data("dutyid","");
                            self.$checkin.find("[data-key=sex]").hide()
                            self.$checkin.find("li").filter("[data-key=dutyid]").css("background-size", "0px");
                        } else {
                            self.$checkin.find("li").filter("[data-key=dutyid]").css("background-size", "6px 10px");
                        }
                        self.getShopDuty(shop.parentShopId, shop.shopId)
                    }
                } else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function () {
                        self.getShopList();
                    }, function () {

                    });
                }
            })
        },
        getShopDuty: function(parentShopId, shopId){
            this.setStatus("loading");
            amGloble.api.getCheckDuty.exec({
                parentShopId: parentShopId,
                shopid: shopId
            }, function(ret) {
                self.setStatus("normal");
                self.dutyList = ret.content
            })
        },
        checkinSave: function(editorCfg){
            var textObj = this.getValue()
            var $input = this.$.find('.input input');
            if(textObj){
                var $clis = self.$checkin.find("li")
                for(var key in textObj){
                    var text = textObj[key];
                    text = text.replace(/[\s\r\n\\\/\'\"\‘\’\“\”]/g, '');
                    $input.val(text);
                    switch (key) {
                        case "empName":
                            if(!text){
                                return amGloble.msg("请输入姓名")
                            }
                            $clis.filter("[data-key=name]").find(".value").text(text)
                            break;
                        case "mobile":
                            var reg = /^1[0-9]{10}$/;
                            if(!reg.test(text)){
                                return amGloble.msg("请输入正确的手机号")
                            }
                            $clis.filter("[data-key=mobile]").find(".value").text(text)
                            break;
                        case "idNo":
                            var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
                            if(!reg.test(text)){
                                return amGloble.msg("请输入正确的身份证号")
                            }
                            $clis.filter("[data-key=idNo]").find(".value").text(text)
                            break;
                        case "userName":
                            if(!text){
                                return amGloble.msg("请输入登录用户名")
                            }
                            $clis.filter("[data-key=userName]").find(".value").text(text)
                            break;
                        case "passWord":
                            if(!text){
                                return amGloble.msg("请输入密码")
                            }
                            $clis.filter("[data-key=passWord]").find(".value").text(text)
                            $clis.filter("[data-key=passWord]").find(".password").text(text ? "******" : "")
                            break;
                        default:
                            break;
                    }
                }
            }
            $.am.page.back();
        },
        getDevicePostData: function() {
            var user = amGloble.metadata.userInfo;
            return {
                userId: user.userId,
                userType: user.userType === 0 ? 3 : 2, // 管理员入参 3，员工入参 2
                deviceId: device.uuid,
                deviceType: 2,
            }
        },
        getData: function(callback) {
            var self = this;
            if (amGloble.metadata.configs.AutoScanType == 3 && amGloble.metadata.userInfo.userType !== 0) {
                var userInfo = amGloble.metadata.userInfo;
                this.setStatus("loading");
                amGloble.api.getEmpList.exec({
                    id: userInfo.userId,
                    shopid: userInfo.shopId,
                    parentShopId: userInfo.parentShopId
                }, function(ret) {
                    self.setStatus("normal");
                    if (ret.code === 0 && ret.content && ret.content.length) {
                        amGloble.metadata.userInfo.empCode = ret.content[0].empCode;
                    }
                    callback && callback();
                })
            } else {
                callback && callback()
            }
        },
        beforeShow: function(ret) {
            var self = this;
            if (ret == "back") {
                return;
            }
            if (ret && ret.userInfoUpdate) {
                // 修改用户信息后返回，传空对象会刷新
                this.backParams = ret.userInfoUpdate;
            } else {
                this.backParams = undefined;
            }

            if(ret&&ret.type&&ret.type=="checkin"){
                // this.$.find(".am-header .button.left").hide()
                this.clearCheckin()
                this.codeDetail = ret
                if (window.config.isCheckin) {
                    this.$.find(".am-header .button.left").hide()
                } else {
                    this.$.find(".am-header .button.left").show()
                }
                this.$.find(".am-header .button.right").hide()
                this.$.find(".am-header .title .text").text("填写入职信息")
                this.$.find(".am-body-wrap .am-body-inner").hide()
                this.$.find(".am-body-wrap .am-body-inner-checkin").show()
                this.$.find(".am-body-wrap .am-body-inner-checkinDetail").hide()
                if (self.codeDetail && self.codeDetail.softgenre != 0) {
                    self.$checkin.find("li").filter("[data-key=shopid]").css("background-size", "0px")
                } else {
                    self.$checkin.find("li").filter("[data-key=shopid]").css("background-size", "6px 10px")
                }
                if(ret.userInfo){
                    self.renderCheck(ret.userInfo, "checkin")
                }
                this.initCheckin()
            }else{
                this.$.find(".am-body-wrap .am-body-inner-checkin").hide()
                this.$.find(".am-header .title .text").text("我的信息")
                if(ret&&ret.userInfo){
                    this.$.find(".am-header .button.left,.am-header .button.right").hide()
                    this.$.find(".am-body-wrap .am-body-inner").hide()
                    this.$.find(".am-body-wrap .am-body-inner-checkinDetail").show()
                    self.renderCheck(ret.userInfo, "checkinDetail")
                }else{
                    this.$.find(".am-header .button.left,.am-header .button.right").show()
                    this.$.find(".am-body-wrap .am-body-inner-checkinDetail").hide()
                    this.$.find(".am-body-wrap .am-body-inner").show()
                    this.getData(function() {
                        self.render();
                    })
                    var closePushToken = window.localStorage.getItem('closePushToken');
                    self.$swtich.find('.am_switch__checkbox').prop('checked', Number(closePushToken) !== 1);
                }
            }
        },
        afterShow: function(paras) {
            if (window.config.isCheckin) {
                $.am.history.length = [];
                if (window.RouterUtils) {
                    window.RouterUtils.history = [];
                }
            }
        },
        beforeHide: function() {},
        getShareData: function(shareType) {
            var _this = this
            amGloble.api.inventionList.exec({
                empId: amGloble.metadata.userInfo.userId,
                pageNumber: 0,
                pageSize: 3,
                type: 1,
                visible: 1
            }, function(ret) {
                if (ret.code == 0) {
                    var imgs = ret.content.map(function(_item) {
                        var imgUrl = _item.photo.split(",");
                        var $img = amGloble.photoManager.getPhotoUrl("show", {
                            catigoryId: _item.type,
                            parentShopId: _item.parentShopId,
                            authorId: _item.empId
                        }, imgUrl[0], "s");
                        return $img
                    })
                    _this.toSharePage(imgs,shareType)
                } else {
                    amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                }
            });
        },
        toSharePage: function(imgs,shareType) {
            var userInfo = amGloble.metadata.userInfo
            var _obj = {
                img: [],
                text: [
                    {
                        text: userInfo.userName,
                        x: 200,
                        y: 50,
                        css: 'font-weight: bold;font-size:18px'
                    },
                    {
                        text: userInfo.levelName,
                        x: 200,
                        y: 80,
                        css:"color: #909090;"
                    },
                    {
                        text: 'Ta的作品',
                        x: 26,
                        y: 200,
                        css:"color: #909090;"
                    },
                    {
                        text: '长按识别二维码',
                        x: 139,
                        y: 485,
                        css:"color: #909090;font-size: 12px;"
                    },
                    {
                        text: '去预约',
                        x: 162,
                        y: 505,
                        css:"color: #909090;font-size: 12px;"
                    }
                ],
            }
            var $photo = this.$lis.filter("[data-key=header]").find(".value > .photo");
            var photoImg = $photo.find('img')[0].src
            if ($photo.find('img').is(":hidden")) {
                photoImg = $photo.hasClass('female') ? 'https://img.meiguanjia.net/syb/barberBg-women.gif' : 'https://img.meiguanjia.net/syb/barberBg-man.gif'
            }
            _obj.img.push({
                url: photoImg,
                x: 29,
                y: 25,
                w: 100,
                h: 100
            })
            if(imgs.length>0){
                for (let i = 0; i < imgs.length; i++) {
                    var e = imgs[i];
                    var x = imgs.length > 1 ? 26 + (i*105) : 130
                    _obj.img.push({
                        url: e,
                        x: x,
                        y: 250,
                        w: 100,
                        h: 100
                    })
                }
            }else{
                _obj.text.splice(2,1)
                _obj.text[2].y = 365
                _obj.text[3].y = 385
            }
            amGloble.api.getSmallAppInfo.exec({
                id: window.config.parentShopId
            }, function(ret) {
                if (ret.content && ret.content.isSmallPro) {
                    var user = window.amGloble.metadata.userInfo;
                    var link = window.config.miniProUrl + "/xcx/qrCode/?tenantId=" + window.config.parentShopId + "&page=pages/home/index&scene=31@" + user.userId + "@" + user.shopId + "@" + user.userType;
                    setLink(link,1)
                } else {
                    var link = amGloble.getShareRoot() + $.param({
                        tenantId: userInfo.parentShopId,
                        view: 6,
                        modelId: userInfo.userId
                    })
                    setLink(link,0)
                }
            })
            var setLink = function(link,type){
                if(type==0){
                    var _div = document.createElement('div')
                    new QRCode(_div, {
                        text: link,
                        width: 100,
                        height: 100,
                    })
                    var image = $(_div).find('img')[0]
                    image.onload = function(){
                        var _src = $(_div).find('img')[0].src
                        _obj.img.push({
                            url: _src,
                            x: 130,
                            y: imgs.length>0?380:260,
                            w: 100,
                            h: 100
                        })
                        window.userInfoShare.toPage(_obj)
                    }
                }else{
                    var image = document.createElement('img')
                    image.src = link
                    image.onload = function(){
                        _obj.img.push({
                            url: link,
                            x: 130,
                            y: imgs.length>0?380:260,
                            w: 100,
                            h: 100
                        })
                        window.userInfoShare.toPage(_obj,shareType)
                    }
                }

            }

        },
        share: function() {
            amGloble.api.getSmallAppInfo.exec({
                id: window.config.parentShopId
            }, function(ret) {
                if (ret.content && ret.content.isSmallPro) {
                    self.getShareData(1)
                } else {
                    var user = amGloble.metadata.userInfo;
                    var shareObj = {
                        title: "你的时尚，我来护航。我是" + (user.levelName || "") + user.userName + "，我在" + user.hqName + user.osName + "等你！",
                        link: amGloble.getShareRoot() + $.param({
                            tenantId: user.parentShopId,
                            view: 6,
                            modelId: user.userId
                        }),
                        imgUrl: amGloble.photoManager.getPhotoUrl("artisan", {
                            parentShopId: user.parentShopId
                        }, user.userId + ".jpg", "s")
                    };
                    var $photo = self.$lis.filter("[data-key=header]").find(".value > .photo");
                    if ($photo.children('img').is(':hidden')) {
                        shareObj.imgUrl = $photo.hasClass('female') ? 'https://img.meiguanjia.net/syb/barberBg-women.gif' : 'https://img.meiguanjia.net/syb/barberBg-man.gif'
                    }
                    amGloble.share(shareObj);
                }
            })
        },
        clearCheckin: function(){
            $.extend(true, window.config, {parentShopId: ''});
            localStorage.setItem("BusinessAppV2_config", JSON.stringify(window.config));
            var $checkin = self.$.find(".am-body-inner-checkin")
            $.each($checkin.find("li"), function(j, itemj) {
                if(!$(itemj).hasClass("sex")){
                    $(itemj).find(".value").text("")
                    $(itemj).find(".password").text("")
                }
            });
        },
        renderCheck: function(userInfo, type){
            userInfo.osName = userInfo.osName ? (userInfo.osName.trim() || userInfo.shopName) : userInfo.shopName;
            this.checkinParams = userInfo
            var $checkinDetail = self.$.find(".am-body-inner-checkinDetail")
            if(type == "checkin"){
                $checkinDetail = self.$.find(".am-body-inner-checkin")
                $checkinDetail.find(".shopid .value").text(userInfo.osName).data("id", userInfo.shopId)
                this.getShopDuty(userInfo.parentShopId, userInfo.shopId)
                if(userInfo.role == 1 || userInfo.role == 2){
                    $checkinDetail.find(".dutyId .value").text(userInfo.levelName).data("role", userInfo.role)
                }else{
                    $checkinDetail.find(".dutyId .value").text(userInfo.levelName).data("dutyid", userInfo.dutyid)
                }
                $checkinDetail.find(".userName .checkin-input").val(userInfo.realUserName)
                $checkinDetail.find(".passWord .checkin-input").val(userInfo.password)

                $checkinDetail.find(".name .checkin-input").val(userInfo.userName)
                if(userInfo.sex=="M"){
                    $checkinDetail.find(".sex .value [data-sex='M']").trigger("vclick")
                }else{
                    $checkinDetail.find(".sex .value [data-sex='F']").trigger("vclick")
                }
                $checkinDetail.find(".idNo .checkin-input").val(userInfo.idNo)
                $checkinDetail.find(".mobile .checkin-input").val(userInfo.mobile)
            } else {
                $checkinDetail.find(".name .value").text(userInfo.userName)
                $checkinDetail.find(".sex .value").text(userInfo.sex=="M"?"男":"女")
                $checkinDetail.find(".osName .value").text(userInfo.osName)
                $checkinDetail.find(".levelName .value").text(userInfo.levelName)
                $checkinDetail.find(".idNo .value").text(userInfo.idNo)
                $checkinDetail.find(".mobile .value").text(userInfo.mobile)
            }

            if(userInfo.auditStatus==2){
                $checkinDetail.find(".resultIcon").show().addClass("refuse icon-ruzhishenhejujue").removeClass("icon-ruzhishenhezhong pass")
            }else{
                $checkinDetail.find(".resultIcon").show().addClass("pass icon-ruzhishenhezhong").removeClass("icon-ruzhishenhejujue refuse")
            }

            $checkinDetail.find(".result").show()
            if(userInfo.auditStatus == 0){
                $checkinDetail.find(".result .icon").attr("src","css/img/checkin/submit.png")
                $checkinDetail.find(".result .remake").hide()
                $checkinDetail.find(".result .title").text("入职申请已提交")
                $checkinDetail.find(".result .tips").html(userInfo.userName+"，您的入职申请已经成功提交<br/>门店管理员会尽快审核您的申请，<br/>欢迎你的加入")
                $checkinDetail.find(".result .btn").text("我知道了").removeClass("refuse")
                $checkinDetail.find(".result .outLogin").hide()
            }else if(userInfo.auditStatus == 1){
                $checkinDetail.find(".result .icon").attr("src","css/img/checkin/pass.png")
                $checkinDetail.find(".result .title").text("入职申请已通过")
                $checkinDetail.find(".result .remake").show().text("管理员备注：" + (userInfo.auditRemark || '--'))
                $checkinDetail.find(".result .tips").text("您可以开始使用美管加App查看服务数据及管理自己的顾客")
                $checkinDetail.find(".result .btn").text("开始使用").addClass("pass")
                $checkinDetail.find(".result .mask").removeClass("am-clickable");
                $checkinDetail.find(".result .outLogin").hide()
            }else if(userInfo.auditStatus == 2){
                $checkinDetail.find(".result .title").text("入职申请已拒绝")
                $checkinDetail.find(".result .icon").attr("src","css/img/checkin/refuse.png")
                $checkinDetail.find(".result .remake").show().text("拒绝原因：" + (userInfo.auditRemark || '--'))
                $checkinDetail.find(".result .tips").text("您可以重新申请，如有疑问可以联系门店管理员")
                $checkinDetail.find(".result .btn").text("重新提交申请").addClass("refuse").data("shopid",userInfo.shopId).data("parentshopid",userInfo.parentShopId).data("userid",userInfo.userId).data("oldtype",userInfo.userType)
                $checkinDetail.find(".result .outLogin").show()
            }
            $checkinDetail.find(".idNo").show()
            $checkinDetail.find(".sex").show()
            $checkinDetail.find(".userName").show()
            if(userInfo.userType){
                $checkinDetail.find("[data-key=header]").show().find(".value > .photo").html(amGloble.photoManager.createImage("artisan", {
                    parentShopId: userInfo.parentShopId,
                    updateTs: userInfo.lastphotoupdatetime
                }, userInfo.userId + ".jpg", "s"));
                $checkinDetail.find(".userName").hide()
            }else{
                $checkinDetail.find(".idNo").hide()
                $checkinDetail.find(".sex").hide()
                $checkinDetail.find("[data-key=header]").show().find(".value > .photo").html(amGloble.photoManager.createImage("manager", {
                    parentShopId: userInfo.parentShopId,
                    updateTs: userInfo.lastphotoupdatetime
                }, userInfo.userId + ".jpg", "s"));
            }
            if (userInfo.sex == "F") {
                $checkinDetail.find("[data-key=header]").find(".value > .photo").addClass("female");
            } else {
                $checkinDetail.find("[data-key=header]").find(".value > .photo").removeClass("female");
            }

        },
        render: function() {
            var $lis = this.$lis;
            $lis.hide();
            var user = amGloble.metadata.userInfo;
            var configs=amGloble.metadata.configs;
            if (user.userType) {
                this.$shareTop.show();
                this.$shareBottom.show();
                this.$shareCode.show();
                //员工
                $lis.filter("[data-key=header]").show().find(".value > .photo").html(amGloble.photoManager.createImage("artisan", {
                    parentShopId: user.parentShopId,
                    updateTs: user.lastphotoupdatetime
                }, user.userId + ".jpg", "s"));
                if (user.sex == "F") {
                    $lis.filter("[data-key=header]").find(".value > .photo").addClass("female");
                } else {
                    $lis.filter("[data-key=header]").find(".value > .photo").removeClass("female");
                }
                $lis.filter("[data-key=name]").show().attr("data-cvalue", user.userName).children(".value").html(user.userName);
                if(configs.staffHandle){//员工姓名是否可修改
                    var userHandle=JSON.parse(configs.staffHandle);
                    if(userHandle.notAllowedChangeEmployeeName!=1){
                        $lis.filter("[data-key=name]").addClass('am-clickable editAble');
                    }else{
                        $lis.filter("[data-key=name]").removeClass('am-clickable editAble');
                    }
                }
                $lis.filter("[data-key=nickname]").show().attr("data-cvalue", user.nickname).children(".value").html(!user.nickname ? "<span class='red'>未设置</span>" : user.nickname);
                $lis.filter("[data-key=code]").show().children(".value").html(user.code);
                $lis.filter("[data-key=phone]").show().children(".value").html(user.mobile);
                $lis.filter("[data-key=level]").show().children(".value").html(user.levelName);
                if(amGloble.metadata.configs.v4_barberfajiaList){
                    $lis.filter("[data-key=price]").show().find(".title").html(amGloble.metadata.configs.v4_barberfajiaList);

                }
                $lis.filter("[data-key=price]").show().attr("data-cvalue", user.cutPrice).children(".value").html(!user.cutPrice ? "<span class='red'>未设置</span>" : user.cutPrice);
                $lis.filter("[data-key=description]").show().attr("data-cvalue", user.bio).children(".value").html(!user.bio ? "<span class='red'>未设置</span>" : user.bio);
                $lis.filter("[data-key=password]").show();
                if (amGloble.metadata.configs.AutoScanType == 3) {
                    if (user.empCode) {
                        $lis.filter("[data-key=empCode]").show().attr('data-cvalue', user.empCode).children(".value").html(user.empCode);
                    } else {
                        $lis.filter("[data-key=empCode]").show().attr('data-cvalue', user.empCode).children(".value").html('<span class="btn-bind_emp_code red">未绑定</span>');
                    }
                } else {
                    $lis.filter("[data-key=empCode]").hide();
                }

                //tags
                if (user.tags) {
                    var tags = user.tags.split(",");
                    var htmlSnippet = [];
                    for (var i = 0; i < tags.length; i++) {
                        var tag = tags[i];
                        if (tag) {
                            htmlSnippet.push('<span class="tag">' + tag + '</span>');
                        }
                    }
                    // console.log(htmlSnippet);
                    $lis.filter("[data-key=tags]").show().attr("data-cvalue", user.tags).children(".value").html(htmlSnippet.join(""));
                } else {
                    $lis.filter("[data-key=tags]").show().children(".value").html("<span class='red'>未设置</span>");
                }

            } else {
                this.$shareTop.hide();
                this.$shareBottom.hide();
                this.$shareCode.hide();
                //管理员
                $lis.filter("[data-key=header]").show().find(".value > .photo").html(amGloble.photoManager.createImage("manager", {
                    parentShopId: user.parentShopId,
                    updateTs: user.lastphotoupdatetime
                }, user.userId + ".jpg", "s"));
                if (user.sex == "F") {
                    $lis.filter("[data-key=header]").find(".value > .photo").addClass("female");
                } else {
                    $lis.filter("[data-key=header]").find(".value > .photo").removeClass("female");
                }
                $lis.filter("[data-key=name]").show().attr("data-cvalue", user.userName).children(".value").html(user.userName);
                $lis.filter("[data-key=phone]").show().children(".value").html(user.mobile);
                $lis.filter("[data-key=level]").show().children(".value").html(user.levelName);
                $lis.filter("[data-key=password]").show();
            }

            $lis.filter("[data-key=pushSwitch]").show();
            $lis.filter("[data-key=privacy]").show();
            $lis.filter("[data-key=agreement]").show();
            if(window.device.platform != "iOS"){
                this.$shareCode.hide();
            }
        }
    });

})();
