var targetManagementConfig = function() {
    this._init();
}

targetManagementConfig.prototype = {
    _init() {
        this.defaultArr = [
            {name: '现金业绩', key: 'cashAchiTarget', total: 'CASHACHITARGETTOTAL',  type: 1, icon: 'icon-xianjinyeji', placeholder: '输入金额'},
            {name: '劳动业绩', key: 'workAchiTarget', total: 'WORKACHITARGETTOTAL', type: 2, icon: 'icon-laodongyeji', placeholder: '输入金额'},
            {name: '个人业绩', key: 'workAndMallTarget', total: 'MALLANDORDERTARGETTOTAL', type: 3, icon: 'icon-gerenyeji', placeholder: '输入金额', tip: '现金业绩+外卖业绩'},
            {name: '外卖业绩', key: 'goodsTarget', type: 4, total: 'GOODSTARGETTOTAL', icon: 'icon-waimaiyeji', placeholder: '输入金额'},
            {name: '客单价', key: 'atvTarget', type: 5, total: 'ATVTARGETTOTAL', icon: 'icon-kedanjia', placeholder: '输入金额'},
            {name: '总客数', key: 'customerNumTarget', type: 6, total: 'CUSTOMERNUMTARGETTOTAL', icon: 'icon-kezongshu', placeholder: '输入数量'},
            {name: '指定客数', key: 'pointCustomerTarget', type: 7, total: 'POINTCUSTOMERTARGETTOTAL', icon: 'icon-zhidingkeshu', placeholder: '输入数量'},
            {name: '办卡率', key: 'cardRateTarget', type: 8, total: 'CARDRATETARGETTOTAL', icon: 'icon-bankashuai', placeholder: '输入小数', tip: '开充卡单数/总单数'},
        ];
        var defaultArrMap = {};
        this.defaultArr.map(function(item) {
            defaultArrMap[item.type] = item;
        })
        this.defaultArrMap = defaultArrMap;
    },
    getDataByType: function(type) {
        return this.defaultArrMap[type]
    }
}
