$.am.videoPlayer = {
    show: function(options) {
        var _this = this;
        if (this.el) return;
        var rawPlayer = navigator.userAgent.indexOf('DUB-AL00') != -1;
        var $el = '';
        if(rawPlayer) {
            $el = $('<div class="video_player__wrap"><span class="video_player__close iconfont icon-guanbi1"></span>'+
                        '<video class="raw_player" poster="'+ options.poster +'" x5-playsinline="true" webkit-playsinline="true" playsinline="true" x-webkit-airplay="allow" controls preload="auto">'+
                            '<source type="video/mp4" src="'+ options.videoUrl +'" />'
                        +'</video>'
                    +'</div>');
        } else {
            $el = $('<div class="video_player__wrap"><span class="video_player__close iconfont icon-guanbi1"></span><div id="video_player__content" class="video_player__content"></div></div>');
        }
        this.el = $el;
        $("body").append(this.el);

        var _this = this;
        if(!rawPlayer) {
            _this.player = new window.Player({
                id: 'video_player__content',
                url: options.videoUrl,
                poster: options.poster,
                autoplay: true,
                fluid: true,
            })
            _this.player.on('exitFullscreen', function() {
                _this.hide();
            })
        }

        

        this.el.on('click', function(e) {
            if (e.target == this) {
                _this.hide();
            }
        }).on('click', '.video_player__close', function() {
            _this.hide();
        })
    },
    hide: function() {
        if (this.el) {
            this.player && this.player.destroy && this.player.destroy()
            this.el.remove();
            this.el = null;
        }
    }
}