(function() {

    var self = amGloble.api = {
        // 获取数据看板
        getDashboards: new Api({
            serviceName: '/shengyibao/dataDashboard/getDashboards'
        }),
        // 获取排班列表数据
        shiftsList: new Api({
            serviceName: "/shengyibao/scheduleshift/list"
        }),
        // 设置排班
        shiftsSave: new Api({
            serviceName: "/shengyibao/scheduleshift/save"
        }),
        // 删除排班
        shiftsDelete: new Api({
            serviceName: "/shengyibao/scheduleshift/delete"
        }),
        // 获取员工列表
        getEmpList: new Api({
            serviceName: "/shengyibao/employee/getByShopid"
        }),
        getEmpLevel:new Api({
            serviceName: "/shengyibao/employee/getEmpDuty"
        }),
        // 查询历史预约
        getReservationHistory:new Api({
            serviceName: "/shengyibao/reservation/history"
        }),
        //通用
        //metadata
        metadata: new Api({
            serviceName: "/shengyibao/mobile/metadata",
        }),
        //上传图片
        base64Upload: new Api({
            serviceName: "/FilesMgr/base64Upload"
        }),
        //修改头像更新时间
        modifyPhotoUpdateTime: new Api({
            serviceName: "/shengyibao/lastupdate/photo"
        }),
        //验证码
        sendCode: new Api({
            serviceName: "/shengyibao/codes/sendcode"
        }),
        //登录登出
        login: new Api({
            serviceName: "/shengyibao/mobile/user/login"
        }),
        logout: new Api({
            serviceName: "/shengyibao/mobile/user/logout"
        }),
        updDeviceActive: new Api({
            serviceName: '/shengyibao/mobile/user/updDeviceActive',
        }),
        queryDeviceInfo: new Api({
            serviceName: '/shengyibao/mobile/user/queryDeviceInfo',
        }),
        // 小精灵登录探测
        elf_check: new Api({
            serviceName: "account/checkMobile"
        }),
        // 小精灵登录
        elf_login: new Api({
            serviceName: "account/login"
        }),
        //无纸化登录码
        getShortCode: new Api({
            serviceName: "/shengyibao/codes/getShortCode"
        }),
        //Dashboard
        dashboard: new Api({
            serviceName: "/shengyibao/dashboard/list"
        }),
        //预约列表chali
        reservationList: new Api({
            serviceName: "/shengyibao/reservation/list"
        }),
        //预约配置chali
        reservationQueryConfig: new Api({
            serviceName: "/shengyibao/reservation/queryConfig"
        }),
        reservationAdd: new Api({
            serviceName: "/shengyibao/reservation/create"
        }),
        reservationCancel: new Api({
            serviceName: "/shengyibao/reservation/cancel"
        }),
        reservationChangeStatus: new Api({
            serviceName: "/shengyibao/reservation/changeStatus"
        }),
        reservationUpdateComment: new Api({
            serviceName: "/shengyibao/reservation/updateComment"
        }),
        //客户
        //搜索客户
        customerQuerCusts: new Api({
            serviceName: "/shengyibao/customer/querCusts"
        }),
        searchConfigList: new Api({
            serviceName: "/shengyibao/customer/searchConfigList"
        }),
        queryMemInfo: new Api({
            serviceName: "/shengyibao/customer/queryMemInfo"
        }),
        //客户数量统计
        customerDashboard: new Api({
            serviceName: "/shengyibao/customer/dashboard"
        }),
        //客户详情
        customerQuerMemInfo: new Api({
            serviceName: "/shengyibao/customer/querMemInfo"
        }),
        //档案分类数据详情
        getMemArchivesCount: new Api({
            serviceName: "/shengyibao/customer/countArchives"
        }),
        //会员线上消费记录汇总
        customerQuerConsume: new Api({
            serviceName: "/shengyibao/empCusProfitRelation/consume"
        }),
        //客户档案列表
        customerArchivesList: new Api({
            serviceName: "/shengyibao/customer/archivesList"
        }),
        //新增客户档案
        customerAddArchives: new Api({
            serviceName: "/shengyibao/customer/addArchives"
        }),
        //删除客户档案
        customerDelArchives: new Api({
            serviceName: "/shengyibao/customer/delArchives"
        }),
        //客户消费记录
        customerListServices: new Api({
            serviceName: "/shengyibao/customer/listServices"
        }),
        // 私法红包
        sendRedPacket:new Api({
            serviceName: "/shengyibao/customer/sendRedPacket"
        }),
        //客户红包
        customerLuckyMoneyList: new Api({
            serviceName: "/shengyibao/customer/querLuckyMoney"
        }),
        //客户商城订单
        customerMallOrderList: new Api({
            serviceName: "/shengyibao/customer/querOrderList"
        }),
        //将顾客加入收藏夹
        customerAddMemFavor: new Api({
            serviceName: "/shengyibao/customer/addMemFavor"
        }),
        //将顾客从收藏夹移除
        customerDelMemFavor: new Api({
            serviceName: "/shengyibao/customer/delMemFavor"
        }),
        //修改消费周期
        customerUpdateMemInfo: new Api({
            serviceName: "/shengyibao/customer/updateMemInfo"
        }),
        //个人信息
        userModify: new Api({
            serviceName: "/shengyibao/mobile/user/modify"
        }),
        userModifypwd: new Api({
            serviceName: "/shengyibao/mobile/user/modifypwd"
        }),
        userForgotpwd: new Api({
            serviceName: "/shengyibao/mobile/user/forgotpwd"
        }),
        userBindMobile: new Api({
            serviceName: "/shengyibao/mobile/user/bindMobile"
        }),
        //消息
        messageList: new Api({
            serviceName: "/shengyibao/message/list"
        }),
        //报表
        //营业总览
        rpt_busitotal: new Api({
            serviceName: "/shengyibao/policy/busitotal",
	        numFixed:1,
            timeout: 60 * 1000,
        }),
        //各门店员工业绩排名
        rpt_empPerformanceRank: new Api({
            serviceName: "/shengyibao/policy/empPerformanceRank"
        }),
        //各门店业绩汇总
        rpt_shopperflist: new Api({
            serviceName: "/shengyibao/policy/shopperflist",
	        numFixed:1
        }),
        //现金流水表
        rpt_cashflow: new Api({
            serviceName: "/shengyibao/finance/cashflow",
	        numFixed:1
        }),
        //营业额流水表
        rpt_turnover: new Api({
            serviceName: "/shengyibao/finance/turnover"
        }),
        //项目分类明细表
        rpt_typeStatDetail: new Api({
            serviceName: "/shengyibao/performance/typeStatDetail",
        }),
        //卡储值消费统计
        rpt_cardConsume: new Api({
            serviceName: "/shengyibao/performance/cardConsume",
        }),
        //卡金结余统计
        rpt_cardBalance: new Api({
            serviceName: "/shengyibao/performance/cardBalance",
        }),
        //员工业绩汇总
        rpt_empPerformanceTotal: new Api({
            serviceName: "/shengyibao/performance/empPerformanceTotal",
        }),
        //店内业绩统计表
        rpt_shopperf: new Api({
            serviceName: "/shengyibao/performance/shopperf",
	        numFixed:1,
            timeout: 60 * 1000,
        }),
        //员工项目列表
        rpt_employeeItemlist: new Api({
            serviceName: "/shengyibao/employee/itemlist",
        }),
        //员工卖品列表
        rpt_employeeBuylist: new Api({
            serviceName: "/shengyibao/employee/buylist",
        }),
        //员工开充卡列表
        rpt_employeeReclist: new Api({
            serviceName: "/shengyibao/employee/reclist",
        }),
        //员工套餐销售列表
        rpt_employeeTreatlist: new Api({
            serviceName: "/shengyibao/employee/treatlist",
        }),
        //员工年卡销售列表
        rpt_employeeYearlist: new Api({
            serviceName: "/shengyibao/employee/yearlist",
        }),
        //业绩总览
        rpt_employeeEmpperf: new Api({
            serviceName: "/shengyibao/employee/empperf",
	        numFixed:1
        }),
        //工资提成
        rpt_employeeEmpgain: new Api({
            serviceName: "/shengyibao/employee/empgain",
	        numFixed:1
        }),

        // 查询配置信息
        queryData: new Api({
            serviceName: "/shengyibao/userdefined/queryData"
        }),
        addUserData: new Api({
            serviceName: "/shengyibao/userdefined/add"
        }),


        //财务优化
        shopReducescale: new Api({
            serviceName: "/shengyibao/shop/reducescale"
        }),

        //作品列表
        inventionList: new Api({
            serviceName: "/shengyibao/invention/getList"
        }),
        //作品分类
        inventionSubTypes: new Api({
            serviceName: "/shengyibao/invention/subTypes"
        }),
        //作品评论删除
        inventionDeleteEvaluation: new Api({
            serviceName: "/shengyibao/invention/delInventionEvaluation"
        }),
        //作品评论删除
        delInvention: new Api({
            serviceName: "/shengyibao/invention/delInvention"
        }),
        //作品审核
        inventionVisible: new Api({
            serviceName: "/shengyibao/invention/audit"
        }),
        addInvention: new Api({
            serviceName: "/shengyibao/invention/addInvention"
        }),
        //服务管理
        serviceManagement: new Api({
            serviceName: "/shengyibao/employee/service/list"
        }),
        //代收代付
        queryWithdraw: new Api({
            serviceName: "/shengyibao/mall/queryMallWithdrawBalance"
        }),
        //提现
        getwithdraw: new Api({
            serviceName: "/shengyibao/mall/withdraw"
        }),
        //提现记录
        getWithdrawHistory: new Api({
            serviceName: "/shengyibao/mall/getWithdrawHistory"
        }),
        //获取签约信息
        getSigning: new Api({
            serviceName: "/shengyibao/mall/getSigning"
        }),
        //保存签约信息
        saveSigning: new Api({
            serviceName: "/shengyibao/mall/saveSigning"
        }),
        //获取商城统计数据
        mallPandect: new Api({
            serviceName: "/shengyibao/mall/pandect"
        }),
        //门店PK
        mallreportStopPK: new Api({
            serviceName: "/shengyibao/mall/reportStopPK"
        }),
        //分类汇总
        reportCategory: new Api({
            serviceName: "/shengyibao/mall/reportCategory"
        }),
        //明细汇总
        reportItem: new Api({
            serviceName: "/shengyibao/mall/reportItem"
        }),
        //查看明细
        reportDetail: new Api({
            serviceName: "/shengyibao/mall/reportDetail"
        }),
        //【生意宝】查询打赏可提现额度
        rewardBalance: new Api({
            serviceName: "/shengyibao/reward/balance"
        }),
        //【生意宝】查询打赏提现历史
        rewardHistory: new Api({
            serviceName: "/shengyibao/reward/history"
        }),
        //【生意宝】打赏提现
        rewardWithdraw: new Api({
            serviceName: "/shengyibao/reward/withdraw"
        }),
        //【生意宝】查询打赏记录
        rewardRewards: new Api({
            serviceName: "/shengyibao/reward/rewards"
        }),
        //【生意宝】绑定提现微信账号
        bindWechat: new Api({
            serviceName: "/shengyibao/mall/bindWechat"
        }),
        marketingToolsList: new Api({
            serviceName: "/shengyibao/marketingTools/list"
        }),
        marketingToolsAvailable: new Api({
            serviceName: "/shengyibao/marketingTools/available"
        }),
        marketingToolsEffect: new Api({
            serviceName: "/shengyibao/marketingTools/effect"
        }),
        marketingToolsGetOwnPackage: new Api({
            serviceName: "/shengyibao/marketingTools/getOwnPackage"
        }),
        getOwnPackageEffect: new Api({
            serviceName: "/shengyibao/marketingTools/getOwnPackageEffect"
        }),
        //洗发时长
        hairTime: new Api({
            serviceName: "/shengyibao/shop/hairTime"
        }),
        //【生意宝】进行中列表
        getInstoreServiceList: new Api({
            serviceName: "/shengyibao/instoreService/list"
        }),
        //洗发合格率
        clearHairRate: new Api({
            serviceName: "/shengyibao/shop/clearHairRate"
        }),
        listEmployee: new Api({
            serviceName: "/shengyibao/attendanceManagement/listEmployee"
        }),
        //点评报表
        commentStatistics: new Api({
            serviceName: "/shengyibao/comment/statistics"
        }),

        //点评报表
        registerDevice: new Api({
            serviceName: "/shengyibao/mobile/user/registerDevice"
        }),

        //获取服务/卖品列表(无分页)
        queryMallItem: new Api({
            serviceName: "/shengyibao/mall/queryMallItem"
        }),

        //获取该租户是否使用了小程序
        getSmallAppInfo: new Api({
            serviceName: "/shengyibao/shop/getSmallAppInfo"
        }),
        //生意宝排行榜
        getRankingList: new Api({
            serviceName: "/shengyibao/ranking/list"
		}),
		// 生意宝排行榜 KPI 配置数据
		getRankingData: new Api({
			serviceName: "/shengyibao/ranking/getRankingData"
		}),
		// 获取区域数据
		getAreaList: new ApiCacheable({
            serviceName: "/shengyibao/ranking/getShopAreaList",
            keys: ["parentShopId"],
            isSuccess: function(ret) {
                if (ret && ret.code == 0) {
                    return true;
                }
            }
        }),
        //待办事项列表
        todoList: new Api({
            serviceName: "/shengyibao/todo/list"
        }),
        //待办事项处理
        todoProcess: new Api({
            serviceName: "/shengyibao/todo/handle"
        }),
        //闹钟列表
        clockList: new Api({
            serviceName: "/shengyibao/clock/list"
        }),
        //添加闹钟
        clockAdd: new Api({
            serviceName: "/shengyibao/clock/add"
        }),
        //删除闹钟
        clockDelete: new Api({
            serviceName: "/shengyibao/clock/delete"
        }),
        //扫一扫
        scan: new Api({
            serviceName: "/shengyibao/scancode/scan"
        }),
        //得到商品分类
        queryMallItemCategory: new Api({
            serviceName: "/shengyibao/mall/queryMallItemCategory"
		}),
		// 获取收益页面数据
		queryPromoteData: new Api({
			serviceName: "/shengyibao/promote/init"
		}),
        //获得收益列表
        queryCampaignList: new Api({
            serviceName: "/shengyibao/mall/queryCampaignList"
		}),
		queryPromoteRewardList: new Api({
			serviceName: '/shengyibao/promote/withdarws'
		}),
		promoteWithdraw: new Api({
			serviceName: '/shengyibao/promote/withdraw'
		}),
        //获得收益报表
        queryCampaignReport: new Api({
            serviceName: "/shengyibao/mall/queryCampaignReport"
        }),
        //添加顾客
        addNewCustomer: new Api({
            serviceName: "/shengyibao/customer/createMember"
        }),
        // 视频详情
        videoDetail: new Api({
            serviceName: "/shengyibao/video/detail"
        }),
        //评论详情
        listComment: new Api({
            serviceName: "/shengyibao/video/listComment"
        }),
        // 上新的视频列表
        NewVideoList: new Api({
            serviceName: "/shengyibao/video/listNewVideo"
        }),
        // 视频列表
        videoList: new Api({
            serviceName: "/shengyibao/video/list"
        }),
        // 搜索视频
        videoFind: new Api({
            serviceName: "/shengyibao/video/find"
        }),
        // 点赞
        videoLikes: new Api({
            serviceName: "/shengyibao/video/like"
        }),
        videoPlay:new Api({
            serviceName: "/shengyibao/video/play"
        }),
        submitComment:new Api({
            serviceName: "/shengyibao/video/submitComment"
        }),
        submitComplaint:new Api({
            serviceName: "/shengyibao/video/submitComplaint"
        }),
        // 教师列表
        listTeacher: new Api({
            serviceName: "/shengyibao/video/listTeacher"
        }),
        // 机构列表
        listOrganization: new Api({
            serviceName: "/shengyibao/video/listOrganization"
        }),
        attendanceSignin: new Api({
            serviceName: "/shengyibao/attendanceManagement/confirm"
        }),
        attendanceUpdata: new Api({
            serviceName: "/shengyibao/attendanceManagement/signin"
        }),
        updateEmployeeCheck: new Api({
            serviceName: "/shengyibao/attendanceManagement/updateEmployeeCheck"
        }),
        employeeRecord: new Api({
            serviceName: "/shengyibao/attendanceManagement/employeeRecord"
        }),
        shiftSetting: new Api({
            serviceName: "/shengyibao/attendanceManagement/shiftSetting"
        }),
        shiftList: new Api({
            serviceName: "/shengyibao/attendanceManagement/sslist"
        }),
        adslist:new Api({
            serviceName: "/shengyibao/video/adslist"
        }),
        msgRecord:new Api({
            serviceName: "/shengyibao/smsautopay/log"
        }),
        msgShop:new Api({
            serviceName: "/shengyibao/smsautopay/shop"
        }),
        msgShops:new Api({
            serviceName: "/shengyibao/smsautopay/shops"
        }),
        msgTrans:new Api({
            serviceName: "/shengyibao/smsautopay/transfer"
        }),
        // 续费接口红点显示
        msgRenewlist:new Api({
            serviceName:"/shengyibao/smsautopay/inval"
        }),
        //获取商品
        msgGoods:new Api({
            serviceName:"/shengyibao/smsautopay/goods"
        }),
        // 获取活动信息
        getProductConfig: new Api({
            serviceName: "shengyibao/shop/getProductConfig"
        }),
        //未支付记录
        msgNopayment:new Api({
            serviceName:"/shengyibao/smsautopay/UnPayConsumLog"
        }),
        //续费记录
        msgPayrenewList:new Api({
            serviceName:"/shengyibao/smsautopay/paylog"
        }),
        msgAlipayCharge:new Api({
            serviceName: "/shengyibao/charge/alipay/mobilePay"
        }),
        msgCheckOrderStatus:new Api({
            serviceName: "/shengyibao/charge/checkOrderStatus"
        }),
        msgRule:new Api({
            serviceName: "/shengyibao/smsautopay/role"
        }),
        querEmpCusts:new Api({
            serviceName: "/shengyibao/customer/querEmpCusts"
        }),
        rotateList:new Api({
            serviceName: "/shengyibao/rotate/list"
        }),
        employeeGetEmpByShopid:new Api({
            serviceName: "/shengyibao/employee/getByShopid"
        }),
        queryReservationByEmpAll:new Api({
            serviceName: "/shengyibao/reservation/queryReservationByEmpAll"
        }),
        updEmpCusts:new Api({
            serviceName: "/shengyibao/customer/updEmpCusts"
        }),
        reservationCount:new Api({
            serviceName: "/shengyibao/reservation/count"
        }),
        tagAdd:new Api({
            serviceName: "/shengyibao/customer/tag/add"
        }),
        tagDel:new Api({
            serviceName: "/shengyibao/customer/tag/del"
        }),
        tagList:new Api({
            serviceName: "/shengyibao/customer/tag/list"
        }),
        tagFilter:new Api({
            serviceName: "/shengyibao/customer/tag/filter"
        }),
        queryEmpTarget:new Api({
            serviceName: "/shengyibao/target/empTarget"
        }),
        saveEmpTarget:new Api({
            serviceName: "/shengyibao/target/saveEmpTarget"
        }),
        queryShopTarget:new Api({
            serviceName: "/shengyibao/target/shopTarget"
        }),
        empdutyMetadata:new Api({
            serviceName: "/shengyibao/mobile/empdutyMetadata"
        }),
        communityList:new Api({
            serviceName: "/shengyibao/association/topicList"
        }),
        communityPublish:new Api({
            serviceName: "/shengyibao/association/saveTopic"
        }),
        communityLabelList:new Api({
            serviceName: "/shengyibao/association/labelList"
        }),
        communityAddLabel:new Api({
            serviceName: "/shengyibao/association/addLabel"
        }),
        communityDeleteLabel:new Api({
            serviceName: "/shengyibao/association/deleteLabel"
        }),
        communityDeleteTopic:new Api({
            serviceName: "/shengyibao/association/deleteTopic"
        }),
        getCommunityDetails:new Api({
            serviceName: "/shengyibao/association/getTopic"
        }),
        actComment:new Api({
            serviceName: "/shengyibao/association/comment"
        }),
        actLike: new Api({
            serviceName: "/shengyibao/association/like"
        }),
        communityAssociation:new Api({
            serviceName: "/shengyibao/association/associationData"
        }),
        communityMsg: new Api({
            serviceName: "/shengyibao/association/newsNotify"
        }),
        msgtplList:new Api({
            serviceName: "/shengyibao/msgtpl/list"
        }),
        msgtplPush:new Api({
            serviceName: "/shengyibao/msgtpl/push"
        }),
        saveShopTarget:new Api({
            serviceName: "/shengyibao/target/saveShopTarget"
        }),
        audit_archives:new Api({
            serviceName: "/shengyibao/workingaudit/achives"
        }),
        audit_todolist:new Api({
            serviceName: "/shengyibao/workingaudit/todolist"
        }),
        audit_reservation:new Api({
            serviceName: "/shengyibao/workingaudit/reservation"
        }),
        audit_invention:new Api({
            serviceName: "/shengyibao/workingaudit/invention"
        }),
        audit_topic:new Api({
            serviceName: "/shengyibao/workingaudit/topic"
        }),
        audit_achivesList:new Api({
            serviceName: "/shengyibao/workingaudit/achivesList"
        }),
        checkMobile: new Api({
            serviceName: "/shengyibao/customer/checkMobile"
        }),
        cleanPushToken: new Api({
            serviceName: "/shengyibao/attendanceManagement/cleanPushToken"
        }),
        getNewTopic: new Api({
            serviceName: "/shengyibao/association/newOperatedTopic"
		}),
		targetTip: new Api({
            serviceName: "/shengyibao/target/tips"
		}),
		queryAcrossCashSum: new Api({
			serviceName: '/shengyibao/report/acrossCashSum'
		}),
		queryAcrossTenantList: new Api({
			serviceName: '/shengyibao/report/queryShopConfig'
		}),
		queryDashboardRedDot: new Api({
			serviceName: '/shengyibao/promote/max'
        }),
        //获取活动详情
        getVoteActive: new Api({
			serviceName: '/shengyibao/votactivity/votactivityList'
        }),
        //提交参赛作品接口
        submitParticipate: new Api({
			serviceName: '/shengyibao/votactivity/partake'
        }),
        //弃权
        waiverFunc: new Api({
			serviceName: '/shengyibao/votactivity/waiver'
        }),
        questionnaireList: new Api({
            serviceName: '/shengyibao/questionnaire/list',
        }),
        getLuckyMoneyTemplate: new Api({
            serviceName: '/shengyibao/mobile/luckyMoneyTemplate',
        }),
        getLuckyMoneyUnionConfig: new Api({
            serviceName: '/shengyibao/mobile/luckyMoneyUnionConfig',
        }),
        getProductCategory: new Api({
            serviceName: '/shengyibao/mobile/productCategory'
        }),
        getTpList: new Api({
            serviceName: '/shengyibao/mobile/tpList'
        }),
        getCategory: new Api({
            serviceName: '/shengyibao/mobile/category'
        }),
        getActiveList: new Api({
            serviceName: '/shengyibao/votactivity/votactivityList',
        }),
        queryOperateActivity: new Api({
            serviceName: '/shengyibao/operateActivity/queryOperateActivity'
        }),
        getProducts: new Api({
            serviceName: '/shengyibao/operateActivity/getProducts',
        }),
        todoAdd: new Api({
            serviceName: '/shengyibao/todo/add'
        }),
        listNormalConfig: new Api({
            serviceName: '/shengyibao/normalConfig/listNormalConfig'
        }),
        bindEmpCode: new Api({
            serviceName: '/shengyibao/employee/bindEmpCode'
        }),
        addCusAction: new Api({
            serviceName: '/shengyibao/productNotice/addCusAction'
        }),
        updArchives: new Api({
            serviceName: '/shengyibao/customer/updArchives'
        }),

	queryTags: new Api({
            serviceName: '/shengyibao/tag/queryTags'
        }),
        delTagGroup: new Api({
            serviceName: '/shengyibao/tag/delTagGroup'
        }),
        updTagGroup: new Api({
            serviceName: '/shengyibao/tag/updTagGroup'
        }),
        addTag: new Api({
            serviceName: '/shengyibao/tag/addTag'
        }),
        batchAddTag: new Api({
            serviceName: '/shengyibao/tag/batchAddTag'
        }),
        delTag: new Api({
            serviceName: '/shengyibao/tag/delTag'
        }),
        updGradeTagGroup: new Api({
            serviceName: '/shengyibao/tag/updGradeTagGroup'
        }),
        updGradeTagGroupNewName: new Api({
            serviceName: '/shengyibao/tag/updGradeTagGroupNewName'
        }),
		updGradeTag: new Api({
            serviceName: '/shengyibao/tag/updGradeTag'
        }),
        queryCustomerTagNums: new Api({
            serviceName: '/shengyibao/tag/queryCustomerTagNums'
        }),
        addTagGroup: new Api({
            serviceName: '/shengyibao/tag/addTagGroup'
        }),
        queryCustomerTagNums: new Api({
            serviceName: '/shengyibao/tag/queryCustomerTagNums'
        }),
        getShopInfo: new Api({
            serviceName: '/shengyibao/shop/getShopInfo'
        }),
        getDuty: new Api({
            serviceName: '/shengyibao/shop/getDuty'
        }),
        getCheckDuty: new Api({
            serviceName: 'shengyibao/shop/getCheckDuty'
        }),
        addEmploye: new Api({
            serviceName: '/shengyibao/employee/addEmploye'
        }),
        getUserInfo: new Api({
            serviceName: '/shengyibao/mobile/user/getUserInfo'
        }),
        checkPhone: new Api({
            serviceName: '/shengyibao/employee/check'
        }),
        //产品合作商
        merchantList: new Api({
            serviceName: '/shengyibao/merchant/merchantList',
        }),
        renewLog: new Api({
            serviceName: '/shengyibao/smsautopay/renewalLog'
        }),
        getMemClassNew: new Api({
            serviceName: '/shengyibao/customer/getMemClassNew'
        }),
    };

    // 考勤获取离线数据
    amGloble.api.employeeRecord._exec = amGloble.api.employeeRecord.exec;
    amGloble.api.employeeRecord.exec = function(opt, cb) {
        this._exec(opt, function(ret) {
            if (ret.code === 0) {
                ret.content = window.offlineAttendance.getMergeData(ret.content);
                cb && cb(ret);
            } else {
                cb && cb(ret);
            }
        })
    }
    // 获取离线数据
    amGloble.api.dashboard._exec = amGloble.api.dashboard.exec;
    amGloble.api.dashboard.exec = function(opt, cb) {
        this._exec(opt, function(ret) {
            if (ret.code === 0) {
                var employeeCheck = ret.content.employeeCheck;
                if (employeeCheck) {
                    employeeCheck.employeeGoWorkTime = employeeCheck.goWorkTime
                    employeeCheck.employeeOutWorkTime = employeeCheck.outWorkTime;
                    ret.content.employeeCheck = employeeCheck;
                }
                var lastData = window.offlineAttendance.getLastData();
                if (lastData && (!employeeCheck || lastData.workdate >= employeeCheck.workdate)) {
                    ret.content.employeeCheck = lastData;
                    ret.content.workStatus = lastData.employeeOutWorkTime ? 0 : 1;
                }
                cb && cb(ret)
            } else {
                cb && cb(ret)
            }
        })
    }
    // 拦截打卡接口，增加离线逻辑
    amGloble.api.attendanceSignin._exec = amGloble.api.attendanceSignin.exec;
    amGloble.api.attendanceSignin.exec = function(opt, cb) {
        var offlineAddData = function(sync) {
            window.offlineAttendance.addData({
                timeDifference: opt.timeDifference,
                createTime: opt.date,
                shopId: opt.shopId,
            }).then(function(res) {
                cb && cb(res);
                sync && window.offlineAttendance.syncData();
            }).catch(function(res) {
                cb && cb(res);
            })
        }
        // 如果存在离线打卡数据，则当前打卡存入离线，并一起同步
        var cacheData = window.offlineAttendance.getData();
        if (cacheData) {
            offlineAddData(true)
        } else {
            this._exec(opt, function(ret) {
                if (ret.code === -1) {
                    offlineAddData()
                } else {
                    cb && cb(ret);
                }
            }, false, 20 * 1000)
        }
    }
    // 拦截上班卡逻辑
    amGloble.api.attendanceUpdata._exec = amGloble.api.attendanceUpdata.exec;
    amGloble.api.attendanceUpdata.exec = function(opt, cb) {
        var offlineAddData = function(sync) {
            window.offlineAttendance.addData({
                shiftSetId: opt.shiftSetId,
                msName: opt.shiftName,
            }).then(function(res) {
                cb && cb(res);
                sync && window.offlineAttendance.syncData();
            }).catch(function(res) {
                cb && cb(res);
            })
        }
        // 如果存在离线打卡数据，则当前打卡存入离线，并一起同步
        var cacheData = window.offlineAttendance.getData();
        if (cacheData) {
            offlineAddData(true);
        } else {
            this._exec(opt, function(ret) {
                if (ret.code === -1) {
                    offlineAddData()
                } else {
                    cb && cb(ret);
                }
            }, false, 20 * 1000)
        }
    }

    amGloble.api.metadata._exec = amGloble.api.metadata.exec;
    amGloble.api.metadata.exec = function(opt,cb,refresh){
        var metaKey = amGloble.getMetaStorageKey && amGloble.getMetaStorageKey();
        var localMetaDataStr = localStorage.getItem(metaKey);
        var localMetaJsonData;
        try{
            if(!refresh && localMetaDataStr){
                localMetaJsonData = JSON.parse(localMetaDataStr);
            }
        }catch(e){
            console.error(e);
        }
        if(localMetaJsonData){
            opt.confLastUpdTime = localMetaJsonData.confLastUpdTime;
            $.am.debug.log("get metadata cache timestap:" + opt.confLastUpdTime);
        }
        opt.configKeys = [
            'mykPrivilegeOpen',
            'httpsEnable',
            'review',
            'mgjReservationDays',
            'reportPermission',
            'strategy',
            'reservationFrom',
            'reservationTo',
            'myk_benefitTime',
            'privateSendRed',
            'noDelFile',
            'handEmployees',
            'hideEducation',
            'v4_tenantLogo',
            'toAcountDay',
            'toAcountMode',
            'enabledNewBonusModel',
            'rankingScope',
            'rankingConfigVersion',
            'hiddenPerformanceAmount',
            'rankingView_isPart',
            'rankingView_isPartForArea',
            'rankingView_isPartForShop',
            'rankingView_top',
            'rankingView_topForArea',
            'rankingView_topForShop',
            'rankingView_preview',
            'rankingView_next',
            'rankingView_shop',
            'mgjMallPrivilege',
            'replaceShampoo',
            'mgjReservationItem',
            'counterReservation',
            'takeUpModel',
            'luckyMoneySeq',
            'privateSendRed',
            'rcordRinseTime',
            'staffHandle',
            'v4_barberfajiaList',
            'wageDay',
            'mgjPrivilegeSettings',
            'mykPrivilegeOpen',
            'memcardShrinkFlag',
            'mgjFinancialOptimization',
            'syb_allowphone',
            'syb_allowcard',
            'operatorFacility',
            'staffFacility',
            'stillCustomer',
            'loss',
            'mobileRepeat',
            'hideWxmall',
            'shrinkTime',
            'mgjGroupbuyingOrderStatisticsEnable',
            'customAppointmentSet', // 服务端依赖
            'mgjReservationSelectUser',
            'AutoScanType',
            'mgjReservationProcessType',
            'mgjReservationSelectProject',
            'archivesCategory',
            'mgjMergeGainByMobile',
            'mgjOperationalActivitiesShops',
            'mgjWeCom', // admin是否开启企业微信标识
            'operateApproveExpiredTime',
            'themeConfigKey'
        ]

        // 增加作品分类自定义的 normalConfig
        for(var worksname = 1; worksname < 7; worksname ++) {
            opt.configKeys.push('category_' + worksname);
            var textCount = worksname == 2 ? 4 : 10;
            for(var textIndex = 1; textIndex < textCount; textIndex ++) {
                opt.configKeys.push('category_'+worksname+'_text'+textIndex);
            }
        }
        opt.version = 1;
        this._exec(opt,function(ret){
            if(ret && ret.code === 0 && ret.content){
                ret.content.confLastUpdTime = ret.confLastUpdTime;
                cb(ret);
                if (ret.content.userInfo.password) {
                    var metaKey = amGloble.getMetaStorageKey();
                    localStorage.setItem(metaKey,JSON.stringify(ret.content));
                }
                $.am.debug.log("not get cache metadata:");
            }else if(ret && ret.code === 0 && !ret.content){
                var metaKey = amGloble.getMetaStorageKey();
                var json = localStorage.getItem(metaKey);
                try{
                    if(json){
                        json = JSON.parse(json);
                    }
                }catch(e){
                    console.error(e);
                }
                if(json){
                    $.am.debug.log("get cache metadata ");
                    ret.content = json;
                    cb(ret);
                }else{
                    amGloble.api.metadata.exec(opt,cb,1);
                }
            } else if ([203009, 2022021532].indexOf(ret.code) !== -1 ) {
                cb(ret);
            } else{
                if (localMetaJsonData) {
                    cb({
                        code: 0,
                        content: localMetaJsonData,
                    })
                } else {
                    cb(ret);
                }
            }
        });
    }
})();
