function processData(tagList, shopList, hideNoChild) {
    var groupObj = {}
    var groupSort = {}
    var realGroupSort = {}
    var groupList = []
    tagList.forEach(function(item) {
        if (!item.groupId) {
        item.groupName = '其他'
        item.groupId = -1
        item.groupSortNum = -1
        }
        if (!groupObj[item.groupId]) {
        groupObj[item.groupId] = [item]
        } else {
        groupObj[item.groupId].push(item)
        }
        if (!groupSort[item.groupShopId]) {
        groupSort[item.groupShopId] = [{
            groupName: item.groupName,
            groupId: item.groupId,
            groupSortNum: item.groupSortNum
        }]
        } else {
        groupSort[item.groupShopId].push({
            groupName: item.groupName,
            groupId: item.groupId,
            groupSortNum: item.groupSortNum
        })
        }
    })
    var shopMap = amGloble.metadata.shopMap
    for (var k in groupObj) {
        groupObj[k] = groupObj[k].sort(function(a, b) {
            var aShop = shopMap[parseInt(a.shopId)] || {softgenre: 2}
            var bShop = shopMap[parseInt(b.shopId)] || {softgenre: 2}
            return aShop.softgenre - bShop.softgenre
        })
    }
    if(shopList){
        for (var i = 0; i < shopList.length; i++) {
            var k = shopList[i];
            if(groupSort[k]){
                var sort = groupSort[k].map(function(t){
                    return t.groupId || '其他'
                })
                realGroupSort[k] = unique(sort)
            }
        }
    }
    for (var k in realGroupSort) {
        for (var i = 0; i < realGroupSort[k].length; i++) {
        var groupId = realGroupSort[k][i];
        if (groupId !== -1) {
            groupList.push({
            children: groupObj[groupId].filter(function(tagData){return tagData.id}),
            groupName: groupObj[groupId][0].groupName,
            groupId: groupObj[groupId][0].groupId,
            groupSortNum: groupObj[groupId][0].groupSortNum,
            shopId: groupObj[groupId][0].groupShopId,
            parentShopId: amGloble.metadata.userInfo.parentShopId,
            className: groupObj[groupId][0].shopId !== groupObj[groupId][0].parentShopId ? 'shop' : ''
            })
        }
        }
    }
    var groupIds = groupList.map(function(t){return t.groupId})
    for (var k in groupObj) {
        var item = groupObj[k]
        var children = item.filter(function(t){return t.id})
        var flag = true
        if(hideNoChild){
            flag = children.length
        }
        if (groupIds.indexOf(item[0].groupId) == -1 && k !== "-1" && flag) {
          groupList.push({
            children: children || [],
            groupName: item[0].groupName,
            groupId: item[0].groupId,
            groupSortNum: item[0].groupSortNum,
            shopId: item[0].groupShopId,
            parentShopId: amGloble.metadata.userInfo.parentShopId,
            className: item[0].groupShopId !== this.parentShopId ? 'shop' : ''
          })
        }
      }
    if(groupObj[-1]){
        groupList.push({
            children: groupObj[-1],
            groupName: '其他',
            groupId: -1,
            groupSortNum: -1,
            shopId: groupObj[-1][0].groupShopId,
            parentShopId: amGloble.metadata.userInfo.parentShopId,
            className: 'order'
        })
    }
    return groupList
}
function unique(arr) {
    for (var i = 0; i < arr.length; i++) {
        for (var j = i + 1; j < arr.length; j++) {
            if (arr[i] === arr[j]) {
                arr.splice(j, 1);
                j--;
            }
        }
    }
    return arr;
}
