(function () {
	amGloble.page.customerClockAdd = new $.am.Page({

		id: "page_customerClockAdd",
		backButtonOnclick: function () {
			if (!(amGloble.empSelect.$.is(":hidden"))) {
				amGloble.empSelect.hide();
			} else {
				$.am.page.back("slidedown");
			}
		},
		init: function () {
			var self = this;
			self.openEmp = false;
			this.$dateType = 1; // 默认日期类型的闹钟
			this.$back = this.$header.find(".left").vclick(function () {
				if (self.openEmp) {
					self.closeEmpSelect();
				} else {
					self.backButtonOnclick();
				}
			});
			this.$header.find(".left").on("vclick", ".selecAll", function(e) {
				e.stopPropagation();
				amGloble.empSelect.selectAll();
			})
			this.$text = this.$.find("#custClockText");
			this.$days = this.$.find("#custClockDays");
			this.$tips = this.$.find('.tips');
			this.$bindCustomer = this.$.find('.bind_customer');
			this.$customerItem = this.$bindCustomer.find('.bind_customer_list').remove();
			this.$customerMain = this.$bindCustomer.find('.bind_customer_main').on('vclick', '.close', function() {
				var itemEl = $(this).parent('.bind_customer_list');
				itemEl.remove();
			})
			this.$bindCustomerContent = this.$bindCustomer.find('.bind_customer_header').on('vclick', function () {
				var defaultSelectdKeys = self.defaultSelectdKeys();
				$.am.changePage(amGloble.page.customerSearch, "slideleft", {
					userId: defaultSelectdKeys.length ? defaultSelectdKeys[0] : "",
					userType: defaultSelectdKeys.length ? 1 : "",
					callback: function (data) {
						$.am.page.back("slideleft", { customerData: data, defaultSelectEmp: self.defaultSelectEmp, type: 9, back: true });
					}
				});
			});
            this.$isAppendWordsInput = this.$.find(".page-textarea .appendWords input").change(function(){
                if($(this).is(':checked')){
                    self.$.find(".appendWords .am-checkbox").addClass("am-checkbox-checked")
                }else{
                    self.$.find(".appendWords .am-checkbox").removeClass("am-checkbox-checked")
                }
            })
            this.$.find(".create-words").on("vclick",".iconfont",function(e){
                e.stopPropagation()
                var index = $(this).data('index')
                self.createWords.splice(index, 1);
                localStorage.setItem("CREATE_WORDS", JSON.stringify(this.createWords))
                self.initCreateWords()
            })
            this.$.find(".create-words").on("vclick",".words-item",function(){
                var text = $(this).find('.create-words-label').html()
                self.$text.val(text)
            })

			this.$bindStaffContent = this.$.find(".bind_staff .bind_staff_content").hide();
			this.$bindStaffMain = this.$bindStaffContent.find('.bind_staff_main');
			this.$bindStaffList = this.$bindStaffContent.find('.bind_staff_list').remove();
			this.$bindStaffContent.on("vclick", ".bind_staff_header", function() {
				self.openEmpSelect();
			}).on("vclick", ".bind_staff_main .bind_staff_list .close", function() {
				var itemEl = $(this).parent('.bind_staff_list');
				itemEl.remove();
				// 优化成当最后一个删除的时候将执行下面的清空
				self.defaultSelectEmp = [];
			});
			this.$bindStaff = this.$.find(".bind_staff").on("vclick", ".bind_remind_type .remind_radio", function() {
				$(this).addClass('checked').siblings().removeClass('checked');
				self.remindType = $(this).attr("value-type");
				if (self.remindType == 2) {
					self.$bindStaffContent.show();
					self.$dateSetArea.find(".date-type .label").html("提醒");
					self.$dateSetArea.find(".days-type .label").html("天后提醒");
				} else {
					self.$bindStaffContent.hide();
					self.$dateSetArea.find(".date-type .label").html("提醒我");
					self.$dateSetArea.find(".days-type .label").html("天后提醒我");
				}
			});

			this.$save = this.$header.find(".right").vclick(function () {
				if (self.openEmp) {
					self.getCurrentEmps();
				} else {
					self.save();
				}
			});
			this.$dateTypeMenu = this.$.find('.setTime .dateTypeMenu').on('vclick', 'li', function () {
				var _this = this
				self.onSwitchDateType(_this)
			})
			this.$dateSetArea = this.$.find('.setTime .dateSetArea')
			this.$timePicker = this.$dateSetArea.find(".date-type .date")
			this.$timePicker.mobiscroll().date({
				dateFormat: "yyyy-mm-dd",
				display: 'bottom',
				animate: 'slideup',
				lang: "zh",
				mode: "scroller",
				max: '',
				onSet: function (obj) {
					self.$setDate = obj.valueText;
					$(this).addClass('active').text(obj.valueText)
				}
			});
			this.$timePicker.vclick(function () {
				$(this).mobiscroll('setVal', new Date(self.$setDate));
			})
		},
		beforeShow: function (paras) {
			// debugger
			if (paras === 'back') {
				return;
			}
			this.openEmp = false;
			this.defaultSelectEmp = [];
			this.data = paras;
			this.type = paras.type;
			if (amGloble.metadata.userInfo.userType == 0) {
				this.$bindStaff.show();
			} else {
				this.$bindStaff.hide();
			}
			if (this.type === 9) {
				if (paras.customerData) {
					this.data = paras.customerData;
					this.$customerMain.empty();
					var falg = false;
					this.$customerMain.find('.bind_customer_list').each(function() {
						var data = $(this).data();
						if (data.id === paras.customerData.id) {
							falg = true;
						}
					})
					if (!falg) {
						var $item = this.$customerItem.clone();
						$item.find('.list-info-img').html(amGloble.photoManager.createImage("customer", {
							parentShopId: amGloble.metadata.userInfo.parentShopId,
							updateTs: this.data.lastphotoupdatetime
						}, this.data.id + ".jpg", "s"));
						$item.find('.list-info-user-title').text(this.data.name);
						$item.find('.list-info-user-phone').text(this.data.mobile);
						if (this.data.sex === 'M') {
							$item.find('.list-info-img').addClass('male');
						}

						var empids = paras.customerData.empid ? paras.customerData.empid.split(",") : [];

						if (empids.length == 1) {
							var emp = this.findEmployeeDataById(empids[0]);
							emp && this.renderSelectEmps([{ id: emp.empid, name: emp.empname }]);
						}

						$item.data(paras.customerData);
						this.$customerMain.append($item);
					}

				}

				if (paras.defaultSelectEmp && paras.defaultSelectEmp.length) {
					this.defaultSelectEmp = paras.defaultSelectEmp;
					this.renderSelectEmps(paras.defaultSelectEmp);
				}
			}
			if (paras && paras.back) {
				return;
			}
            var Words = localStorage.getItem("CREATE_WORDS")
            this.createWords = (Words && Words!=="undefined") ? JSON.parse(Words) : []
			this.resetUI();
		},
		onSwitchDateType: function (_this) {
			var self = this
			var _this = _this
			$(_this).addClass('selected').siblings().removeClass('selected');
			var dateType = $(_this).attr('date-type')
			if (dateType == 1) {
				self.$dateType = 1;
				self.$days.val("");
			} else {
				self.$dateType = 2;
				self.$timePicker.removeClass('active').text("选择日期");
				self.$setDate = amGloble.now().format("yyyy-mm-dd");
			}
			var index = dateType - 1
			self.$dateSetArea.find('div').eq(index).show().siblings().hide()
		},
		afterShow: function () {
			//处理点穿的问题
			this.$text.prop("disabled", false);
			this.$days.prop("disabled", false);
		},
		beforeHide: function () {
			// this.$bindCustomerContent.empty();
			// this.$bindCustomerContent.html('<p>可不关联 <i class="iconfont icon-gengduo2"></i></p>');
			this.$text.prop("disabled", true);
			this.$days.prop("disabled", true);
		},
		resetUI: function () {
			this.$text.val("");
			this.$days.val("");
            this.$isAppendWordsInput.prop("checked",false)
            this.$.find(".appendWords .am-checkbox").removeClass("am-checkbox-checked")
			this.$dateType = 1;
			this.$dateTypeMenu.find('li').eq(0).addClass('selected').siblings().removeClass('selected');
			this.$dateSetArea.find('div').eq(0).show().siblings().hide();
			this.$timePicker.removeClass('active').text("选择日期");
			this.$setDate = amGloble.now().format("yyyy-mm-dd");
			this.$header.find('p').text(this.type === 9 ? '新增待办' : '添加顾客闹钟');
			this.$bindCustomer.find('.bind_customer_list').remove();
			this.$bindStaffContent.find('.bind_staff_list').remove();
			if (this.type === 9) {
				this.$tips.hide();
				this.$bindCustomer.show();
				this.$bindCustomerContent.addClass('empty').find('span').siblings().remove();
			} else {
				this.$tips.show();
				this.$bindCustomer.hide();
			}
            this.initCreateWords()
		},
        initCreateWords: function(){
            var createWordsHtml = ""
            for (var i = 0; i < this.createWords.length; i++) {
                createWordsHtml += '<li class="words-item am-clickable"><label class="create-words-label">'+this.createWords[i]+'</label><span class="iconfont am-clickable" data-index='+i+'>&#xe60a;</span></li>'
            }
            if(createWordsHtml){
                this.$.find('.create-words').html(createWordsHtml)
                this.$.find('.create-words').show()
            }else{
                this.$.find('.create-words').hide()
            }
        },
		save: function () {
			var self = this;
			var title = $.trim(this.$text.val());
			var days = $.trim(this.$days.val()) * 1;
			var user = amGloble.metadata.userInfo;
			var cust = this.data;
			var params = {
				"customerId": cust.id,
				"shopId": user.shopId,
				"customerName": cust.name,
				"gender": cust.gender,
				"mobile": cust.phone,
			}
			var todoAddParams = {
				"empTodoList": []
			};

			if (!title.length) {
				amGloble.msg("请输入闹钟标题！");
				return;
			}

			if (title.length > 100) {
				amGloble.msg("最多只能输入 100 个字！");
				return;
			}
			if (self.type == 9) {
				var selectEmp = self.getSelectEmp();
				if (self.remindType == 2 && !selectEmp.length) {
					amGloble.msg("请选择提醒手艺人！");
					return;
				}

				params.barberType = self.remindType == 2 ? 1 : user.userType;
				params.barberId = self.remindType == 2 ? selectEmp[0].id : user.userId;
				params.barberName = self.remindType == 2 ? selectEmp[0].name : user.userName;
				params.content = title;
				params.creatorName = user.userName;
				params.creatorId = user.userId;
				params.creatorType = user.userType;
			} else {
				params.title = title;
				params.operator = user.userId;
				params.operatorType = user.userType;
			}
			if (self.$dateType === 1) { // 按日期设置
				if (!self.$setDate || new Date(self.$setDate) < amGloble.now()) {
					amGloble.msg("请设置正确的日期！（大于今天）");
					return;
				}
				params.alarmType = 1;
				params.alarmDate = self.$setDate;
				params.runTime = new Date(params.alarmDate).getTime();
			} else { // 按天数设置
				if (!days || isNaN(days) || days < 1) {
					amGloble.msg("请输入正确的提醒时间！（1-99999天）");
					return;
				}
				params.days = days;
				params.runTime = new Date().getTime() + days * (3600 * 1000 * 24);
			}
			if (self.type == 9) {
				this.$customerMain.find('.bind_customer_list').each(function() {
					var data = $(this).data();
					var baseData = JSON.parse(JSON.stringify(params));
					todoAddParams.empTodoList.push($.extend(baseData, {
						"customerId": data.id,
						"shopId": self.remindType == 2 ? user.shopId : data.shopid,
						"customerName": data.name,
						"gender": data.sex,
						"mobile": data.mobile,
					}));
				})
				if (this.$customerMain.find('.bind_customer_list').length === 0) {
					var baseData = JSON.parse(JSON.stringify(params));
					todoAddParams.empTodoList.push($.extend(baseData, {
						"customerId": '',
						"customerName": '',
						"gender": '',
						"mobile": '',
					}));
				}
			}
			amGloble.loading.show();
			var actionName = self.type == 9 ? 'todoAdd' : 'clockAdd';
			amGloble.api[actionName].exec(actionName === 'todoAdd' ? todoAddParams : params, function (ret) {
				amGloble.loading.hide();
				if (ret.code == 0) {
					amGloble.msg("添加成功");
					$.am.page.back("slidedown");

                    if (self.$isAppendWordsInput.is(':checked')){
                        self.appendWords(title)
                    }
					if (self.type !== 9) {
						//将客户档案页码消0
						cust.clockCount++;
						amGloble.page.customerDetail.custClock.pageIndex = 0;
						amGloble.page.customerDetail.custClock.$list.empty();
						amGloble.page.customerDetail.tab.$inner.find("li:eq(8)").trigger("vclick").find("div.num").text(cust.clockCount);
						amGloble.page.customerDetail.custClock.$title.text("共有" + cust.clockCount + "个客户闹钟");
					} else {
						window.RouterUtils.eventBus.$emit('global-message', { type: 'refresh' })
					}
					amGloble.page.dashboard.dashboardCacheUtil && amGloble.page.dashboard.dashboardCacheUtil.clear();

				} else {
					amGloble.msg(ret.message || "提交失败");
				}
			});
		},
        appendWords: function(data) {
            var find = false
            for (var i = 0; i < this.createWords.length; i++) {
                var e = this.createWords[i];
                if (data === e) {
                    find = true
                    break
                }
            }
            if (!find) {
                this.createWords.push(data)
                localStorage.setItem("CREATE_WORDS", JSON.stringify(this.createWords));
            }
        },
		renderSelectEmps: function(emps) {
			var self = this;
			self.defaultSelectEmp = emps;
			self.$bindStaffMain.empty();
			emps.forEach(function(item) {
				var $item = self.$bindStaffList.clone();
				$item.find('.list-info-img').html(amGloble.photoManager.createImage("artisan", {
					parentShopId: amGloble.metadata.userInfo.parentShopId,
					updateTs: ""
				}, item.id + ".jpg", "s"));
				$item.find('.list-info-user-title').text(item.name);
				if (item.sex == 'M') {
					$item.find('.list-info-img').addClass('male');
				}
				$item.data("item", item);
				self.$bindStaffMain.append($item)
			})
			self.refresh();
		},
		defaultSelectdKeys: function() {
			var defaultSelectdKeys = [];
			this.$bindStaffMain.find(".bind_staff_list").each(function() {
				var item = $(this).data("item");
				defaultSelectdKeys.push(item.id);
			})
			return defaultSelectdKeys;
		},
		getSelectEmp: function() {
			var selectEmp = [];
			this.$bindStaffMain.find(".bind_staff_list").each(function() {
				var item = $(this).data("item");
				selectEmp.push(item);
			})
			return selectEmp;
		},
		getSelectCustomer: function() {
			// 获取选中的顾客
			var selectCustomer = [];
			this.$customerMain.find('.bind_customer_list').each(function() {
				var data = $(this).data();
				selectCustomer.push(data);
			})
			return selectCustomer;
		},
		getCurrentEmps: function() {
			var emps = amGloble.empSelect.getCurrentEmps();

			this.renderSelectEmps(emps);
			this.closeEmpSelect();
		},
		formatEmpList: function(emp) {
			var data = [];
			var employeeLevels = amGloble.metadata.employeeLevels;
			var selectCustomer = this.getSelectCustomer();
			var empidsArr = selectCustomer && selectCustomer.length && selectCustomer[0].empid ? selectCustomer[0].empid.split(",") : [];
			var customerBinding = [];
			empidsArr.forEach(function(id) {
				customerBinding.push(Number(id));
			})

			employeeLevels.forEach(function(levelItem) {
				var children = [];
				emp.forEach(function(item) {
					if (item.dutyid == levelItem.dutyId && (!customerBinding.length || customerBinding.indexOf(Number(item.empid)) != -1)) {
						children.push({
							sex: item.sex,
							name: item.empname,
							id: item.empid
						})
					}
				})

				if (children && children.length) {
					data.push({
						indexName: levelItem.name,
						children: children
					})
				}
			})

			return data;
		},
		closeEmpSelect: function() {
			this.openEmp = false;
			this.$header.find(".left").html("取消");
			this.$header.find(".right").html("保存");
			amGloble.empSelect.hide();
		},
		findEmployeeDataById: function(id) {
			var data = amGloble.metadata.employees || [];
			var findData;
			for (var i = 0; i < data.length; i++) {
				var emp = data[i];
				if (emp.empid == id) {
					findData = emp;
					break;
				}
			}
			return findData;
		},
		openEmpSelect: function() {
			var self = this;

			self.openEmp = true;
			self.$header.find(".left").html('<span class="back"></span>');
			self.$header.find(".right").html("确定");

			var data = self.formatEmpList(amGloble.metadata.employees || []);

			amGloble.empSelect.show({
				callback: function() {
					self.getCurrentEmps();
				},
				data: data,
				config: { multiple: false, defaultSelectdKeys: (data.length == 1 && data[0].children.length == 1) ? [data[0].children[0].id] : self.defaultSelectdKeys() }
			});
		}
	});
})();
