amGloble.page.customerDetail = new $.am.Page({
    backButtonOnclick: function() {
        if ($("#pswp_dom").is(":visible")) {
            amGloble.gallery.close();
        } else {
            $.am.page.back("slideright",this.paras);
        }
    },
    id: "page-customerDetail",
    init: function() {
        var _this = this;
        this.archiveCategoryList = [];
        this.memArchivesCount = {};
        this.tab = new $.am.ScrollView({
            $wrap: this.$.find("div.custDetail_tab"),
            $inner: this.$.find("div.custDetail_tab ul"),
            direction: [1, 0]
        });
        this.tab.$inner.delegate("li", "vclick", function() {
            var $this = $(this);
            var idx = $this.index();
            var user = _this.data.meta;
            $this.addClass("selected").siblings().removeClass();
            //显示相应模块
            var $clist = _this.$blocks.eq(idx);
            _this.$blocks.hide().eq(idx).show();
            _this.scrollview.pauseTouchBottom = true;

            var $list = $clist.find("dl.list dd, div.archiveList li, ul li");
            if (!$list.length) {
                _this.$empty.css("display", "-webkit-box");
            } else {
                _this.$empty.hide();
            }
            if (idx == 0) {
                if (_this.custProfile.pageIndex == 0) {
                    //如果客户档案的页码是0，还没有取过数据
                    _this.getCustomerProfile();
                } else {
                    if (Math.ceil(user.archivesCount / 10) > _this.custProfile.pageIndex) {
                        _this.scrollview.pauseTouchBottom = false;
                    }
                }
            } else if (idx == 1) {
                if (_this.custPhotoProfile.pageIndex == 0) {
                    //如果美丽档案的页码是0，还没有取过数据
                    _this.getCustomerPhotoProfile();
                } else {
                    if (Math.ceil(user.custPhotoProfileCount / 10) > _this.custPhotoProfile.pageIndex) {
                        _this.scrollview.pauseTouchBottom = false;
                    }
                }
            } else if (idx == 2) {
                if (_this.serviceHistory.pageIndex == 0) {
                    //消费历史
                    _this.getCustomerServiceHistory();
                } else {
                    if (Math.ceil(user.serviceCount / 10) > _this.serviceHistory.pageIndex) {
                        _this.scrollview.pauseTouchBottom = false;
                    }
                }
            } else if (idx == 4 && !_this.custCards.rendered) {
                //
            } else if (idx == 5 && !_this.comboCards.rendered) {
                //
            } else if (idx == 6) {
                if (_this.luckyMoneyList.pageIndex == 0) {
                    //红包
                    _this.getLuckyMoneyList();
                } else {
                    if (Math.ceil(user.luckyMoneyCount / 10) > _this.luckyMoneyList.pageIndex) {
                        _this.scrollview.pauseTouchBottom = false;
                    }
                }
            } else if (idx == 7) {
                if (_this.mallOrderList.pageIndex == 0) {
                    //商城订单
                    _this.getMallOrderList();
                } else {
                    if (Math.ceil(user.mallOrderCount / 10) > _this.mallOrderList.pageIndex) {
                        _this.scrollview.pauseTouchBottom = false;
                    }
                }
            } else if (idx == 8) {
                //
                if (_this.custClock.pageIndex == 0) {
                    //消费历史
                    _this.getCustomerClock();
                } else {
                    if (Math.ceil(user.clockCount / 10) > _this.custClock.pageIndex) {
                        _this.scrollview.pauseTouchBottom = false;
                    }
                }
            } else if(idx == 3){
                _this.getReservationHistory(user)

            }


            _this.refresh();
        });
        this.$blocks = this.$.find(".custDetail_blocks > div");

        this.$header.children(".left.backbutton").vclick(function () {
            _this.paras['dback']=1;
            $.am.page.back("slideright",_this.paras);
        })

        this.$header.children(".right").vclick(function(){
            $.am.changePage(amGloble.page.customerDetailMore,'slideleft',_this.data);
        });

        /* this.$tqk = this.$.find('.tqk');// fix bug 0016357
        this.$myk = this.$.find('.myk'); */

        //客户档案
        this.custProfile = {
            $title: this.$blocks.eq(0).find(".title_t"),
            $num: this.$blocks.eq(0).find(".tips_count .num"),
            $list: this.$blocks.eq(0).find("dl"),
            pageIndex: 0
        }
        this.custProfile.$title.on('vclick', function(e) {
            var text = $(this).find('span.name');
            _this.showArchives(false, text.data('id') || 0);
            // _this.$categoryDetail.addClass('query').show();
        })
        $('.custDetail_doc').on('vclick', 'dd .category .category_text', function(e) {
            var id = $(this).parents('.category-item').attr('dataid')
            var categoryId = $(this).parents('.category-item').data('categoryid');
            console.log(id);
            _this.$choosedCategoryItem = $(this);
            _this.$categoryDetail.data({chooseId: id});
            if(_this.archiveCategoryList && _this.archiveCategoryList.length) {
                _this.showArchives(true, categoryId);
            }
        })
        this.categoryListScroll = new $.am.ScrollView({
            $wrap: _this.$.find(".categoryDetail .list_wrap"),
            $inner: _this.$.find(".categoryDetail .list_wrap .archives"),
            direction: [0, 1]
        })
        this.custProfile.$list.delegate("div.edit", "vclick", function() {
            var $this = $(this).parent();
            var user = _this.data.meta;
            atMobile.nativeUIWidget.confirm({
                caption: "删除客户档案",
                description: "确定要删除这一条记录吗?",
                okCaption: "删除",
                cancelCaption: "返回"
            }, function() {
                amGloble.api.customerDelArchives.exec({
                    id: $this.parents('.category-item').attr("dataid") * 1
                }, function(ret) {
                    if (ret.code == 0) {
                        user.archivesCount--;
                        _this.tab.$inner.find("div.num").eq(0).text(user.archivesCount);
                        _this.custProfile.$num.text(Number(_this.custProfile.$num.text()) - 1);
                        // _this.custProfile.$title.text("共有" + user.archivesCount + "条档案");

                        // $this.prev().remove();
                        $this.parents('.category-item').remove();
                        _this.refresh();
                    } else {
                        amGloble.msg("删除失败！");
                    }
                });
            }, function() {});
        }).delegate('.photos li','vclick',function(){
            var itemData = $(this).closest('.category-item').data('item');
            if (itemData.videos) {
                var options = {
                    parentShopId: amGloble.metadata.userInfo.parentShopId,
                    authorId: amGloble.metadata.userInfo.userId
                }
                $.am.videoPlayer.show({
                    poster: amGloble.photoManager.getPhotoUrl("customerFile", options, itemData.imgs ? itemData.imgs.split(',')[0] : ''),
                    videoUrl: amGloble.photoManager.getPhotoUrl("customerFile", options, itemData.videos)
                })
                return;
            }
            var items = [];
            var index = $(this).parent().children().index($(this));
            $(this).parent().find("img").each(function() {
                // items.push({
                //     src: $(this).attr("src").replace("_s", "_l"),
                //     w: $(this).attr("w")==256?1024:2048,
                //     h: $(this).attr("w")==256?1024:2048,
                // });
                var imageWidth = $(this).attr("w"),
                    imageHeight = $(this).attr("h");
                items.push({
                    src: $(this).attr("src").replace("_s", "_l"),
                    w: 2048,
                    h: (2048 * imageHeight)/imageWidth,
                });
            });
            self.pswpTimer && clearTimeout(self.pswpTimer);
            amGloble.loading.show();
            self.pswpTimer = setTimeout(function() {
                amGloble.loading.hide();
                amGloble.pswp(items, index);
            }, 500);
        });
        //添加客户档案
        this.$.find("#createCustInfoBtn").vclick(function() {
            var user = _this.data.meta;
            user.archiveList = _this.archiveCategoryList;
            amGloble.page.customerCreatFile.changeToMe("slideup", user);
        });
        this.$.find('.benefit_tab').vclick(function () {
            var data = $(this).data('data');
            window.RouterUtils.push({
                name: 'customerBehavior',
                animation: 'slideleft',
                params: { empInfo: JSON.parse(JSON.stringify(data)), refresh: false}
            })
        });

        //美丽档案
        this.custPhotoProfile = {
            $title: this.$blocks.eq(1).find(".title_t"),
            $list: this.$blocks.eq(1).find(".archiveList > ul"),
            pageIndex: 0
        }


        this.custPhotoProfile.$list.on("vclick", ".userHeader", function() {
            // //点击头像
        }).on("vclick", ".left > .like", function(e) {
            // //赞
        }).on("vclick", ".left > .share", function(e) {
            //分享
            e.stopPropagation();
            var $this = $(this);
            var $li = $this.parents("li");
            var data = $this.parents("li").data("item");
            console.log(data);

            var shareObj = {
                title: "哎哟，不错哦~" + amGloble.metadata.userInfo.shopName + amGloble.getStoresById(data.shopId).shopFullName + data.empName + "近期作品「" + data.title + "」，你心动了吗？约起！",
                link: amGloble.getShareRoot() + $.param({
                    tenantId: amGloble.metadata.userInfo.parentShopId,
                    view: 8,
                    modelId: data.id
                }),
                imgUrl: $li.find("ul.photos img").eq(0).attr("src"),
                success: function() {}
            };

            amGloble.share(shareObj);

        }).on("vclick", ".right > .comment", function(e) {
            //审核和取消审核
            e.stopPropagation();
            var $thisli = $(this).parents("li");
            var data = $thisli.data("item");
            if (data.visible) {
                atMobile.nativeUIWidget.confirm({
                    caption: "取消审核",
                    description: "取消审核后此作品将不再显示在美一客，确认要取消吗?",
                    okCaption: "确定",
                    cancelCaption: "取消"
                }, function() {
                    amGloble.loading.show();
                    amGloble.api.inventionVisible.exec({
                        id: data.id,
                        visible: 0
                    }, function(ret) {
                        amGloble.loading.hide();
                        if (ret.code == 0) {
                            data.visible = 0;
                            $thisli.find(".comment").text("审核");
                            $thisli.find(".mykVisible").text("待审核");
                            amGloble.msg("取消成功!");
                        } else {
                            amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                        }
                    });
                }, function() {

                });
            } else {
                atMobile.nativeUIWidget.confirm({
                    caption: "审核",
                    description: "审核通过后作品将显示在美一客，确认审核吗?",
                    okCaption: "确定",
                    cancelCaption: "取消"
                }, function() {
                    amGloble.loading.show();
                    amGloble.api.inventionVisible.exec({
                        id: data.id,
                        visible: 1
                    }, function(ret) {
                        amGloble.loading.hide();
                        if (ret.code == 0) {
                            data.visible = 1;
                            $thisli.find(".mykVisible").text("美一客可见");
                            $thisli.find(".comment").text("取消审核");
                            amGloble.msg("审核成功!");
                        } else {
                            amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                        }
                    });
                }, function() {

                });
            }
        }).on("vclick", ".right > .complain", function(e) {
            //删除
            e.stopPropagation();
            var $thisli = $(this).parents("li");
            var data = $thisli.data("item");
            atMobile.nativeUIWidget.confirm({
                caption: "删除作品",
                description: "确认要删除此作品吗?",
                okCaption: "确定",
                cancelCaption: "取消"
            }, function() {
                amGloble.loading.show();
                amGloble.api.delInvention.exec({
                    id: data.id
                }, function(ret) {
                    amGloble.loading.hide();
                    if (ret.code == 0) {
                        data.visible = 1;
                        $thisli.remove();
                        amGloble.msg("删除成功!");
                        self.refresh();
                    } else {
                        amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                    }
                });
            }, function() {});
        }).on("vclick", ".center > .un_involved", function(e) {
            //删除
            e.stopPropagation();
            $(".un_involved").attr("data-that","");
            $(this).attr("data-that","selected");
            var submitData = $(this).parents("li.am-touchable").data("item");
            if (submitData.visible != 1) {
                amGloble.msg('作品未审核，无法参赛')
                return
            }
            _this.$.find(".select_dynamic_box").data("data",submitData);
            amGloble.loading.show();
            amGloble.api.getVoteActive.exec({
                "activityType":2,
                "parentShopId": amGloble.metadata.userInfo.parentShopId,
                "shopId": amGloble.metadata.userInfo.shopId,
                "userId":amGloble.metadata.userInfo.userId
            }, function (res) {
                amGloble.loading.hide();
                console.log("获取参赛活动回调",res);
                if(res.code == 0) {
                    if(res.content && res.content.length > 0) {
                        _this.renderActive(res.content);
                        _this.$.find(".select_dynamic_box").fadeIn();
                    } else {
                        amGloble.msg("暂时没有可参赛的活动！！");
                    }
                } else {
                    amGloble.msg(res.message || "网络请求失败,请稍后再试！");
                }
            });
        }).on("vclick", ".center > .has_involved .canvassing", function(e) {
            //拉票
            e.stopPropagation();
            var that = this;
            _this.gotoMinipro(that);
        }).on("vclick", ".center > .has_involved .waiver", function(e) {
            //弃权
            e.stopPropagation();
            var submitData = $(this).parents("li.am-touchable").data("item");
            console.log("弃权数据==============================",submitData)
            var that = $(this);
            atMobile.nativeUIWidget.confirm({
                caption: "弃权",
                description: "确定弃权吗？",
                okCaption: "是",
                cancelCaption: "否"
            }, function() {
                amGloble.loading.show();
                amGloble.api.waiverFunc.exec({
                    "parentShopId": amGloble.metadata.userInfo.parentShopId,
                    "shopId": amGloble.metadata.userInfo.shopId,
                    "memId":amGloble.metadata.userInfo.userId,
                    // "activityId": submitData.votActivityId, //活动id
                    "activityType":2,
                    "inventionId": submitData.id //作品id
                }, function (res) {
                    amGloble.loading.hide();
                    console.log("弃权回调",res);
                    if(res.code == 0) {
                        // self.getOnePage(true);
                        that.parents(".has_involved").siblings(".un_involved").show();
                        that.parents(".has_involved").hide();
                        that.parents(".actions").find('.right .complain').show();
                    } else {
                        amGloble.msg(res.message || "网络请求失败,请稍后再试！");
                    }
                });
            })
        }).on("vclick", "ul.photos > li", function(e) {
            //看大图
            e.stopPropagation();
            var itemData = $(this).parents('li').data('item');
            if (itemData.videos) {
                var options = {
                    catigoryId: itemData.type,
                    parentShopId: itemData.parentShopId,
                    authorId: itemData.empId,
                }
                $.am.videoPlayer.show({
                    poster: amGloble.photoManager.getPhotoUrl("show", options, itemData.photo ? itemData.photo.split(',')[0] : ''),
                    videoUrl: amGloble.photoManager.getPhotoUrl("show", options, itemData.videos)
                })
                return;
            }
            var items = [];
            var index = $(this).parent().children().index($(this));
            $(this).parent().find("img").each(function() {
                var imageWidth = $(this).attr("w"),
                    imageHeight = $(this).attr("h");
                items.push({
                    src: $(this).attr("src").replace("_s", "_l"),
                    w: 2048,
                    h: (2048 * imageHeight)/imageWidth,
                });
                // items.push({
                //     src: $(this).attr("src").replace("_s", "_l"),
                //     w: $(this).attr("w")==256?1024:2048,
                //     h: $(this).attr("w")==256?1024:2048,
                // });
            });
            self.pswpTimer && clearTimeout(self.pswpTimer);
            amGloble.loading.show();
            self.pswpTimer = setTimeout(function() {
                amGloble.loading.hide();
                amGloble.pswp(items, index);
            }, 600);
        }).on("vclick", ".commentsList .del", function(e) {
            //删除评论
            e.stopPropagation();
            //删除评论
            var $this = $(this);
            var data = $this.parents("p").data("item");
            console.log(data);

            atMobile.nativeUIWidget.confirm({
                caption: "删除评论",
                description: "确定要删除这个评论吗？",
                okCaption: "是",
                cancelCaption: "否"
            }, function() {
                amGloble.loading.show();
                amGloble.api.inventionDeleteEvaluation.exec({
                    id: data.id,
                    //token : amGloble.token
                }, function(ret) {
                    amGloble.loading.hide();
                    if (ret.code == 0) {
                        var $list = $this.parents(".commentsList");
                        $this.parent().remove();
                        if ($list.is(":empty")) {
                            $list.hide();
                        }

                        amGloble.msg("删除成功.");
                    } else {
                        amGloble.msg(ret.message || "数据提交失败,请检查网络!");
                    }
                });
            }, function() {});

        })


        //添加美丽档案
        this.$.find("#addBeautyDoc").vclick(function() {
            var user = _this.data.meta;
            amGloble.page.addArchive.changeToMe("slideup", {
                id: user.id,
                name: user.name,
                shopId: user.storeId
            });
        });

        //消费记录
        this.serviceHistory = {
            $title: this.$blocks.eq(2).find(".title_t"),
            $list: this.$blocks.eq(2).find("ul.custDetail_record"),
            pageIndex: 0,
            $clone: this.$blocks.eq(2).find("ul.custDetail_record>li").remove()
        };
        //会员卡
        this.custCards = {
            $clone: this.$blocks.eq(4).find("ul.fileds>li").remove(),
            $list: this.$blocks.eq(4).find("ul.fileds").remove(),
            $wrapper: this.$blocks.eq(4).find('.wrapper').remove(),
            $container: this.$blocks.eq(4)
        };
        //套餐卡
        this.comboCards = {
            $clone: this.$blocks.eq(5).find("ul.fileds>li").remove(),
            $list: this.$blocks.eq(5).find("ul.fileds").remove(),
            $wrapper: this.$blocks.eq(5).find('.wrapper').remove(),
            $container: this.$blocks.eq(5)
        };

        //红包
        this.luckyMoneyList = {
            $title: this.$blocks.eq(6).find(".title_t"),
            pageIndex: 0,
            $clone: this.$blocks.eq(6).find("ul.fileds>li").remove(),
            $list: this.$blocks.eq(6).find("ul.fileds"),
            $container: this.$blocks.eq(6)
        };
        //私发红包
        this.$.find("#sendRedpackage").vclick(function() {
            var user = _this.data.meta;
            $.am.changePage(amGloble.page.sendRedPocket, "slideup",{customer:user});
            console.log(user);
        });
        this.$ruleDetail = this.$.find('.ruleDetail').on('vclick','.close,.mask',function(){
            _this.$ruleDetail.hide();
            _this.$ruleDetail.find('.wrapper').removeClass('active');
        });
        this.$classDetail = this.$.find('.classDetail').on('vclick','.close,.mask',function(){
            _this.$classDetail.find('.wrapper').removeClass('active');
            setTimeout(function(){
                _this.$classDetail.hide();
            },350)
        });
        this.$categoryDetail = this.$.find('.categoryDetail').on('vclick', '.close,.mask',function(){
            _this.$categoryDetail.removeClass('query').hide();
        }).on('vclick', '.archives .item', function(){
            console.log($(this));
            $(this).addClass('active').siblings().removeClass('active');
            var data = $(this).data();
            var type = $(this).parents('.categoryDetail').hasClass('query');
            if(type) {
                $(this).parents('.categoryDetail').removeClass('query');
                $('.custDetail_doc .title_t .name').text($(this).find('.name').text()).data({id: data.id});
                _this.custProfile.pageIndex = 0;
                _this.lastCategroyType = data.id ? data.id : undefined
                _this.getCustomerProfile(_this.lastCategroyType);
            } else {
                var itemId = $(this).parents('.categoryDetail').data('chooseId');
                amGloble.api.updArchives.exec({
                    id: itemId,
                    categoryId: data.id,
                    parentShopId: amGloble.metadata.userInfo.parentShopId
                }, function(ret){
                    if(ret.code == 0) {
                        amGloble.msg("修改成功！");
                        if(_this.$choosedCategoryItem && data.name) {
                            _this.$choosedCategoryItem.text(data.name.substring(0, 1)).css('background-color', data.color);
                            _this.$choosedCategoryItem.parents('.category-item').data('categoryid', data.id)
                        } else {
                            _this.getCustomerProfile(_this.lastCategroyType || '', true);
                        }
                    } else {
                        amGloble.msg("修改失败！");
                    }
                })
            }
            _this.$categoryDetail.hide();
        })
        this.ruleDetailScroll = new $.am.ScrollView({
            $wrap: this.$ruleDetail.find('.wrap'),
            $inner: this.$ruleDetail.find('.inner'),
            direction: [0, 1]
        });
        this.classDetailScroll = new $.am.ScrollView({
            $wrap: this.$classDetail.find('.wrapper'),
            $inner: this.$classDetail.find('.inner'),
            direction: [0, 1]
        });
        this.luckyMoneyList.$list.on('vclick','.openRule',function(){
            var item = $(this).parents('li').data('data');
            amGloble.initTpList().then(function() {
                return amGloble.initProductCategory();
            }).then(function() {
                _this.showRuleDetail(item);
            })
        });

        //商城订单
        this.mallOrderList = {
            pageIndex: 0,
            $clone: this.$blocks.eq(7).find("ul.fileds>li"),
            $list: this.$blocks.eq(7).find("ul.fileds"),
            $container: this.$blocks.eq(7)
        };

        //客户闹钟
        this.custClock = {
            $title: this.$blocks.eq(8).find(".title_t"),
            $list: this.$blocks.eq(8).find("ul.fileds"),
            $clone: this.$blocks.eq(8).find("ul.fileds>li").remove(),
            pageIndex: 0
        };
        //添加客户档案
        this.$.find("#addClock").vclick(function() {
            var user = _this.data.meta;
            amGloble.page.customerClockAdd.changeToMe("slideup", user);
        });

        this.custClock.$list.on("vclick", "div.edit", function() {
            var $this = $(this).parent().parent();
            var item = $this.data("item");
            var user = _this.data.meta;
            atMobile.nativeUIWidget.confirm({
                caption: "删除客户闹钟",
                description: "确定要删除这个客户闹钟吗?",
                okCaption: "删除",
                cancelCaption: "返回"
            }, function() {
                amGloble.api.clockDelete.exec({
                    id: item.id,
                    type: item.type
                }, function(ret) {
                    if (ret.code == 0) {
                        user.clockCount--;
                        _this.tab.$inner.find("div.num").eq(8).text(user.clockCount);
                        _this.custClock.$title.text("共有" + user.clockCount + "个客户闹钟");
                        $this.remove();
                        _this.refresh();
                    } else {
                        amGloble.msg("删除失败！");
                    }
                });
            }, function() {});
        });
        this.activityEle = new $.am.ScrollView({
            $wrap: $(".select_dynamic_box").find(".content_box_list"),
            $inner: $(".select_dynamic_box").find(".content_boxs"),
            direction: [0, 1]
        });
        this.$select_dynamic_box = this.$.find(".select_dynamic_box");
        this.$select_dynamic_box.on("click", ".mask",function() {
            $(this).parents(".select_dynamic_box").fadeOut();
        }).on("click", ".cancel",function() {
            $(this).parents(".select_dynamic_box").fadeOut();
        }).on("click", ".dynamic_detail",function() {
            var activeData = $(this).parents(".content_box").data("data"),
                activeData2 = $(this).parents(".select_dynamic_box").data("data");
            activeData.dynamicData = activeData2;
            $(this).parents(".select_dynamic_box").fadeOut();
            $.am.changePage(amGloble.page.participate, "slideleft", {
                activeData:activeData
            });
            // self.goParticipate(activeData);
        })


        //上传头像
        this.$pic = this.$.find("#uploadHeaderBtn").vclick(function() {
            // amGloble.page.uploadHeader.changeToMe("slideup", _this.data);
            // alert("上传头像");

            var user = amGloble.metadata.userInfo;
            var $this = $(this);
            var custId = _this.data.meta.id;
            amGloble.photoManager.takePhoto("customer", {
                parentShopId: user.parentShopId,
                customerId: custId
            }, function() {
                console.log("succ");

                $this.html(amGloble.photoManager.createImage("customer", {
                    parentShopId: user.parentShopId,
                    updateTs: amGloble.now().getTime()
                }, custId + ".jpg", "s"));

                if (_this.paras && _this.paras.$li) {
                    var $li = _this.paras.$li;
                    $li.find(".header").html(amGloble.photoManager.createImage("customer", {
                        parentShopId: user.parentShopId,
                        updateTs: amGloble.now().getTime()
                    }, custId + ".jpg", "s"));
                }
            }, function() {
                console.log("fail");
            });
        });

        this.$title = this.$.find("div.am-header>p");
        this.$custInfo = this.$.find("div.custInfo");
        this.$name = this.$custInfo.find("div.name");
        this.$gender = this.$custInfo.find("div.gender");

        this.$addNickname = this.$.find('.addNickname').vclick(function(){
            $.am.changePage(amGloble.page.setNickname, "slideup",{customer:_this.data.meta});
        });

       this.$tags= this.$.find('.tags')
        this.$tags.on("vclick", ".tagName", function(){
            $.am.changePage(amGloble.page.addTag, "slideup",{customer:_this.data.meta});
        })

        this.$addTag= this.$.find('.addtag')
        this.$addTag.find("span").vclick(function(){
            $.am.changePage(amGloble.page.addTag, "slideup",{customer:_this.data.meta});
        });

		// 工单16361 处理
		this.$innerTitle = this.$custInfo.find("div.title")
		this.$customerName = this.$innerTitle.find('.name')
		this.$stf = this.$custInfo.find("div.stf")
		//收藏/取消收藏
        this.$star = this.$custInfo.find("a.favor").vclick(function() {
			if (_this.favorLoading) return;
            if ($(this).hasClass("isFavor")) {
                _this.changeFavorStatus(0);
            } else {
                _this.changeFavorStatus(1);
            }
        });
        this.$level = this.$custInfo.find("div.level").on("vclick", function(){
            _this.showClassDetail()
        });
        this.$sms = this.$custInfo.find("a.sms").vclick(function(){
            $.am.changePage(amGloble.page.customerMessage, "slideleft",{customer:_this.data.meta});
        });
        this.$tel = this.$custInfo.find("a.tel");
        this.$averageExpensePrice = this.$custInfo.find("li.averageExpensePrice");
        this.$lastConsumption = this.$custInfo.find("li.lastConsumption");
        this.$defaultBarber = this.$custInfo.find("li.defaultBarber");

        //消费周期
        this.$changeCycleBtn = this.$custInfo.find("li.changeCycleBtn").vclick(function() {
            amGloble.page.customerChangeCycle.changeToMe("slideup", _this.data.meta);
        });

        this.$fullloading = this.$.find("div.am-page-loading.full");
        this.$loading = this.$.find("div.am-page-loading.part");
        this.$error = this.$.find("div.am-page-error");
        this.$empty = this.$.find("div.am-page-empty");

        var _this=this;
        this.$createReservation = this.$.find('.create-btn').on('vclick', function () {
            console.log(_this.data)
            var customer = _this.data.meta;
            // newRole 1操作员 2管理员 3老板 4第一工位员工 5第二工位员工 6第三工位员工
            var userInfo = amGloble.metadata.userInfo, type = 0;
            if (userInfo.newRole < 4) {
                // 老板
                type = 0;
            } else {
                // 手艺人
                type = 1;
            }
            // 获取预约时间段 trTimes start
			var configs = amGloble.metadata.configs,
				strategy = configs.strategy,
                startTime = amGloble.now().format("yyyy/mm/dd ") + (configs.reservationFrom || "9:00") + ":00",
                endTime = amGloble.now().format("yyyy/mm/dd ") + (configs.reservationTo || "22:00") + ":00";
            if(window.mainTable.isCrossDay(configs.reservationFrom, configs.reservationTo)) {
                endTime = new Date(new Date(endTime).getTime()+24*60*60*1000).format('yyyy/mm/dd HH:MM:ss');
            }
            var nowMM = amGloble.now().getMinutes(),currentDate = '';
            if(strategy == '2'){
                if(nowMM < 15){
                    currentDate = amGloble.now().format('yyyy/mm/dd HH') + ':15';
                }else if(nowMM < 30){
                    currentDate = amGloble.now().format('yyyy/mm/dd HH') + ':30';
                }else if(nowMM < 45){
                    currentDate = amGloble.now().format('yyyy/mm/dd HH') + ':45';
                }else {
                    currentDate = new Date((amGloble.now().getTime() + 3600000)).format('yyyy/mm/dd HH') + ':00';
                }
            }
            if(strategy == '0'){
                if(nowMM < 30){
                    currentDate = amGloble.now().format('yyyy/mm/dd HH') + ':30';
                }else {
                    currentDate = new Date((amGloble.now().getTime() + 3600000)).format('yyyy/mm/dd HH') + ':00';
                }
            }
            if(strategy == '1'){
                currentDate = new Date((amGloble.now().getTime() + 3600000)).format('yyyy/mm/dd HH') + ':00';
            }
            var c = new Date(currentDate).getTime(), // 现在时间 后的整 半点
                a = new Date(startTime).getTime(), // 开门时间
				b = new Date(endTime).getTime(); // 打烊时间
				
            var timeNums = [], names = [];
            var timeInterval = 1800000;
            if(strategy == '1'){
                timeInterval = 1800000 * 2;
            }else if(strategy == '2'){
                timeInterval = 900000;
            }
            a = a < c ? c : a;
            a = a - timeInterval; //current 取的下一个整、半点 循环时不需要再加半个小时
            b = b - timeInterval;//打烊前半个小时停止预约
            var i = 1;
            while (a < b) {
                timeNums.push(i++)
                a += timeInterval;
                names.push(new Date(a).format('yyyy-mm-dd HH:MM'));
            }
            var trTimes = [];
            for (var i = 0, len = timeNums.length; i < len; i++) {
                trTimes.push({
                    time: new Date(names[i].replace(/-/g,'/')),
                    timeNum: timeNums[len - 1 - i],
                    name: names[i]
                })
            }
            console.log('trTimes', trTimes);
            // 获取预约时间段 trTimes  end
            var empFromCustomer = {
                empId: userInfo.userId,
                empName: userInfo.empName,
                nickName: userInfo.nickname,
                shopId: userInfo.shopId
            };
            var reservationTime = new Date(trTimes[0].time).getTime()
            console.log('reservationTime', reservationTime)
            $.am.changePage(amGloble.page.reservationCreate, "slideup", {
                reservationTime: reservationTime,
                customer: customer,
                customerId: customer.id,
                shopId: customer.storeId,
                customerName: customer.name,
                mobile: customer.phone,
                gender: customer.gender,
                timeNum: null,
                trTimes: trTimes,
                type: type, // 老板进来反预约 0   技师进来反预约 1
                empFromCustomer: empFromCustomer
            });
        });
        this.$histList=this.$.find('.hist-ul');
        this.$reservationCount=this.$.find('.reservation-count');
        this.$histTab=this.$.find('.custDetail_tab').find('li').eq(3);
        this.$histTabNum=this.$histTab.find('.num');

        this.$chargePromotion = this.$.find('.chargePromotion').on('vclick','.right',function(){
            _this.$promotionList.show();
            _this.$promotionList.find('.wrapper').addClass('active');
            _this.promotionListScroll.refresh();
            _this.promotionListScroll.scrollTo('top');
        });
        this.$promotionList = this.$.find('.promotionList').on('vclick','.mask',function(){
            _this.$promotionList.hide();
            _this.$promotionList.find('.wrapper').removeClass('active');
        }).on('vclick','.promote_poster_btn',function(){
            var mallData = $(this).parents('.mall-item').data('data');
            amGloble.shareRecharge.share(mallData,function(src,dom){
                shareImageUtils.saveImageByBase64(src.substring(22)).catch(function() {
                    _this.toSharePage({ base64Url: src, pageTitle: mallData.name });
                })
            });
        }).on('vclick','.promote_share_btn',function(){
            var mallData = $(this).parents('.mall-item').data('data');
            amGloble.shareRecharge.share(mallData,function(src,dom){
                amGloble.createShareBase(dom);
            });
        });
        this.$promotionItem = this.$promotionList.find('.mall-item').remove();
        this.promotionListScroll = new $.am.ScrollView({
            $wrap: this.$promotionList.find('.wrap'),
            $inner: this.$promotionList.find('.list'),
            direction: [0, 1]
        });
    },
    getReservationHistory: function (param, cb) { // 获取该顾客历史预约数据
        var _this=this;
        var opt={
            memId:param.id,
            // empId:amGloble.metadata.userInfo.userId
        }
        this.$loading.css("display", "-webkit-box");
        amGloble.api.getReservationHistory.exec(opt, function (ret) {
            _this.$loading.hide();
            if (ret.code == 0) { //成功
                console.log(ret);
                _this.renderReservationHistory(ret.content)
            } else {
                amGloble.msg(ret.message || "哎呀，出错了！");
            }
        });
    },
    renderBenefit: function(id){
        var _this = this;
        amGloble.api.customerQuerConsume.exec({
            memId: id,
        }, function(ret) {
            if (ret.code == 0) { //成功
                if (ret.content) {
                    _this.$.find('.benefit_tab').data('data',ret.content);
                    _this.$.find('.benefit_tab').show();
                    if(ret.content.empId){
                        _this.$.find('.benefit_name .value').text(ret.content.empName);
                        _this.$.find('.benefit_price .value').text('￥' + (ret.content.totalConsume || 0));
                        var timeSetting = amGloble.metadata.configs.myk_benefitTime || 1;
                        var isOverTime = _this.isOverTime(ret.content.updateTime, timeSetting);
                        if(isOverTime){
                            _this.$.find('.benefit_tab').addClass('gray');
                        }else{
                            _this.$.find('.benefit_tab').removeClass('gray');
                        }
                    } else {
                        _this.$.find('.benefit_name .value').text('--');
                        _this.$.find('.benefit_price .value').text('￥' + (ret.content.totalConsume || 0));
                    }
                } else {
                    _this.$.find('.benefit_name .value').text('--');
                    _this.$.find('.benefit_price .value').text('--');
                    _this.$.find('.benefit_tab').hide();
                }
            } else {
                amGloble.msg(ret.message || "哎呀，出错了！");
            }
        })
    },
    isOverTime: function (time, timeSetting) {
        if (new Date().getTime() - time > timeSetting * 24 * 60 * 60 * 1000) {
            return true
        }
        return false
    },
    renderReservationHistory:function(arr){
        this.$histList.empty();
        var userId=amGloble.metadata.userInfo.userId;
        var $lis=[],len=arr.length;
        this.$histTabNum.text(len); // 重新渲染数字
        if(len==0){
            this.$empty.css("display", "-webkit-box");
        }else{
            this.$empty.hide();
        }
        this.$reservationCount.text(len);
        for(var i=0;i<len;i++){
            var item=arr[i],$li='',$statusSpan=$('<span class="status-text"></span>');
                switch(item.status)
                {
                case 0:
                $statusSpan.html('已预约').addClass('booked');
                break;
                case 1:
                $statusSpan.html('已到店').addClass('used');
                break;
                case 2:
                $statusSpan.html('已取消').addClass('cancel');
                break;
                case 3:
                $statusSpan.html('已结算').addClass('used');
                break;
                default:
                $statusSpan.html('');
                }
                var itemsStr = '',obj = JSON.parse(item.itemProp);
                if (obj) {
                    for (var key in obj.items) {
                        itemsStr += obj.items[key].name + '、'
                    }
                }
                itemsStr = itemsStr.substring(0, itemsStr.length - 1); // 去掉最后的、
                // 判断是否已过期
                if(amGloble.now().getTime() > item.reservationTime && ($statusSpan.html()=='已预约' ||$statusSpan.html().length==0 )){
                    $statusSpan.removeClass().addClass('status-text overdue').html('已逾期');
                }
            if (item.reservationSource == 3) {
                // 反预约
                $li = $('<li class="right"><div class="name-div"><span class="name-span">' +
                    (item.shopAdminName || '') +
                    '</span> <span class="text">-创建的预约</span></div><div class="content-div"><div class="left-div"><div class="time-div"><span class="content-title">时间：</span><span class="time-text">' +
                    new Date(item.reservationTime).format('yyyy-mm-dd HH:MM') +
                    '</span></div>'+
                    '<div class="server-div"><span class="content-title">手艺人：</span><span class="name-text">' +
                    (item.empName||item.empNickname||'') +
                    '</span></div>'
                    +'<div class="project-div"><span class="content-title">项目：</span><span class="project-text">' +
                    (item.className || ' ') + (itemsStr || '') +
                    '</span></div><div class="status-div"><span class="content-title">状态：</span>' +
                    '</div></div><div class="photo-div"><div class="emp-pic">' +
                    item.memId +
                    '</div></div></div></li>');
                if (item.shopAdminId) {
                    // 管理者反预约
                    // $li.find('.photo-div').css('display','inline-block');
                    if (userId == item.shopAdminId) {
                        $li.find('.emp-pic').addClass('me').html('我');
                        $li.find('.name-div').find('.name-span').text('我');
                    } else {
                        $li.find('.name-span').text(item.shopAdminName||'');// 兼容手艺人自己创建的反预约
                        var $img = amGloble.photoManager.createImage("manager", {
                            parentShopId: amGloble.metadata.userInfo.parentShopId,
                            updateTs: amGloble.metadata.userInfo.lastphotoupdatetime
                        }, item.shopAdminId + ".jpg", "s");
                        $li.find('.emp-pic').html($img);
                    }
                } else if(!item.shopAdminId){
                    // 手艺人反预约

                    // 如果登录的是手艺人自己
                    if(amGloble.metadata.userInfo.userId==item.empId){
                        $li.find('.emp-pic').addClass('me').html('我');
                        $li.find('.name-div').find('.name-span').text('我');
                    }else{
                        $li.find('.name-span').text(item.empName||item.empNickname||'');// 兼容手艺人自己创建的反预约
                        var $img = amGloble.photoManager.createImage("artisan", {
                            parentShopId: amGloble.metadata.userInfo.parentShopId,
                            updateTs: amGloble.metadata.userInfo.lastphotoupdatetime
                        }, item.empId + ".jpg", "s");
                        $li.find('.emp-pic').html($img);
                    }
                }else {
                    $li.find('.emp-pic').removeClass('me').html('');
                }
                if(userId == item.shopAdminId){
                    $li.find('.name-div').hide();
                }else{
                    $li.find('.name-div').show();
                }
            } else {
                // 预约
                $li = $('<li class="left"><div class="photo-div"><div class="customer-pic">' +
                    '' +
                    '</div></div><div class="content-div"><div class="time-div"><span class="content-title">时间：</span><span class="time-text">' +
                    new Date(item.reservationTime).format('yyyy-mm-dd HH:MM') +
                    '</span></div><div class="server-div"><span class="content-title">手艺人：</span><span class="name-text">' +
                    (item.empName||item.empNickname||'') +
                    '</span></div><div class="remark-div"><span class="content-title">备注：</span><span class="remark-text">' +
                    (item.remark||'') +
                    '</span></div><div class="project-div"><span class="content-title">项目：</span><span class="project-text">' +
                    (item.className || '') + (itemsStr || '') +
                    '</span></div><div class="persons-div"><span class="content-title">人数：</span><span class="person-text">' +
                    (item.number?item.number+'人':'') +
                    '</span></div><div class="status-div"><span class="content-title">状态：</span>' +
                    '</div></div></li>');
                var $img = amGloble.photoManager.createImage("customer", {
                    parentShopId: amGloble.metadata.userInfo.parentShopId,
                    updateTs: amGloble.now().getTime()
                }, item.memId + ".jpg", "s");
                $li.find('.customer-pic').append($img);

                if(!$li.find('.remark-text').text()){
                    $li.find('.remark-div').hide();
                }else{
                    $li.find('.remark-div').show();
                }

                if(!$li.find('.person-text').text()){
                    $li.find('.persons-div').hide();
                }else{
                    $li.find('.persons-div').show();
                }
            }
            $li.find('.status-div').append($statusSpan)
            $lis.push($li);
        }
        this.$histList.append($lis);

        this.refresh();
    
    },
    beforeShow: function(paras) {
		console.log(paras)
        this.classListArr = []
		// 工单16361处理
		var $innerTitleWidth = this.$innerTitle.width()
		var $stfWidth = this.$stf.width()
		var $customerNameWidth = $innerTitleWidth - $stfWidth - 30
		this.$customerName.css('maxWidth', $customerNameWidth)
		
        if(paras && paras.back&& paras.fromCustomer){
            this.$histTab.trigger('vclick');
            return;
        }
        if (paras == "back" || paras == "forceRefresh" || paras == 'formsms') {
            return;
        }
        this.$chargePromotion.hide();
        if(paras == "backSign") {
            var participateList = this.$.find(".un_involved");
            for(var i = 0; i < participateList.length; i++) {
                if($(participateList[i]).attr("data-that") == "selected") {
                    $(participateList[i]).siblings(".has_involved").show();
                    $(participateList[i]).hide();
                }
            }
            this.custPhotoProfile.pageIndex = 0;
            this.custPhotoProfile.$list.empty();
            this.getCustomerPhotoProfile();
            return
        } else {
            this.$.find(".un_involved").attr("data-that","");
        }
        if(!!paras.customerTags){
            this.data.meta.tags = paras.customerTags;
            this.renderTags(paras.customerTags);
            return;
        }
        if('nickname' in paras){
            this.data.meta.nickname = paras.nickname;
            this.$.find('.nickname').html(paras.nickname || '未设置昵称');
            return;
        }
		this.paras = paras;
		this.paras.favorChangeCount = 0;
        this.$title.text("正在加载");
        this.$addNickname.hide();
        this.$fullloading.css("display", "-webkit-box");
        this.scrollview.scrollTo("top");
        this.scrollview.$wrap.hide();
        this.$header.children(".right").hide();
        //this.clear();
        this.$.find('.benefit_name .value').text("--");
        this.$.find('.benefit_price .value').text("--");
        var userInfo = amGloble.metadata.userInfo;
        this.renderBenefit(paras.custId);
        if(userInfo.shopType==0 && (userInfo.newRole==1 || userInfo.newRole==2 || userInfo.newRole==3)){
            // 总部管理员操作员老板
            this.$createReservation.hide();
        }else{
            if(userInfo.userType==0){
                // 非总部管理者
                this.$createReservation.show();
            }else{
                if(userInfo.mgjshowmyk==1){
                    // 手艺人可以被预约
                    this.$createReservation.show();
                }else{
                    // 手艺人不可以被预约
                    this.$createReservation.hide();
                }
            }
        }
        $('.page-customerDetail .categoryDetail').hide();
    },

    afterShow: function(paras) {
        console.log(paras)
        if(paras.back){
            return;// 创建预约后返回
        }

        if (paras == "back" || paras == "backSign" || !!paras.customerTags || (paras && paras.hasOwnProperty('nickname'))) {
            return;
        }
        if(paras == 'formsms'){
            this.data.meta.archivesCount++;
            this.custProfile.pageIndex = 0;
            this.custProfile.$list.empty();
            this.tab.$inner.find("li:eq(0)").trigger("vclick");
            return
        }
        this.paras = paras;
        if (paras == "forceRefresh") {
            this.custPhotoProfile.pageIndex = 0;
            this.custPhotoProfile.$list.empty();
            this.getCustomerPhotoProfile();
            return;
        }

        var archiveList = amGloble.metadata.configs.archivesCategory;
        this.archiveCategoryList = JSON.parse(archiveList) || [];
        this.archiveCategoryListMap = {};
        for(var i = 0; i < this.archiveCategoryList.length; i++) {
            var item = this.archiveCategoryList[i];
            this.archiveCategoryListMap[item.id] = item;
        }
        this.archiveCategoryListMap[-2] = {name: '短信问候', id: -2}

        // newRole 1操作员 2管理员 3老板 4第一工位员工 5第二工位员工 6第三工位员工
        var isUser = amGloble.metadata.userInfo.newRole > 3;
        var privateSendRed = JSON.parse(amGloble.metadata.configs.privateSendRed || "{}");
        if (privateSendRed &&
            ((privateSendRed.enableCashierAndAdmin == true && !isUser) || (isUser && privateSendRed.enableEmployeeSend == true) ) && 
            [3,5,6].indexOf(Number(amGloble.metadata.userInfo.mgjVersion) != -1)
            ) {
            this.$.find("#sendRedpackage").show();
        } else {
            this.$.find('#sendRedpackage').hide();
        } 
        this.getData(paras);
        this.getArchivesCount(paras);
        this.getPromotionRechargeMallItem();
    },
    getArchivesCount: function(paras) {
        var memberid = paras.custId;
        var that = this;
        amGloble.api.getMemArchivesCount.exec({parentShopId: amGloble.metadata.userInfo.parentShopId, memId: memberid}, function(res){
            if(res.code == 0 && res.content) {
                that.memArchivesCount = res.content;
                var all = 0;
                Object.values(res.content).forEach(function(num){
                    all = all + num;
                })
                that.memArchivesCount.all = all;
            } else {
                that.memArchivesCount = {};
            }
        })
    },
    renderActive: function(data) {
        console.log("活动渲染数据",data);
        var $html = "";
        this.$.find(".select_dynamic_box .content_boxs").empty();
        for(var i = 0; i < data.length; i++) {
            $html = $(
                '<div class="content_box">' +
                    '<div class="list_title">' + data[i].activityName + '</div>' +
                    '<div class="submit_time">' +
                        '<span>作品提交时间：</span>' +
                        '<span class="time_txt">' + (new Date(data[i].competitionTimeStart).format("yyyy.mm.dd") + '-' + new Date(data[i].competitionTimeEnd).format("yyyy.mm.dd")) + '</span>' +
                    '</div>' +
                    '<div class="submit_time vote_time">' +
                        '<span>投票时间：</span>' +
                        '<span class="time_txt">' + (new Date(data[i].voteTimeStart).format("yyyy.mm.dd") + '-' + new Date(data[i].voteTimeEnd).format("yyyy.mm.dd")) + '</span>' +
                    '</div>' +
                    (data[i].partake == 1?
                    '<div class="dynamic_detail">' +
                        '<span class="trophy iconfont icon-trophy"></span>' +
                        '<span>详情</span>' +
                    '</div>':
                    '<div class="dynamic_detail1">' +
                        '<span>已参赛</span>' +
                    '</div>') +
                '</div>'
            )
            $html.data("data",data[i]);
            this.$.find(".select_dynamic_box .content_boxs").append($html);
        }
        this.activityEle.refresh();
    },
    gotoMinipro: function (that) {
        amGloble.loading.show("正在生成图片");
        var $li = $(that).parents('li');
        var _item = $li.data('item');
        console.log("分享数据",_item);
        var user = amGloble.metadata.userInfo;
        // 作品图片
        if(_item.photo) {
            var imgUrl = _item.photo.split(",");
            var $img = amGloble.photoManager.getPhotoUrl("show", {
                catigoryId: _item.type,
                parentShopId: _item.parentShopId,
                authorId: _item.empId
            }, imgUrl[0], "s");
        }
        if($(that).parents("li").find(".userHeader img").attr("data-load")) {
            // 作品作者头像
            var $head;
            if (_item.empType != 1) {
                $head = amGloble.photoManager.getPhotoUrl("manager", {
                    parentShopId: amGloble.metadata.userInfo.parentShopId
                }, _item.empId + ".jpg", "s");
            } else {
                $head = amGloble.photoManager.getPhotoUrl("artisan", {
                    parentShopId: amGloble.metadata.userInfo.parentShopId
                }, _item.empId + ".jpg", "s");
            }

            $('.shareVotePhoto .avatar_box .avatar_img').attr("src", $head);
        } else {
            $('.shareVotePhoto .avatar_box .avatar_img').attr("src", "css/img/MYK/head_male.png");
        }
        $('.shareVotePhoto .productImg img').attr("src", $img);
        // $('.shareVotePhoto .avatar_box .avatar_img').attr("src", $head);
        var shopName = user.osName.trim() || user.shopName
        $('.shareVotePhoto .user_box .user_name').text(shopName + "-" + _item.empName);
        $('.shareVotePhoto .shareVoteTitle').text(amGloble.cutString(_item.title,80));
        if(_item.votActivityId && _item.votActivityId != "null") {
            var qrImgSrc = config.miniProUrl + "/xcx/qrCode/?tenantId=" + window.config.parentShopId + "&page=pages/mine/index&scene=61@" + _item.votActivityId + "_" + _item.empId + "_2";
        } else {
            amGloble.loading.hide();
            amGloble.msg("网络请求失败，请刷新重新！！");
            return
        }
        console.log("二维码路径",qrImgSrc);
        $.am.debug.log("二维码路径"+qrImgSrc);
        $('.shareVotePhoto .qrImg').attr("src", qrImgSrc);
        $('.shareVotePhoto').show();
        var shareDom = document.getElementById('shareVotePhoto');
        var canvas=document.createElement('canvas');
        var ctx = canvas.getContext('2d');
        if (window.device.platform == "iOS") {
            canvas.width = shareDom.clientWidth * 2;
            canvas.height = shareDom.clientHeight * 2;
            ctx.scale(2, 2);
        } else {
          var scaleSize = 2.75;
          canvas.width = shareDom.clientWidth * scaleSize;
          canvas.height = shareDom.clientHeight * scaleSize;
          ctx.scale(scaleSize, scaleSize);
        }
        
        html2canvas(shareDom, {
            canvas:canvas,
            useCORS:true,
            onrendered: function (canvas) {
                // document.body.appendChild(canvas)
                var context = canvas.getContext('2d');
                // 【重要】关闭抗锯齿
                context.mozImageSmoothingEnabled = false;
                context.webkitImageSmoothingEnabled = false;
                context.msImageSmoothingEnabled = false;
                context.imageSmoothingEnabled = false;
                var clientHeight=canvas.height;
                var clientWith=canvas.width;
                if( window.device.platform == "iOS"){
                    clientHeight=clientHeight*2;
                    clientWith=clientWith*2;
                }
                var img = Canvas2Image.convertToImage(canvas, clientWith,clientHeight);
                console.log(img.src)
                dataUrl = img.src.substring(22);
                $('.shareVotePhoto').hide();
                amGloble.loading.hide();
                $.am.debug.log('shareImage before');
                amGloble.shareImage({
                    title: '',
                    imageBase64: dataUrl,
                    success: function() {
                        $.am.debug.log('shareImage success');
                    },
                    fail: function() {
                        $.am.debug.log('shareImage fail');
                    }
                })
            }
        });
    },
    getData: function(opt) {
        if (!opt) {
            opt = {};
        }
        if (!opt.custId) {
            opt.custId = this.data.meta.id;
            opt.shopid = this.data.meta.storeId;
        }
        var emp = amGloble.metadata.userInfo;
        var _this = this;
        this.$fullloading.css("display", "-webkit-box");
        amGloble.api.customerQuerMemInfo.exec({
            shopid: opt.shopid,
            memId: opt.custId,
            userType: emp.userType,
            empid: emp.userId,
        }, function(ret) {
            _this.$fullloading.hide();
            if (ret.code == 0) {
                _this.setRecentViewCustomer(ret.content.meta);
                _this.data = ret.content;
                _this.scrollview.$wrap.show();
                _this.render();

                //将客户档案页码消0
                _this.custProfile.pageIndex = 0;
                _this.custProfile.$list.empty();
                //将美丽档案页码消0
                _this.custPhotoProfile.pageIndex = 0;
                _this.custPhotoProfile.$list.empty();
                //将消费记录页码消0
                _this.serviceHistory.pageIndex = 0;
                _this.serviceHistory.$list.empty();
                _this.luckyMoneyList.pageIndex = 0;
                _this.luckyMoneyList.$list.empty();
                _this.mallOrderList.pageIndex = 0;
                _this.mallOrderList.$list.empty();
                //会员卡设为未渲染
                _this.custCards.rendered = false;
                //会员卡设为未渲染
                _this.comboCards.rendered = false;
                //将客户档案页码消0
                _this.custClock.pageIndex = 0;
                _this.custClock.$list.empty();

                var _k = 0;
                _this.tab.$inner.find('li').each(function(k, v) {
                    if ($(v).is(':visible')) {
                        _k = k;
                        return false;
                    }
                });
                _this.tab.$inner.find("li:eq(" + (opt.idx || _k) + ")").trigger("vclick");
                //_this.getCustomerProfile(opt.custId);
            } else {
                var description = ret.code == 30000 ? '该顾客已被删除，请查看其他顾客资料' : '客户资料读取失败,请检查网络';
                atMobile.nativeUIWidget.confirm({
                    caption: "读取失败",
                    description: description,
                    okCaption: "重试",
                    cancelCaption: "返回"
                }, function() {
                    _this.getData(opt);
                }, function() {
                    $.am.page.back();
                });
            }
        });
    },
    setRecentViewCustomer: function(data) {
        var recentViewCustomer = JSON.parse(localStorage.getItem("recentViewCustomer"));
        var item = {
            id: data.id,
            // shopid: data.storeId,
            // name: data.name,
            // sex: data.gender,
            // mobile: data.phone,
            // empid: data.empids,
            // lastphotoupdatetime: data.lastphotoupdatetime,
            recentViewTime: new Date().getTime()
        };

        if (recentViewCustomer && recentViewCustomer.shopid == amGloble.metadata.userInfo.shopId) {
            for(var i=0; i<recentViewCustomer.data.length; i++){
                var customer = recentViewCustomer.data[i];
                if (customer.id == data.id) {
                    recentViewCustomer.data.splice(i, 1);
                    break;
                }
            }
            recentViewCustomer.data.unshift(item);
            recentViewCustomer.data = recentViewCustomer.data.slice(0, 6);
        } else {
            recentViewCustomer = {shopid: amGloble.metadata.userInfo.shopId, data: [item]}
        }
        localStorage.setItem("recentViewCustomer", JSON.stringify(recentViewCustomer))
    },
    toSharePage: function(option){
        window.RouterUtils.push({
            name: 'promotionbenefitShare',
            params: {
                base64Url: option.base64Url,
                pageTitle: option.pageTitle,
                bodyStyle: 'padding: 0;'
            }
        })
    },
    getPromotionRechargeMallItem: function(){
        var _this = this;
        this.OperateActivityGetProducts(function(listData){
            var activityMallItemIdList = [];
            if(listData.length){
                _this.OperateActivityQeryOperateActivity(function(activityList){
                    var activityData = activityList ? activityList[0] : null;
                    if(activityData){
                        var activityEndTime = activityData.activityEndTime;
                        var mallItemIds = activityData.mallItemIds;
                        var currentTime = new Date().getTime();
                        if (activityEndTime > currentTime) {
                            var mallItemIdsArray = mallItemIds.split(',');
                            for(var i=0;i<mallItemIdsArray.length;i++){
                                activityMallItemIdList.push(Number(mallItemIdsArray[i]));
                            }
                        }
                    }
                    var buyOperateActivityShopIdList = [];
                    for(var i=0;i<listData.length;i++){
                        buyOperateActivityShopIdList.push(Number(listData[i].shopId));
                    }
                    _this.queryMallItem(activityMallItemIdList,buyOperateActivityShopIdList);
                });
            }else {
                _this.queryMallItem([],[])
            }
        })
    },
    OperateActivityGetProducts: function(callback){
        amGloble.api.getProducts.exec({
            parentShopId: amGloble.metadata.userInfo.parentShopId
        }, function (ret) {
            if(ret.code == 0 && ret.content && ret.content.length){
                callback(ret.content);
            }else {
                callback([]);
            }
        });
    },
    OperateActivityQeryOperateActivity: function(callback){
        amGloble.api.queryOperateActivity.exec({
            parentShopId: amGloble.metadata.userInfo.parentShopId
        }, function (ret) {
            if(ret.code == 0 && ret.content && ret.content.length){
                callback(ret.content);
            }else {
                callback([]);
            }
        });
    },
    queryMallItem: function(activityMallItemIdList,buyOperateActivityShopIdList){
        var _this = this;
        amGloble.api.queryMallItem.exec({
            pageNumber: 1,
            pageSize: 9999,
            includeZeroCampaignMoney: false,
            categories: [1,2],
            newFlag: 1,
            goodsType: 2,
        }, function (ret) {
            var result = [];
            if(ret.code == 0 && ret.content && ret.content.length){
                result = ret.content;
            }
            var promotionRechargeMallItem = _this.convertMallItem(result,activityMallItemIdList,buyOperateActivityShopIdList);
            if(promotionRechargeMallItem && promotionRechargeMallItem.length){
                _this.$chargePromotion.show();
                _this.renderChargePromotionList(promotionRechargeMallItem);
            }else {
                _this.$chargePromotion.hide();
            }
        });
    },
    convertMallItem: function(mallItem,activityMallItemIdList,buyOperateActivityShopIdList) {
        var userInfo = amGloble.metadata.userInfo;
        var _mallItem = [];
        for(var i=0;i<mallItem.length;i++){
            if(mallItem[i].goodsType == 2){
                _mallItem.push(mallItem[i]);
            }
        }
        mallItem = _mallItem;
        for (var i = 0; i < mallItem.length; i++) {
            if (activityMallItemIdList.indexOf(mallItem[i].id) != -1) {
                var shopids = mallItem[i].shopids.split(',');
                if(!shopids && buyOperateActivityShopIdList.length){
                    mallItem[i].disabled = true;
                }else {
                    var isExsit = false;
                    for(var j=0;j<shopids.length;j++){
                        if(buyOperateActivityShopIdList.indexOf(Number(shopids[i])) != -1){
                            isExsit = true;
                            break;
                        }
                    }
                    if(!isExsit){
                        mallItem[i].disabled = true;
                    }else if(userInfo.shopType != 0 && buyOperateActivityShopIdList.indexOf(userInfo.shopId) == -1){
                        mallItem[i].disabled = true;
                    }
                }
            }
            if (mallItem[i].images.indexOf("minipro") != "-1") {
                mallItem[i].images = config.filesMgr + mallItem[i].images;
            } else {
                mallItem[i].images = amGloble.photoManager.getPhotoUrl(
                "mall",
                {
                    //"goods"改为"mall"
                    parentShopId: amGloble.metadata.userInfo.parentShopId
                },
                mallItem[i].images.split(",")[0],
                "s"
                );
            }
        }
        var mallItemData = [];
        for(var i=0;i<mallItem.length;i++){
            var item = mallItem[i];
            if(item.campaignmoney != undefined && item.campaignmoney != 0){
                mallItemData.push(item);
            }
        }
        return mallItemData;
    },
    renderChargePromotionList: function(mallItem){
        this.$promotionList.find('.list').empty();
        for(var i=0;i<mallItem.length;i++){
            var $promotionItem = this.$promotionItem.clone(true,true);
            $promotionItem.find('.mall-item__image img').attr('src',mallItem[i].images);
            $promotionItem.find('.tith2').text(mallItem[i].name);
            $promotionItem.find('.pricep').text('充值金额：¥'+mallItem[i].price+'赠送金额：¥'+(mallItem[i].presentFee || 0));
            $promotionItem.find('.promotionbenefit b').text(mallItem[i].campaignmoney);
            if(window.device.platform != "iOS"){
                $promotionItem.find('.promote_poster_btn').remove();
            }
            this.$promotionList.find('.list').append($promotionItem.data('data',mallItem[i]));
        }
    },
    gender: {
        "M": "先生",
        "F": "女士"
    },
    clear: function() {
        this.$title.text("正在加载");
        this.$name.text("");
        this.$pic.empty();
        this.$star.removeClass("isFavor");
        this.$level.text("");
        this.$sms.hide();
        this.$tel.hide();
        this.$averageExpensePrice.find(".value").text("--");
        this.$lastConsumption.find(".value").text("--");
        this.$defaultBarber.find(".value").text("--");
        this.$changeCycleBtn.find(".value").text("--");

        var $num = this.tab.$inner.find("div.num");
        $num.text(0);

        // this.custProfile.$title.text("共有" + 0 + "条档案");
        this.custPhotoProfile.$title.text("共有" + 0 + "条作品");
        _this.luckyMoneyList.$title.html("共有" + 0 + "个红包<br/>未拆开：" + 0 + '，未使用：' + 0 + '，已使用：' + 0);
        this.custClock.$title.text("共有" + 0 + "个客户闹钟");
        this.$blocks.hide();
    },
    render: function() {
        this.$header.children(".right").show();
        //隐藏会员卡和套餐卡
        if (amGloble.metadata.permissions.allowcard) {
            this.tab.$inner.find("li").eq(4).show();
            this.tab.$inner.find("li").eq(5).show();
        } else {
            this.tab.$inner.find("li").eq(4).hide();
            this.tab.$inner.find("li").eq(5).hide();
        }
        //员工才显示闹钟
        if (amGloble.metadata.userInfo.userType) {
            this.tab.$inner.find("li").eq(8).show();
        } else {
            this.tab.$inner.find("li").eq(8).hide();
        }
        this.tab.refresh();
        var user = this.data.meta;
        var emp = amGloble.metadata.userInfo;
        var cards = this.data.cards;
        var packages = this.data.packages;
        var _this = this;

        this.$title.text(user.name + (this.gender[user.gender] || ""));
        this.$name.text(user.name);
        this.$pic.empty().html(amGloble.photoManager.createImage("customer", {
            parentShopId: emp.parentShopId,
            updateTs: user.lastphotoupdatetime
        }, user.id + ".jpg", "s"));

        if(user.nickname){
            this.$addNickname.show().find('.nickname').html(user.nickname);
        }else {
            this.$addNickname.show().find('.nickname').html('未设置昵称').show();
        }

        if (user.gender == "M") {
            this.$pic.removeClass("famale");
            this.$gender.addClass("male");
        } else if (user.gender == "F") {
            this.$pic.addClass("famale");
            this.$gender.addClass("female");
        } else {
            this.$pic.addClass("famale");
            this.$gender.removeClass("male female");
        }
        //优质客
        if(this.paras.isHighQuality == 1){
            this.$pic.addClass("good");
        }else{
            this.$pic.removeClass("good");
        }

        // 是否绑定企业微信外部联系人
        if (user.externalUserid && amGloble.metadata.configs.mgjWeCom == 1) {
            this.$pic.addClass('bind_work_wechat')
        } else {
            this.$pic.removeClass('bind_work_wechat')
        }

        /* if(this.data.privilege){
            this.$tqk.show();
        }else {
            this.$tqk.hide();
        } */

        /* if(this.data.meta.openId){
            this.$myk.show();
        }else {
            this.$myk.hide();
        } */

        if (user.isFavor) {
            this.$star.addClass("isFavor");
        } else {
            this.$star.removeClass("isFavor");
        }
        this.$level.empty()
        var classSpan = '<span class="identification"></span>'
        for (var index = 0; index < user.customersClasss.length; index++) {
            var tag = user.customersClasss[index]
            var $span = $(classSpan).clone()
            if(tag.className){
                if(index < 4 || user.customersClasss.length == (index + 1)){
                    $span.text(tag.tag?tag.tag:tag.className.substring(0, 1)).css("background",tag.color || predefineColors())
                    this.$level.append($span)
                }else{
                    $span.text("···").css({"background":"#EBEBEB","color":"#999"})
                    this.$level.append($span)
                    break
                }
            }
        }
        // this.$level.text(user.className || "--");
        this.$changeCycleBtn.find(".value").text(user.mgjconsumeperiod || "--");
        this.$averageExpensePrice.find(".value").text(user.req == null ? "--" : amGloble.cashierRound(user.req, 1));
        this.$lastConsumption.find(".value").text(user.lastconsumetime ? new Date(user.lastconsumetime).format("yyyy-mm-dd") : "--");
        this.$defaultBarber.find(".value").text(user.mgjlastserver || "--");

        this.renderTags(user.tags);

        if (user.phone && user.phone.length){
            if(amGloble.metadata.userInfo.operatestr && amGloble.metadata.userInfo.operatestr.indexOf('MGJP')>0){
                this.$tel.hide();
            }else {
                this.$tel.attr("href", "tel:" + user.phone).show();
            }
        }else {
            this.$tel.hide();
        }

        // if (user.phone && user.phone.length > 4 && amGloble.allowViewTel) {
        if (user.phone && user.phone.length && amGloble.metadata.permissions.allowphone) {
            // this.$sms.show();
            this.$tel.attr("href", "tel:" + user.phone).show();
        } else {
            // this.$sms.hide();
            this.$tel.hide();
        }

        var $num = this.tab.$inner.find("div.num");
        $num.eq(0).text(user.archivesCount || "0");
        $num.eq(1).text(user.inventionCount || "0");
        $num.eq(2).text(user.serviceCount || "0");
        if(cards.length && amGloble.metadata.permissions.allowcard){
            $num.eq(4).text(cards.length);
            this.tab.$inner.find('li').eq(4).show();
        }else {
            this.tab.$inner.find('li').eq(4).hide();
        }
        if(packages.length && amGloble.metadata.permissions.allowcard){
            $num.eq(5).text(packages.length);
            this.tab.$inner.find('li').eq(5).show();
        }else {
            this.tab.$inner.find('li').eq(5).hide();
        }
        $num.eq(6).text(user.redPacketCount || "0");
        if(user.mallOrderCount){
            $num.eq(7).text(user.mallOrderCount);
            this.tab.$inner.find('li').eq(7).show();
        }else {
            this.tab.$inner.find('li').eq(7).hide();
        }
        $num.eq(8).text(user.clockCount || "0");
        $num.eq(3).text(user.reservationCount || "0");

        this.custProfile.$title.find('.num').text(user.archivesCount);
        this.custPhotoProfile.$title.text("共有" + user.inventionCount + "条作品");
        this.luckyMoneyList.$title.html("共有" + user.redPacketCount + "个红包<br/>未拆开：" + 0 + '，未使用：' + 0 + '，已使用：' + 0);
        this.custClock.$title.text("共有" + user.clockCount + "个客户闹钟");

        _this.renderCards(cards);
        _this.renderComboCards(packages);
    },
    renderCards: function(cards) {
        var _this = this;
        _this.custCards.rendered = true;
        _this.custCards.$container.empty();
        if(cards.length){
            var cardsObj = {};
            for(var i=0;i<cards.length;i++){
                if(!cardsObj[cards[i].storeId]){
                    cardsObj[cards[i].storeId] = [];
                }
                cardsObj[cards[i].storeId].push(cards[i]);
            }
            for(var key in cardsObj){
                var $wrapper = this.custCards.$wrapper.clone(true,true);
                $wrapper.find('.shopname').text(this.getShopName(key));
                var $list = this.custCards.$list.clone(true,true);
                for(var i=0;i<cardsObj[key].length;i++){
                    var item = cardsObj[key][i];
                    var $clone = _this.custCards.$clone.clone(true, true);
                    $clone.find(".mid .line1").text(item.cardName);
                    $clone.find(".mid .line2").text(item.cardNo);
                    // if (item.cardType == 2) {
                    //     $clone.find(".right .line1").hide();
                    //     $clone.find(".right .line2").hide();
                    // } else {
                    //     $clone.find(".right .line1").text("金额：￥" + amGloble.cashierRound(item.balance));
                    //     $clone.find(".right .line2").text("赠送金：￥" + amGloble.cashierRound(item.bonusBalance));
                    // }


                    if (item.timeFlag == 0) {
                        //timeFlag,0--普通储值卡  1--计次卡  2--套餐卡  3--年卡，套餐卡卡和年卡如果balance和bonusBalance都等于0，就不显示
                        //普通储值卡
                        if (item.cardType == 2) {
                            $clone.find(".right .line1").text("折扣卡");
                        } else {
                            $clone.find(".right .line1").text("余额:￥" + amGloble.cashierRound(item.balance));
                        }
                    } else if (item.timeFlag == 1) {
                        $clone.find(".right .line1").text("余:" + item.cardTimes + "次");
                    } else if ((item.timeFlag == 2 || item.timeFlag == 3)) {
                        $clone.find(".right .line1").text("余额:￥" + amGloble.cashierRound(item.balance));
                    }

                    if (item.bonusBalance) {
                        $clone.find(".right .line2").text("赠送金:￥" + amGloble.cashierRound(item.bonusBalance));
                    } else {
                        $clone.find(".right .line2").hide();
                    }
                    $list.append($clone);
                }
                $wrapper.append($list);
                this.custCards.$container.append($wrapper);
            }

        }

        if (!cards.length) {
            this.$empty.css("display", "-webkit-box");
        } else {
            this.$empty.hide();
        }
        this.refresh();
    },
    renderComboCards: function(comboCards) {
        var _this = this;
        _this.comboCards.rendered = true;
        _this.comboCards.$container.empty();
        if(comboCards.length){
            var comboCardsObj = {};
            for(var i=0;i<comboCards.length;i++){
                if(!comboCardsObj[comboCards[i].shopId]){
                    comboCardsObj[comboCards[i].shopId] = [];
                }
                comboCardsObj[comboCards[i].shopId].push(comboCards[i]);
            }
            for(var key in comboCardsObj){
                var $wrapper = this.comboCards.$wrapper.clone(true,true);
                $wrapper.find('.shopname').text(this.getShopName(key));
                var $list = this.comboCards.$list.clone(true,true);
                for(var i=0;i<comboCardsObj[key].length;i++){
                    var item = comboCardsObj[key][i];
                    if (item.totalTimes != 0 && item.times == 0) {
                        return true;
                    }
                    var $clone = _this.comboCards.$clone.clone(true, true);
                    $clone.find(".line1").text(item.serviceItemName);
                    $clone.find(".line2").text(item.closingDate ? "到期时间: " + new Date(item.closingDate).format("yyyy-mm-dd") : "无期限");
                    if ((item.totalTimes == 0 && item.times == 0) || item.totalTimes == -99) {
                        $clone.find(".right").text("不限次数");
                    } else {
                        $clone.find(".right").html("剩余<strong>" + item.times + "次</strong> / " + "总共" + item.totalTimes + "次");
                    }
                    $list.append($clone);
                }
                $wrapper.append($list);
                this.comboCards.$container.append($wrapper);
            }
        }

        if (!comboCards.length) {
            this.$empty.css("display", "-webkit-box");
        } else {
            this.$empty.hide();
        }
        this.refresh();
    },
    getShopName: function(id) {
        for (var i = 0; i < amGloble.metadata.allShops.length; i++) {
            if (amGloble.metadata.allShops[i].shopId == id) {
                var item = amGloble.metadata.allShops[i];
                return (item.osName==' ' || item.osName=='' || item.osName==null)?((item.shopName==' ' || item.shopName=='' || item.shopName==null)?'门店名称未设定':item.shopName):item.osName;
            }
        }
        return "--";
    },
    renderClassDetail: function(list){
        if(list && list.length){
            var ids = this.data.meta.customersClasss.map(function(t){
                return t.memberClassId
            })
            var dimensionIds = this.data.meta.customersClasss.map(function(item){
                return item.dimensionId
            })
            this.$classDetail.find('.wrapper .inner').empty()
            var $cate = $('<div class="cateBox"><p class="title">顾客类别</p><div class="classBox"></div></div>')
            var $class = $('<div class="classTitle"><span class="identification">优</span><span class="className">优秀会员</span><div class="ruleBox"></div></div>')
            var $rule = $('<span class="rule">最后消费时间≥60天</span>')
            for (var index = 0; index < list.length; index++) {
                if(dimensionIds.indexOf(list[index].id) == -1) continue
                var $cateHtml = $cate.clone()
                $cateHtml.find(".title").text(list[index].name)
                for (var i = 0; i < list[index].memberClasss.length; i++) {
                    var classItem = list[index].memberClasss[i];
                    var $classHtml = $class.clone()
                    $classHtml.find(".className").text(classItem.className)
                    $classHtml.find(".identification").text(classItem.className.substring(0, 1)).css("background",classItem.color || predefineColors())
                    for (var j = 0; j < classItem.rules.length; j++) {
                        var rule = classItem.rules[j];
                        var $ruleHtml = $rule.clone()
                        $ruleHtml.text(rule)
                        if(ids.indexOf(classItem.id) >= 0){
                            $ruleHtml.addClass("selected")
                        }
                        $classHtml.find(".ruleBox").append($ruleHtml)
                    }
                    $cateHtml.find(".classBox").append($classHtml)
                }
                this.$classDetail.find('.wrapper .inner').append($cateHtml)
            }

            this.$classDetail.show();
            var _this = this
            setTimeout(function(){
                _this.$classDetail.find('.wrapper').addClass('active');
            },10)
            this.classDetailScroll.refresh();
            this.classDetailScroll.scrollTo('top');
        }else{
            amGloble.msg("无会员分类信息！");
        }
    },
    showClassDetail: function(){
        var _this = this
        if(_this.classListArr && _this.classListArr.length){
            _this.renderClassDetail(_this.classListArr)
            return
        }
        var userInfo = this.data.meta
        var params = {
            parentShopId: userInfo.parentshopid,
            shopId: userInfo.parentshopid
        }
        this.$loading.css("display", "-webkit-box");
        amGloble.api.getMemClassNew.exec(params, function(ret) {
            _this.$loading.hide();
            if (ret.code == 0) {
                _this.classListArr = ret.content.map(function(item) {
                    if(!item.memberClasss) item.memberClasss = []
                    if (item.type == '1') {
                        item.memberClasss.forEach(function(t) {
                            let obj = {
                                lctflag: item.lctflag,
                                cfflag: item.cfflag,
                                cfMonth: item.cfMonth,
                                ctFlag: item.ctFlag,
                                ctMonth: item.ctMonth,
                                caFlag: item.caFlag,
                                caMonth: item.caMonth,
                                ...t
                            }
                            t.rules = getRules(obj)
                        })
                    } else if (item.id == '-1') {
                        item.memberClasss.forEach(function(t) {
                            t.rules =  ['客单价≥'+t.clientFee]
                        })
                    } else {
                        item.memberClasss.forEach(function(t) {
                            t.rules = [t.remark]
                        })
                    }
                    return item
                })
                _this.renderClassDetail(_this.classListArr)
            } else {
                amGloble.msg("会员分类信息获取失败！");
            }
        });
    },
    //获取客户档案
    getCustomerProfile: function(type, refresh) {
        var _this = this;
        var user = this.data.meta;
        var custId = user.id;
        if(this.lastCategroyType != type || refresh) {
            this.lastCategroyType = type;
            this.custProfile.pageIndex = 0;
        }
        if(!type) {
            $('.custDetail_doc .title .title_t .name').text('全部分类');
            this.lastCategroyType = '';
        }
        if (this.custProfile.pageIndex == 0) {
            this.$loading.css("display", "-webkit-box");
        } else {
            this.$loading.hide();
        }
        this.$empty.hide();
        var params = {
            memId: custId,
            categoryId: type,
            pageNumber: this.custProfile.pageIndex,
            pageSize: 10
        }
        if(type) {
            params.categoryId = type;
        }
        amGloble.api.customerArchivesList.exec(params, function(ret) {
            _this.$loading.hide();
            _this.closeBottomLoading();
            if (ret.code == 0) {
                _this.custProfile.pageIndex++;
                _this.renderCustomerProfile(ret.content);
                if(!type) {
                    _this.tab.$inner.find("div.num").eq(0).text(ret.totalCount);
                }

                _this.custProfile.$num.text(ret.totalCount);
                // _this.custProfile.$title.text("共有" + ret.totalCount + "条档案");

                if (!ret.content || !ret.content.length) {
                    _this.scrollview.pauseTouchBottom = true;
                } else {
                    _this.scrollview.pauseTouchBottom = false;
                }
            } else {
                amGloble.msg("客户档案读取失败！");
            }
        });
    },
    renderCustomerProfile: function(list) {
        if (this.custProfile.pageIndex <= 1) {
            this.custProfile.$list.empty();
        }
        this.appendCustomerProfile(list);
    },
    showArchives(isEdit, id) {
        var list = this.archiveCategoryList;
        var $archive = this.$categoryDetail.find('.archives');
        $archive.html('');
        var iconDom = '<div class="check"><i class="iconfont icon-gou"></i></div>';
        if(!isEdit) {
            $archive.append($(
                '<div class="item am-clickable '+(id=='0'?'active':'')+'">'+
                    '<div class="icon"></div>' +
                    '<div class="name">全部档案</div>'+
                    '<div class="num">'+(this.memArchivesCount['all'] || 0)+'</div>'+
                    iconDom +
                '</div>'
            ));
            $archive.append($(
                '<div class="item am-clickable '+(id=='-2'?'active':'')+'">'+
                    '<div class="icon"></div>' +
                    '<div class="name">未分类</div>'+
                    '<div class="num">'+(this.memArchivesCount[-2] || 0)+'</div>'+
                    iconDom +
                '</div>'
            ).data({id: -2}));
            $archive.append($(
                '<div class="item am-clickable '+(id=='-1'?'active':'')+'">'+
                    '<div class="icon"><span><i class="iconfont icon-duanxinwenhou"></i></span></div>' +
                    '<div class="name">短信问候</div>'+
                    '<div class="num">'+(this.memArchivesCount[-1] || 0)+'</div>'+
                    iconDom +
                '</div>'
            ).data({id: -1}));
        }
        for(var i = 0; i < list.length; i++) {
            var item = list[i];
            var content = '';
            content = '<span style="background-color:'+ item.color +'">'+ item.name.substring(0, 1) +'</span>';
            var $dom = $(
                '<div class="item am-clickable">'+
                    '<div class="icon">'+ content +'</div>' +
                    '<div class="name">'+ item.name +'</div>'+
                    '<div class="num">'+(this.memArchivesCount[item.id] || 0)+'</div>'+
                    iconDom +
                '</div>'
            );
            if((id == item.id && isEdit != undefined)) {
                $dom.addClass('active');
            }
            $dom.data(item);
            $archive.append($dom);
        }
        if(isEdit) {
            this.$categoryDetail.show();
        } else {
            this.$categoryDetail.addClass('query').show();
        }
        this.categoryListScroll.scrollTo('top');
        this.categoryListScroll.refresh();
    },
    appendCustomerProfile: function(list) {
        var ts = new Date();
        var today = ts.format("yyyy-mm-dd");
        ts.setDate(ts.getDate() - 1);
        var yestoday = ts.format("yyyy-mm-dd");
        for (var i = 0; i < list.length; i++) {
            var item = list[i];
            var del = '<div class="edit am-clickable">删除</div>';
            if(amGloble.metadata.configs.noDelFile == "true" && amGloble.metadata.userInfo.userType == 1){//禁止员工删除顾客资料
                del = "";
            }
            var iconType = true;
            var categoryData = this.archiveCategoryListMap[item.categoryId]
            var categoryName = categoryData ? categoryData.name : '';
            var backgdColor = categoryData ? 'style="background-color:'+categoryData.color+'"' : '';

            var iconHtmlTemplate = '';
            if(item.categoryId && item.categoryId == -1) {
                iconHtmlTemplate = '<div class="category_text"><i class="iconfont icon-duanxinwenhou"></i></div>';
            } else if(!item.categoryId || item.categoryId == -2) {
                iconHtmlTemplate = '<div class="category_text weifenlei am-clickable"><i class="iconfont icon-weifenlei"></i></div>';
            } else {
                iconHtmlTemplate = '<div class="category_text am-clickable" '+backgdColor+'>'+(categoryName.substring(0, 1))+'</div>';
            }

            var $html = $('<dd class="category-item" dataid="' + item.id + '" data-categoryid="'+ item.categoryId +'">'+
                    '<div class="category">'+
                        iconHtmlTemplate +
                    '</div>'+
                    '<div class="category-img">'+
                        '<div class="content">'+
                            '<p>'+item.archives+'</p>'+
                            '<ul class="photos"></ul>'+
                            '<div class="clear"></div>'+
                        '</div>'+
                        '<div class="author">' + item.userName+'&nbsp;&nbsp;&nbsp;&nbsp;'+ amGloble.time2str(parseInt(item.createTime / 1000)) + '</div>' + del +
                        '<div class="clear"></div>'+
                    '</div>'+
                '</dd>');
            $html.data('item', item);
            this.custProfile.$list.append($html);
            var videoPoster = item.videos ? '<span><i class="iconfont icon-bofang"></i></span>' : '';
            if(item.imgs){
                var w = Math.floor(($(".category-item").width() - 73) / 3);
                var arr = item.imgs.split(',');
                $.each(arr, function(j, itemj) {
                    var $img = amGloble.photoManager.createImage('customerFile', {
                        parentShopId: amGloble.metadata.userInfo.parentShopId,
                        authorId: amGloble.metadata.userInfo.userId
                    }, arr[j], "s");
                    $html.find('.photos').append($("<li class='am-clickable'>" + videoPoster + "</li>").css({
                        width: w,
                        height: w
                    }).append($img));
                    var img = new Image();
                    img.src = $img.attr('src');
                    img.onload = function(){
                        $img.attr('w',this.width);
                        $img.attr('h',this.height);
                    }
                });
    
            }
        }

        if (!this.custProfile.$list.find('dd').length) {
            this.$empty.css("display", "-webkit-box");
        }

        this.refresh();

    },

    //美丽档案
    getCustomerPhotoProfile: function() {
        var _this = this;
        var user = this.data.meta;
        var custId = user.id;

        if (this.custPhotoProfile.pageIndex == 0) {
            this.$loading.css("display", "-webkit-box");
        } else {
            this.$loading.hide();
        }
        this.$empty.hide();
        amGloble.api.inventionList.exec({
            memId: custId,
            pageNumber: this.custPhotoProfile.pageIndex,
            pageSize: 10
        }, function(ret) {
            _this.$loading.hide();
            _this.closeBottomLoading();
            if (ret.code == 0) {
                _this.custPhotoProfile.pageIndex++;
                _this.renderCustomerPhotoProfile(ret.content);

                _this.tab.$inner.find("div.num").eq(1).text(ret.totalCount);
                _this.custPhotoProfile.$title.text("共有" + ret.totalCount + "条作品");

                if (!ret.content || !ret.content.length) {
                    _this.scrollview.pauseTouchBottom = true;
                } else {
                    _this.scrollview.pauseTouchBottom = false;
                }
            } else {
                amGloble.msg("客户作品读取失败！");
            }
        });
    },
    renderCustomerPhotoProfile: function(list) {
        if (this.custPhotoProfile.pageIndex <= 1) {
            this.custPhotoProfile.$list.empty();
        }
        this.appendCustomerPhotoProfile(list);
    },
    appendCustomerPhotoProfile: function(list) {
        //$.am.debug.log(JSON.stringify(list));
        var $ul = this.custPhotoProfile.$list;
        $.each(list, function(i, item) {
            $ul.append(amGloble.page.archiveList.createItem(item));
        });

        if ($ul.is(":empty")) {
            this.$empty.css("display", "-webkit-box");
        }
        this.refresh();

    },

    //消费历史
    getCustomerServiceHistory: function() {
        var _this = this;
        var user = this.data.meta;
        var custId = user.id;
        if (this.serviceHistory.pageIndex == 0) {
            this.$loading.css("display", "-webkit-box");
        } else {
            this.$loading.hide();
        }
        this.$empty.hide();
        amGloble.api.customerListServices.exec({
            memberid: custId,
            channel: 2, // 生意宝
            shopid: user.storeId,
            pageNum: this.serviceHistory.pageIndex + 1,
            pageSize: 10,
            timeUnLimit:1
        }, function(ret) {
            _this.$loading.hide();
            _this.closeBottomLoading();
            if (ret.code == 0) {
                _this.serviceHistory.pageIndex++;
                _this.renderCustomerServiceHistory(ret.content);

                if (!ret.content || !ret.content.length) {
                    _this.scrollview.pauseTouchBottom = true;
                } else {
                    _this.scrollview.pauseTouchBottom = false;
                }
                _this.tab.$inner.find("div.num").eq(2).text(ret.count);
            } else {
                amGloble.msg("客户档案读取失败！");
            }
        });
    },
    renderCustomerServiceHistory: function(list) {
        if (this.serviceHistory.pageIndex <= 1) {
            this.serviceHistory.$list.empty();
        }
        this.appendCustomerServiceHistory(list);
    },
    appendCustomerServiceHistory: function(list) {
        var self = this;
        if (list && list.length) {
            $.each(list, function (i, item) {
                var $li = self.serviceHistory.$clone.clone(true, true);
                $li.data("data", item);
                $li.find("div.time").text(amGloble.time2str(item.createDate / 1000));
                $li.find("div.total > .price").text("¥" + amGloble.cashierRound(item.expense));
                if (item.remainFee > 0 && item.debtBillId < 0) { 
                    // 新欠款显示欠款金额
                    $li.find("div.total").append('（<span> 欠款：</span><span class="price">¥'+item.remainFee+'</span>）')
                }
                var $itemlist = $li.find("ul.detail");
                var itemsArr = item.items;
                if(item.expenseCategory == 0 || item.expenseCategory == 4 || item.expenseCategory == 6){
                    itemsArr = amGloble.mergeServiceItems(item.items);
                }
                for (var j = 0; j < itemsArr.length; j++) {
                    var $p = $('<li><span class="left"></span><span class="right"></span></li>');
                    var itemj = itemsArr[j];
                    if (
                        (item.expenseCategory == 4 && itemj.consumeType == 1) || //套餐项目消费
                        (item.expenseCategory == 6 && item.consumeType == -1 && itemj.consumeType == 4) //年卡项目消费
                    ) {
                        $p.children(".left").text(itemj.serviceItemName.replace('疗程','套餐'));
                        $p.find(".right").html(itemj.num + '次');
                    } else {
                        $p.children(".left").text(itemj.serviceItemName + ([0,1,4,6].indexOf(item.expenseCategory) != -1 ? " x" + itemj.num : ""));
                        var p = amGloble.cashierRound(itemj.price);
                        var bonus = "";
                        if (itemj.largess && 　itemj.largess > 0) {
                            bonus = '<span class="bonus">(赠送金:' + itemj.largess + "元)</span>";
                        }
                        $p.children(".right").html(p + '元' + bonus);
                        if (!isNaN(p)) {
                            $p.children(".right").html(p + '元' + bonus);
                        } else {
                            $p.children(".right").html(itemsj.price + bonus);
                        }
                    }

                    $itemlist.append($p);

                }
                var commentLevel = typeof item.addOverallScore == 'number'  ? item.addOverallScore : item.overallScore;
                var commentContent = item.addFeedbackComment || item.feedbackComment;
                if (typeof(commentLevel) == "number" && commentLevel >= 0 && item.feedbackDT > 0) {

                    var $commentText = $li.find(".comment").show();
                    switch (commentLevel) {
                        case 0:
                            $commentText.html('<span class="icon icon1">好评</span>' + commentContent);
                            break;
                        case 1:
                            $commentText.html('<span class="icon icon2">中评</span>' + commentContent);
                            break;
                        case 2:
                            $commentText.html('<span class="icon icon3">差评</span>' + commentContent);
                            break;
                    }
                }

                if (item.expenseCategory == 0 || (item.expenseCategory == 6 && item.consumeType == -1)) {} else {
                    $li.children("div.commentText").hide();
                    $li.find("span.comment").hide();
                }
                self.serviceHistory.$list.append($li);
            });
        }



        this.refresh();
        if (self.serviceHistory.$list.is(":empty")) {
            this.$empty.css("display", "-webkit-box");
        }
    },

    //红包
    getLuckyMoneyList: function(){
        var _this = this;
        var user = this.data.meta;
        var custId = user.id;
        if (this.luckyMoneyList.pageIndex == 0) {
            this.$loading.css("display", "-webkit-box");
        } else {
            this.$loading.hide();
        }
        this.$empty.hide();
        amGloble.api.customerLuckyMoneyList.exec({
            memId: custId,
            shopid: user.storeId,
            pageNumber: this.luckyMoneyList.pageIndex,
            pageSize: 10,
        }, function(ret) {
            _this.$loading.hide();
            _this.closeBottomLoading();
            if (ret.code == 0) {
                _this.luckyMoneyList.pageIndex++;
                _this.renderCustomerLuckyMoneyList(ret.content);
                _this.luckyMoneyList.$title.html("共有" + ret.count + "个红包<br/>未拆开：" + ret.notOpenCount + '，未使用：' + ret.notUsedCount + '，已使用：' + ret.usedNo);
                if (!ret.content || !ret.content.length) {
                    _this.scrollview.pauseTouchBottom = true;
                } else {
                    _this.scrollview.pauseTouchBottom = false;
                }
                _this.tab.$inner.find("div.num").eq(6).text(ret.count);
            } else {
                amGloble.msg("客户档案读取失败！");
            }
        });
    },
    renderCustomerLuckyMoneyList: function(list){
        if (this.luckyMoneyList.pageIndex < 1) {
            this.luckyMoneyList.$list.empty();
        }
        this.appendCustomerluckyMoneyList(list);
    },
    appendCustomerluckyMoneyList: function(list){
        var self = this;
        if (list && list.length) {
            $.each(list, function(i, item) {
                var $li = self.luckyMoneyList.$clone.clone(true, true);
                $li.data("data", item);
                $li.find('.title').text(item.templateId ? (item.templateName || '--') : '--');
                $li.find('.price').text(item.money ? '￥' + item.money : (item.discount ? item.discount + '折' : '￥0'));
                try {
                    var extraRule = JSON.parse(JSON.parse(item.rule).content.rule).extraRule
                    if (extraRule.type == 0 && extraRule.customType == 1 && !item.money) {
                        $li.find('.price').text('资格红包');
                    }
                    if (extraRule.type == 2) {
                        $li.find('.price').text(extraRule.discount+'折');
                    }
                } catch ( e ) {}
                item.createtime = new Date(item.createtime.replace(/\-/g,'/')).getTime();
                if(item.expiretime){
                    item.expiretime = new Date(item.expiretime.replace(/\-/g,'/')).getTime();
                }
                var status = self.getLuckyMoneyStatus(item)
                $li.find('.status').text(status.str).css('color',status.color);
                if(status.passed){
                    $li.addClass('passed');
                }
                var startTime = 0 ,endTime = 0;
                var expiretimeText = '无';
                if(item.expiretime){
                    if(item.rule && JSON.parse(item.rule).useTemplate){
                        var rule = JSON.parse(JSON.parse(JSON.parse(item.rule).content).rule);
                        if(rule && rule.validitymode==0){
                            endTime = item.expiretime;
                            startTime = item.createtime*1 + rule.days*24*60*60*1000;
                        }else if(rule && rule.validitymode==1) {
                            endTime = new Date(rule.endTime+' 23:59:59').getTime();
                            startTime = new Date(rule.startTime).getTime();
                            if(endTime > item.expiretime){
                                endTime = item.expiretime;
                            }
                        }
                    }else {
                        endTime = item.expiretime;
                        startTime = item.createtime;
                    }
                    if(new Date().getTime()>endTime){
                        expiretimeText = new Date(item.expiretime*1).format('yyyy-mm-dd HH:MM')
                    }else {
                        expiretimeText = new Date(startTime*1).format('yyyy-mm-dd')+'至'+new Date(endTime*1).format('yyyy-mm-dd');
                    }
                }
                item.expiretimeText = expiretimeText;
                $li.find('.time').text('有效期：'+ expiretimeText);
                $li.find('.sendTime').text(item.createtime ? amGloble.time2str(item.createtime/1000) : '无');
                self.luckyMoneyList.$list.append($li);
            });
        }
        this.refresh();
        if (self.luckyMoneyList.$list.is(":empty")) {
            this.$empty.css("display", "-webkit-box");
        }
    },
    getLuckyMoneyStatus: function(item){
        var status=item.status,      // 状态
            expiretime=item.expiretime; // 过期时间
        var str = "",color = "",passed = 0;
        //-1已过期,1未拆开,2已经拆开,3已使用,4 已支付，未绑定流水单,5 已撤回
        if(status == -1){
            str = "已过期";
            color = "#ccc";
            passed = 1;
        }else if(status == 1){
            str = "未拆开";
            color = "#FF8200";
            if(expiretime-0 < new Date().getTime()){
                str = "已过期";
                color = "#ccc";
                passed = 1;
            }
        }else if(status == 2){
            str = "未使用";
            color = "#6BCF6C";
            if(expiretime-0 < new Date().getTime()){
                str = "已过期";
                color = "#ccc";
                passed = 1;
            }
        }else if(status == 3){
            str = "已使用";
            color = "#222";
            passed = 1;
        }else if(status == 4){
            str = "已支付";
            color = "#222";
            if(expiretime-0 < new Date().getTime()){
                str = "已过期";
                color = "#ccc";
                passed = 1;
            }
        }
        return {
            str : str,
            color: color,
            passed: passed
        };
    },
    showRuleDetail: function(data){
        var rule = this.getLuckyMoneyConfig(data);
        if(!rule || (!rule.mallPay && !rule.cashierPay)){
            return amGloble.msg('该红包没有规则');
        }
        this.$ruleDetail.find('.time').text('有效期：'+data.expiretimeText);
        if(!rule.mallPay){
            this.$ruleDetail.find('.item').eq(0).hide();
        }else {
            this.$ruleDetail.find('.item').eq(0).show();
            this.$ruleDetail.find('.item').eq(0).find('.text').empty();
            for(var i=0;i<rule.mallPay.length;i++){
                if(rule.mallPay[i]){
                    this.$ruleDetail.find('.item').eq(0).find('.text').append('<div><span>'+(i+1)+'、</span><p>'+rule.mallPay[i]+'</p></div>');
                }
            }
        }
        if(!rule.cashierPay){
            this.$ruleDetail.find('.item').eq(1).hide();
        }else {
            this.$ruleDetail.find('.item').eq(1).show();
            this.$ruleDetail.find('.item').eq(1).find('.text').empty();
            for(var i=0;i<rule.cashierPay.length;i++){
                if(rule.cashierPay[i]){
                    this.$ruleDetail.find('.item').eq(1).find('.text').append('<div><span>'+(i+1)+'、</span><p>'+rule.cashierPay[i]+'</p></div>');
                }
            }
        }
        if(rule.custom){
            this.$ruleDetail.find('.item').eq(0).hide(); 
            this.$ruleDetail.find('.item').eq(1).find('.label').hide();
            for(var i=0; i<rule.custom.length; i++) {
                if(rule.custom[i]) {
                    this.$ruleDetail.find('.item').eq(1).find('.text').attr('id', 'custom-rule').append('<div><p>'+rule.custom[i]+'</p></div>');
                }
            }
        }
        this.$ruleDetail.show();
        this.$ruleDetail.find('.wrapper').addClass('active');
        this.ruleDetailScroll.refresh();
        this.ruleDetailScroll.scrollTo('top');
    },
    getLuckyMoneyConfig: function(pocketInfo){
        if(!pocketInfo.rule){
            return '';
        }
        var result = {
            mallPay: [],
            cashierPay: [],
        }
        var rule = JSON.parse(pocketInfo.rule);
        var _rule = rule.content && rule.content.rule ? rule.content.rule : "";
        if(_rule){
            rule = JSON.parse(_rule);
        }else{
            //另一种content为string的情况(后台红包规则不统一)
            if(typeof rule.content === "string"){
                _rule = JSON.parse(rule.content);
                rule = _rule.rule;
            }else{
                return '';
            }
        }
        if(rule.customRedpackRule) {
            result.custom = rule.customRedpackRule.split('\n')
        } else {
            if (rule && rule.luckyMoneyRule && rule.luckyMoneyRule.enableMallPay ) { // 启用商城抵扣
                var allowMallPay=rule.luckyMoneyRule.allowMallPay;
                if(allowMallPay.orderAmountFlag){
                    result.mallPay.push('订单金额满' + rule.luckyMoneyRule.allowMallPay.orderAmount + '可用');
                }
                if (allowMallPay.enableItems) {
                    var mallItems = '指定商品（'
                    var items = rule.luckyMoneyRule.allowMallPay.items;
                    for (var index = 0; index < items.length; index++) {
                        var item = items[index];
                        if(index==items.length-1){
                            mallItems += item.name;
                        }else{
                            mallItems += item.name + '、';
                        }
                    }
                    mallItems += '）可用';
                    result.mallPay.push(mallItems);
                }
            }else {
                delete result.mallPay;
            }
            if (rule && rule.luckyMoneyRule && rule.luckyMoneyRule.enableCashierPay) { // 启用项目抵扣
                var allowCashierPay = rule.luckyMoneyRule.allowCashierPay;
                var itemsStr = this.getItemsStr(allowCashierPay);
                var treatsStr = this.getTreatsStr(allowCashierPay);
                var depotsStr = this.getDepotsStr(allowCashierPay);
                var itemsAndTreatsStr = '';
                if(itemsStr.indexOf('全部项目可用')>-1 && treatsStr.indexOf('全部套餐包可用')>-1 && treatsStr.indexOf('单个项目套餐可用')>-1 && depotsStr.indexOf('全部卖品可用')>-1){
                    itemsAndTreatsStr = '店内消费可用，';
                }else{
                    itemsAndTreatsStr = itemsStr + treatsStr+depotsStr;
                }
                if(itemsAndTreatsStr.lastIndexOf('，')===itemsAndTreatsStr.length-1){
                    itemsAndTreatsStr = itemsAndTreatsStr.substring(0,itemsAndTreatsStr.length-1);
                }
                var subtract = allowCashierPay.consumptionAmountFlag && allowCashierPay.consumptionAmount ? '满' + allowCashierPay.consumptionAmount + '元可以抵扣现金' : '';
                var memCard = allowCashierPay.memCard ? '仅允许散客使用（仅未在门店或线上办卡/充值/购买套餐的顾客使用）' : '';
                var otherRedPackage = allowCashierPay.otherRedPackage ? '禁止同时使用其它红包' : '';
                var shops = this.getAppShops(pocketInfo);
                result.cashierPay.push(subtract);
                result.cashierPay.push(memCard);
                result.cashierPay.push(otherRedPackage);
                result.cashierPay.push(itemsAndTreatsStr);
                result.cashierPay.push(shops);
            }else {
                delete result.cashierPay
            }
            if(result.mallPay){
                result.mallPay = result.mallPay.filter(function(item){
                    return item;
                });
            }
            if(result.cashierPay){
                result.cashierPay = result.cashierPay.filter(function(item){
                    return item;
                });
            }
        }
        return result;
    },
    getDepotsStr: function (allowCashierPayObj) {
        // enabled 是否开启套餐包抵扣 allowCashierPayObj.enableDepots
        // depots 指定的卖品编号Str  allowCashierPayObj.depots
        var enabled = allowCashierPayObj.enableDepots,
            depots = allowCashierPayObj.depots,
            resStr = '';
        if (enabled) {
            // 开启套餐包抵扣
            if (depots && depots.length) {
                var depotsCodeMap = amGloble.metadata.categoryCodeMap;
                var depotsArr = depots.split(','); // 卖品编号数组
                if (depotsArr[0] === 'r') {
                    // 反向指定
                    resStr += '指定卖品不可用（';
                    for (var i = 0, len = depotsArr.length; i < len; i++) {
                        var depot = depotsCodeMap[depotsArr[i]];
                        if (depot) {
                            resStr += depot.name + '、'
                        }
                    }
                } else if (depotsArr[0] === 'a') {
                    resStr += '全部卖品可用，';
                } else {
                    // 正向指定
                    resStr += '指定卖品可用（';
                    for (var i = 0, len = depotsArr.length; i < len; i++) {
                        var depot = depotsCodeMap[depotsArr[i]];
                        if (depot) {
                            resStr += depot.name + '、'
                        }
                    }
                }
            }
            var lastIndex=resStr.length - 1;
            if(resStr.lastIndexOf('、')==lastIndex){
                resStr = resStr.substring(0, lastIndex) + '），';
            }
            return resStr;
        } else {
            // 未开启卖品
            return resStr;
        }
    },
    // 获取配置的套餐包信息
    getTreatsStr:function(allowCashierPayObj){
        // enabled 是否开启套餐包抵扣 allowCashierPay.enableTreats
        // treats 指定的套餐包idStr  allowCashierPay.treats
        var enabled=allowCashierPayObj.enableTreats,
            enableSingleTreats = allowCashierPayObj.enableSingleTreats,
            treats= allowCashierPayObj.treats,
            resStr='';
        if(enabled){
            // 开启套餐包抵扣
            if(treats && treats.length){
                var treatsArr=treats.split(',');
                var metaTreats=amGloble.metadata.tpList;
                if(treatsArr[0]==='r'){
                    // 反向指定
                    resStr += '指定套餐包不可用（';
                    for(var i=0,len=treatsArr.length;i<len;i++){
                        for(var j=0,jlen=metaTreats.length;j<jlen;j++){
                            var item=metaTreats[j];
                            if(item.id==treatsArr[i]){
                                resStr += item.packName + (i == (len - 1) ? '）' : '、');
                            }
                        }
                    }
                }else if(treatsArr[0]==='a'){
                    resStr += '全部套餐包可用，';
                }else{
                    // 正向指定
                    resStr += '指定套餐包可用（';
                    for(var i=0,len=treatsArr.length;i<len;i++){
                        for(var j=0,jlen=metaTreats.length;j<jlen;j++){
                            var item=metaTreats[j];
                            if(item.id==treatsArr[i]){
                                resStr += item.packName + (i == (len - 1) ? '）' : '、');
                            }
                        }
                    }
                }
            }
            if(amGloble.metadata.userInfo.shopType===3){
                resStr = '附属店全部套餐包可用，'
            }
            
        }
        if(enableSingleTreats){
            resStr += '单个项目套餐可用，';
        }
        return resStr;
    },
    getAppShops:function(item){
        var shopText = "";
        if(amGloble.metadata.userInfo.shopType==1){
            return shopText;
        }else if(item && item.appShopInfo){
            var appShopInfo = JSON.parse(item.appShopInfo);
            if(appShopInfo){
                shopText = this.getShopsStr(appShopInfo);
                if(shopText.indexOf('仅在发送门店可使用')>-1 && appShopInfo.currentShop && appShopInfo.currentShop.osName){
                    shopText ='指定门店可使用：' + appShopInfo.currentShop.osName;
                }
                return shopText;
            }
        }else{
            return shopText;
        }
    },
    getShopsStr:function(appShopInfo){
        // 显示红包规则中的门店配置
        var shopTextInfo='';
        if (appShopInfo.chosenShop == '0') {
            shopTextInfo = "全部门店可使用";
        } else if (appShopInfo.chosenShop == '1') {
            shopTextInfo = "仅在发送门店可使用";
        } else {
            var shopMap = amGloble.metadata.shopMap,
                checkedDirectShops = appShopInfo.checkedDirectShops,
                checkedIndirectShops = appShopInfo.checkedIndirectShops;
            if(checkedDirectShops[0]=='r'){
                shopTextInfo = "指定门店不可使用：";
                for (var i = 0, dlen = checkedDirectShops.length; i < dlen; i++) {
                    if(shopMap[checkedDirectShops[i]]){
                        shopTextInfo += shopMap[checkedDirectShops[i]].osName + '、';
                    }
                }
                for (var j = 0, ilen = checkedIndirectShops.length; j < ilen; j++) {
                    if(shopMap[checkedIndirectShops[j]]){
                        shopTextInfo += shopMap[checkedIndirectShops[j]].osName + '、';
                    }
                }
            }else{
                shopTextInfo = "指定门店可使用：";
                for (var i = 0, dlen = checkedDirectShops.length; i < dlen; i++) {
                    if(shopMap[checkedDirectShops[i]]){
                        shopTextInfo += shopMap[checkedDirectShops[i]].osName + '、';
                    }
                }
                for (var j = 0, ilen = checkedIndirectShops.length; j < ilen; j++) {
                    if(shopMap[checkedIndirectShops[j]]){
                        shopTextInfo += shopMap[checkedIndirectShops[j]].osName + '、';
                    }
                }
            }
            shopTextInfo = shopTextInfo.substring(0, shopTextInfo.length - 1); // 去掉最后的，
        }
        return shopTextInfo;
    },
    getItemsStr:function(allowCashierPayObj){
        var itemsStr='';
        var checkedItems = allowCashierPayObj.items; // 指定的项目
        if (allowCashierPayObj.enableItems && checkedItems && checkedItems.length) {
            // 指定部分项目可用
            for (var i = 0, len = checkedItems.length; i < len; i++) {
                var checkedItem = checkedItems[i];
                itemsStr += checkedItem.name + '、';
            }
            itemsStr = '指定项目可用（' + itemsStr.substring(0, itemsStr.length - 1) + '），';
        } else if (allowCashierPayObj.enableItems && checkedItems && checkedItems.length === 0 || allowCashierPayObj.enableTreats === undefined) {
            // 指定全部项目可用 或者 只勾选店内消费的老红包默认全部项目可用
            itemsStr = '全部项目可用，';
        }
        
        return itemsStr;
    },
    //商城订单
    getMallOrderList: function(){
        var _this = this;
        var user = this.data.meta;
        var custId = user.id;
        if (this.mallOrderList.pageIndex == 0) {
            this.$loading.css("display", "-webkit-box");
        } else {
            this.$loading.hide();
        }
        this.$empty.hide();
        amGloble.api.customerMallOrderList.exec({
            memberid: custId,
            shopid: user.storeId,
            pageNumber: this.mallOrderList.pageIndex,
            pageSize: 10,
        }, function(ret) {
            _this.$loading.hide();
            _this.closeBottomLoading();
            if (ret.code == 0) {
                _this.mallOrderList.pageIndex++;
                _this.renderCustomerMallOrderList(ret.content && ret.content.list || []);

                if (!ret.content || !ret.content.list || !ret.content.list.length) {
                    _this.scrollview.pauseTouchBottom = true;
                } else {
                    _this.scrollview.pauseTouchBottom = false;
                }
                _this.tab.$inner.find("div.num").eq(7).text(ret.count);
            } else {
                amGloble.msg("客户档案读取失败！");
            }
        });
    },
    renderCustomerMallOrderList: function(list){
        if (this.mallOrderList.pageIndex < 1) {
            this.mallOrderList.$list.empty();
        }
        this.appendCustomerMallOrderList(list);
    },
    appendCustomerMallOrderList: function(list){
        var self = this;
        if (list && list.length) {
            var tuanStatus = {
                "1":"团购中",
                "2":"已成团,可使用",
                "3":"等待退款",
            }
            $.each(list, function(i, item) {
                var $li = self.mallOrderList.$clone.clone(true, true);
                $li.data("data", item);
                var images = item.images;
                var image = images ? images.split(",")[0] : '';
                if(image){
                    if(image.indexOf('minipro')!=-1){
                        $li.find('.left').html('<img src="https://img.meiguanjia.net/'+image+'">');
                    }else {
                        $li.find('.left').html(amGloble.photoManager.createImage('mall', {
                            parentShopId: amGloble.metadata.userInfo.parentShopId,
                        }, image, 's'));
                    }
                }
                $li.find('.title').text(item.mallItemName);
                $li.find('.price').text('¥'+item.cashPay);
                $li.find('.num').text('x '+item.mallItemNum);
                if(item.goodsType == 1){
                    $li.find('.time').show().text('核销有效期至：'+(item.expireWriteOffTime ? new Date(item.expireWriteOffTime).format('yyyy-mm-dd HH:MM') : '无'));
                    $li.find('.content').hide();
                }else if(item.goodsType==2){
                    $li.find('.time').hide();
                    $li.find('.title').addClass('card');
                    $li.find('.content').show().html(self.getMallContent(item));
                }else if(item.goodsType==3){
                    $li.find('.time').hide();
                    $li.find('.title').addClass('package');
                    $li.find('.content').show().html(self.getMallContent(item));
                }else if(item.goodsType==4){
                    $li.find('.time').hide();
                    $li.find('.title').addClass('ticket');
                    $li.find('.content').show().html(self.getMallContent(item));
                }
                if(item.allowgroupbuying) {
                    $li.find('.title').addClass('allowgroupbuying');
                } else if(item.shareDiscount) {
                    $li.find('.title').addClass('shareDiscount');
                } else if(typeof item.privilegePrice != 'undefined' && item.privilegePrice !== null) {
                    $li.find('.title').addClass('privilegePrice');
                } else if(item.shareRebateDiscount != null) {
                    $li.find('.title').addClass('shareRebateDiscount');
                } else if (item.newCustPrice !== null && item.newCustPrice>=0){
                    $li.find('.title').addClass('newCustPrice');
                }
                $li.find('.sendTime').text(item.createTime ? amGloble.time2str(item.createTime/1000) : '无');
                var status = '';
                var statusClass = '';
                var usedClass = '';
                if (item.status == "2" && item.isgroupbuying == 1) {
                    if (item.refundTimes > 10 && item.groupbuyingstatus != 4) {
                        status = '退款失败,到期未成团';
                        statusClass = 'negative';
                    } else if(item.groupbuyingstatus == 4) {
                        status = '已退款';
                        statusClass = 'negative';
                    }else {
                        status = tuanStatus[item.groupbuyingstatus];
                        statusClass = 'upright';
                    }
                } else if (item.status == "2" && item.isgroupbuying != 1) {
                    status = '未使用';
                    statusClass = 'upright';
                } else if (item.status == "-2") {
                    status = '已退款';
                    statusClass = 'negative';
                } else if (item.status == "-3") {
                    status = '退款失败';
                    statusClass = 'negative';
                } else {
                    status = '已使用';
                    usedClass = 'used'
                };
                $li.find('.status').text(status).addClass(statusClass);
                $li.addClass(usedClass);
                self.mallOrderList.$list.append($li);
            });
        }
        this.refresh();
        if (self.mallOrderList.$list.is(":empty")) {
            this.$empty.css("display", "-webkit-box");
        }
    },
    getMallContent: function(data){
        console.log(data)
        var content = '';
        if(data.goodsType==2 && data.cardtypeInfo){
            var cardtypeInfo = JSON.parse(data.cardtypeInfo);
            content = cardtypeInfo.cardtypename + '：项目' + cardtypeInfo.discount + '折，卖品' + cardtypeInfo.buydiscount + '折';
        }
        if(data.goodsType==3 && data.packageInfo){
            var packageInfo = JSON.parse(data.packageInfo);
            var packageName = packageInfo.name;
            var items = '';
            for(var i=0;i<packageInfo.items.length;i++){
                var item = packageInfo.items[i];
                if(item.itemInfo && item.itemInfo[0]){
                    var item0 = item.itemInfo[0];
                    items += item0.itemName + ((item.itemTimes==-99 || !item.itemTimes) ? ' <span>不限次</span>，' : ' x<span>'+item.itemTimes+'</span>，');
                }
            }
            content = packageName + '：' + items;
            content = content.substring(0,content.length-1);
        }
        if(data.goodsType==4 && data.redpackInfo){
            var redpackInfo = JSON.parse(data.redpackInfo);
            content += '红包：';
            for(var i=0;i<redpackInfo.length;i++){
                content += redpackInfo[i].title + '，';
            }
            content = content.substring(0,content.length-1);
        }
        return content;
    },
    //客户闹钟
    getCustomerClock: function() {
        var _this = this;
        var user = this.data.meta;
        var custId = user.id;

        if (this.custClock.pageIndex == 0) {
            this.$loading.css("display", "-webkit-box");
        } else {
            this.$loading.hide();
        }
        this.$empty.hide();
        amGloble.api.clockList.exec({
            "customerId": custId,
            "shopId": amGloble.metadata.userInfo.shopId,
            "operator": amGloble.metadata.userInfo.userId,
            "pageSize": 10,
            "pageNumber": this.custClock.pageIndex
        }, function(ret) {
            _this.$loading.hide();
            _this.closeBottomLoading();
            if (ret.code == 0) {
                _this.custClock.pageIndex++;
                _this.renderCustomerClock(ret.content);

                // _this.tab.$inner.find("div.num").eq(0).text(ret.totalCount);
                // _this.custClock.$title.text("共有" + ret.totalCount + "个客户闹钟");

                if (!ret.content || !ret.content.length) {
                    _this.scrollview.pauseTouchBottom = true;
                } else {
                    _this.scrollview.pauseTouchBottom = false;
                }
            } else {
                amGloble.msg("客户闹钟读取失败！");
            }
        });
    },
    renderCustomerClock: function(list) {
        if (this.custClock.pageIndex <= 1) {
            this.custClock.$list.empty();
        }
        this.appendCustomerClock(list);
    },
    appendCustomerClock: function(list) {
        for (var i = 0; i < list.length; i++) {
            var item = list[i];
            // item.createtime = new Date(item.createtime).getTime();

            var date = new Date(new Date(item.unixtime + item.days * 86400000).format("yyyy/mm/dd"));
            var now = new Date(amGloble.now().format("yyyy/mm/dd"));
            var $li = this.custClock.$clone.clone(true, true);
			$li.find(".line1").html(item.title);
			var text;
			if (item.alarmType == 1) {
				text = item.alarmDate.slice(0, 10) + " 提醒";
			} else {
				text = ((date.getTime() - now.getTime()) / 86400000) + "天后提醒";
			}
            $li.find(".line2").html(text);
            $li.data("item", item);
            this.custClock.$list.append($li);
        }

        if (this.custClock.$list.is(":empty")) {
            this.$empty.css("display", "-webkit-box");
        }

        this.refresh();

    },

    changeFavorStatus: function(isFavor) {
        var self = this;
        var cust = this.data.meta;
		var user = amGloble.metadata.userInfo;
		self.favorLoading = true;
        if (isFavor) {
            amGloble.api.customerAddMemFavor.exec({
                memid: cust.id,
                shopId: user.shopId,
                userType: user.userType,
                empid: user.userId
            }, function(ret) {
				self.favorLoading = false;
                if (ret.code == 0) {
					self.$star.addClass("isFavor");
					self.paras.favorChangeCount += 1;
                    amGloble.msg("设置星标成功，可在星标客户中看到TA");
                } else {
                    amGloble.msg("设置星标失败！");
                }
            });
        } else {
            amGloble.api.customerDelMemFavor.exec({
                memid: cust.id,
                shopId: user.shopId,
                userType: user.userType,
                empid: user.userId
            }, function(ret) {
				self.favorLoading = false;
                if (ret.code == 0) {
					self.paras.favorChangeCount -= 1;
                    self.$star.removeClass("isFavor");
                    amGloble.msg("已取消星标");
                } else {
                    amGloble.msg("取消星标失败！");
                }
            });
        }
    },
    /*
     touchTop: function () {
     var _this=this;
     setTimeout(function () {
     _this.closeTopLoading();
     }, 500);
     },
     amDragTopTips: ["下拉可以刷新", "松开开始刷新", "加载中..."],
     */
    touchBottom: function() {
        var _this = this;
        var idx = this.tab.$inner.find("li.selected").index();
        if (idx == 0) {
            this.getCustomerProfile(this.lastCategroyType);
        } else if (idx == 1) {
            this.getCustomerPhotoProfile();
        } else if (idx == 2) {
            this.getCustomerServiceHistory();
        } else if (idx == 6) {
            this.getLuckyMoneyList();
        } else if (idx == 7) {
            this.getMallOrderList();
        } else if (idx == 8) {
            this.getCustomerClock();
        }

    },
    amDragBottomTips: ["上拉加载更多", "松开开始加载", "加载中..."],
    renderTags:function(tags){
        if(tags && tags.length){
            this.$addTag.hide();
            var list = processData(tags)
            this.$tags.show().empty().css('width','auto');
            if(list.length <= 2 && tags.length <= 6){
                for(var i=0;i<list.length;i++){
                    var $group = $('<div class="tagGroup"><span class="groupName">'+list[i].groupName+'</span><span class="tagList"></span></div>')
                    for (var c = 0; c < list[i].children.length; c++) {
                        $group.find(".tagList").append('<span class="tagName am-clickable">'+list[i].children[c].tagName+'</span>')
                    }
                    this.$tags.append($group);
                }
            }else{
                for(var i=0;i<tags.length;i++){
                    this.$tags.append('<p class="tagName am-clickable">'+tags[i].tagName+'</p>');
                }
                var cw = this.$tags.width();
                var lis = this.$tags.find('p');
                var wArr = [];
                for(var i=0;i<lis.length;i++){
                    wArr.push($(lis[i]).outerWidth(true));
                }

            }

        }else {
            this.$addTag.show();
            this.$tags.hide();
        }
    },
});
