amGloble.page.customerGrouping = new $.am.Page({
    id: "page-customerGrouping",
    init: function () {
        var self = this;
        // this.$header.children(".right.search").vclick(function() {
        //     $.am.changePage(amGloble.page.customerSearch, "slideleft");
        // });
        document.addEventListener("backbutton", function() {
            self.cancelPageMadal();
        }, false);

        this.$header.children(".right.ellipsis").vclick(function () {
            var display = self.$.find(".menu-list").css('display');
            if (display == 'none') {
                self.$.find(".menu-list").slideDown(200);
                self.$.find(".menu-list-mask").show();
            }
        });
        this.$header.children(".left.backbutton").vclick(function () {
            if (self.eid) {
                var type = self.$tab.find(".selected").data("type")
                $.am.changePage(amGloble.page.customerByCraftsman, "",{type: type,aback:true});
            } else if (self.eid && self.aback) {
                self.eid = null;
                self.emp = null;
                self.$header.find(".title>.c-storeSelectBtn").show();
                self.$header.find(".title>.c-empsSelectBtn").hide();
                self.refreshPage();
            } else {
                $.am.page.back();
            }
        });
        this.$.find(".menu-list-mask").vclick(function () {
            self.$.find(".menu-list").slideUp(200);
            self.$.find(".menu-list-mask").hide();
        })
        this.$.find(".menu-list li").vclick(function () {
            var type = self.$tab.find(".selected").data("type")
            var $sort = self.$sortbar.find(".selected");
            var sort = $sort.data("sort");
            var isReverse = $sort.find("span.sort").hasClass("up") ? 0 : 1;
            if ($(this).data("index") == 0) {
                $.am.changePage(amGloble.page.customerSearch, "slideleft");
            } else if ($(this).data("index") == 1) {
                $.am.changePage(amGloble.page.addCustomer, "slideleft");
            } else if ($(this).data("index") == 2) {
                $.am.changePage(amGloble.page.customerByCraftsman, "",{ type: 0, expandType: 1, expandParams: { emp: self.emp, type: 0, sort: sort, isReverse: isReverse, pageIndex: self.pageIndex, cData: [], totalData: self.totalData } });
            } else if ($(this).data("index") == 3) {
                $.am.changePage(amGloble.page.customerByCraftsman, "",{type: type});
            } else if ($(this).data("index") == 4) {
                self.loadSearcher(true);
            }
            self.$.find(".menu-list").slideUp(200);
            self.$.find(".menu-list-mask").hide();
        })
        // 搜索器
        this.$.find(".searcher-list-mask").vclick(function() {
            self.$.find(".searcher-list").slideUp(200);
            self.$.find(".searcher-list-mask").hide();
        })
        this.$searcherInner = this.$.find(".searcher-list-inner");
        this.$searcherList = this.$searcherInner.find(".searcher-list-content");
        this.$searcherListItem = this.$searcherList.find(".searcher-list-item");
        this.$searcherList.empty();

        this.$.find(".searcher-list .searcher-list-header .tip").vclick(function() {
            console.log('提示');
            self.$.find(".searcher-empty-tip-mask").show();
            self.$.find(".searcher-empty-tip-content").show();
        })
        this.$.find(".searcher-empty-tip-mask").vclick(function() {
            self.$.find(".searcher-empty-tip-mask").hide();
            self.$.find(".searcher-empty-tip-content").hide();
        })
        this.$.find(".searcher-empty-tip-content .bottom .button").vclick(function() {
            self.$.find(".searcher-empty-tip-mask").hide();
            self.$.find(".searcher-empty-tip-content").hide();
        })
        this.$searcherList.on("vclick", ".searcher-list-item", function() {
            var itemData = $(this).data('itemData');
            console.log('itemData', itemData);
            // $.am.changePage(amGloble.page.advanceCustomerQuery, "slideleft", { data: itemData });

            self.renderSearcherTag(itemData);

            self.$.find(".searcher-list").slideUp(200);
            self.$.find(".searcher-list-mask").hide();
        })

        this.searcherListScroll = new $.am.ScrollView({
            $wrap: this.$searcherInner,
            $inner: this.$searcherInner.find(".scrollInner"),
            direction: [0, 1]
        });
        this.searcherListScroll.touchBottom = function(e) {
            console.log(e);
            console.log('上拉刷新');
            // TODO 加载数据所有数据后禁止加载
            if (e == 3) {
                self.loadSearcher();
            }
        }
        // 查询标签的滚动
        this.$advanceCustomerQuerySearcherTag = this.$.find(".page-advanceCustomerQuery-searcher-tag").hide();
        this.$searcherTagWrap = this.$advanceCustomerQuerySearcherTag.find(".tag-tip-wrap").vclick(function() {
            self.$.find(".searcher-list").slideDown(200);
            self.$.find(".searcher-list-mask").show();
        });
        this.$searcherTagInner = this.$searcherTagWrap.find(".tag-tip-inner");

        this.searcherTagScroll = new $.am.ScrollView({
            $wrap: this.$searcherTagWrap,
            $inner: this.$searcherTagInner,
            direction: [1, 0]
        });
        this.$advanceCustomerQuerySearcherTag.on('vclick', '.closeTagTip', function() {
            self.closeSearcher(true);
        })

        //类型bar
        var $tabc = this.$.find(".page-customerGrouping-type");
        this.$tab = $tabc.find("ul").on("vclick", "li", function () {
            if (self.loading) {
                return;
            }
            var type = $(this).attr('data-type');
            if(type==-1){
                self.getFilterTags();
                self.hideWorkWechatFilter();
            } else if (type == -2) {
                self.$selectTag.hide().find('.container').hide();
                self.$tab.find('li[data-type=-1]').removeClass('selected');
                self.$tab.find('li[data-type=-2]').addClass('selected');
                self.$workWechatFilter.show().find('.workWechatFilter__main').slideDown(200);
            }else {
                self.hideWorkWechatFilter();
                self.$selectTag.hide().find('.container').hide();
                $(this).addClass("selected").siblings().removeClass("selected");
                self.refreshPage();
            }
        });

        this.$workWechatFilter = this.$.find('.workWechatFilter').on('vclick', function() {
            if(self.$tab.find('.selected').length>1){
                self.$tab.find('li[data-type=-2]').removeClass('selected');
            }
            self.hideWorkWechatFilter();
        })
        this.$workWechatFilter.find('.workWechatFilter__main').on('vclick', function(e) {
            e.stopPropagation();
        }).find('.workWechatFilter__item').on('vclick', function(e) {
            e.stopPropagation();
            var data = $(this).data()
            self.$tab.find('li[data-type=-2]').addClass('selected').siblings().removeClass('selected');
            self.isQYWechatFlag = Number(data.value);
            self.refreshPage();
            self.hideWorkWechatFilter();
        });


        //客户标签
        this.$tagTip = this.$.find('.page-customerGrouping-tagTip').on('vclick','.closeTagTip',function(){
            self.$tab.find('li[data-type=0]').trigger('vclick');
			self.TAG = [];
            self.$selectTag.find('.reset').hide()
        });
        this.$selectTag = this.$.find('.selectTag');
        this.$tagUl = this.$selectTag.find('.tagGroupList>div').on('vclick','li',function(){
            if($(this).hasClass('active')){
                $(this).removeClass('active');
            }else {
                $(this).addClass('active');
            }

            var lis = self.$tagUl.find('.active');
            if (lis.length) {
                self.$selectTag.find('.reset').show()
            } else {
                self.$selectTag.find('.reset').hide()
            }
        });
        this.$tagGroupItem = this.$tagUl.find(".tagGroupItem").remove()
        this.$resetTags = this.$selectTag.find('.reset').hide().vclick(function(){
            self.$tagUl.find('li').removeClass('active');
            $(this).hide();
        });
        this.$getTags = this.$selectTag.find('.sure').vclick(function(){
            var lis = self.$tagUl.find('.active');
            if(lis.length){
                var tagArr = [];
                var TAG = [];
                for(var i=0;i<lis.length;i++){
                    tagArr.push($(lis[i]).data('data').id);
                    TAG.push($(lis[i]).data('data'));
                }
                self.TAG = TAG;
                self.tagString = tagArr.join(',');
                self.$tab.find('li[data-type=-1]').addClass('selected').siblings().removeClass('selected');
                self.refreshPage();
            }else {
                self.$tab.find('li[data-type=-1]').removeClass('selected');
				self.$tab.find('li[data-type=0]').trigger('vclick');
				self.TAG = []
            }
            self.$selectTag.hide().find('.container').hide();
        });
        this.$selectTag.find('.top,.bottom').vclick(function(){
            if(self.$tab.find('.selected').length>1){
                self.$tab.find('li[data-type=-1]').removeClass('selected');
            }
            self.$selectTag.hide().find('.container').hide();
        });
        this.$selectTag.find('.container').vclick(function(e){
            e.stopPropagation();
        });
        this.$selectTag.find('.to-manage-tag').vclick(function(e){
            $.am.changePage(amGloble.page.tagManage,'slidedown');
        });
        this.sv_tag = new $.am.ScrollView({
            $wrap: self.$.find('.selectTag .container .tagGroupList'),
            $inner: self.$.find('.selectTag .container .tagGroupList>div'),
            direction: [0, 1]
        });

        this.sv_tab = new $.am.ScrollView({
            $wrap: $tabc,
            $inner: this.$tab,
            direction: [1, 0]
        });

        this.$emps_sc = new $.am.ScrollView({
            $wrap: this.$.find(".c-empsSelect-inner"),
            $inner: this.$.find(".c-empsSelect-inner .scrollInner"),
            direction: [0, 1]
        });


        //排序
        this.$sortbar = this.$.find(".page-customerGrouping-sort ul").on("vclick", "li", function () {
            if (self.loading) {
                return;
            }
            var $this = $(this);
            if ($this.hasClass("selected")) {
                $this.find("span.sort").toggleClass("up");
            } else {
                $this.addClass("selected").siblings().removeClass("selected");
            }
            self.refreshPage();
        });

        //滚动加载

        this.$ul = this.$.find(".c-custList").on("vclick", "li", function () {
            var $this = $(this);
            var item = $this.data("item");
            $.am.changePage(amGloble.page.customerDetail, "slideleft", {
                custId: item.id,
                shopid: item.shopid,
                $li: $this,
                isHighQuality: item.isHighQuality
            });
        });
        this.$li = this.$ul.find(":first").remove();
        this.$header.on("vclick", ".title>.c-empsSelectBtn", function () {
            if (!self.$.find("#c-empsSelect").is(":hidden")) {
                self.$.find("#c-empsSelect").slideUp(200)
                $(this).removeClass("up");
            } else {
                self.$.find("#c-empsSelect").slideDown(200)
                $(this).addClass("up");
                self.$emps_sc.refresh();
            }
        })
        this.$.find("#c-empsSelect .empList").on("vclick", "ul>li", function () {
            var emp = $(this).data("emp");
            emp.id = emp.empid;
            self.eid = emp.empid;
            self.emp = emp;
            self.$header.find(".title>.c-empsSelectBtn>.text").text(emp.empname ? emp.empname : emp.pname ? emp.pname : emp.name)
            self.$header.find(".title>.c-empsSelectBtn>.emp_tenantLogo").html(amGloble.photoManager.createImage("artisan", {
                parentShopId: amGloble.metadata.userInfo.parentShopId,
            }, emp.empid + ".jpg", "s"));
            self.refreshPage();
            self.$header.find(".title>.c-empsSelectBtn").removeClass("up");
        });
        //重试
        this.$.find(".am-page-error .button-common").vclick(function () {
            self.refreshPage();
        });
    },
    beforeShow: function (paras) {
		if (paras && paras.noRefresh) return;
        console.log(paras)
        var self = this;
        var userinfo = amGloble.metadata.userInfo
        if (userinfo.userType == 1) {
            var metadataConfig = amGloble.metadata.configs;
            var notAllowedAddAndDelTag = metadataConfig.staffHandle?JSON.parse(metadataConfig.staffHandle).notAllowedAddAndDelTag:0;
            if (notAllowedAddAndDelTag==1) {
                this.$selectTag.find('.to-manage-tag').hide();
            } else {
                this.$selectTag.find('.to-manage-tag').show();
            }
        } else {
            if (userinfo.operatestr && userinfo.operatestr.indexOf('a83') == -1) {
                this.$selectTag.find('.to-manage-tag').hide();
            } else {
                this.$selectTag.find('.to-manage-tag').show();
            }
        }

        if (amGloble.metadata.configs.mgjWeCom == 1) {
            self.$tab.find('li[data-type=-2]').show()
        } else {
            self.$tab.find('li[data-type=-2]').hide()
        }
        amGloble.storeSelect.onShopChange = function (shops) {
            self.refreshPage();
        };
        this.aback = paras && paras.aback ? paras.aback : false;
        if ((paras&&paras.dback==1)) {
			// 从顾客详情返回，如果星标客的状态有修改，则修改星标客个数
			if (paras.favorChangeCount) {
				var favorNumberEl = self.$tab.find('li').eq(5).find(".num");
				var originNum = favorNumberEl.text();
				var newNumber = originNum ? Number(originNum) + paras.favorChangeCount : paras.favorChangeCount;
				favorNumberEl.text(newNumber);
			}
			if (paras.favorChangeCount < 0) {
				var type = self.$tab.find(".selected").data("type");
				if (type == 4) {
					paras.$li.remove();
				}
			}
            return false;
        }
        if (paras && paras.emp) {
            var emp = paras.emp;
            this.emp = emp;
            this.eid = emp.id;
            this.$header.find(".title>.c-storeSelectBtn").hide();
            this.$header.find(".title>.c-empsSelectBtn").show();
            this.$header.find(".title>.c-empsSelectBtn>.text").text(emp.empname ? emp.empname : emp.pname ? emp.pname : emp.name)
            this.$header.find(".title>.c-empsSelectBtn>.emp_tenantLogo").html(amGloble.photoManager.createImage("artisan", {
                parentShopId: amGloble.metadata.userInfo.parentShopId,
                updateTs: paras.emp.lastphotoupdatetime
            }, paras.emp.id + ".jpg", "s"));
            this.getEmsList();
        } else {
            this.emp = null;
            this.eid = null;
            this.$header.find(".title>.c-storeSelectBtn").show();
            this.$header.find(".title>.c-empsSelectBtn").hide();
            this.closeSearcher();
        }
        this.setStatus("loading");
        this.initPageParas(paras);
    },
    afterShow: function (paras) {
        this.sv_tab.refresh();
        this.searcherTagScroll.refresh();
        if (paras == "back") {
            return false;
        }
        var userinfo = amGloble.metadata.userInfo;
        this.$.find(".menu-list ul li").show()
        if (userinfo.shopType == 0) {
            // this.$header.children(".right.add").hide();
            // this.$header.children(".right.search").css("right","0px");
            // this.$.find(".menu-list ul li>i.add").parent().remove();
            this.$.find(".menu-list ul li>i.add").parent().hide();
        }
        if (userinfo.newRole != 3 && userinfo.newRole != 2) {
            this.$.find(".menu-list ul li>i.assign").parent().hide();
            this.$.find(".menu-list ul li>i.craftsmans").parent().hide();
        }
        if (!amGloble.metadata.configs.handEmployees || amGloble.metadata.configs.handEmployees == 'false') {
            this.$.find(".menu-list ul li>i.assign").parent().hide();
        }

    },
    hideWorkWechatFilter: function() {
        this.$workWechatFilter.hide().find('.workWechatFilter__main').hide();
    },
    cancelPageMadal:function(){
        this.$.find(".menu-list").slideUp(200);
        this.$.find(".menu-list-mask").hide();
        this.$selectTag.hide().find('.container').hide();
        this.hideWorkWechatFilter();
        this.$tab.find('li[data-type=-1]').removeClass('selected');
    },
    initPageParas: function (paras) {
        if (!paras) {
            paras = {}
        }
        if (typeof paras.type != 'undefined') {
            // $(this.$tab.find("li")[paras.type]).addClass("selected").siblings().removeClass("selected");
            this.$tab.find('li[data-type='+paras.type+']').addClass("selected").siblings().removeClass("selected");
        }
        if (typeof paras.sort != 'undefined') {
            $(this.$sortbar.find("li")[paras.sort]).addClass("selected").siblings().removeClass("selected");
        }
        if (typeof paras.isReverse != 'undefined') {
            if (paras.isReverse == 0) {
                $(this.$sortbar.find("li")[paras.sort]).find("span.sort").toggleClass("up");
            }
        }
        this.resetList();
        if (typeof paras.pageIndex != 'undefined') {
            this.pageIndex = paras.pageIndex;
        }
        if (paras.cData) {
            this.appendList(paras.cData);
            this.setStatus("normal")
            this.cData = paras.cData;
        } else {
            this.getOnePage(1);
        }
        if (paras.totalData) {
            var data = paras.totalData;
            this.totalData = data;
            var $tabitems = this.$tab.find("li");
            $tabitems.eq(0).find(".num").html(data.totalCount || 0);
            $tabitems.eq(2).find(".num").html(data.highQualityCount || 0);
            $tabitems.eq(3).find(".num").html(data.lostCount || 0);
            $tabitems.eq(4).find(".num").html(data.staticCount || 0);
            $tabitems.eq(5).find(".num").html(data.favorCount || 0);
        } else {
            this.getSummaryData();
        }
    },
    refreshPage: function () {
        this.resetList();
        this.getSummaryData();
        this.getOnePage(1);
        if (this.eid) {
            this.getEmsList();
        }
    },
    //重新加载列表
    resetList: function () {
        this.pageLength = 10;
        //每页条数
        this.pageIndex = 0;
        //当前页数 -1表示未加载
        this.pageCount = -1;
        //列表总页数 -1表示未知
        this.$ul.empty();
        this.scrollview.scrollTo("top");
        // this.setStatus("normal");
        this.$emps_sc.refresh();
        var type = this.$tab.find(".selected").data("type");
        var config = amGloble.metadata.configs;
        var text = "";
        this.cData = null;
        this.$.find("#c-empsSelect").hide();
        switch (type) {
            case 0:
                this.$sortbar.removeClass("disableSort");
                break;
            case 1:
                text = '<span class="type1"> </span><span>门店最有价值的顾客</span>';
                this.$sortbar.addClass("disableSort");
                break;
            case 2:
                text = '<span class="type2"> </span><span>已经' + (config.loss || 60) + '天没有来店消费的顾客</span>';
                this.$sortbar.removeClass("disableSort");
                break;
            case 3:
                text = '<span class="type3"> </span><span>超过' + (config.stillCustomer || 120) + '天没有来店消费的顾客</span>';
                this.$sortbar.removeClass("disableSort");
                break;
            case 4:
                text = '<span class="type4"> </span><span>被星标的顾客</span>';
                this.$sortbar.removeClass("disableSort");
                break;
        }
        var searcherParams = this.searcherParams;
        if (!(searcherParams && searcherParams.searchParams && searcherParams.searchParams.length)) {
            if (text) {
                this.$.find(".topText").show().html(text);
            } else {
                this.$.find(".topText").hide();
            }
            if(this.tagString && this.$tab.find('li[data-type=-1]').hasClass('selected')){
                this.showTagTip();
            }else {
                this.hideTagTip();
            }
        }

    },
    showTagTip:function(){
        this.$tagTip.find('.tagTip').empty();
        for(var i=0;i<this.TAG.length;i++){
            this.$tagTip.find('.tagTip').append('<span>'+this.TAG[i].tagName+'</span>');
        }
        this.$tagTip.show();

        var cw = this.$tagTip.find('.tagTip').width();
        var lis = this.$tagTip.find('.tagTip span');
        var wArr = [];
        for(var i=0;i<lis.length;i++){
            wArr.push($(lis[i]).outerWidth(true));
        }
        var w = 0;
        for(var i=0;i<wArr.length;i++){
            w += wArr[i];
            if(w>cw){
                var w2 = 0;
                for(var j=0;j<i;j++){
                    w2 += wArr[j];
                }
                // if(cw-w2-16>=12){
                    this.$tagTip.find('.tagTip span').eq(j).css('width',cw-w2-16+'px');
                // }
                return false;
            }
        }
    },
    hideTagTip:function(){
        this.$tagTip.hide();
    },
    getSummaryData: function () {
        var self = this;
        var user = amGloble.metadata.userInfo;
        var shop = amGloble.storeSelect.getCurrentShops();
        if (shop) {
            //单个门店
            if ([3, 6].indexOf(Number(shop.mgjversion)) === -1) {
                var $tabitems = self.$tab.find("li.need");
                $tabitems.find(".num").html(0);
                return false;
            }
            shop = [shop];
        } else {

            //多门店
            shop = amGloble.metadata.shops.filter(function (item) {
                return  [3, 6].indexOf(Number(item.mgjversion)) !== -1;
            });
        };

        amGloble.api.customerDashboard.exec({
            "type": this.$tab.find(".selected").data("type"),
            "empid": self.eid ? self.eid : user.userId,
            "shopIds": amGloble.getKeyArr(shop, "shopId", true, true).join(","),
            "userType": self.eid ? 1 : user.userType, // 0管理员  1员工
        }, function (ret) {
            if (ret.code == 0) {
                var data = ret.content;
                self.totalData = data;
                var $tabitems = self.$tab.find("li");
                $tabitems.eq(0).find(".num").html(data.totalCount || 0);
                $tabitems.eq(2).find(".num").html(data.highQualityCount || 0);
                $tabitems.eq(3).find(".num").html(data.lostCount || 0);
                $tabitems.eq(4).find(".num").html(data.staticCount || 0);
                $tabitems.eq(5).find(".num").html(data.favorCount || 0);
            } else {
                amGloble.msg("数据加载失败,点击重试!");
            }

        });
    },
    getEmsList: function () {
        var self = this;
        var shop = amGloble.storeSelect.getCurrentShops();
        if (shop) {
            //单个门店
            shop = [shop];
        } else {
            //多门店
            shop = amGloble.metadata.shops.filter(function (item) {
                return item.mgjversion == 3;
            });
        };
        amGloble.api.employeeGetEmpByShopid.exec({
            "shopid": shop[0].shopId
        }, function (ret) {
            if (ret.code == 0) {
                self.emps = ret.content;
                var empsGroupByPinyin = {};
                for (var i = 0; i < self.emps.length; i++) {
                    var item = self.emps[i];
                    // item.shopFullName = item.shopName + (item.osName || "");
                    item.pinyin = codefans_net_CC2PY(item.empname ? item.empname : "帅帅的设计师");
                    var py = item.pinyin.substr(0, 1).toUpperCase() || "#";
                    item.pname = item.empname ? item.empname : "帅帅的设计师";
                    if (empsGroupByPinyin[py]) {
                        empsGroupByPinyin[py].push(item);
                    } else {
                        empsGroupByPinyin[py] = [item];
                    }
                }
                self.$.find(".c-empsSelect-inner .scrollInner .empList").empty();
                for (var key in empsGroupByPinyin) {
                    var emps = empsGroupByPinyin[key];
                    // var shops = item.shops;
                    var $index = $('<div class="index">' + key + '</div>');
                    var $ul = $('<ul class="subList"></ul>');
                    for (var j = 0; j < emps.length; j++) {
                        var emp = emps[j];
                        var $li = $('<li class="am-clickable">' + emp.pname + '</li>');
                        if (emp.empid == self.eid) {
                            $li.addClass("selected");
                        }
                        $li.data("emp", emp);
                        $ul.append($li);
                    }
                    self.$.find(".c-empsSelect-inner .scrollInner .empList").append($index).append($ul);
                }

            } else {
                amGloble.msg("数据加载失败,点击重试!");
            }
        });
    },
    getOnePage: function (top) {
        var self = this;

        var $sort = this.$sortbar.find(".selected");
        var sort = $sort.data("sort");
        var isReverse = $sort.find("span.sort").hasClass("up") ? 0 : 1;


        var user = amGloble.metadata.userInfo;
        var shop = amGloble.storeSelect.getCurrentShops();
        if(!shop){
            //如果当前没有选择问题，选择第一个
            amGloble.storeSelect.selectShop(0, true);
            shop = amGloble.storeSelect.getCurrentShops();
        }
        if (shop) {
            //单个门店
            if ([3, 6].indexOf(Number(shop.mgjversion)) === -1) {
                self.setStatus("normal");
                if (shop.mgjversion == 1) {
                    self.appendList("此门店是盛传版，不可使用客户管理");
                } else if (shop.mgjversion == 2) {
                    self.appendList("此门店是风尚版，不可使用客户管理");
                } else if (shop.mgjversion == 4) {
                    self.appendList("此门店是青春版，不可使用客户管理");
                }
                return false;
            }
            shop = [shop];
        } else {

            //多门店
            shop = amGloble.metadata.shops.filter(function (item) {
                return item.mgjversion == 3;
            });
        };
        if(top){
            this.pageIndex = 0;
            self.cData = [];
        }
        if (this.$ul.is(":empty")) {
            this.setStatus("loading");
        }
        var opt = {
            "empid": self.eid ? self.eid : user.userId,
            "shopIds": amGloble.getKeyArr(shop, "shopId", true, true).join(","),
            "userType": self.eid ? 1 : user.userType, // 1 管理员 0 员工
            "pageNumber": this.pageIndex,
            "pageSize": this.pageLength,
            "orderByType": sort,
            "isReverse": isReverse
        }
        if(this.tagString && this.$tab.find('li[data-type=-1]').hasClass('selected')){
            opt.tagIds = this.tagString;
            opt.type = 0;
        }else {
            opt.type = this.$tab.find(".selected").data("type")
        }
        if (this.$tab.find('li[data-type=-2]').hasClass('selected')) {
            opt.isQYWechatFlag = this.isQYWechatFlag;
            opt.type = 0;
        }
        var searcherParams = self.searcherParams;
        if (searcherParams && searcherParams.searchParams && searcherParams.searchParams.length) {
            opt.type = 0;
            delete opt.tagIds;
            delete opt.isQYWechatFlag;
            searcherParams.searchParams.forEach(function (paramItem) {
                var paramITEM = JSON.parse(JSON.stringify(paramItem));
                if (paramITEM.key == 'tagIds') {
                    paramITEM.params.tagIds = paramITEM.params.tagIds.join(",");
                }
                opt = $.extend(opt, paramITEM.params);
            })
        }
        this.loading = true;
        amGloble.api.customerQuerCusts.exec(opt, function (ret) {
            self.loading = false;
            self.setStatus("normal");
            if (ret.code == 0) {
                console.log(ret);
                console.log("-------------------------------------------------------------------------------");
                var data = ret.content;

                self.pageIndex += 1;
                if (!ret.content || (ret.content && ret.content.length === 0)) {
                    self.scrollview.pauseTouchBottom = true;
                } else {
                    self.scrollview.pauseTouchBottom = false;
                }
                if (!self.cData) {
                    self.cData = data
                } else {
                    self.cData = self.cData.concat(data)
                }
                if(top){
                    self.$ul.empty();
                    self.closeTopLoading();
                    self.topLoading = false;
                }
                if(!top){
                    self.closeBottomLoading();
                    self.bottomLoading = false;
                }
                self.appendList(data);
            } else {
                if (self.$ul.is(":empty")) {
                    self.setStatus("error");
                }
                amGloble.msg("数据加载失败,点击重试!");
            }

		}, false, 5 * 60 * 1000);

    },
    birthDay:['今天','一天后','两天后','三天后','四天后','五天后','六天后'],
    createCustItem: function (item, sort,isInAllShops) {
        var $li = this.$li.clone(true, true);
        $li.find(".header").html(amGloble.photoManager.createImage("customer", {
            parentShopId: amGloble.metadata.userInfo.parentShopId,
            updateTs: item.lastphotoupdatetime
        }, item.id + ".jpg", "s"));

        var type = this.$tab.find('.selected').data('type');

        if(type==-1){
            $li.find('.l5').show();
            $li.find(".phone").parent().hide();
        }else {
            $li.find('.l5').hide();
            if (!amGloble.metadata.permissions.allowphone) {
                $li.find(".phone").parent().hide();
            } else {
                $li.find(".phone").html(item.mobile).parent().show();
            }
        }

        // $li.find(".phone").parent().hide();

        $li.find(".name").html(item.name);
        $li.find(".ename").html(item.empname ? item.empname : '无~');

        if(type==5 && $.am.getActivePage().id=='page-customerGrouping'){
            $li.find('.l3').hide();
            $li.find('.l6').show();
            $li.find(".birth").html((item.birthType==0?'阴历':'阳历')+item.birthDay.substring(5,item.birthDay.length)+'('+this.birthDay[item.days]+')');
        }else {
            $li.find('.l3').show();
            $li.find('.l6').hide();
            $li.find(".store").html(amGloble.getStoresById(item.shopid,isInAllShops).shopFullName);
        }

        if(item.tags && item.tags.length){
            for(var i=0;i<item.tags.length;i++){
                $li.find('.l5').append('<p>'+item.tags[i].tagName+'</p>');
            }
        }else {
            $li.find('.l5').html('未添加标签~');
        }

        $li.find(".custlevel").empty()
        var classSpan = '<span class="identification"></span>'
        for (var index = 0; index < item.customersClasss.length; index++) {
            var tag = item.customersClasss[index]
            var $span = $(classSpan).clone()
            if(tag.className){
                if(index < 2 || item.customersClasss.length == (index + 1)){
                    $span.text(tag.tag?tag.tag:tag.className.substring(0, 1)).css("background",tag.color || predefineColors())
                    $li.find(".custlevel").append($span)
                }else{
                    $span.text("···").css({"background":"#EBEBEB", "color":"#999"})
                    $li.find(".custlevel").append($span)
                    break
                }
            }
        }
        // $li.find(".custlevel").html(item.className || "--");

        if (item.sex == "M") {
            $li.find(".gender").addClass("male");
            $li.find(".header").addClass("male");
        }
        if (item.isHighQuality == 1) {
            $li.find(".header").addClass("good");
        }else{
            $li.find(".header").removeClass("good");
        }
        if (!item.externalUserId || amGloble.metadata.configs.mgjWeCom != 1) {
            $li.find('.work-wechat').hide();
        }
        if (!item.isLost) {
            $li.find(".type2").hide();
        }
        if (!item.isStatic) {
            $li.find(".type3").hide();
        }
        if (!item.isFavor) {
            $li.find(".type4").hide();
        }

        $li.find(".showValue").html(item.req || 0);

        sort = sort == null ? 1 : sort;
        switch (sort) {
            case 0:
                $li.find(".showName").html("来店时间 ");
                $li.find(".showValue").html((item.lastconsumetime && item.lastconsumetime > 631152000000) ? amGloble.time2str(item.lastconsumetime / 1000) : "--");
                break;
            case 1:
                $li.find(".showName").html("客单价");
                $li.find(".showValue").html((item.req ? amGloble.cashierRound(item.req, 1) : 0) + " <span class='gray'>元<span>");
                break;
            case 2:
                //无来电用1000000表示
                $li.find(".showName").html("来店频率");
                $li.find(".showValue").html((item.consumeFreq != null && item.consumeFreq < 999999) ? Math.ceil(item.consumeFreq) + " <span class='gray'>天/次<span>" : "无");
                break;
            case 3:
                $li.find(".showName").html("消费总额");
                $li.find(".showValue").html(item.consumeTotal ? amGloble.cashierRound(item.consumeTotal, 1) : 0);
                break;
            case 4:
                $li.find(".showName").html("添加时间");
                $li.find(".showValue").html((item.registDate && item.registDate > 631152000000) ? amGloble.time2str(item.registDate / 1000) : "--");
                break;
        }

        $li.data("item", item);
        return $li;
    },
    appendList: function (data) {
        var self = this;
        var $ul = this.$ul;

        if (typeof data == "string") {
            $ul.append("<p>" + data + "</p>");
        } else {
            var sort = this.$sortbar.find(".selected").data("sort");
            if (data && data.length) {
                $.each(data, function (i, item) {
                    $ul.append(amGloble.page.customerGrouping.createCustItem(item, sort));
                });
                var $list = $ul.find('li');
                for(var p=0;p<$list.length;p++){
                    var $tags = $($list[p]).find('.l5');
                    var cw = $tags.width();
                    var lis = $tags.find('p');
                    var wArr = [];
                    for(var m=0;m<lis.length;m++){
                        wArr.push($(lis[m]).outerWidth(true));
                    }
                    var w = 0;
                    for(var m=0;m<wArr.length;m++){
                        w += wArr[m];
                        if(w>cw){
                            var w2 = 0;
                            for(var n=0;n<m;n++){
                                w2 += wArr[n];
                            }
                            $tags.find('p').eq(n).css('width',cw-w2-11+'px');
                        }
                    }
                }
            }

            if ($ul.is(":empty")) {
                this.setStatus("empty");
            }
        }
        self.refresh();
    },
    touchBottom: function () {
        var _this = this;
        if(this.bottomLoading){
            return;
        }
        this.bottomLoading = true;
        this.getOnePage();
    },
    amDragBottomTips: ["上拉加载更多", "松开开始加载", "加载中..."],
    amDragTopTips: ["下拉刷新列表", "松开开始加载", "加载中..."],
    touchTop: function(){
        if(this.topLoading){
            return;
        }
        this.topLoading = true;
        this.getOnePage(1);

    },
    renderTaggFilter:function(data){
        this.$tagUl.empty();
        this.$selectTag.find('.reset').hide();
        this.$selectTag.find('.tagGroupList').css("height","auto")
        var user = amGloble.metadata.userInfo;
        var shop = amGloble.storeSelect.getCurrentShops();
        var listdata = processData(data,[user.parentShopId,shop.shopId],true);
        var ids = this.TAG&&this.TAG.length ? this.TAG.map(function(item){
				return item.id
				}) : []
        for (var index = 0; index < listdata.length; index++) {
            var group = listdata[index];
            var $group = this.$tagGroupItem.clone()
            $group.find('.type').text(group.groupName)
            for (var i = 0; i < group.children.length; i++) {
                var tag = group.children[i];
                var $li = $('<li class="am-clickable" data-id="'+tag.id+'"><span>'+tag.tagName+'<span class="count">'+tag.CNT+'人</span>'+'</span></li>').data('data',tag);
				if(tag.status == 1){
					$li.addClass("del")
				}
				if(ids.indexOf(tag.id)>=0){
	    			$li.addClass("active")
				}else{
					$li.removeClass("active")
				}

                $group.find("ul").append($li);
            }
            this.$tagUl.append($group)
        }
        if (ids && ids.length) {
            this.$selectTag.find('.reset').show()
        } else {
            this.$selectTag.find('.reset').hide()
        }
        this.$tab.find('li[data-type=-1]').addClass('selected');
        this.$selectTag.show().find('.container').slideDown(200);
        var self = this
        setTimeout(function (){
            var height = self.$selectTag.find('.container').height()
            self.$selectTag.find('.tagGroupList').css("height",height+"px")
            self.sv_tag.refresh();
            self.sv_tag.scrollTo('top');
        }, 300);
    },
    getFilterTags:function(){
        var self = this;
        var user = amGloble.metadata.userInfo;
        var shop = amGloble.storeSelect.getCurrentShops();
        if (shop) {
            //单个门店
            if (shop.mgjversion != 3 && shop.mgjversion != 6) {
                self.setStatus("normal");
                if (shop.mgjversion == 1) {
                    amGloble.msg("此门店是盛传版，不可使用客户管理");
                } else if (shop.mgjversion == 2) {
                    amGloble.msg("此门店是风尚版，不可使用客户管理");
                } else if (shop.mgjversion == 4) {
                    amGloble.msg("此门店是青春版，不可使用客户管理");
                }
                return false;
            }
            shop = [shop];
        } else {
            //多门店
            shop = amGloble.metadata.shops.filter(function (item) {
                return item.mgjversion == 3;
            });
        };
        amGloble.loading.show();
        amGloble.api.tagFilter.exec({
            "empId": self.eid ? self.eid : user.userId,
            "shopId": shop[0].shopId,
            "empType": self.eid ? 1 : user.userType, // 1 管理员 0 员工
        }, function (ret) {
            amGloble.loading.hide();
            if (ret && ret.code == 0) {
                console.log(ret);
                if(ret.content.length){
                    self.renderTaggFilter(ret.content);
                }else {
                    amGloble.msg('不存在客户标签，无法筛选');
                }
            }else {
                atMobile.nativeUIWidget.confirm({
                    caption: '网络异常',
                    description: '数据读取失败，是否立即重试？',
                    okCaption: '重试',
                    cancelCaption: '取消'
                }, function() {
                    self.getFilterTags();
                }, function() {

                });
            }
        });
    },
    setStatus : function(status, text) {
        var $page = this.$.removeClass("am-status-loading am-status-error am-status-empty");
        switch(status) {
            case "loading":
                $page.addClass("am-status-loading");
                break;
            case "error":
                amGloble.loading.hide();
                $page.addClass("am-status-error");
                break;
            case "empty":
                amGloble.loading.hide();
                $page.addClass("am-status-empty");
                break;
            case "normal":
                amGloble.loading.hide();
            default:

        }

    },
    loadSearcher: function(refresh) {
        var self = this;
        if (refresh) {
            self.searcherPageNumber = 1;
            self.$searcherList.empty();
        }
        amGloble.api.searchConfigList.exec({
            pageSize: 30,
            pageNum: self.searcherPageNumber
        }, function (ret) {
            if (ret.code == 0) {
                console.log(ret);
                var content = ret.content;
                var operatestr = amGloble.metadata.userInfo.operatestr || '';
                var shopType = amGloble.metadata.userInfo.shopType;
                if ((content.pageCount * content.pageSize) >= content.total) {
                    self.searcherListScroll.pauseTouchBottom = true;
                } else {
                    self.searcherListScroll.pauseTouchBottom = false;
                }
                if (refresh && content.total == 0) {
                    if ((operatestr.indexOf('EDSEARCH') != -1) && (shopType == 0 || shopType == 1)) {
                        self.$.find(".searcher-empty-tip-mask").show();
                        self.$.find(".searcher-empty-tip-content").show();
                    } else {
                        amGloble.msg("管理员未配置搜索器");
                    }
                    return;
                }
                if (refresh) {
                    self.$.find(".searcher-list").slideDown(200);
                    self.$.find(".searcher-list-mask").show();
                    if ((operatestr.indexOf('EDSEARCH') != -1) && (shopType == 0 || shopType == 1)) {
                        self.$.find(".searcher-list .searcher-list-header .tip").show();
                    } else {
                        self.$.find(".searcher-list .searcher-list-header .tip").hide();
                    }
                }
                self.searcherPageNumber += 1
                self.renderSearcher(content.list)
            } else {
                amGloble.msg("数据加载失败,点击重试!");
            }
        });
    },
    renderSearcher: function(data) {
        var self = this;
        $.each(data, function(index, item) {
            var $searcherListItem = self.$searcherListItem.clone();

            var $title = '<p class="searcher-title">' + item.searchName + '</p>';
            item.searchParams = JSON.parse(item.searchParams);
            $searcherListItem.append($title);
            $.each(item.searchParams, function(i, node) {
                var $tag = '<div class="searcher-tag">' + node.label + '</div>';
                $searcherListItem.append($tag);
            })

            $searcherListItem.data("itemData", item);

            self.$searcherList.append($searcherListItem)
        })
        self.searcherListScroll.refresh();
    },
    closeSearcher: function(refresh) {
        var self = this;
        self.searcherParams = undefined;
        self.$.removeClass('advanced-searcher');
        self.$.find(".page-customerGrouping-type").show();
        self.$advanceCustomerQuerySearcherTag.hide();
        if (refresh) {
            self.refreshPage();
        }
    },
    renderSearcherTag: function (data) {
        console.log('tag', data)
        var self = this;
        var paramsData = data.searchParams;

        self.$.addClass('advanced-searcher');
        self.$.find(".page-customerGrouping-type").hide();
        self.$.find(".topText").hide();
        self.$tagTip.hide();

        self.$advanceCustomerQuerySearcherTag.show();
        self.searcherParams = data;

        self.$searcherTagInner.empty();
        $.each(paramsData, function (index, item) {
            var $tag = '<li><div class="tag-item">' + item.label + '</div></li>';
            self.$searcherTagInner.append($($tag));
        })
        self.searcherTagScroll.refresh();
        self.searcherTagScroll.scrollTo('top');
        self.resetList();
        self.getOnePage(1);
        if (self.eid) {
            this.getEmsList();
        }
    }
});
