(function() {

    // var findParentShop = function(array) {
    //     var ret = [];
    //     for (var i = 0; i < array.length; i++) {
    //         var item = array[i];
    //         if (item.shopId == item.parentShopId) {
    //             ret.push(item);
    //         }
    //     }
    //     return ret;
    // };

    amGloble.page.login = new $.am.Page({
        id: "page-login",
        backButtonOnclick: function() {
            atMobile.nativeUIWidget.confirm({
                caption: "退出",
                description: "是否退出?",
                okCaption: "退出",
                cancelCaption: "返回"
            }, function() {
                atMobile.appManager.exitApp();
            }, function() {

            });
        },
        init: function() {
            var self = this;

            this.$.find('.top .left').vclick(function(){
                $.am.page.back();
            })

            this.$title = this.$.find(".top .photo");

            this.$username = this.$.find("#page-login-username").blur(function(){
				self.setVcCode();
				self.$loginBtn.removeClass('am-disabled').text('登录');
				self.lockLoginTimer && clearInterval(self.lockLoginTimer);
			});
            // 分布式登录
            this.$status = self.$.find('.checkServer .status');
            this.$status1 = self.$.find('.checkServer .status.status-checking');
            this.$status2 = self.$.find('.checkServer .status.status-pass');
            this.$username = this.$.find("#page-login-username");
            this.$cluster = this.$.find(".cluster-l");
            this.$clusterName = this.$.find(".cluster-info");
            this.$clusterShopName = this.$.find(".cluster-shopname .shopname");
            this.$status3 = self.$.find('.checkServer .status.status-recheck').vclick(function(){
                var userName = self.$username.val();
                if(userName){
                    self.userName = userName;
                    self.changeStatus(1);
                    self.checkUser(function(mgjUsers){
                        if(mgjUsers && mgjUsers.length){
                            var list = [];
                            list = amGloble.dedup(mgjUsers, 'parentShopId');
                            self.chooseParentShop(list,function(parentShop){
                                self.saveConfig({
                                    parentShopId: parentShop.parentShopId
                                });
                                var cluster = {
                                    cluster: parentShop.cluster,
                                    existence: parentShop.existence,
                                    shopName: parentShop.shopName,
                                    url: parentShop.url
                                }
                                self.changeConfig(cluster);
                            });
                        }
                    },'refresh');
                }
            });

            this.$password = this.$.find("#page-login-password").keyup(function(e) {
                if (e.keyCode == 13) {
                    self.$loginBtn.trigger("vclick");
                }
            });
            this.$vcCodeWrap = this.$.find('.vcCodeWrap');
            this.$vcCode = this.$.find('#page-login-vcCode');
			this.$vcCodeImg = this.$.find('.vcCodeImg').vclick(function(){
				self.setVcCode();
			});
            // this.$usernameClear = this.$username.next().vclick(function() {
            //     self.$username.val("");
            // });
            // 暂时注释清除事件
            // this.$usernameClear = this.$username.next().vclick(function() {
            //     self.$username.val("");
            // });

            this.$loginBtn = this.$.find("#page-login-loginBtn").vclick(function() {
                var login = function() {
                    var userName = self.$username.val();
                    var pwd = self.$password.val();
                    var code = self.$vcCode.val();
                    if(!self.$privacyEnable.hasClass('checked')){
                        amGloble.msg("请同意美管加服务协议和隐私政策!");
                        return;
                    }
                    if (!amGloble.reCellphone.test($.trim(userName))) {
                        amGloble.msg("请输入正确的手机号!");
                        return;
                    }

                    if (!$.trim(pwd)) {
                        amGloble.msg("请输入密码!");
                        return;
                    }

                    if (!$.trim(code) && self.$vcCode.is(':visible')) {
                        amGloble.msg("请输入验证码!");
                        return;
                    }
                    var sys_type = JSON.parse(window.localStorage.getItem('mgjLoginType'));
                    self.userName = userName;
                    self.checkUser2(function(mgjUsers){
                        self.checkElfUser(userName,pwd,function(elfUsers, errorMsg){
                            var users = [];
                            if(mgjUsers && mgjUsers.length){
                                users = users.concat(mgjUsers);
                            }
                            users = users.concat(elfUsers || []);
                            if(!users.length){
                                if(sys_type=='elf'){
                                    return amGloble.msg('网络开小差，请稍后重试！');
                                }else {
                                    self.login(userName, pwd, code);
                                    return;
                                }
                            }
                            //选择用户
                            self.chooseUser(users, function (user) {
                                console.log('user',user);
                                if(user.mgjsys_type && user.mgjsys_type === 'elf'){
                                    self.elf_login(user,userName);
                                }else {
                                    var cluster = {
                                        cluster: user.cluster,
                                        existence: user.existence,
                                        shopName: user.shopName,
                                        url: user.url
                                    }
                                    if(cluster.cluster){
                                        self.changeConfig(cluster,function(){
                                            self.login(userName, pwd, code, user);
                                        });
                                    }else {
                                        self.login(userName, pwd, code, user);
                                    }
                                }
                            });
                        });
                    });
                };
                if (navigator.appplugin && navigator.appplugin.hideIme) {
                    navigator.appplugin.hideIme();
                    // setTimeout(login, 500);
                    setTimeout(login, 500);
                } else {
                    // login();
                    login();
                }
            });

            this.$reset = this.$.find("#page-login-reset").vclick(function() {
                atMobile.nativeUIWidget.confirm({
                    caption: "重置",
                    description: "重置将清除之前的登录信息，是否继续？",
                    okCaption: "是",
                    cancelCaption: "否"
                }, function() {
                    self.reset();
                }, function() {});
            });
            this.$demo = this.$.find("#page-login-demo").vclick(function() {
                var sys_type = JSON.parse(window.localStorage.getItem('mgjLoginType'));
                if(sys_type=='syb'){
                    self.mgjDemo();
                }else if(sys_type=='elf'){
                    self.elfDemo();
                }else {
                    var list = [{hqName: "美管加"},{hqName: "小精灵"}];
                    self.chooseParentShop(list,function(parentShop){
                        console.log(parentShop)
                        if(parentShop.hqName=='美管加'){
                            self.mgjDemo();
                        }else {
                            self.elfDemo();
                        }
                    });
                }
            });

            //忘记密码
            this.$forgotPwd = this.$.find("#page-login-forgortPwd").vclick(function() {
                $.am.changePage(amGloble.page.userinfoForgotPwd, "slideleft", {
                    phone: self.$username.val(),
                    modify: 2
                });
            });
            this.$privacyEnable = this.$.find(".privacyEnable");
            if (Number(window.localStorage.getItem('privacyAgreement')) === 1) {
                this.$privacyEnable.addClass('checked').find(".checked_icon").addClass("icon-biaojiwancheng");
            }
            this.$privacyEnable.vclick(function() {
                if($(this).hasClass('checked')){
                    $(this).removeClass('checked');
                    $(this).find('.checked_icon').removeClass("icon-biaojiwancheng");
                }else{
                    $(this).addClass('checked')
                    $(this).find('.checked_icon').addClass("icon-biaojiwancheng");
                    window.localStorage.setItem('privacyAgreement', 1)
                }
            })
            this.$toPrivacyPage = this.$.find(".toPrivacyPage").vclick(function(e) {
                e.stopPropagation();
                $.am.changePage(amGloble.page.privacy, "slideleft");
			})
            this.$toAgreementPage = this.$.find('.toAgreementPage').vclick(function(e) {
                e.stopPropagation();
                $.am.changePage(amGloble.page.privacy, "slideleft", {
                    type: "agreement"
                });
            })


			var clickTimeList = [];
			var compareTime = function(time1, time2) {
                return time2 / 1000 - time1 / 1000;
			};
			var serversList = [
				{name: '发源地', id: 'n_shengyibao_fyd'},
				{name: '美管加', id: 'n_shengyibao'}
			]
			this.$.find('.app_version').on('vclick', function() {
				var nowTime = new Date().getTime();
				clickTimeList.push(nowTime);
				var diffTime = compareTime(clickTimeList[0], nowTime);
				if (diffTime < 1) {
					if (clickTimeList.length >= 2) {
						clickTimeList.length = 0;
						amGloble.popupMenu('请选择服务', serversList, function (ret) {
							amGloble.clearStorage();
							self.resetServerConfig(function() {
								self.saveServerConfig(ret.id, function() {
									alert("设置成功，干掉APP再打开！");
								});
							})

						});
					}
				} else {
					clickTimeList.length = 0;
				}
			})

            this.$.find('.checkinScanBtn').on('vclick', function() {
                if(!self.$privacyEnable.hasClass('checked')){
                    amGloble.msg("请同意美管加服务协议和隐私政策!");
                    return;
                }

                if(window.config.token&&window.config.isCheckin){
                    self.getChickinDetail(function(userInfo){
                        $.am.changePage(amGloble.page.userinfo, "slideleft", {
                            userInfo: userInfo
                        });
                    })
                    return
                }
                // var obj = {
                //     type: 'checkin',
                //     shopId: 99950,
                //     parentShopId: 99950,
                //     softgenre: 0,
                // }
                // $.am.debug.log("obj：" + obj);
                // $.am.changePage(amGloble.page.userinfo, "slideleft", obj);
                // // $.am.changePage(amGloble.page.userinfo, "slideleft", {
                // //     userInfo: userInfo
                // // });
                // return
                cordova.plugins.barcodeScanner.scan(function (result) {
                    $.am.debug.log("扫码结果：" + JSON.stringify(result));
                    $.am.debug.log("扫码text：" + result.text);
                    var text = result.text;
                    if (text) {
                        try {
                            text = JSON.parse(text);
                        } catch (e) {
                            $.am.debug.log("error：" + e.message);
                        }
                    }
                    if(typeof text == 'string'){
                        text = text.replace(/(.*)([?])(.*)/g, '$3');
                        var arr = text.split('_');
                        if(arr[0]=='checkin'){
                            var obj = {
                                type: 'checkin',
                                shopId: arr[1],
                                parentShopId: arr[2],
                                softgenre: arr[3],
                            }
                            $.am.debug.log("obj：" + JSON.stringify(obj));
                            // $.am.changePage(amGloble.page.userinfo, "slideleft", obj);
                            window.RouterUtils.pushOld({ name: 'userinfo', params: obj, animation: 'slideleft' })
                        } else {
                            amGloble.msg('请扫描入职二维码！');
                        }
                    }
                }, function (error) {
                    $.am.debug.log("Scanning failed: " + error);
                    if(error.indexOf('camera')!==-1 && error.indexOf('enable')!==-1 && error.indexOf('Settings')!==-1){
                        error = '相机已被禁止使用，请在设置中启用后继续';
                    }
                    amGloble.msg(error);
                });
            })
        },
        getChickinDetail: function(callback){
            var self = this
            this.setStatus("loading");
            amGloble.api.getUserInfo.exec({
                token: window.config.token
            }, function(ret) {
                self.setStatus("normal");
                if (ret && ret.code == 0) {
                    if (!ret.content) {
                        $.am.changePage(amGloble.page.login);
                        localStorage.removeItem('BusinessAppV2_config');
                    } else {
                      $.am.debug.log(JSON.stringify(ret.content));
                        callback(ret.content)
                    }
                } else {
                    atMobile.nativeUIWidget.confirm({
                        caption: '网络异常',
                        description: '数据读取失败，是否立即重试？',
                        okCaption: '重试',
                        cancelCaption: '取消'
                    }, function () {
                        self.getChickinDetail(callback);
                    }, function () {

                    });
                }
            })
        },
        checkUser2: function(callback){
            var self = this;
            this.checkUser(function(mgjUsers){
                if(!mgjUsers || !mgjUsers.length){
                    if(!self.checkUserRetryTime){
                        self.checkUserRetryTime ++;
                        self.checkUser2(callback);
                    }else {
                        self.checkUserRetryTime = 0;
                        callback && callback(mgjUsers);
                    }
                }else {
                    self.checkUserRetryTime = 0;
                    callback && callback(mgjUsers);
                }
            });
        },
        mgjDemo: function(){
            var self = this;
            amGloble.confirm("演示模式", "即将进入演示模式，是否继续？", "是", "否", function() {
                config.demoUser = true;
                self.login("17788889999", "1", '', {
                    parentShopId: 10000
                });
            }, function() {});
        },
        elfDemo: function(){
            var self = this;
            amGloble.confirm("演示模式", "即将进入演示模式，是否继续？", "是", "否", function() {
                self.checkElfUser('17788889999','123456',function(elfUsers){
                    self.elf_login({
                        groupId: 412,
                        hqName: "小精灵",
                        levelName: "老板",
                        mgjsys_type: "elf",
                        nickName: "小精灵",
                        osName: "小精灵",
                        userName: "小精灵"
                    },'17788889999');
                });
            }, function() {});
        },
        changeStatus: function(status){
            this.$status.hide();
            switch(status){
                case 1:
                    this.$status1.show();
                    break;
                case 2:
                    this.$status2.show().removeClass('all');
                    break;
                case 3:
                    this.$status2.show().addClass('all');
                    break;
                case 4:
                    this.$status3.show();
                    this.$cluster.hide();
                    var cluster = localStorage.getItem('CLUSTER');
                    if(cluster){
                        this.changeStatus(5);
                    }
                    break;
                case 5:
                    this.$status3.show();
                    this.$cluster.show();
                    break;
                default:
                    this.$status3.show();
                    this.$cluster.hide();
                    break;
            }
        },
        checkElfUser:function(userName,pwd,callback){
            var sys_type = JSON.parse(window.localStorage.getItem('mgjLoginType'));
            if(sys_type=='syb'){
                callback && callback();
                return;
            }
            var self = this;
            // 小精灵探测
            $.ajax({
                type: 'post',
                url: window.config.elfUrl + 'account/checkMobile',
                data: JSON.stringify({
                    content: {
                        mobile: userName
                    }
                }),
                contentType: 'application/json;charset=UTF-8',
                dataType: "json",
                success:function(check){
                    if(check.code === 'SUCCESS'){
                        // 在小精灵里有账号
                        $.ajax({
                            type: "post",
                            url: window.config.elfUrl + "account/login",
                            data: JSON.stringify({
                                content: {
                                    mobile: userName,
                                    password: window.$.md5(pwd),
                                    deviceId: device.uuid,
                                },
                                deviceType: 'APP'
                            }),
                            contentType: 'application/json;charset=UTF-8',
                            dataType: "json",
                            success: function(response){
                                if (response.code === 'SUCCESS'){
                                    var request = {
                                        token: response.token,
                                        accountId: response.content.id,
                                        content: ['serviceUserList'],
                                        deviceType: 'APP'
                                    }
                                    $.ajax({
                                        type: "post",
                                        url: window.config.elfUrl + "account/metadata",
                                        data: JSON.stringify(request),
                                        contentType: 'application/json;charset=UTF-8',
                                        dataType: "json",
                                        success:function(res){
                                            console.log(res);
                                            // 门店列表保存
                                            // 测试账号 13419548907
                                            var elf_accountList = [];
                                            if(res.content.groupList instanceof Array && res.content.groupList.length > 0){
                                                var tmplist = [];
                                                for(var i = 0; i<res.content.groupList.length; i++){
                                                    var ele = res.content.groupList[i]
                                                    if (ele.creator === response.content.id ) {
                                                        tmplist.push(ele)
                                                    } else {
                                                        for(var j = 0; j< ele.serviceUserList.length; j++){
                                                            if( ele.serviceUserList[j].accountId === response.content.id) {
                                                                tmplist.push(ele)
                                                            }
                                                        }
                                                    }
                                                }
                                                res.content.groupList = tmplist
                                                for(var i = 0;i<res.content.groupList.length;i++){
                                                    var obj = {};
                                                    // var levelName = '员工';
                                                    if(res.content.groupList[i].creator === response.content.id) {
                                                        // 你的店
                                                        elf_accountList.push({
                                                            hqName: res.content.groupList[i].name,
                                                            levelName: "老板",
                                                            mgjsys_type: "elf",
                                                            nickName: res.content.groupList[i].contact,
                                                            osName: res.content.groupList[i].name,
                                                            userName: res.content.groupList[i].contact,
                                                            groupId: res.content.groupList[i].id
                                                        })
                                                    } else {
                                                        if(res.content.groupList[i].serviceUserList instanceof Array){
                                                            // 别人的店
                                                            for (var j = 0; j < res.content.groupList[i].serviceUserList.length; j++) {
                                                                if (res.content.groupList[i].serviceUserList[j].accountId === response.content.id) {
                                                                    elf_accountList.push({
                                                                        hqName: res.content.groupList[i].name,
                                                                        levelName: "员工",
                                                                        mgjsys_type: "elf",
                                                                        nickName: res.content.groupList[i].serviceUserList[j].name,
                                                                        osName: res.content.groupList[i].name,
                                                                        userId: res.content.groupList[i].serviceUserList[j].id,
                                                                        userName: res.content.groupList[i].serviceUserList[j].name,
                                                                        groupId: res.content.groupList[i].id
                                                                    })
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            self.elf_accountList = elf_accountList;
                                            // 存储小精灵 登录用户信息
                                            self.elf_info = {
                                                "elf__User-Info": {
                                                    value: response.content
                                                },
                                                "elf__Access-Token": {
                                                    value: response.token
                                                },
                                                "mgjsys_type": "elf"
                                            }
                                            localStorage.setItem('elf__User',JSON.stringify(self.elf_info))
                                            callback && callback(elf_accountList);
                                        },
                                        error:function(){
                                            callback && callback();
                                        }
                                    });
                                }else {
                                    callback && callback();
                                }
                            },
                            error:function(){
                                callback && callback();
                            }
                        })
                    }else {
                        // 没账号
                        callback && callback();
                    }
                },
                error: function (err) {
                    callback && callback();
                },
            });
        },
        checkUser: function(callback,refresh) {
            var sys_type = JSON.parse(window.localStorage.getItem('mgjLoginType'));
            if(sys_type=='elf' && !refresh){
                callback && callback();
                return;
            }

            if(this.currentCluster && !refresh){
                callback && callback();
                return;
            }

            if(amGloble.isNull(serverClusterConfig)){
                callback && callback();
                return;
            }

            var serverClusterConfigTemp = JSON.parse(JSON.stringify(serverClusterConfig));
            var serverCluster = [];
            for(var key in serverClusterConfigTemp){
                serverCluster.push({
                    name: key,
                    url: serverClusterConfigTemp[key].url,
                    ping: serverClusterConfigTemp[key].ping,
                });
            }

            if(!serverCluster.length){
                return;
            }

            this.serverCluster = serverCluster;

            this.checkUserReset();

            if(callback){
                this.checkUserCallback = callback;
            }else {
                this.checkUserCallback = null;
            }

            this.changeStatus(1);

            this.setSelfToMainCheck();

            for(var i=0;i<this.serverCluster.length;i++){
                this.ajax(this.serverCluster[i].url,i);
            }
        },
        checkUserReset:function(){
            this.result = [];
            this.successNumber = 0;
            this.currentCluster = null;
        },
        changeConfig: function(cluster,callback){
            var baseUrl = config.baseUrl;
            config.baseUrl = config.baseUrl.replace(baseUrl,cluster.url);
            if(serverClusterConfig && serverClusterConfig[cluster.cluster]){
                config.ping = serverClusterConfig[cluster.cluster].ping || [];
                if(serverClusterConfig[cluster.cluster].filesMgr){
                    config.filesMgr = serverClusterConfig[cluster.cluster].filesMgr;
                }
            }
            this.setCluster(cluster);
            callback && callback();
        },
        setCluster: function(cluster){
            localStorage.setItem('CLUSTER',JSON.stringify(cluster));
            this.currentCluster = cluster;
            this.$cluster.show();
            this.$clusterName.text(cluster.cluster);
            this.$clusterShopName.text(cluster.shopName);
            this.changeStatus(4);
        },
        setSelfToMainCheck: function(){
            for(var key in this.serverCluster){
                var ping = this.serverCluster[key].ping;
                if(ping && ping.length){
                    for(var i=0;i<ping.length;i++){
                        if(ping[i].replace('https://','').replace('http://','').indexOf(config.baseUrl.replace('https://','').replace('http://','')) != -1){
                            this.serverCluster[key].url = ping[i];
                            break;
                        }
                    }
                }
            }
            for(var key in this.serverCluster){
                var ping = this.serverCluster[key].ping;
                if(ping && ping.length){
                    for(var i=0;i<ping.length;i++){
                        if(ping[i].indexOf(this.serverCluster[key].url) != -1){
                            this.serverCluster[key].ping.splice(i,1);
                            break;
                        }
                    }
                }
            }
        },
        end: function(){

            var aviable = [];
            for(var i=0;i<this.result.length;i++){
                if(this.result[i].data && this.result[i].data.length){
                    aviable = aviable.concat(this.result[i].data);
                }
            }
            this.checkUserCallback && this.checkUserCallback(aviable);
        },
        watch: function(){
            var checkNumber = 0;
            for(var i=0;i<this.result.length;i++){
                if(this.result[i]){
                    checkNumber ++;
                }
            }
            if(checkNumber==this.serverCluster.length){
                this.end();
            }
        },
        success: function(index,flag,data){
            var self = this
            var clusterResult = {
                flag: flag
            };
            if(flag){
                clusterResult.data = data;
                self.successNumber ++;
            }
            self.result[index] = clusterResult;
            self.watch();
        },
        ajax: function(url,index,pingIndex){
            var _this = this;
            var opt = {
                userName: this.userName
            }
            var ping = _this.serverCluster[index].ping;
            $.ajax({
                url: url + 'shengyibao/mobile/user/check',
                data: JSON.stringify(opt),
                type: "POST",
                timeout: 3000,
                contentType: "application/json",
                success: function (ret) {
                    if(ret && ret.code==0 && ret.content && ret.content.list && ret.content.list.length){
                        for(var i=0;i<ret.content.list.length;i++){
                            var user = ret.content.list[i];
                            user.url = url;
                            user.cluster = ret.content.cluster;
                            user.existence = ret.content.existence;
                        }
                        _this.success(index,true,ret.content.list);
                    }else {
                        if(ping && ping.length){
                            if(pingIndex == undefined){
                                for(var i=0;i<ping.length;i++){
                                    _this.ajax(ping[i],index,i);
                                }
                            }else {
                                if(pingIndex>=ping.length-1){
                                    if(!_this.result[index]){
                                        _this.success(index,false);
                                    }
                                }
                            }
                        }else {
                            _this.success(index,false);
                        }
                    }
                },
                error: function (ret) {
                    if(ping && ping.length){
                        if(pingIndex == undefined){
                            for(var i=0;i<ping.length;i++){
                                _this.ajax(ping[i],index,i);
                            }
                        }else {
                            if(pingIndex>=ping.length-1){
                                if(!_this.result[index]){
                                    _this.success(index,false);
                                }
                            }
                        }
                    }else {
                        _this.success(index,false);
                    }
                }
            });
        },
        beforeShow: function (ret) {
            if (amGloble.hideEducation || amGloble.metadata.configs.hideEducation === "true") {
                // 不显示学堂则不显示登录页面的back按钮
                this.$.find('.am-backbutton').hide();
            } else {
                this.$.find('.am-backbutton').show();
            }
            if (ret == "logout") {
                this.logout();
            } else if (ret == "logoutWithoutReload") {
                this.reset(true, true);
            }
            if(ret && ret.id){
                this.backInfo = ret;
            }
            this.render();

            var cluster = localStorage.getItem('CLUSTER')?JSON.parse(localStorage.getItem('CLUSTER')):'';
			if(cluster){
				this.$clusterName.text(cluster.cluster);
				this.$clusterShopName.text(cluster.shopName);
				this.changeStatus(4);
                this.changeConfig(cluster);
            }

            this.setVcCode();
            this.$loginBtn.removeClass('am-disabled').text('登录');
            this.lockLoginTimer && clearInterval(this.lockLoginTimer);

            this.elf_accountList = [];
            this.checkUserRetryTime = 0;
        },
        afterShow: function() {
            //处理点穿的问题
            this.$username.prop("disabled", false);
            this.$password.prop("disabled", false);
        },
        beforeHide: function() {
            this.$username.prop("disabled", true);
            this.$password.prop("disabled", true);
        },
        afterHide: function() {
            this.backInfo = null;
        },
        saveConfig: function(userinfo) {
            $.extend(true, window.config, userinfo);
            localStorage.setItem("BusinessAppV2_config", JSON.stringify(window.config));
        },
        elf_login: function(user,userName){
            var self = this;
            if(user.userId){
                self.elf_info['elf__User-Info'].value.userId = user.userId
            }
            self.elf_info['elf__User-Info'].value.groupId = user.groupId
            self.elf_info['elf__User-Info'].value.levelName = user.levelName
            self.elf_info['elf__User-Info'].value.userName = user.userName
            self.elf_info['elf__User-Info'].value.shopName = user.shopName
            window.localStorage.setItem('elf__User-Info', JSON.stringify(self.elf_info['elf__User-Info']))
            window.localStorage.setItem('elf__Access-Token', JSON.stringify(self.elf_info['elf__Access-Token']))
            window.localStorage.setItem('mgjsys_type', 'elf');
            // debugger
            var info = JSON.stringify(self.elf_info)
            // 登录账号(手机号保存 退出后可以显示上一次登录的账号)
            if(userName!='17788889999'){
                self.saveConfig({
                    phone: userName,
                });
                window.localStorage.setItem('mgjLoginType', 'elf');
            }
            // debugger
            window.location.href = 'elf/index.html?info=' + info
        },
        login: function(userName, pwd, code, user,cb,fcb,scb) {
            var self = this;
            var switchAccount = user && user.switchAccount;
            var elf = user && user.mgjsys_type && user.mgjsys_type === 'elf';
            amGloble.loading.show("正在登录,请稍候...");
            var closePushToken = window.localStorage.getItem('closePushToken');
            var params = {
                "parentShopId": user && user.parentShopId,
                "userId": user && user.userId,
                "userName": userName,
                "password": pwd,
                "userType": user && user.userType,
                "deviceType": device.platform != "Android" ? 1 : 2,
                "deviceId": device.uuid,
                "sysInfo": "",
                "pushToken": config.pushToken,
                "code": code,
                active: Number(closePushToken) === 1 ? 0 : 1,
            }
            if (user && user.switchAccount) {
                params.loginType = 2;
                params.token = window.config ? window.config.token : null;
            }
            if(userName!='17788889999'){
                self.saveConfig({
                    phone: userName,
                });
            }
            amGloble.api.login.exec(params, function(ret) {
                // console.log(ret);
                amGloble.loading.hide();
                if (ret.content && ret.content.userInfo && ret.content.userInfo.pwFlag == '0' && ret.content.userInfo.userType == '0') {
                    var userinfo = ret.content.userInfo;
                    if (switchAccount) {
                        userinfo.switchAccount = true;
                    }
                    var params = {
                        phone: ret.content.mobile || userName,
                        shopId: ret.content.userInfo.shopId,
                        userId: ret.content.userInfo.userId,
                        userType: ret.content.userInfo.userType,
                        type: 'checkPhone',
                        scb: function() {
                            amGloble.msg('校验成功！');
                            self.login(userName, pwd, code, userinfo, function () {
                                setTimeout(function() { 
                                    location.reload();
                                 }, 500)
                            });
                        }
                    }
                    window.RouterUtils.push({name:'validatePhoneNum',params:params,animation:'slideleft'});

                    return;
				}

                if (ret.code == 0 && ret.content) {
                    //登录成功
					// console.log(ret);
                    var parentShopId = ret.content.userInfo.parentShopId;
                    self.selectedUserId = ret.content.userInfo.userId
                    self.saveConfig({
                        parentShopId: parentShopId,
                        token: ret.content.token
                    });
                    try {
                        var aTextInfo = JSON.stringify({ tenantId: parentShopId });
                        atMobile.setExtInfo(aTextInfo, function() {
                            $.am.debug.log('设置 extInfo success');
                            $.am.debug.log(aTextInfo);
                        }, function(error) {
                            $.am.debug.log('设置 extInfo error: ');
                            $.am.debug.log(error);
                        })
                    } catch (error) {
                        $.am.debug.log('setExtInfo error: ')
                        $.am.debug.log(error)
                    }
					var themeTenantId = localStorage.getItem(themeSetting.tenantIdCacheKey);
                    localStorage.removeItem('errorInfo'+userName);
                    // 判断是否更换了用户，若更换了用户，则清除其他用户的 metadata
                    self.resetMetadata(ret.content.userInfo);
                    self.getMetadata(function() {
                        $.am.debug.log("get localStorage theme tenantid: " + themeTenantId);
                        if (!themeTenantId || themeTenantId != parentShopId) {
                            $.am.debug.log("重置主题，local tenantid：" + themeTenantId + '|| 用户的 tenantid: ' + parentShopId);
                            var themeConfigKey = amGloble.metadata.configs.themeConfigKey;
                            if (!themeConfigKey && amGloble.metadata.userInfo.mgjVersion == '2') {
                                themeConfigKey = 'themeColor5'; // 风尚版默认配色
                            }
                            themeSetting.set(parentShopId, themeConfigKey);
                        }
                        amGloble.page.community.shopId = null;
                        //有密码则正常进入，无密码则设置密码
                        var user = amGloble.metadata.userInfo;
                        if(userName!='17788889999'){
                            window.localStorage.setItem('mgjLoginType','syb');
                        }
                        if (amGloble.hideEducation) {
                            if (amGloble.metadata.userInfo.mgjVersion === 5) {
                                window.RouterUtils.push({ name: 'marketingDashboard' })
                                $.am.changePage(amGloble.page.vueApp, "slideleft");
                            } else {
                                $.am.changePage(amGloble.page.dashboard, "slideleft");
                            }
                        }
                        if(self.backInfo){
                            $.am.changePage(amGloble.page.videodetails, "slideleft",self.backInfo);
                            return
                        }
                        // if(amGloble.page.education.$.find('.tab-main .active').index()==1){

                        //     $.am.changePage(amGloble.page.dashboard, "slideleft");
                        // }else if(amGloble.page.education.$.find('.tab-main .active').index()==2) {
                        //     $.am.changePage(amGloble.page.userinfo, "slideleft");
                        // }
                        cb && cb();
                    });
                } else if (ret.code == 203005) {
                    var user = ret.content;
                    // $.am.changePage(amGloble.page.userinfoResetPwd, "slideleft", {
                    //     phone: user.mobile || userName,
                    //     shopId: user.shopId,
                    //     userId: user.userId,
                    //     userType: user.userType,
                    //     backPage: amGloble.page.login,
                    //     scb: function() {
                    //         amGloble.msg('密码设置成功，请登录！');
                    //         $.am.page.back();
                    //     }
                    // });
                    var params = {
                        phone: user.mobile || userName,
                        shopId: user.shopId,
                        userId: user.userId,
                        userType: user.userType,
                        scb: function() {
                            amGloble.msg('密码设置成功，请登录！');
                            $.am.page.back();
                        }
                    }
                  window.RouterUtils.push({name:'validatePhoneNum',params:params,animation:'slideleft'})
                } else if ((ret.code == 200001 && ret.content.length) || elf) {
                    //出现重复用户
                    self.chooseUser(ret.content, function (user) {
                        if (user.mgjsys_type && user.mgjsys_type === 'elf') {
                            console.log(user);
                            self.elf_login(user,userName);
                        } else {
                            self.elf_accountList = []
                            user.onlyLogin = true;
                            self.login(userName, pwd, code, user, cb);
                        }
                    });

                } else if (ret.code == 203017){
                    if(fcb){
                        fcb();
                    }else{
                        //需要绑定手机号
                        var _userInfo = ret.content.userInfo;
                        $.am.changePage(amGloble.page.userinfoResetPwd, "slideleft", {
                            shopId: _userInfo.shopId,
                            userId: _userInfo.userId,
                            userType: _userInfo.userType,
                            boundPhone: true
                        });
                    }

                }else if(ret.code == 200003){
                    if(!ret.content){
                        fcb && fcb(ret);
                        amGloble.msg('用户名或密码错误，请重新输入！');
                        return;
                    }
                    localStorage.setItem('errorInfo'+userName,JSON.stringify(ret.content));
                    if(ret.content.failedLoginTimes==1){
                        fcb && fcb(ret);
                        amGloble.msg('用户名或密码错误，请重新输入！');
                    }else if(ret.content.failedLoginTimes>=2 && ret.content.failedLoginTimes<=4){
                        atMobile.nativeUIWidget.confirm({
                            caption: '用户名或密码错误',
                            description: '用户名或密码错误第'+ret.content.failedLoginTimes+'次，连续5次输入错误账号将被锁定，请重新输入！',
                            okCaption: '确定',
                            cancelCaption: '取消'
                        }, function(){

                        }, function(){

                        });
                    }else if(ret.content.failedLoginTimes>=5){
                        var diff = self.getLockTs(ret.content.lastLoginTime,ret.content.failedLoginTimes,ret.content.nowTime);
                        var timeStr = self.getLockStr(ret.content.failedLoginTimes);
                        atMobile.nativeUIWidget.confirm({
                            caption: '用户名或密码错误',
                            description: '用户名或密码错误过于频繁，您的账号被锁定'+timeStr+'！',
                            okCaption: '确定',
                            cancelCaption: '取消'
                        }, function(){

                        }, function(){

                        });
                        self.setLoginStatus(userName);
                    }
                    self.setVcCode();
                }
                else if(ret.code == 203019){
                    localStorage.setItem('errorInfo'+userName,JSON.stringify(ret.content));
                    var diff = self.getLockTs(ret.content.lastLoginTimeStamp,ret.content.failedLoginTimes,ret.content.nowTime);
                    var timeStr = self.getLockStr(ret.content.failedLoginTimes);
                    atMobile.nativeUIWidget.confirm({
                        caption: '用户名或密码错误',
                        description: '用户名或密码错误过于频繁，您的账号被锁定'+timeStr+'！',
                        okCaption: '确定',
                        cancelCaption: '取消'
                    }, function(){

                    }, function(){

                    });
                    self.setLoginStatus(userName);
                    self.setVcCode();
                }else if(ret.code == 20190306){
                    amGloble.msg(ret.message || "验证码校验失败!");
                    self.setVcCode(1);
                    fcb && fcb(ret)
                } else if (ret.code == 203018) {
					amGloble.msg(ret.message);
				} else if (ret.code == 2022072501) {
                    // 切换账号密码错误
                    fcb && fcb(ret)
                } else if (ret.code == 2022072502) {
                    // 切换账号未设置密码
                    fcb && fcb(ret)
                } else {
                    //登录失败
                    if(self.elf_errormsg){
                        amGloble.msg(self.elf_errormsg || "数据获取失败,请检查网络!");
                    }else {
                        amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                    }
                }
            }, true);
        },
        chooseParentShop: function(array, scb) {
            if (array.length > 1) {
                amGloble.popup.list.show({
                    title: "选择商户",
                    content: "登录名重复，请选择商户",
                    data: array,
                    shownKeys: ["hqName"],
                    scb: function(parentShop) {
                        scb && scb(parentShop);
                    }
                });
            } else {
                scb && scb(array[0]);
            }
        },
        chooseUser: function(array, scb, options, isSelect) {
            for(var i=0;i<array.length;i++){
                array[i].viewShopName = (array[i].osName==' ' || array[i].osName=='' || array[i].osName==null)?((array[i].shopName==' ' || array[i].shopName=='' || array[i].shopName==null)?'门店名称未设定':array[i].shopName):array[i].osName;
                array[i].tenantName = array[i].hqName || array[i].shopName;
                array[i].newRole = array[i].userType == 1 ? (-1 * array[i].role) : array[i].role;
            }
            var opt = $.extend({
                title: '选择角色',
                content: '您有多个账号，请选择账号登录',
            }, options)
            if (array.length > 1 || isSelect) {
                array.sort(function(prevData, nextData) {
                    return Number(nextData.newRole) - Number(prevData.newRole);
                })
                array.sort(function(prevData, nextData) {
                    return prevData.shopId - nextData.shopId;
                })
                array.sort(function(prevData, nextData) {
                    return prevData.parentShopId - nextData.parentShopId;
                })
                amGloble.popup.list.show({
                    title: opt.title,
                    content: opt.content,
                    data: array,
                    shownKeys: ["viewShopName", "levelName", "userName", "tenantName"],
                    scb: function(user) {
                        scb && scb(user);
                    },
                });
            } else {
                scb && scb(array[0]);
            }
        },
        getMetadata: function(scb, refresh, hideLoading) {
            var _this = this;
            var getOnce = function() {
                !hideLoading && amGloble.loading.show("正在登录,请稍候...");
                amGloble.api.metadata.exec({
                    parentShopId: config.parentShopId,
                    token: config.token,
                    empId: _this.selectedUserId || null
                }, function(ret, isLocal) {
                   !hideLoading && amGloble.loading.hide();
                   if (ret.code == 0 && ret.content) {
                        amGloble.metadata = amGloble.processMetadata($.extend(true, {}, ret.content));
                        amGloble.setLastMetadataCacheKey();
                        //初始化下拉菜单
                        amGloble.storeSelect.init();
                        amGloble.empSelect.init();
                        scb && scb();
                    } else if ([203009, 2022021532].indexOf(ret.code) !== -1 ) {
                        amGloble.msg("请重新登录！");
                        $.am.changePage(amGloble.page.login, "slideright", "logout");
                    } else {
                        if(confirm("获取数据失败，确定重试吗？")){
                            getOnce();
                        }
                        // amGloble.messageBox("获取数据失败", "点击确认重试", function() {

                        // });
                    }
                }, refresh);
            }

            getOnce();

        },
        getStoregeIgnoreData: function() {
            var ignoreKeyList = ['isFirstSign','privacyAgreement'];
            var data = {};
            var metadataKeyList = amGloble.getMetadataCacheKeyList();
            var keyList = ignoreKeyList.concat(metadataKeyList);
            keyList.forEach(function(key) {
                var cacheData = window.localStorage.getItem(key);
                if (cacheData) {
                    data[key] = cacheData;
                }
            })
            return data;
        },
        resetMetadata: function(userInfo) {
            if (!userInfo) return;
            var currentKey = amGloble.getMetaStorageKey(userInfo);
            var lastKey = amGloble.getLastMetadataCacheKey();
            if (currentKey !== lastKey) {
                amGloble.metadata = null; // 如果是切换账号，则清空当前的 metadata
                amGloble.setLastMetadataCacheKey(currentKey);
            }
            var cacheData = window.localStorage.getItem(lastKey);
            var cacheMetadata = null;
            try {
                cacheMetadata = cacheData ? JSON.parse(cacheData) : null;
            } catch (error) {
                $.am.debug.log('resetMetadata json parse error');
                console.log('error', error);
            }
            if (!cacheMetadata || cacheMetadata.userInfo.mobile !== userInfo.mobile) {
                var keyList = amGloble.getMetadataCacheKeyList();
                keyList.forEach(function(key){
                    window.localStorage.removeItem(key);
                })
            }
        },
        reset: function(logout, dontReload) {
            if (!config.demoUser && logout) {
                //如果不是演示账号，并且是登出操作，则只清理token
                this.saveConfig({
                    token: ""
                });
            } else {
                var ignoreCacheData = this.getStoregeIgnoreData();
                localStorage.clear();
                for(var key in ignoreCacheData) {
                    window.localStorage.setItem(key, ignoreCacheData[key]);
                }
            }
            this.$username.val("");
            this.$password.val("");
            this.$title.empty();
            if (!dontReload) {
                location.reload();
            }
        },
        logout: function(dontReload) {
            var self = this;
            var user = amGloble.metadata.userInfo;
            amGloble.api.logout.exec({
                "userId": user.userId,
                "userType": user.userType,
            }, function(ret) {
                if (ret.code == 0) {} else {
                    amGloble.msg(ret.message || "数据获取失败,请检查网络!");
                }
                self.reset(true, dontReload);
            });
        },
        render: function(cluster) {
            var _this = this;
            this.$username.val(config.phone || this.userName || "");
            this.$password.val("");
            delete this.demoUser;
		},
		saveServerConfig: function(appid, scb) {
            var self = this;
            setTimeout(function() {
                navigator.appplugin.changeAppInfo({
                    "appid": appid,
                    "masserver": "http://mas.meiguanjia.net",
                    "tenantid": "",
                }, function(msgCode) {
                    $.am.debug.log("changeAppInfo:succ");
                    scb && scb();
                }, function(msg) {
                    alert(msg);
                });
            }, 100);
        },
        resetServerConfig: function(scb) {
            setTimeout(function() {
                navigator.appplugin.removeAppInfo(function(msgCode) {
                    $.am.debug.log("resetConfig:succ");
                    scb && scb();
                }, function(msg) {
                    alert(msg);
                });
            }, 100);
        },
        getLockTs: function(lastLoginTimeStamp,failedLoginTimes,nowTime){
            var totalTs = 0;
            if(config.baseUrl.indexOf("test") != -1 || config.baseUrl.indexOf("develop") != -1 || config.baseUrl.indexOf("youngb") != -1){
                if(failedLoginTimes==5){
                    totalTs = 1*60*1000;
                }else if(failedLoginTimes==6){
                    totalTs = 3*60*1000;
                }else if(failedLoginTimes>=7){
                    totalTs = 5*60*1000;
                }
            }else {
                if(failedLoginTimes==5){
                    totalTs = 60*1000;
                }else if(failedLoginTimes==6){
                    totalTs = 15*60*1000;
                }else if(failedLoginTimes>=7){
                    totalTs = 24*60*60*1000;
                }
            }

            if(nowTime){
				var timeDuration = nowTime - new Date().getTime();
				localStorage.setItem('_timeDuration',timeDuration);
			}

			var ts = localStorage.getItem('_timeDuration')*1 || 0;

			var unLockTs = lastLoginTimeStamp + totalTs;
			var diff = unLockTs - (new Date().getTime() + ts);
			return diff;
		},
		getTimeStr: function(ts){
			var leave1 = ts%(24*3600*1000);
            var h = Math.floor(leave1/(3600*1000));
            var leave2 = leave1%(3600*1000);
            var m = Math.floor(leave2/(60*1000));
            var leave3 = leave2%(60*1000);
            var s = Math.round(leave3/1000);
			return this.addZero(h) + ':' + this.addZero(m) + ':' + this.addZero(s);
        },
        getLockStr: function(failedLoginTimes){
            if(config.baseUrl.indexOf("test") != -1 || config.baseUrl.indexOf("develop") != -1 || config.baseUrl.indexOf("youngb") != -1){
                if(failedLoginTimes==5){
                    return '1分钟'
                }else if(failedLoginTimes==6){
                    return '3分钟'
                }
                else if(failedLoginTimes>=7){
                    return '5分钟'
                }
            }else {
                if(failedLoginTimes==5){
                    return '1分钟'
                }else if(failedLoginTimes==6){
                    return '15分钟'
                }
                else if(failedLoginTimes>=7){
                    return '24小时'
                }
            }
			return '';
		},
		addZero: function(num){
			if(num<10){
				num = '0' + num;
			}
			return num;
		},
        setLoginStatus: function(userName){
            var _this = this;
			this.$loginBtn.removeClass('am-disabled').text('登录');
			this.lockLoginTimer && clearInterval(this.lockLoginTimer);
			var errorInfo = localStorage.getItem('errorInfo'+userName)?JSON.parse(localStorage.getItem('errorInfo'+userName)):null;
			if(!errorInfo){
				return;
			}
			var diff = this.getLockTs(errorInfo.lastLoginTimeStamp,errorInfo.failedLoginTimes);
			if(diff>0){
				this.$loginBtn.addClass('am-disabled').text('账号被锁定（'+ this.getTimeStr(diff) +'）');
				this.lockLoginTimer = setInterval(function(){
					diff -= 1000;
					if(diff>0){
						_this.$loginBtn.addClass('am-disabled').text('账号被锁定（'+ _this.getTimeStr(diff) +'）');
					}else {
						clearInterval(_this.lockLoginTimer);
						_this.$loginBtn.removeClass('am-disabled').text('登录');
					}
				},1000);
			}
		},
        setVcCode: function(force){
			var username = this.$username.val();
            this.$vcCode.val('');
            this.$vcCodeWrap.hide();
			if(username){
                if(!force){
                    var errorInfo = localStorage.getItem('errorInfo'+username)?JSON.parse(localStorage.getItem('errorInfo'+username)):null;
                    if(!errorInfo){
                        return;
                    }
                }
				var src = config.baseUrl + 'shengyibao/mobile/user/vc2?userKey='+username+'&ts='+new Date().getTime();
				this.$vcCodeImg.attr('src',src);
				this.$vcCodeWrap.show();
			}else {
				this.$vcCodeWrap.hide();
			}
        }
    });

})();
