amGloble.page.mallTotal = new $.am.Page({
	id : "page-mallTotal",
	init:function(){
        var self=this;
        
		this.$headerClick=this.$.find(".header .nav li").vclick(function(){
            var idx=$(this).index();
            self.$nav=idx;
            $(this).addClass("selected").siblings().removeClass('selected');
            self.rendeHeader(idx);
        });
        
        this.$.find(".header .withDraw").vclick(function(){
            $.am.changePage(amGloble.page.withDraw, "slideleft");
        });
        this.$nav=0;
        this.headName=["day","month","year"];

        this.$malltotal=this.$.find(".totalValue .malltotal");//销售总额
        this.$mallamount=this.$.find(".totalValue .mallamount");//订单笔数
        this.$saleProject=this.$.find(".centerProject .saleProject");//售卖中的项目
        this.$client=this.$.find(".centerProject .client");//购买的客户

        this.$error = this.$.find("div.am-page-error");
        this.$error.find(".button-common").vclick(function() {
            self.getData();
        });
        this.$reportList=[{report:{
            name:"门店PK",
            filter:"",
            apiName:"mallreportStopPK",
            dataProcessor: function(data) {
                return data;
            }
        }},{report:{
            name:"分类汇总",
            apiName:"reportCategory",
            filter:"showCategory",
            dataProcessor: function(data) {
                return data;
            },
            paramsFilter: function (defultParam) {
                if (self.paras && self.paras.shops) {
                    defultParam.distrShopId = self.paras.shops.shopId;
                }
                return defultParam;
            }
        }},{report:{
            name:"明细汇总",
            filter:"showCategory",
            apiName:"reportItem",
            paramsFilter: function (defultParam) {
                if (self.paras && self.paras.shops) {
                    defultParam.distrShopId = self.paras.shops.shopId;
                }
                return defultParam;
            }
        }}];
        this.$.find(".bottomList ul li").vclick(function(){
            var idx=$(this).index();
            $.am.changePage(amGloble.page.reportStandard, "slideleft",{ report: self.$reportList[idx].report, shops: self.paras.shops });
        });
        this.$dv = this.$.find(".mainTable");

        this.$.find(".centerProject .left").vclick(function(){
            var src=window.config.shareRoot+"tenantId="+amGloble.metadata.userInfo.parentShopId+"&view=3";
            window.open(src,'_blank','location=no');
        });
	},
	beforeShow:function(ret){
        if (ret == "back") {
            return;
        }
        this.paras = ret; // { shops: {}, report: {} }
        if (ret && ret.shops) {
            // 如果是门店隐藏门店PK，代收代付
            this.$.find(".header .withDraw").hide();
            this.$.find(".bottomList .clear .store").hide();
        } else {
            this.$.find(".header .withDraw").show();
            this.$.find(".bottomList .clear .store").show();
        }
        var sybPowerStr = amGloble.metadata && amGloble.metadata.userInfo.sybPowerStr;
        if(sybPowerStr && sybPowerStr != ',,') {
            if(sybPowerStr.indexOf(",mallreportStopPK,") == -1) {
                this.$.find(".bottomList .store").hide();
            } else {
                this.$.find(".bottomList .store").show();
            }
            if(sybPowerStr.indexOf(",reportCategory,") == -1) {
                this.$.find(".bottomList .classtotal").hide();
            } else {
                this.$.find(".bottomList .classtotal").show();
            }
            if(sybPowerStr.indexOf(",reportItem,") == -1) {
                this.$.find(".bottomList .Details").hide();
            } else {
                this.$.find(".bottomList .Details").show();
            }
        }
	},
	afterShow:function(ret){
        if (ret == "back") {
            return;
        }
		this.getData();
	},
    render:function(ret){
        if(ret.content){
            this.$data=ret.content;
            this.rendeHeader(this.$nav);
            this.$saleProject.text(ret.content.project.saleProject);
            this.$client.text(ret.content.project.client);
        }
    },
    rendeHeader:function(idx){
        var data=this.$data,headData;
        var headName=this.headName;
        for(var i in data){
            if(i==headName[idx]){
                headData=data[i];
            }
        }
        this.$malltotal.text(headData.total);
        this.$mallamount.text(headData.amount);
    },
    getData:function(scb){
        var self=this;
        var params = {
            parentShopId: amGloble.metadata.userInfo.parentShopId
        };
        if (self.paras && self.paras.shops) {
            params.shopId = self.paras.shops.shopId;
        }
        this.setStatus("loading");
        amGloble.api.mallPandect.exec(params, function(ret) {
            // amGloble.loading.hide();
            console.log(ret);
            if (ret.code == 0) {
                self.setStatus("normal");
                self.render(ret);
            } else {
                self.setStatus("error");
            }
        });
    }
});

