(function() {
    var self = amGloble.page.msgDetail = new $.am.Page({
        id: "page-msg-detail",
        init: function() {
            this.$parentShop = this.$.find('.parent');
            this.$parentShopItem = this.$parentShop.find('.wrap').eq(0);
            this.$shops = this.$.find('.shops')
            this.$shopsItem = this.$shops.find('.wrap').eq(0);

            this.$checkRecord = this.$.find('.am-header .noteRenew').vclick(function(){
                var data = {
                    shopId: amGloble.metadata.userInfo.shopId,
                    osName: amGloble.metadata.userInfo.osName,
                    name: amGloble.metadata.userInfo.shopName
                };
                $.am.changePage(amGloble.page.msgRecord, "slideleft",data);
            });
            // 续费记录
            this.$checkRenewList = this.$.find('.am-header .Renew').vclick(function(){
                var data = {
                    shopId: amGloble.metadata.userInfo.shopId,
                    osName: amGloble.metadata.userInfo.osName,
                    name: amGloble.metadata.userInfo.shopName
                };
                $.am.changePage(amGloble.page.msgRenewList, "slideleft",data);
            });

            this.$.on('vclick','.btn',function(){       
                var data = $(this).parent().data('data');
                if(!self.isControledShop(data.shopId) || !data.smsFee){
                    return;
                }
                $.am.changePage(amGloble.page.msgTrans, "slideleft",data);
            }).on('vclick','.toRecharge',function(){
                var data = $(this).parent().data('data');
                if(!self.isControledShop(data.shopId)){
                    return;
                }
                $.am.changePage(amGloble.page.msgCharge, "slideleft",data);
            }).on('vclick','.renew',function(){
                var data = $(this).parent().data('data');
                if (data.invaldate) {
                    var invaldTime = new Date(data.invaldate);
                    var currentTime = new Date().getTime();
                    var diffTime = currentTime - invaldTime;
                    if (diffTime > 90 * 24 * 3600 * 1000) {    
                        amGloble.msg('门店已到期超3个月，请联系美管加客服');
                        return;
                    }
                }
                var Signflag= self.getSignflag(data.shopId);
                if(Signflag===0){
                    amGloble.msg('未签约门店不支持自助续费！');
                }else{
                    if (self.allUnpayedData && self.allUnpayedData[data.shopId] && self.allUnpayedData[data.shopId].count > 1) {
                        window.RouterUtils.push({
                            name: 'unpayed',
                            animation: 'slideleft',
                            params: { shopId: data.shopId }
                        })
                    } else {
                        // 单条欠款或者没有欠款，跳转续费页面
                        data.unpayType = 1;
                        data.backName = "msgDetail";
                        var firstUnpayed;
                        if (self.allUnpayedData && self.allUnpayedData[data.shopId]) {
                            firstUnpayed = JSON.parse(JSON.stringify(self.allUnpayedData[data.shopId].data[0]));
                            firstUnpayed.backName = "msgDetail";
                        }
                        $.am.changePage(amGloble.page.msgRenew, "slideleft", firstUnpayed ? firstUnpayed : data);
                    }
                    // $.am.changePage(amGloble.page.msgRenew, "slideleft",data);
                    // $.am.debug.log('-----------------------',data);
                }
                
            });

            this.$promotion = this.$.find('.promotion');

            this.$.find('.am-header .icon-gengduo1').vclick(function(){
                $('.am-header .reocrd').slideDown(200);
                $('.am-header .reocrd').show();  
                $('.covering').show();
            });
            this.$.find('.covering').vclick(function(){
                $('.am-header .reocrd').hide();
                $('.covering').hide();
            });
        },
        beforeShow: function(clearCache) {
            if(typeof clearCache == 'object') {
                this.options = clearCache;
            } else {
                this.options = undefined
            }
            var _this = this;
            if (this.nowUserId != amGloble.metadata.userInfo.userId) {
                this.allUnpayedData = undefined;
                this.nowUserId = amGloble.metadata.userInfo.userId;
            }
            self.getAllUnPayed(function() {
                _this.$parentShop.empty();
                _this.$shops.empty();
                _this.scrollview.scrollTo('top');
                amGloble.page.treasure.getMsg(function(data){
                    self.render(data);
                },null,clearCache);
                amGloble.page.treasure.getRule(function(data){
                    if(data.act){
                        self.$promotion.find('p').html(data.act.title).end().show();
                    }
                },null,clearCache);
                $('.am-header .reocrd').hide();
                $('.covering').hide();
            })
        },
        afterShow: function() {
            
        },
        beforeHide: function() {

        },
        getSignflag:function(data){
            var allShop=amGloble.metadata.shops;
            for(var i=0;i<allShop.length;i++){
                if(data===allShop[i].shopId){
                    return allShop[i];
                }
            }
        },
        getAllUnPayed: function(cb, refresh) {
            var unpaedData = amGloble.page.dashboard.getUnpayedData();

            if (unpaedData && unpaedData.length) {
                var unPayedData = {};
                for (var i = 0; i< unpaedData.length; i++) {
                    if( unPayedData[unpaedData[i].shopid]) {
                        unPayedData[unpaedData[i].shopid].data.push(unpaedData[i]);
                        unPayedData[unpaedData[i].shopid].count++;
                    } else {
                        unPayedData[unpaedData[i].shopid] = { data: [unpaedData[i]], count: 1 }
                    }

                }
                this.allUnpayedData = unPayedData;
            }

            cb && cb();
        },
        render:function(shops){
            var _this = this;
            if(this.options && this.options.shopId) {
                var data = shops.filter(function(item){
                    return item.shopId == _this.options.shopId
                })
            } else {
                var data = amGloble.page.treasure.getControlShops(shops);
            }
            $(".last-renewinfo").hide();
            if(data.length>1){
                $('.oneShop').hide();
                $('.parent').show();
                $('.shops').show();
                for(var i=0;i<data.length;i++){
                    var $item;
                    if(data[i].shopId==amGloble.metadata.userInfo.parentShopId){
                        $item = self.$parentShopItem.clone();
                    }else {
                        $item = self.$shopsItem.clone();
                    }
                    $item.data('data',data[i]);
                    if(data[i].osName && data[i].osName.replace(/(^\s*)|(\s*$)/g,'')){
                        $item.find('.name').html(data[i].osName);
                    }else {
                        // if(data[i].shopId==amGloble.metadata.userInfo.parentShopId){
                            if(data[i].name && data[i].name.replace(/(^\s*)|(\s*$)/g,'')){
                            $item.find('.name').html(data[i].name);
                        }else {
                            $item.find('.name').html('门店名称未设定');
                        }
                    }
                    $item.find('.get-num').html(data[i].smsFee+'条');
                    $item.find('.get-time').html(data[i].invaldate);
                    
                    // 添加欠费数量的角标
                    var $badge = $item.find(".badge");
                    var shopUnPaye = this.allUnpayedData ? this.allUnpayedData[data[i].shopId] : {};
                    if (shopUnPaye && shopUnPaye.count) {
                        $item.find(".badge").html(shopUnPaye.count);
                        $badge.show();
                    } else {
                        $badge.hide();
                        if(data[i].invaldate){
                            var outDays = this.getOutDays(data[i]);
                            if(outDays > 30){
                                $item.find('.renew').hide();
                            }
                        }else {
                            $item.find('.renew').hide();
                        }
                    }

                    if(data[i].invalnum>0){
                        $item.find('.due-soon').html('即将到期').show(); 
                    }else if(data[i].invalnum==-1){
                        $item.find('.due-soon').html('已过期').show();
                    }else{
                        $item.find('.due-soon').hide();
                    }
                    if(data[i].smsFee<100){
                        $item.find('.num').addClass('warn')
                    }
                    // if(data[i].recent3Mth){
                    //     $item.find('.rencent').html('最近3个月月均使用'+data[i].recent3Mth+'条').show();
                    // }else {
                    //     $item.find('.rencent').hide();
                    // }
                    if(amGloble.metadata.userInfo.shopType==1){
                        $item.addClass('single');
                    }
                    if(!this.isControledShop(data[i].shopId) || !data[i].smsFee){
                        $item.find('.btn').addClass('disabled');
                    }
                    if(!this.isControledShop(data[i].shopId)){
                        $item.find('.toRecharge').addClass('disabled');
                    }
                    if(data[i].shopId==amGloble.metadata.userInfo.parentShopId){
                        self.$parentShop.append($item);
                        var v4_tenantLogo = amGloble.metadata.configs.v4_tenantLogo;
                        if(v4_tenantLogo){
                            $item.find('.parent-shop').html(amGloble.photoManager.createImage("tenantLogo", {
                                parentShopId: config.parentShopId
                            }, v4_tenantLogo));
                        } else {
                            $item.find('.parent-shop').empty();
                        }
                    }else {
                        self.$shops.append($item);
                    }
                    
                }
            }
            if(data.length==1){
                $('.parent').hide();
                $('.shops').hide();
                $('.oneShop').show().data('data',data[0]);
                $('.oneShop .name').html(data[0].osName);
                $('.oneShop .get-time').html(data[0].invaldate);
                $('.oneShop .get-num').html(data[0].smsFee+'条');
                var shopInfo = amGloble.metadata.shopMap[data[0].shopId];
                amGloble.api.renewLog.exec({
                    shopId: data[0].shopId,
                    parentShopId: amGloble.metadata.userInfo.parentShopId,
                    softgenre: shopInfo ? shopInfo.softgenre : undefined
                }, function(res){
                    if(res && res.code == 0) {
                        var renewInfo = res.content;
                        if(renewInfo && renewInfo.renewalTerm) {
                            var $lastRenewInfo = $(".last-renewinfo");
                            $lastRenewInfo.find(".info").empty();
                            $lastRenewInfo.find(".info").append($(
                                '<p>续期'+ renewInfo.renewalTerm +'年，'+ dateFormat(Number(renewInfo.renewalStartDate), 'yyyy-mm-dd') +'至'+ dateFormat(Number(renewInfo.renewalEndDate), 'yyyy-mm-dd') +'</p>' + 
                                '<p class="graytext">付款时间：'+ dateFormat(Number(renewInfo.renewalDate), 'yyyy-mm-dd') +'</p>'
                            ));
                            $(".last-renewinfo").show();
                        }
                    }
                }) 
                var v4_tenantLogo = amGloble.metadata.configs.v4_tenantLogo;
                if(v4_tenantLogo){
                    $('.shop-logo').html(amGloble.photoManager.createImage("tenantLogo", {
                        parentShopId: config.parentShopId
                    }, v4_tenantLogo));
                } else {
                    $('.shop-logo').empty();
                }
                if(data[0].invalnum>0){
                    $('.oneShop .due-soon').html('即将到期').show();
                }else if(data[0].invalnum==-1){
                    $('.oneShop .due-soon').html('已过期').show();
                }else{
                    $('.oneShop .due-soon').hide();
                }

                var shopUnPaye = this.allUnpayedData ? this.allUnpayedData[data[0].shopId] : {};
                if (shopUnPaye && shopUnPaye.count) {
                    $('.oneShop .renew .badge').html(shopUnPaye.count).show();
                } else {
                    $('.oneShop .renew .badge').hide();
                    if(data[0].invaldate){
                        var outDays = this.getOutDays(data[0]);
                        if(outDays > 30){
                            $('.oneShop .renew').hide();
                        }
                    }else {
                        $('.oneShop .renew').hide();
                    }
                }

                if(data[0].smsFee<100){
                    $('.oneShop .num').addClass('warn')
                }
            }
            this.scrollview.refresh();
            this.scrollview.scrollTo('top');
        },
        getOutDays: function(shop){
            var currentTime = new Date().setHours(23, 59, 59, 999);
            // var out = new Date(new Date(shop.invaldate.replaceAll('-','/')).setHours(23, 59, 59, 999)) - currentTime;
            var invaldateString = shop.invaldate.replace(new RegExp('-', 'g'), '/');
            var out = new Date(new Date(invaldateString).setHours(23, 59, 59, 999)) - currentTime;
            return out < 0 ? Math.floor(out / (24 * 3600 * 1000)) : parseInt(out / (24 * 3600 * 1000))
        },
        isControledShop:function(shopId){
            var data = JSON.parse(localStorage.getItem('msg')).data;
            var shops = amGloble.page.treasure.getControlShops(data);
            for(var i=0;i<shops.length;i++){
                if(shops[i].shopId==shopId){
                    return true;
                }
            }
            return false;
        },
        amDragTopTips: ["下拉刷新列表", "松开开始加载", "加载中..."],
        touchTop: function(){
            if(this.topLoading){
                return;
            }
            amGloble.page.treasure.getMsg(function(data){
                self.$parentShop.empty();
                self.$shops.empty();
                self.render(data);
                self.closeTopLoading();
                self.topLoading = false;
            },function(){
                self.closeTopLoading();
                self.topLoading = false;
            },true);
            
            amGloble.page.treasure.getRule(function(data){
                if(data.act){
                    self.$promotion.find('p').html(data.act.title).end().show();
                }
            },function(){

            },true);
        },
    });
})();