(function () {
    /**预约占用备注 */
    var self = amGloble.page.reservationRemark = new $.am.Page({
        id: "page-reservationRemark",
        init: function () {
            this.$.find(".left").vclick(function () {
                if (self.data.time) {
                    self.createHolder({
                        timeBar: self.data.timeBar,
                        time: self.data.time,
                    });
                }
                $.am.changePage(amGloble.page.reservation, "slideLeft", self.data.data);
            });
            this.$.find(".right").vclick(function () {
                var textareaVal = self.$.find(".textarea").val();
                if (self.data.time) {
                    self.createHolder({
                        timeBar: self.data.timeBar,
                        time: self.data.time,
                        val: textareaVal
                    });
                } else {
                    self.save({
                        id: self.data.item.id,
                        val: textareaVal
                    });
                }
            });
        },
        beforeShow: function (paras) {
            this.data = paras;
            if(paras.item){
                self.$.find(".textarea").val(paras.item.comment || "");
            }else{
                self.$.find(".textarea").val("");
            }
        },
        afterShow:function(){
            self.$.find(".textarea").prop("disabled", false);
        },
        beforeHide:function(){
            self.$.find(".textarea").prop("disabled", true);
        },
        createHolder: function (data) {
			var self = this;
			amGloble.loading.show("正在提交，请稍候...");
			var params = {
				"shopId": amGloble.metadata.userInfo.shopId,
                "type": 1,
                "comment": data.val,
                "reservationTime": data.time.getTime(),
                "barberId": amGloble.metadata.userInfo.userId,
                "barberName": amGloble.metadata.userInfo.userName,
                "barberNickname": amGloble.metadata.userInfo.nickname,
                "channel": 3, //0收银 1美一客web 2美一客app 3生意宝
                "custId": -1,
                "categoryId": -1,
                "number": 1,
                "reservationType": 1 //反预约
			}
			var apiCallback = function(ret) {
				amGloble.loading.hide();
                if (ret.code == 0) {
                    amGloble.page.dashboard.reservationCacheUtil.clear();
                    amGloble.page.dashboard.dashboardCacheUtil.clear();
                    amGloble.msg("保存成功");
                    data.timeBar.gotoDate(parseDate(data.time), true, true);
                    $.am.changePage(amGloble.page.reservation, "slideLeft", self.data.data);
                } else {
                    amGloble.msg(ret.message || "提交失败，请重试！", true);
                }
			}
            amGloble.api.reservationAdd.exec(params, function (ret) {
				if (ret.code == 203005) {
					amGloble.api.reservationAdd.exec(params, function (result) {
						apiCallback(result);
					})
				} else {
					apiCallback(ret);
				}
            });
        },
        save: function (data) {
            amGloble.loading.show("正在提交，请稍候...");
            amGloble.api.reservationUpdateComment.exec({
                "comment": data.val,
                "id": data.id,
            }, function (ret) {
                amGloble.loading.hide();
                if (ret.code == 0) {
                    amGloble.msg("保存成功");
                    $.am.changePage(amGloble.page.reservation, "slideLeft", self.data.data);
                } else {
                    amGloble.msg(ret.message || "保存失败，请重试！", true);
                }
            });
        }
    });
})();