(function() {


    var self = amGloble.page.userinfoResetPwd = new $.am.Page({
        id: "page-userinfoResetPwd",
        init: function() {
            var self = this;
            this.$phone = this.$.find(".phone");
            this.$phonenumwrap = this.$.find(".phonenumwrap");
            this.$amHeaderP = this.$.find('.am-header p');
            this.$cButton = this.$.find(".c-button");

            this.$code = this.$.find(".code > input");

            this.$vcCode = this.$.find('.vcCode > input');
            this.$vcCodeImg = this.$.find('.vcCodeImg').vclick(function(){
                self.setVcCode();
            });

            this.$captchaBtn = this.$.find(".captchaBtn").vclick(function() {
                self.getCode();
            });
            this.$audioBtn = this.$.find(".audioBtn").vclick(function() {
                self.getAudioCode();
            });

            this.$saveBtn = this.$.find(".c-button").vclick(function() {
				if(self.paras.checkin && self.paras.type == "checkin"){
                    self.saveChickin()
					return
                }
                if(self.paras.boundPhone){  //绑定手机
                    self.bindMobile();
                }else{  //重设密码
                    self.savePwd();
                }
            });



            this.$code = this.$.find(".code > input");
            this.$password = this.$.find(".password > input").keyup(function(){
                var val = $(this).val();
                val = val.replace(/[\s\r\n\\\/\'\"\‘\’\“\”]/g, '').replace(/[\u4E00-\u9FA5]/g,'');
                $(this).val(val);
            });
            this.$passwordRepeat = this.$.find(".passwordRepeat > input");

            this.$passwordBox = this.$password.parent().parent();
        },
        backButtonOnclick: function() {
            if (this.paras && this.paras.backPage) {
                $.am.changePage(this.paras.backPage, "slideright");
            } else {
                $.am.page.back();
            }
        },
        beforeShow: function(paras) {
            this.paras = paras;
            this.showOrHide();
            this.render();
            this.setVcCode();
        },
        afterShow: function(paras) {},
        beforeHide: function() {},
        showOrHide: function(){
            if(this.paras.boundPhone){  //绑定手机
                this.$amHeaderP.html('手机绑定');
                this.$phone.hide();
                this.$phonenumwrap.val('').show();
                this.$cButton.html('绑定并继续登录');
            }else{  //重设密码
                this.$amHeaderP.html('重设密码');
                this.$phone.html('').show();
                this.$phonenumwrap.hide();
                this.$cButton.html('确认');
            }
            if(this.paras.checkin && this.paras.type == "checkin"){
                this.$amHeaderP.html('验证手机号');
                this.$phone.html('').show();
                this.$phonenumwrap.hide();
                this.$cButton.html('提交入职申请');
            }
        },
        render: function() {
            this.$phone.text(this.paras.phone);
            this.$code.val("");
            this.$password.val("");
            this.$passwordBox.hide();
            this.$audioBtn.addClass("am-disabled");
        },
        getCode: function() {
            var self = this;
            var paras = this.paras;
            var i = 60;

            if(self.paras.boundPhone){  //绑定手机
                var _phone = $.trim(this.$phonenumwrap.find('input').val());
                if (!_phone) {
                    amGloble.msg("请输入手机号");
                    return;
                }
                var _codeKey = "bindMobile";
                var _shopid = 0;
            }else{  //重设密码
                var _phone = paras.phone;
                var _codeKey = "resetPwd";
                //var _shopid = paras.shopId;
                var _shopid = 0;
            }

            if(self.paras.checkin && self.paras.type == "checkin"){
                var _phone = paras.phone;
                var _codeKey = "bindMobile";
                var _shopid = paras.checkin.shopId ;
            }

            var code = this.$vcCode.val();
            if(!code){
                amGloble.msg("请输入图形验证码");
                return;
            }

            amGloble.loading.show("正在发送，请稍候...");
            amGloble.api.sendCode.exec({
                codeKey: _codeKey, // 取验证码的唯一key
                phone: _phone,
                shopid: _shopid,
                code: code
            }, function(ret) {
                amGloble.loading.hide();
                console.log(ret);
                if (ret.code == 0) {
                    amGloble.msg("验证码发送成功！");
                    self.sendCodeTimer();
                } else {
                    amGloble.msg(ret.message || "提交失败，请重试！", true);
                    self.setVcCode();
                }
            });
        },
        sendCodeTimer: function() {
            this.$audioBtn.removeClass("am-disabled");
            var i = 60;
            this.$captchaBtn.text("剩余" + i + "秒").addClass("am-disabled");

            if(this.paras.boundPhone){  //绑定手机
                this.$passwordBox.hide();
            }else{  //重设密码
                this.$passwordBox.show();
            }
            if(this.paras.checkin && this.paras.type == "checkin"){
                this.$passwordBox.hide();
            }

            var timer = setInterval(function() {
                i--;
                if (i <= 0) {
                    self.$captchaBtn.text("发送验证码").removeClass("am-disabled");
                    self.setVcCode();
                    clearInterval(timer);
                } else {
                    self.$captchaBtn.text("剩余" + i + "秒");
                }
            }, 1000);
            setTimeout(function() {
                self.$code.focus();
            }, 100);
        },
        getAudioCode: function() {
            var self = this;
            var paras = this.paras;

            if(self.paras.boundPhone){  //绑定手机
                var _phone = $.trim(this.$phonenumwrap.find('input').val());
                if (!_phone) {
                    amGloble.msg("请输入手机号");
                    return;
                }
                var _codeKey = "bindMobile";
            }else{  //重设密码
                var _phone = paras.phone;
                var _codeKey = "resetPwd";
            }
            if(self.paras.checkin && self.paras.type == "checkin"){
                var _phone = paras.phone;
                var _codeKey = "bindMobile";
            }

            var code = this.$vcCode.val();
            if(!code){
                amGloble.msg("请输入图形验证码");
                return;
            }

            amGloble.loading.show("正在发送，请稍候...");
            amGloble.api.sendCode.exec({
                codeKey: _codeKey, // 取验证码的唯一key
                phone: _phone,
                shopid: paras.shopId,
                type: "z",
                code: code
            }, function(ret) {
                amGloble.loading.hide();
                console.log(ret);
                if (ret.code == 0) {
                    self.$audioBtn.addClass("am-disabled");
                    amGloble.msg("语音验证码发送成功！");
                } else {
                    amGloble.msg(ret.message || "提交失败，请重试！", true);
                    self.setVcCode();
                }
            });
        },
        setMenu:function(){
            if(!amGloble.metadata){
                return;
            }
            if(amGloble.hideEducation || amGloble.metadata.configs.hideEducation === "true"){
	            $("div.tab-main").hide();
	        }else {
                $("div.tab-main").show();
            }
        },
        bindMobile: function(flag,data){
            var _this = this;
            var paras = this.paras;
            var code = this.$code.val();
            var phone = $.trim(this.$phonenumwrap.find('input').val());

            if (!$.trim(code) || code.length != 4) {
                amGloble.msg("请输入正确的验证码");
                return;
            }
            if (!phone) {
                amGloble.msg("请输入手机号");
                return;
            }
            if(flag){
                code = data.code;
                phone = data.phone;
                paras = data.paras;
            }
            amGloble.loading.show("正在提交，请稍候...");
            amGloble.api.userBindMobile.exec({
                userId: paras.userId,
                userType: paras.userType,
                phone: phone,
                shopid: paras.shopId,
                code: code,
                codeKey: "bindMobile"
            }, function(ret) {
                amGloble.loading.hide();
                console.log(ret);
                if (ret.code == 0) {
                    amGloble.msg("绑定成功！");
                    _this.setMenu();
                    $.am.page.back();
                } else {
                    amGloble.msg(ret.message || "提交失败，请重试！", true);
                }
            });
        },
        savePwd: function(flag,data,cb) {
            var _this = this;
            if(!flag){
                var paras = this.paras;
                var code = this.$code.val();
                var password = this.$password.val();
                var passwordRepeat = this.$passwordRepeat.val();

                if (!$.trim(code) || code.length != 4) {
                    amGloble.msg("请输入正确的短信验证码");
                    return;
                }
                if (!$.trim(password)) {
                    amGloble.msg("请输入新密码");
                    return;
                }
                // if (passwordRepeat != password) {
                //     amGloble.msg("两次输入的密码不一致，请重新输入");
                //     return;
                // }
            }else{
                code  = data.code;
                paras = data.paras;
                password = data.password;
            }
            amGloble.loading.show("正在提交，请稍候...");
            amGloble.api.userModifypwd.exec({
                userId: paras.userId,
                userType: paras.userType,
                phone: paras.phone,
                shopid: paras.shopId || paras.shopid,
                code: code,
                codeKey: "resetPwd",
                password: password
            }, function(ret) {
                amGloble.loading.hide();
                console.log(ret);
                if (ret.code == 0) {
                    _this.setMenu();
                    !flag && amGloble.msg("修改成功！");
                    if(cb){
                        cb();
                    }else{
                        if (paras.scb) {
                            paras.scb();
                        } else {
                            $.am.page.back();
                        }
                    }

                } else {
                    amGloble.msg(ret.message || "提交失败，请重试！", true);
                }
            });
        },
        saveChickin: function(flag,data,cb) {
			if(self.isChickin){
				return
			}
            var _this = this;
            var paras = this.paras;
            var code = this.$code.val();

            if (!$.trim(code) || code.length != 4) {
                amGloble.msg("请输入正确的短信验证码");
                return;
            }
            var params = this.paras.checkin
            params.codeKey = "bindMobile"
            params.code = this.$code.val()
			self.isChickin = true
            amGloble.loading.show("正在提交，请稍候...");
            amGloble.api.addEmploye.exec(params, function(ret) {
                amGloble.loading.hide();
                console.log(ret);
                if (ret.code == 0) {
                    _this.setMenu();
                    !flag && amGloble.msg("入职申请成功！");

                    var configUserInfo = {
                        appUserId: ret.content.userInfo.appUserId || window.config.userInfo.appUserId,
                        parentShopId: ret.content.userInfo.parentShopId
                    }
                    
                    $.extend(true, window.config, { token: ret.content.token, isCheckin:true, parentShopId: configUserInfo.parentShopId, userInfo: configUserInfo});
                    localStorage.setItem("BusinessAppV2_config", JSON.stringify(window.config));

                    $.am.changePage(amGloble.page.userinfo, "slideleft", {
                        userInfo: ret.content.userInfo
                    });

                } else {
                    amGloble.msg(ret.message || "提交失败，请重试！", true);
                }
				setTimeout(function(){
					self.isChickin = false
				},500)
            });
        },
        setVcCode: function(){
            this.$vcCode.val('');
            var src = config.baseUrl + 'shengyibao/mobile/user/vc2?userKey='+this.paras.phone+'&ts='+new Date().getTime();
            this.$vcCodeImg.attr('src',src);
        }
    });

})();
