(function () {
    if (amGloble) {
        var obj = {
            init: function () {
                this.$ = $('#cardSharePhoto');
            },
            createBgImg(url, errorUrl, cb) {
                var img = document.createElement("img");
                img.src = url;
                var falg = true;
                img.onload = function(res) {
                  //图片加载成功
                  cb();
                };
                img.onerror = function(res) {
                  if (falg) {
                    falg = false;
                    img.src = errorUrl;
                  }
                };
                return img;
            },
            getShareDom: function(callback) {
                this.$.show()
                var user = amGloble.metadata.userInfo;
                var $head;
                if (user.userType != 1) {
                    $head = amGloble.photoManager.getPhotoUrl("manager", {
                        parentShopId: user.parentShopId
                    }, user.userId + ".jpg", "s");
                } else {
                    $head = amGloble.photoManager.getPhotoUrl("artisan", {
                        parentShopId: user.parentShopId
                    }, user.userId + ".jpg", "s");
                }
                var qrImgSrc = config.miniProUrl + "/xcx/qrCode/?tenantId=" + window.config.parentShopId + "&page=pages/mine/index&scene=26@" + user.userId + "_" + user.userType;
                this.$.find('.qrImg').attr("src", qrImgSrc);
                var osName = (user.osName ? user.osName.trim() : null) || user.shopName
                var userName = user.userName
                this.$.find('.user_description').text(osName + '-' + userName)
                this.$.find('.avatar_box .avatar_img').html(
                    this.createBgImg($head, 'css/img/MYK/head_male.png', function() {
                        var shareDom = document.getElementById('cardSharePhoto');
                        callback(shareDom)
                    })
                );
            },
            gotoMinipro: function () {
                amGloble.loading.show("正在生成图片");
                this.getShareDom(function(shareDom) {
                    amGloble.createShareBase(shareDom);
                })
            },
        };
        amGloble.getShareCardDom = function(callback) {
            if (!obj.$) {
                obj.init();
            }
            obj.getShareDom(callback);
        }
        amGloble.shareCard = function () {
            if (!obj.$) {
                obj.init();
            }
            obj.gotoMinipro();
        };
    } else {
        throw "atMobile.nativeUIWidget.shareCard not ready!";
    }
})();