(function () {
    if (amGloble) {
        var obj = {
            init: function () {
                this.$ = $('#surveySharePhoto');
            },
            createBgImg(url, errorUrl, cb, fcb) {
                var img = document.createElement("img");
                img.src = url;
                var falg = true;
                img.onload = function(res) {
                  //图片加载成功
                  cb();
                };
                img.onerror = function(res) {
                  if (falg) {
                    falg = false;
                    img.src = errorUrl;
                    fcb && fcb()
                  }
                };
                return img;
            },
            createShareBase() {
                var _this = this;
                var shareDom = document.getElementById('surveySharePhoto');
                var canvas = document.createElement('canvas');
                var ctx = canvas.getContext('2d');
                canvas.width=shareDom.clientWidth*2;
                canvas.height=shareDom.clientHeight*2;
                ctx.scale(2,2);
                html2canvas(shareDom, {
                    canvas: canvas,
                    useCORS: true,
                    onrendered: function (canvas) {
                        // document.body.appendChild(canvas)
                        var context = canvas.getContext('2d');
                        // 【重要】关闭抗锯齿
                        context.mozImageSmoothingEnabled = false;
                        context.webkitImageSmoothingEnabled = false;
                        context.msImageSmoothingEnabled = false;
                        context.imageSmoothingEnabled = false;
                        var clientHeight=canvas.height;
                        var clientWith=canvas.width;
                        clientHeight=clientHeight*2;
                        clientWith=clientWith*2;
                        var img = Canvas2Image.convertToImage(canvas, clientWith, clientHeight);
                        console.log(img.src)
                        dataUrl = img.src.substring(22);
                        _this.$.hide()
                        amGloble.loading.hide();
                        $.am.debug.log('shareImage before');
                        amGloble.shareImage({
                            title: '',
                            imageBase64: dataUrl,
                            success: function () {
                                $.am.debug.log('shareImage success');
                            },
                            fail: function () {
                                $.am.debug.log('shareImage fail');
                            }
                        })
                    }
                });
            },
            getShareDom: function(item, callback) {
                this.$.show()
                var _item = JSON.parse(JSON.stringify(item));
                console.log("分享数据", _item);
                var user = amGloble.metadata.userInfo;
                var $head;
                if (user.userType != 1) {
                    $head = amGloble.photoManager.getPhotoUrl("manager", {
                        parentShopId: amGloble.metadata.userInfo.parentShopId
                    }, user.userId + ".jpg", "s");
                } else {
                    $head = amGloble.photoManager.getPhotoUrl("artisan", {
                        parentShopId: amGloble.metadata.userInfo.parentShopId
                    }, user.userId + ".jpg", "s");
                }
                this.$.find('.time_start').text(new Date(_item.startTime).format('yyyy/mm/dd'))
                this.$.find('.time_end').text(new Date(_item.endTime).format('yyyy/mm/dd'))
                this.$.find('.user_description').text('亲爱的，《'+ _item.name +'》投票调研活动正在火热进行中，快来帮我投一下吧~')
                if (_item.id && _item.id != "null") {
                    var qrImgSrc = config.miniProUrl + "/xcx/qrCode/?tenantId=" + window.config.parentShopId + "&page=pages/mine/index&scene=69@" + _item.id + "_" + user.userId + "_" + user.userType;
                } else {
                    amGloble.loading.hide();
                    amGloble.msg("网络请求失败，请刷新重新！！");
                    return
                }
                console.log("二维码路径", qrImgSrc);
                $.am.debug.log("二维码路径" + qrImgSrc);
                this.$.find('.qrImg').attr("src", qrImgSrc);

                // item.imgJson = '{"uploadShareImgFileName":"FD8DE5A7-CED1-4AD7-ABA6-73D64DEF207B.jpg","codeCss":{"top":"448.17px","left":"0px"},"imageBoxCss":{"width":"48.78px","height":"48.78px","top":"19.82px","left":"240.85px"}}'
                //自定义海报
                if(item.imgJson){
                    var self = this
                    this.$.find(".content_box .user_box").hide()
                    this.$.find(".content_box .time_box").hide()
                    this.$.find(".content_box .qrcode .imgText").hide()
                    var imgJson = JSON.parse(item.imgJson)
                    var codeCss = imgJson.codeCss
                    var times = 0.4
                    this.$.find(".content_box .qrcode").css({
                        width: codeCss.width,
                        height: codeCss.height||codeCss.width,
                        top: this.getNum(codeCss.top) - this.getNum(codeCss.height) * (times/2) + 'px',
                        left: this.getNum(codeCss.left) - this.getNum(codeCss.width) * (times/2) + 'px'
                    })
                    this.$.find(".content_box .qrcode_bg").css({
                        width: this.getNum(codeCss.width) * (1 + times) + 'px',
                        height: this.getNum(codeCss.height) * (1 + times) + 'px',
                        top: this.getNum(codeCss.top) - this.getNum(codeCss.height) * (times) + 'px',
                        left: this.getNum(codeCss.left) - this.getNum(codeCss.width) * (times) + 'px'
                    }).show()
                    if(imgJson.imageBoxCss){
                        var imageBoxCss = imgJson.imageBoxCss
                        this.$.find(".content_box .avatar_box").css(imageBoxCss)
                    }else{
                        this.$.find(".content_box .avatar_box").hide()
                    }
                    var bgImgUrl = window.config.filesMgr + 'shareBgImg/' + window.config.parentShopId + '/' + imgJson.uploadShareImgFileName
                    this.$.find(".survey_bgimg").html(
                        this.createBgImg(bgImgUrl, 'css/img/huodongdiaoyan1.png', function(){
                          self.$.find('.avatar_box').html(
                            self.createBgImg($head, 'css/img/MYK/head_male.png', function() {
                                var shareDom = document.getElementById('surveySharePhoto');
                                callback(shareDom)
                            })
                          );
                        }, function(){
                          amGloble.loading.hide();
                          atMobile.nativeUIWidget.confirm({
                                caption: '网络异常',
                                description: '数据读取失败，是否立即重试？',
                                okCaption: '重试',
                                cancelCaption: '取消'
                            }, function() {
                                self.getShareDom(item, callback);
                            }, function() {
                            });
                        })
                    )
                }else{
                    this.$.find(".content_box .qrcode_bg").hide()
                    this.$.find('.avatar_box').html(
                        this.createBgImg($head, 'css/img/MYK/head_male.png', function() {
                            var shareDom = document.getElementById('surveySharePhoto');
                            callback(shareDom)
                        })
                    );
                }
            },
            gotoMinipro: function (item) {
                var _this = this;
                amGloble.loading.show("正在生成图片");
                this.getShareDom(item, function() {
                    _this.createShareBase();
                })
            },
            getNum(string){
                var newNum = 0
                if(typeof string == 'string'){
                    newNum = Number(string.substring(0,string.indexOf("px")))
                }else{
                    newNum = string
                }
                return newNum
            },
        };
        amGloble.getSshareSurveyDom = function(item, callback) {
            if (!obj.$) {
                obj.init();
            }
            obj.getShareDom(item, callback);
        }
        amGloble.shareSurvey = function (item) {
            if (!obj.$) {
                obj.init();
            }
            obj.gotoMinipro(item);
        };
    } else {
        throw "atMobile.nativeUIWidget.shareSurvey not ready!";
    }
})();
