
$(function() {

    amGloble.dialog = {
        init: function() {
            var self = this;
            this.$ = $(".am-dialog");
            this.$mask = this.$.find('.am-dialog__mask').vclick(function(event) {
                self.fcb && self.fcb();
                self.hide();
            })
            this.$close = this.$.find('.am-dialog__close').vclick(function() {
                self.fcb && self.fcb();
                self.hide();
            })
            this.$content = this.$.find('.am-dialog__content');
            this.$confirmButton = this.$.find('.am-dialog__confirm').vclick(function() {
                self.scb && self.scb(self.$);
            });
            this.$cancelButton = this.$.find('.am-dialog__cancel').vclick(function() {
                self.fcb && self.fcb(self.$);
            })
        },
        show: function(opt) {
            var self = this;
            this.scb = opt.scb;
            this.fcb = opt.fcb;
            this.beforeClose = opt.beforeClose;
            if (opt.cancelButtonVisible) {
                this.$cancelButton.show();
            } else {
                this.$cancelButton.hide();
            }
            opt.className && this.$.addClass(opt.className);
            opt.renderContent && this.$content.html(opt.renderContent(this.$content));
            this.$confirmButton.text(opt.confirmButtonText || '确定');
            this.$cancelButton.text(opt.cancelButtonText || '取消');
            this.$.show();
        },
        hide: function() {
            this.$.hide();
            this.$.removeClass().addClass('am-dialog');
            delete this.scb;
            delete this.fcb;
            delete this.beforeClose;
        }
    };

    amGloble.dialog.init();

});
