var androidBarSetting = {
    url: './css/androidBar.css',
    set: function(titleBarHeight, cb){
        this.titleBarHeight = titleBarHeight;
        this.loadStyle(cb);
        console.log('已设置androdBar');
    },
    changeStyle: function(style){
        //text1 状态栏的高度
        //text2 titleBar + 状态栏高度
        style = style.replace( /@{text1}/g, this.titleBarHeight);
        style = style.replace( /@{text2}/g, this.titleBarHeight+44);
        style = style.replace( /@{text3}/g, this.titleBarHeight+84);

        //排行榜样式
        style = style.replace( /@{text4}/g, this.titleBarHeight+8);
        return style;
    },
    loadStyle: function(cb){
        this.removeStyle();
        var _this = this;
        var xmlhttp = new XMLHttpRequest();
        xmlhttp.open('get', this.url, true);
        xmlhttp.setRequestHeader("Content-Type", "application/json");
        xmlhttp.send();
        xmlhttp.onreadystatechange = function (){
            if(xmlhttp.readyState == 4){
                var styleContent = _this.changeStyle(xmlhttp.responseText);
                var style = document.createElement('style');
                style.setAttribute('path',_this.url);
                style.innerHTML = styleContent.trim();
                style.onload = function(){
                    cb();
                }
                document.head.appendChild(style);
            }
        };
    },
    removeStyle: function(){
        var styles = document.getElementsByTagName('style');
        for(var i=0;i<styles.length;i++){
            var href = styles[i].getAttribute('path');
            if(href == this.url){
                document.head.removeChild(styles[i]);
                break;
            }
        }
    },
};
